      SUBROUTINE KINEM(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
 
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 2002
C   Date      : 1994.04.30
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
      IMPLICIT REAL* 8(A-H,O-Z)
************************************************************************
      INTEGER NEXTRN
      PARAMETER ( MXDIM = 50 )
 
      COMMON / BASE1 / XL(MXDIM),XU(MXDIM),NDIM
      REAL*8  X(MXDIM)
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)
      REAL*8  YACOB
      INTEGER NREG, IREG
      INTEGER JUMP
 
      INCLUDE 'inclk.f'
*--------------------------------------------------------------------
      COMMON/KINEM1/S,W,FACT
      COMMON/KCNTL1/ICOST
      COMMON/CUT001/COSCUT(2)
* BETA FUNCTION
       BETA(Z1,Z2)=SQRT(1-2*(Z1+Z2)+(Z1-Z2)**2)
*-----------------------------------------------------------------------
      NREG   =   1
      JUMP   =   0
      YACOB  =   0.D0
      AJACOB=    1
* Set integration variables
************
* PHI      *
************
      IF(NDIM.EQ.2) THEN
       PHI3=X(2)*2*PI
      ELSE
       PHI3=0
      END IF
                 AJACOB = AJACOB*2*PI
************
* C0S(the) *
************
      E1      = (S+AMASS2(1)-AMASS2(2))/2.D0/W
      P1      = SQRT( (E1-AMASS1(1))*(E1+AMASS1(1)) )
      E2      = (S+AMASS2(2)-AMASS2(1))/2.D0/W
      P2      = P1
      E3      = (S+AMASS2(3)-AMASS2(4))/2.D0/W
      P3      = SQRT( (E3-AMASS1(3))*(E3+AMASS1(3)) )      
      E4      = (S+AMASS2(4)-AMASS2(3))/2.D0/W
      P4      = P3

*
      IF     (ICOST.EQ.0) THEN
       COS3=COSCUT(1) + (COSCUT(2)-COSCUT(1))*X(1)
                 AJACOB = AJACOB*(COSCUT(2)-COSCUT(1))
       pp13=E1*E3-P1*P3*COS3
       pp14=E1*E4+P1*P4*COS3
       pp23=E2*E3+P2*P3*COS3
       pp24=E2*E4-P2*P4*COS3
      ELSE IF(ICOST.EQ.+1) THEN
        x1=x(1)
        dmin=    2*(e1*e3-p1*p3*coscut(2))-amass2(3)
        dmax=    2*(e1*e3-p1*p3*coscut(1))-amass2(3)
        if(dmax.lt.dmin) goto 999
        if(dmin.le.0) goto 999
        d=dmin*(dmax/dmin)**x1
        cos3=e1*e3/p1/p3-(d+amass2(3))/2.d0/p1/p3
                  ajacob=ajacob*d*log(dmax/dmin)/p1/p3/2.d0
*        
        pp13=(d+amass2(3))/2.d0
        pp14=(s+amass2(1)-amass2(2)-amass2(3)-d)/2.d0
        pp23=(s-amass2(4)-d)/2.d0
        pp24=(amass2(2)+amass2(4)-amass2(1)+d)/2.d0
*
      ELSE IF(ICOST.EQ.-1) THEN
       if(x(1).le.0.5d0) then
        x1=x(1)*2
        dmin=    2*(e1*e3-p1*p3*coscut(2))-amass2(3)
        dmax=min(2*(e1*e3-p1*p3*coscut(1)),2*e1*e3)-amass2(3)
        if(dmax.lt.dmin) goto 999
        if(dmin.le.0) goto 999
        d=dmin*(dmax/dmin)**x1
        cos3=e1*e3/p1/p3-(d+amass2(3))/2.d0/p1/p3
                   ajacob=ajacob*d*log(dmax/dmin)/p1/p3
*        
        pp13=(d+amass2(3))/2.d0
        pp14=(s+amass2(1)-amass2(2)-amass2(3)-d)/2.d0
        pp23=(s-amass2(4)-d)/2.d0
        pp24=(amass2(2)+amass2(4)-amass2(1)+d)/2.d0
*                                  
       else
        x1=x(1)*2-1
        dmin=    2*(e1*e4+p1*p4*coscut(1))-amass2(4)
        dmax=min(2*(e1*e4+p1*p4*coscut(2)),2*e1*e4)-amass2(4)
        if(dmax.lt.dmin) goto 999
        if(dmin.le.0) goto 999
        d=dmin*(dmax/dmin)**x1
        cos3=-e1*e4/p1/p4+(d+amass2(4))/2.d0/p1/p4
                  ajacob=ajacob*d*log(dmax/dmin)/p1/p4
*        
        pp14=(d+amass2(4))/2.d0
        pp13=(s+amass2(1)-amass2(2)-amass2(4)-d)/2.d0
        pp24=(s-amass2(3)-d)/2.d0
        pp23=(amass2(2)+amass2(3)-amass2(1)+d)/2.d0
*                  
      end if
      ELSE
       GOTO 999
      END IF
      if(abs(cos3).gt.1) goto 999
      SIN3=SQRT( (1-COS3)*(1+COS3) )
 
* Set four-vectors
*Particle 1
      PE(1,1) = 0
      PE(2,1) = 0
      PE(3,1) = P1
      PE(4,1) = E1
 
*Particle 2
      PE(1,2) = 0
      PE(2,2) = 0
      PE(3,2) =-P2
      PE(4,2) = E2
 
*Particle 3
      PE(1,3) = P3*SIN3*COS(PHI3)
      PE(2,3) = P3*SIN3*SIN(PHI3)
      PE(3,3) = P3*COS3
      PE(4,3) = E3
*Particle 4 
      PE(1,4) =-P4*SIN3*COS(PHI3)
      PE(2,4) =-P4*SIN3*SIN(PHI3)
      PE(3,4) =-P4*COS3
      PE(4,4) = E4
 
*Set invariants
      PP(1,1) = AMASS2(1)
      PP(1,2) = (S-AMASS2(1)-AMASS2(2))/2.D0
      PP(1,3) = pp13
      PP(1,4) = pp14
 
      PP(2,1) = PP(1,2)
      PP(2,2) = AMASS2(2)
      PP(2,3) = pp23
      PP(2,4) = pp24
 
      PP(3,1) = PP(1,3)
      PP(3,2) = PP(2,3)
      PP(3,3) = AMASS2(3)
      PP(3,4) = (S-AMASS2(3)-AMASS2(4) )/2.D0
 
      PP(4,1) = PP(1,4)
      PP(4,2) = PP(2,4)
      PP(4,3) = PP(3,4)
      PP(4,4) = AMASS2(4)
*Set jacobian
      YACOB=FACT*AJACOB
     ./32.D0/PI2
     .*BETA(AMASS2(3)/S,AMASS2(4)/S)
      return
999   continue
      jump=1 
      RETURN
      END
