      SUBROUTINE KINIT
      IMPLICIT REAL*8(A-H,O-Z)
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 2003
C   Date      : 1994.11.30
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
 
      PARAMETER ( MXDIM = 50 )
      COMMON / LOOP0 / LOOP
      COMMON / BPARM1 / XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     &                 IG(MXDIM),NCALL
      COMMON / BPARM2 / ACC1,ACC2,ITMX1,ITMX2
 
      CHARACTER XSTR*14
 
      INCLUDE  'inclk.f'
*-----------------------------------------------------------------------
      COMMON/KINEM1/S,W,FACT
      COMMON/KCNTL1/ICOST
      COMMON/CUT001/COSCUT(2)
      common /knmflg/ knmgvs, knmhst, knmsph, knmisr
*-----------------------------------------------------------------------
* 2-body kinematics
*
*  Integration variables
*        COS(the),Phi
*
*--- 1. Initialize constants for kinematics.
* S = (P1+P2)**2
* W = SQRT(S)
      if( knmgvs .eq. 1 ) then
          W = 200.D0
      endif
      S = W*W
      totmas=amass1(3)+amass1(4)
      if(totmas.gt.w) then
	write(6,*)
     .' CM energy is less than the sum of final particle masses.'
	stop
      end if
* Energy and anluare cuts
* minimum cos  cut for particle 3
      COSCUT(1)= -1
* maximum cos  cut for particle 3
      COSCUT(2)=  1
*If  ICOST=+-1
* -t=(p1-p3)**2 is used as integration variable. 
*  +1; forward peak.
*  -1; forward and backward peaks.
      ICOST=-1

      WRITE(6,*)'*'
      WRITE(6,*)'* Kinematics initialization '
      WRITE(6,*)'* particle mass ',amass1
      WRITE(6,*)'* CM Energy ',W
      WRITE(6,*)'* COSCUT    '
      WRITE(6,'(2F20.8)')COSCUT
      WRITE(6,*)'* Integration Variable '
      if(icost.eq.0) then
      WRITE(6,*)'* cos3 '
      else if(icost.eq.+1) then
      WRITE(6,*)'* -t ;forward peak'
      else if(icost.eq.-1) then
      WRITE(6,*)'* -t ;forward-backward peak'
      else
      WRITE(6,*)'* icost should be 0 or +-1.',icost
      end if
      WRITE(6,*)'*'
 
* Following flux factor is for a particle-antiparticle collision
* at s/m**2 >> 1. For an e-gamma collision or low energy interactions
* you should use appropriate formulae.
      VREL = 2
      FLUX = VREL*S
      FACT = GEVPB/FLUX
 
*----- BASES RELATED INITIALIZATIONS -----------------------------------
*--- 3. Dimension of integration variables.
 
          NDIM =   2
          NWILD=   1
 
C-----------------------------------------------------------------------
*--- 4. Region of integration.
 
        XL(1)  =   0.D0
        XU(1)  =   1.D0
        IG(1)  =   1
 
        XL(2)  =   0.D0
        XU(2)  =   1.D0
        IG(2)  =   0
C-----------------------------------------------------------------------
*--- 5. Number of iterations
      ITMX1  =  5
      ITMX2  =  5
 
      NCALL  = 5000
 
*--- 6. Set MXREG : the maximum number of values which are returned
*       by FUNC for one phase space point
 
      MXREG =   1
 
*--- 7. Set histograms
      if( knmhst .eq. 1 ) then
      NX = 50
      ND = 50
 
      DO 100 I = 1, NDIM
         WRITE(XSTR, 110) I
  110    FORMAT('X(',I2,') SPECTRUM')
         CALL XHINIT(I, XL(I), XU(I), NX, XSTR)
  100 CONTINUE
 
         CALL XHINIT(ndim+1, 0.d0, w, NX, 'Energy of Particle 3')
         CALL XHINIT(ndim+2, 0.d0, w, NX, 'Energy of Particle 4')
         CALL XHINIT(ndim+3,-1.d0,1.d0, NX, 'cos_the of Particle 3')
         CALL XHINIT(ndim+4,-1.d0,1.d0, NX, 'cos_the of Particle 4')
      endif
      RETURN
      END
