      SUBROUTINE KINEM(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 3001
C   Date      : 1994.04.30
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
      IMPLICIT REAL* 8(A-H,O-Z)
************************************************************************
      INTEGER NEXTRN
      PARAMETER ( MXDIM = 50 )
 
      COMMON / BASE1 / XL(MXDIM),XU(MXDIM),NDIM
      REAL*8  X(MXDIM)
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)
      REAL*8  YACOB
      INTEGER NREG, IREG
      INTEGER JUMP
 
      INCLUDE 'inclk.f'
*--------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS,ICOS3
      COMMON/KINEM1/S,W,FACT
      COMMON/CUT001/COSCUT(2,3),ENGYCT(2,3),AMASCT(2),ARESNS(2)
      DIMENSION PBSTCL(4)
* BETA FUNCTION
       BETA(Z1,Z2)=SQRT(1-2*(Z1+Z2)+(Z1-Z2)**2)
*-----------------------------------------------------------------------
      NREG   =   1
      JUMP   =   0
      YACOB  =   0.D0
      AJACOB=    1
* Set integration variables
************
* PHI3     *
************
      IF(NDIM.EQ.5) THEN
       PHI3=X(5)*2*PI
      ELSE
       PHI3=0
      END IF
                 AJACOB = AJACOB*2*PI
      if(icos3.eq.0)then
*************
* Q2        *
*************
      Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2)
      Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2)
      IF(Q2MIN.GE.Q2MAX) GOTO 999
      IF     (IRESNS.EQ. 0) THEN
       Q2  = Q2MIN+(Q2MAX-Q2MIN)*X(4)
                 AJACOB = AJACOB*(Q2MAX-Q2MIN)
      ELSE IF(IRESNS.EQ.-1) THEN
       Q2  = Q2MIN*(Q2MAX/Q2MIN)**X(4)
                 AJACOB = AJACOB*Q2*LOG(Q2MAX/Q2MIN)
      ELSE IF(IRESNS.EQ. 1) THEN
       AM    = ARESNS(1)
       AM2   =AM*AM
       AMG   =ARESNS(1)*ARESNS(2)
       THEMIN=ATAN((Q2MIN-AM2)/AMG)
       THEMAX=ATAN((Q2MAX-AM2)/AMG)
       THE   =THEMIN+(THEMAX-THEMIN)*X(4)
       Q2    =AMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+AMG**2)/AMG
      ELSE
       GOTO 999
      END IF
*************
* ENERGY3   *
*************
       E3   = max(0.d0,(S+AMASS2(3)-Q2)/2.D0/W)
       IF(E3.GT.ENGYCT(2,1)) GOTO 999
       IF(E3.LT.ENGYCT(1,1)) GOTO 999
       P3   = SQRT( (E3-AMASS1(3))*(E3+AMASS1(3)) )
       else if(icos3.eq.1) then
*************
* ENERGY3   *
*************
       e3min=MAX(AMASS1(3),ENGYCT(1,1)
     . ,(S+AMASS2(3)-AMASCT(2)**2)/2.D0/W)
       E3MAX=MIN(ENGYCT(2,1)
     . ,(S+AMASS2(3)-(AMASS1(4)+AMASS1(5))**2)/2.D0/W
     . ,(S+AMASS2(3)-AMASCT(1)**2)/2.D0/W)
       E3=E3MIN*(E3MAX/E3MIN)**X(4)
                 AJACOB = AJACOB*E3*log(E3max/E3min)*2.D0*W
       P3   = SQRT( (E3-AMASS1(3))*(E3+AMASS1(3)) )
*************
* Q2        *
*************
       q2=s+amass2(3)-2*w*e3
       ELSE
       GOTO 999
       end if
*************
* ENERGY1   *
*************
       E1   = (S+AMASS2(1)-AMASS2(2))/2.D0/W
       P1   = SQRT( (E1-AMASS1(1))*(E1+AMASS1(1)) )
*************
* ENERGY2   *
*************
       E2   = (S+AMASS2(2)-AMASS2(1))/2.D0/W
*************
* C0S(the3) *
*************
      IF     (ICOS3.EQ.0) THEN
       COS3=COSCUT(1,1) + (COSCUT(2,1)-COSCUT(1,1))*X(3)
       SIN3=SQRT( (1-COS3)*(1+COS3) )
       D1  = 2.D0*(E1*E3-P1*P3*COS3)
       D2  = 2.D0*(E2*E3+P1*P3*COS3)
                 AJACOB = AJACOB*(COSCUT(2,1)-COSCUT(1,1))
      ELSE IF(ICOS3.EQ.1) THEN
       XI   = (E1+P1)/AMASS1(1)
       ABDB = 1+AMASS2(1)/P1/(E1+P1)
       TEMAX= (ABDB+COSCUT(2,1))/(ABDB-COSCUT(2,1))
       TEMIN= (ABDB+COSCUT(1,1))/(ABDB-COSCUT(1,1))
       YMAX = (LOG(TEMAX)/LOG(XI)+2)/4.D0
       YMIN = (LOG(TEMIN)/LOG(XI)+2)/4.D0
       if(coscut(1,1).lt.-1.d0+1.d-10)ymin=0
       if(coscut(2,1).gt. 1.d0-1.d-10)ymax=1
       Y    = YMIN+(YMAX-YMIN)*X(3)
                 AJACOB = AJACOB*(YMAX-YMIN)
       TETA = XI**(4*Y-2)
       COS3 = ABDB*(TETA-1)/(TETA+1)
c      IF(ABS(COS3).GT.1) COS3=SIGN(1.D0,COS3)
       SIN3 = SQRT( (1-COS3)*(1+COS3) )
       D1   = 4*E3*E1/(TETA+1)
       D2   = TETA*D1
       D13  = 4   *E1/(TETA+1)
       D23  = TETA*D13
                 AJACOB = AJACOB*LOG(XI)/2.D0/E1/P1
     .*                   D13*D23
      ELSE
       GOTO 999
      END IF
************************
* PHI4 in 4-5 CM frame *
************************
      PHI4=X(2)*2*PI+PHI3
                 AJACOB = AJACOB*2*PI
 
************************
* COS4 in 4-5 CM frame *
************************
      COS4=-1+2*X(1)
      SIN4=SQRT( (1-COS4)*(1+COS4) )
                 AJACOB = AJACOB*2
 
* Set four-vectors
*Particle 1
      PE(1,1) = 0
      PE(2,1) = 0
      PE(3,1) = P1
      PE(4,1) = E1
 
*Particle 2
      PE(1,2) = 0
      PE(2,2) = 0
      PE(3,2) =-P1
      PE(4,2) = E2
 
*Particle 3
      PE(1,3) = P3*SIN3*COS(PHI3)
      PE(2,3) = P3*SIN3*SIN(PHI3)
      PE(3,3) = P3*COS3
      PE(4,3) = E3
 
*Particle 4 in 4-5 CM frame
      E4      = (Q2+AMASS2(4)-AMASS2(5))/2.D0/SQRT(Q2)
      P4      = SQRT( (E4-AMASS1(4))*(E4+AMASS1(4)) )
      PE(1,4) = P4*SIN4*COS(PHI4)
      PE(2,4) = P4*SIN4*SIN(PHI4)
      PE(3,4) = P4*COS4
      PE(4,4) = E4
 
*Particle 5 in 4-5 CM frame
      E5      = (Q2+AMASS2(5)-AMASS2(4))/2.D0/SQRT(Q2)
      PE(1,5) =-PE(1,4)
      PE(2,5) =-PE(2,4)
      PE(3,5) =-PE(3,4)
      PE(4,5) = E5
 
* boost from 4-5 CM frame to 1-2 CM frame (Lab-frame)
      PBSTCL(1)=-PE(1,3)
      PBSTCL(2)=-PE(2,3)
      PBSTCL(3)=-PE(3,3)
      PBSTCL(4)= SQRT(P3*P3+Q2)
      CALL WTOLAB(PE(1,4),PE(1,5),PBSTCL, PE(1,4),PE(1,5))
c     call pboost(pe(1,4),pbstcl, pe(1,4))
c     call pboost(pe(1,5),pbstcl, pe(1,5))
* cuts in Lab-frame
      COS4LB=PE(3,4)/SQRT(PE(1,4)**2+PE(2,4)**2+PE(3,4)**2)
      IF(COS4LB.LT.COSCUT(1,2) .OR. COS4LB.GT.COSCUT(2,2)) GOTO 999
      COS5LB=PE(3,5)/SQRT(PE(1,5)**2+PE(2,5)**2+PE(3,5)**2)
      IF(COS5LB.LT.COSCUT(1,3) .OR. COS5LB.GT.COSCUT(2,3)) GOTO 999
      IF(PE(4,4).LT.ENGYCT(1,2).OR.PE(4,4).GT.ENGYCT(2,2)) GOTO 999
      IF(PE(4,5).LT.ENGYCT(1,3).OR.PE(4,5).GT.ENGYCT(2,3)) GOTO 999
 
*Set invariants
      PP(1,1) = AMASS2(1)
      PP(1,2) = (S-AMASS2(1)-AMASS2(2))/2.D0
      PP(1,3) = D1/2.D0
      PP(1,4) = PE(4,1)*PE(4,4)-PE(1,1)*PE(1,4)
     .         -PE(2,1)*PE(2,4)-PE(3,1)*PE(3,4)
      PP(1,5) = PE(4,1)*PE(4,5)-PE(1,1)*PE(1,5)
     .         -PE(2,1)*PE(2,5)-PE(3,1)*PE(3,5)
 
      PP(2,1) = PP(1,2)
      PP(2,2) = AMASS2(2)
      PP(2,3) = D2/2.D0
      PP(2,4) = PE(4,2)*PE(4,4)-PE(1,2)*PE(1,4)
     .         -PE(2,2)*PE(2,4)-PE(3,2)*PE(3,4)
      PP(2,5) = PE(4,2)*PE(4,5)-PE(1,2)*PE(1,5)
     .         -PE(2,2)*PE(2,5)-PE(3,2)*PE(3,5)
 
      PP(3,1) = PP(1,3)
      PP(3,2) = PP(2,3)
      PP(3,3) = AMASS2(3)
      PP(3,4) = PE(4,3)*PE(4,4)-PE(1,3)*PE(1,4)
     .         -PE(2,3)*PE(2,4)-PE(3,3)*PE(3,4)
      PP(3,5) = PE(4,3)*PE(4,5)-PE(1,3)*PE(1,5)
     .         -PE(2,3)*PE(2,5)-PE(3,3)*PE(3,5)
 
      PP(4,1) = PP(1,4)
      PP(4,2) = PP(2,4)
      PP(4,3) = PP(3,4)
      PP(4,4) = AMASS2(4)
      PP(4,5) = (Q2-AMASS2(4)-AMASS2(5))/2.D0
 
      PP(5,1) = PP(1,5)
      PP(5,2) = PP(2,5)
      PP(5,3) = PP(3,5)
      PP(5,4) = PP(4,5)
      PP(5,5) = AMASS2(5)
*Set jacobian
      YACOB=FACT*AJACOB
     ./(2*PI)/(32*PI2)/(32*PI2)
     .*BETA(Q2       /S ,AMASS2(3)/S )
     .*BETA(AMASS2(4)/Q2,AMASS2(5)/Q2)

c     write(6,*)pe(4,1)+pe(4,2) 
c     write(6,*)pe(4,3)+pe(4,4)+pe(4,5) 
c     write(6,*)pe(1,3)+pe(1,4)+pe(1,5) 
c     write(6,*)pe(2,3)+pe(2,4)+pe(2,5) 
c     write(6,*)pe(3,3)+pe(3,4)+pe(3,5)
c     write(6,*)amass1
c     write(6,*)amass2
c     write(6,*)pbstcl
c     write(6,*)sqrt(pe(4,3)**2-pe(1,3)**2-pe(2,3)**2-pe(3,3))
c     write(6,*)sqrt(pe(4,4)**2-pe(1,4)**2-pe(2,4)**2-pe(3,4))
c     write(6,*)sqrt(pe(4,5)**2-pe(1,5)**2-pe(2,5)**2-pe(3,5))
      RETURN
999   CONTINUE
      JUMP=1
      YACOB=0
      RETURN
      END
