      SUBROUTINE KINEM(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 3005
C   Date      : 1994.08.19
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
      IMPLICIT REAL* 8(A-H,O-Z)
************************************************************************
      INTEGER NEXTRN
      PARAMETER ( MXDIM = 50 )

      COMMON / BASE1 / XL(MXDIM),XU(MXDIM),NDIM
      REAL*8  X(MXDIM)
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)
      REAL*8  YACOB
      INTEGER NREG, IREG
      INTEGER JUMP

      INCLUDE 'inclk.f'
*--------------------------------------------------------------------
      COMMON/KMCNTL/Idummy,ICOS3
      COMMON/KINEM1/S,W,FACT
      COMMON/CUT001/COSCUT(2,3),ENGYCT(2,3),AMASCT(2),Adummy(2)
*-----------------------------------------------------------------------
      NREG   =   1
      JUMP   =   0
      YACOB  =   0.D0
      AJACOB=    1
* Set integration variables
*************
* ENERGY1   *
*************
       E1   = (S+AMASS2(1)-AMASS2(2))/2.D0/W
       P1   = SQRT( (E1-AMASS1(1))*(E1+AMASS1(1)) )
*************
* ENERGY2   *
*************
       E2   = (S+AMASS2(2)-AMASS2(1))/2.D0/W
       P2   = SQRT( (E2-AMASS1(2))*(E2+AMASS1(2)) )
************
* PHI3     *
************
      IF(NDIM.EQ.5) THEN
       PHI3=X(5)*2*PI
      ELSE
       PHI3=0
      END IF
                 AJACOB = AJACOB*2*PI
****************
*   Q0         *
****************
      Q0MAX=MIN(E1-amass1(3),E1-ENGYCT(1,1))
      Q0MIN=MAX(E1-ENGYCT(2,1),0.D0)
      IF(Q0MAX.LT.Q0MIN) GOTO 999
      Q0 = Q0MIN+(Q0MAX-Q0MIN)*X(1)
      AJACOB=AJACOB * (Q0MAX-Q0MIN)

      E3 = E1-Q0
      P3 = SQRT( (E3-AMASS1(3))*(E3+AMASS1(3)) )
****************
*   Q2         *
****************
      Q2MAX= -AMASS2(1)-AMASS2(3)+2*(E1*E3-P1*P3*COSCUT(1,1))
      Q2MIN= -AMASS2(1)-AMASS2(3)+2*(E1*E3-P1*P3*COSCUT(2,1))
      IF(Q2MIN.EQ.0) GOTO 999
      IF     (ICOS3.EQ.0) THEN
        Q2 = Q2MIN+(Q2MAX-Q2MIN)*X(2)
        AJACOB=AJACOB*(Q2MAX-Q2MIN)
      ELSE IF(ICOS3.EQ.1) THEN
        Q2 = Q2MIN*(Q2MAX/Q2MIN)**X(2)
        AJACOB=AJACOB*Q2*LOG(Q2MAX/Q2MIN)
      ELSE
        GOTO 999
      END IF

      COS3=(2*E1*E3-AMASS2(1)-AMASS2(3)-Q2)/2.D0/P1/P3
      SIN3=SQRT( (1-COS3)*(1+COS3) )
****************
*   COS4       *
****************
      COS4=COSCUT(1,2)+(COSCUT(2,2)-COSCUT(1,2))*X(3)
      SIN4=SQRT( (1-COS4)*(1+COS4) )
      AJACOB=AJACOB*(COSCUT(2,2)-COSCUT(1,2))
****************
*   E4         *
****************
      E4MIN=(S-2*W*E3+AMASS2(3)+AMASS2(4)-AMASS2(5))/2.D0
     ./     (P3*(COS3*COS4+SIN3*SIN4)+W-E3)
      E4MIN=MAX(E4MIN,ENGYCT(1,2),0.D0)
      E4MAX=(S-2*W*E3+AMASS2(3)+AMASS2(4)-AMASS2(5))/2.D0
     ./     (P3*(COS3*COS4-SIN3*SIN4)+W-E3)
      E4MAX=MIN(E4MAX,ENGYCT(2,2))
      IF(E4MAX.LT.E4MIN) GOTO 999
      E4=E4MIN+(E4MAX-E4MIN)*X(4)
      P4 = SQRT( (E4-AMASS1(4))*(E4+AMASS1(4)) )
      AJACOB=AJACOB*(E4MAX-E4MIN)
****************
*   PHI4       *
****************
      COSP34=(S-2*W*(E3+E4)+AMASS2(3)+AMASS2(4)-AMASS2(5)
     .+2*(E3*E4-P3*P4*COS3*COS4))/2.D0/P3/P4/SIN3/SIN4
      IF(ABS(COSP34).GT.1) GOTO 999
      SINP34=SQRT( (1-COSP34)*(1+COSP34) )
      PHI4=ACOS(COSP34)+PHI3
      AJACOB=AJACOB * 2
* Set four-vectors
*Particle 1
      PE( 1, 1) = 0
      PE( 2, 1) = 0
      PE( 3, 1) = P1
      PE( 4, 1) = E1
*Particle 2
      PE( 1, 2) = 0
      PE( 2, 2) = 0
      PE( 3, 2) =-P2
      PE( 4, 2) = E2
*Particle 3
      PE( 1, 3) = P3*SIN3*COS(PHI3)
      PE( 2, 3) = P3*SIN3*SIN(PHI3)
      PE( 3, 3) = P3*COS3
      PE( 4, 3) = E3
*Particle 4
      PE( 1, 4) = P4*SIN4*COS(PHI4)
      PE( 2, 4) = P4*SIN4*SIN(PHI4)
      PE( 3, 4) = P4*COS4
      PE( 4, 4) = E4
*Particle 5
      PE( 1, 5) = -PE(1,3)-PE(1,4)
      PE( 2, 5) = -PE(2,3)-PE(2,4)
      PE( 3, 5) = -PE(3,3)-PE(3,4)
      PE( 4, 5) =W-E3-E4
*Set invariants
      PP( 1, 1) = AMASS2(1)
      PP( 1, 2) = (S -AMASS2(1)-AMASS2(2))/2.D0
      PP( 1, 3) = (Q2+AMASS2(1)+AMASS2(3))/2.D0
      PP( 1, 4) = E1*E4-P1*P4*COS4
      PP( 1, 5) = PE(4,1)*PE(4,5)-PE(1,1)*PE(1,5)
     .                           -PE(2,1)*PE(2,5)
     .                           -PE(3,1)*PE(3,5)

      PP( 2, 1) = PP( 1, 2)
      PP( 2, 2) = AMASS2(2)
      PP( 2, 3) = E2*E3+P2*P3*COS3
      PP( 2, 4) = E2*E4+P2*P4*COS4
      PP( 2, 5) = PE(4,2)*PE(4,5)-PE(1,2)*PE(1,5)
     .                           -PE(2,2)*PE(2,5)
     .                           -PE(3,2)*PE(3,5)

      PP( 3, 1) = PP( 1, 3)
      PP( 3, 2) = PP( 2, 3)
      PP( 3, 3) = AMASS2(3)
      PP( 3, 4) = E3*E4-P3*P4*(COS3*COS4+SIN3*SIN4*COSP34)
      PP( 3, 5) = PE(4,3)*PE(4,5)-PE(1,3)*PE(1,5)
     .                           -PE(2,3)*PE(2,5)
     .                           -PE(3,3)*PE(3,5)

      PP( 4, 1) = PP( 1, 4)
      PP( 4, 2) = PP( 2, 4)
      PP( 4, 3) = PP( 3, 4)
      PP( 4, 4) = AMASS2(4)
      PP( 4, 5) = PE(4,4)*PE(4,5)-PE(1,4)*PE(1,5)
     .                           -PE(2,4)*PE(2,5)
     .                           -PE(3,4)*PE(3,5)

      PP( 5, 1) = PP( 1, 5)
      PP( 5, 2) = PP( 2, 5)
      PP( 5, 3) = PP( 3, 5)
      PP( 5, 4) = PP( 4, 5)
      PP( 5, 5) = AMASS2(5)
* cuts in Lab-frame
      COS5LB=PE(3,5)/SQRT(PE(1,5)**2+PE(2,5)**2+PE(3,5)**2)
      IF(COS5LB.LT.COSCUT(1,3) .OR. COS5LB.GT.COSCUT(2,3)) GOTO 999
      IF(PE(4,5).LT.ENGYCT(1,3).OR.PE(4,5).GT.ENGYCT(2,3)) GOTO 999

*     Normalization factor
      YACOB = FACT/16.D0/(2*PI)**5/SIN3/SIN4
     ./SINP34/P1/P3*AJACOB
*********** DEBUG **********************************
c     WRITE(6,*)'*****************************'
c     WRITE(6,'(5(4E13.4/))')PE
c     WRITE(6,*)'*****************************'
c     WRITE(6,'(5(5E13.4/))')PP
c     WRITE(6,*)' YACOB ',YACOB
c     WRITE(6,*)' TOTAL ENERGY INI   ',PE(4,1)+PE(4,2)
c     WRITE(6,*)' TOTAL ENERGY FINAL ',PE(4,3)+PE(4,4)
c    .+                                PE(4,5)
c     WRITE(6,*)' INITIAL '
c     WRITE(6,*)' PX ',PE(1,1)+PE(1,2)
c     WRITE(6,*)' PY ',PE(2,1)+PE(2,2)
c     WRITE(6,*)' PZ ',PE(3,1)+PE(3,2)
c     WRITE(6,*)' FINAL   '
c     WRITE(6,*)' PX ',PE(1,3)+PE(1,4)+PE(1,5)
c     WRITE(6,*)' PY ',PE(2,3)+PE(2,4)+PE(2,5)
c     WRITE(6,*)' PZ ',PE(3,3)+PE(3,4)+PE(3,5)
c     WRITE(6,'(5E13.4)')(SIGN(SQRT(ABS(PP(KKK,KKK))),PP(KKK,KKK))
c    .,KKK=1,5)
*********** DEBUG **********************************

      RETURN
999   CONTINUE
      JUMP = 1
      RETURN
      END
