      SUBROUTINE KINIT
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 3006
C   Date      : 1994.12.14
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
C
      IMPLICIT REAL*8(A-H,O-Z)
 
      PARAMETER ( MXDIM = 50 )
      COMMON / LOOP0 / LOOP
      COMMON / BPARM1 / XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     &                 IG(MXDIM),NCALL
      COMMON / BPARM2 / ACC1,ACC2,ITMX1,ITMX2
 
      CHARACTER XSTR*14
 
      INCLUDE 'inclk.f'
*-----------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS,ICOS4,ifrad
      COMMON/KINEM1/S,W,FACT
      COMMON/CUT001/COSCUT(2,3),ENGYCT(2,3),AMASCT(2),ARESNS(2)
     .,cosopn
      common /knmflg/ knmgvs, knmhst, knmsfp, knmisr
*-----------------------------------------------------------------------
* 3-body kinematics; for x x' gamma
*   particle 3 is assumed to be photon. 
*
*--- 1. Initialize constants for kinematics.
* S = (P1+P2)**2
* W = SQRT(S)
      if( knmgvs .eq. 1 ) then
      W =1000.D0
      endif
      S = W*W
      totmas=amass1(3)+amass1(4)+amass1(5)
      if(totmas.gt.w) then
	write(6,*)
     .' CM energy is less than the sum of final particle masses.'
	stop
      end if
      if(amass1(3).gt.1.d-20) then
	write(6,*)
     .' Particle 3 should be photon!!'
	stop      
      end if
*******************************
* Angular cuts in Lab-frame.  *
*******************************
* particle 3
* minimum cos  cut
      COSCUT(1,1)= -1
* maximum cos  cut
      COSCUT(2,1)=  1
* particle 4
* minimum cos  cut
      COSCUT(1,2)= -1
* maximum cos  cut
      COSCUT(2,2)=  1
* particle 5
* minimum cos  cut
      COSCUT(1,3)= -1
* maximum cos  cut
      COSCUT(2,3)=  1
* opening angle cut between photon and particle 4,5
*  opmagl : opening angle cut in degree
      opnagl     =  0.d0
      cosopn     =  cos(opnagl*rad) 
*******************************
* Energy  cuts in Lab-frame.  *
*******************************
* particle 3
* minimum energy cut
      ENGYCT(1,1) = 1.d-3
* maximum energy cut
      ENGYCT(2,1) = 
     .(s+amass2(3)-(amass1(4)+amass1(5))**2)/2.d0/w
*     ENGYCT(2,1) = 1.d-1
* particle 4
* minimum energy cut
      ENGYCT(1,2) = AMASS1(4)
* maximum energy cut
      ENGYCT(2,2) = 
     .(s+amass2(4)-(amass1(5)+amass1(3))**2)/2.d0/w
* particle 5
* minimum energy cut
      ENGYCT(1,3) = AMASS1(5)
* maximum energy cut
      ENGYCT(2,3) = 
     .(s+amass2(5)-(amass1(3)+amass1(4))**2)/2.d0/w
 
 
******************************************
* Q2=(p4+p5)**2 singularity treatment    *
******************************************
* no-singularity             : IRESNS= 0
* 1/Q2 singularity only      : IRESNS= 1
* narrow resonance           : IRESNS= 2
* 1/Q2 singularity+resonance : IRESNS= 3
      IRESNS   = 1
      IF(IRESNS.ge.2) THEN
C If you want treat narrow resonance, you should set resonance mass
C and width.
        ARESNS(1)=amz
        ARESNS(2)=agz
      END IF
********************************
* t,u singularity treatment    *
********************************
*     t=(p1-p4)**2             *
*     u=(p1-p5)**2             *
********************************
* no-singularity      : icos4=0
* 1/t                 : icos4=1
* 1/t+1/u             : icos4=2
*
      icos4=0
***************************
* initial/final radiation *
***************************
* initial              : ifrad=1
* final                : ifrad=2
* initial+final        : ifrad=3
      ifrad=3

      WRITE(6,*)'*'
      WRITE(6,*)'* Kinematics initialization '
      WRITE(6,*)'* particle mass ',amass1
      WRITE(6,*)'* CM Energy ',W
      WRITE(6,*)'* COSCUT    '
      WRITE(6,'(2F10.3)')COSCUT
      WRITE(6,*)'* opening angle cut between photon and 4,5 '
     .,opnagl
      WRITE(6,*)'* ENGYCT    '
      WRITE(6,'(2F10.3)')ENGYCT
      write(6,*)'* Q2=(P4+P5)**2 treatment '
      if(iresns.eq.0)write(6,*)'* no-singularity '
      if(iresns.eq.1)write(6,*)'* 1/Q2 singularity only  '
      if(iresns.eq.2)write(6,*)'* narrow resonance      '
      if(iresns.eq.3)write(6,*)'* 1/Q2 singularity+resonance '
      write(6,*)'* 1/t,1/u treatment '
      if(icos4.eq.0)write(6,*)'* non '
      if(icos4.eq.1)write(6,*)'* 1/t '
      if(icos4.eq.2)write(6,*)'* 1/u ' 
      if(ifrad.eq.1)write(6,*)'* initial radiation '
      if(ifrad.eq.2)write(6,*)'* final   radiation '  
      if(ifrad.eq.3)write(6,*)'* initial/final   radiation '         
      WRITE(6,*)'*'
 
* Following flux factor is for a particle-antiparticle collision
* at s/m**2 >> 1. For an e-gamma collision or low energy interactions
* you should use appropriate formulae.
      VREL = 2
      FLUX = VREL*S
      FACT = GEVPB/FLUX
 
*----- BASES RELATED INITIALAZATIONS -----------------------------------
*--- 2. Dimension of integration variables.
 
          NDIM =   5
          NWILD=   4
 
C-----------------------------------------------------------------------
*--- 3. Region of integration.
 
        DO 1 I=1,NDIM
         XL(I)  =   0.D0
         XU(I)  =   1.D0
         IG(I)  =   1
1       CONTINUE
C-----------------------------------------------------------------------
*--- 4. Number of iterations
      ITMX1  =  5
      ITMX2  =  5
 
      NCALL  =10000
 
*--- 5. Set MXREG : the maximum number of values which are returned
*       by FUNC for one phase space point
 
      MXREG =   1
 
*--- 6. Set histograms
      if( knmhst .eq. 1 ) then
      NX = 50 
         num1 = 25
         num2 = 100
         fah  = float(num1)/float(num2)
         emax3 = (s+amass2(3)-(amass1(4)+amass1(5))**2)/(2.0d0*w)
	 pmax3 = sqrt(emax3**2-amass2(3))
         pmax3h = int(pmax3) + 1
         emax4 = (s+amass2(4)-(amass1(3)+amass1(5))**2)/(2.0d0*w)
	 pmax4 = sqrt(emax4**2-amass2(4))
         pmax4h = int(pmax4) + 1
         emax5 = (s+amass2(5)-(amass1(3)+amass1(4))**2)/(2.0d0*w)
	 pmax5 = sqrt(emax5**2-amass2(5))
         pmax5h = int(pmax5) + 1 
         pmax = max(pmax3h,pmax4h)
         pmax = max(pmax,pmax5h)
         pmaxh= pmax
         do 200 i = 1, 40
            pmaxh = float(i*nx)*0.25d0
            if( pmaxh .ge. pmax ) go to 210
  200    continue
  210    pmax = pmaxh
         CALL XHINIT(1, 0.d0, pmax, NX, 'Momentum of Particle 3')
         CALL XHINIT(2, 0.d0, pmax, NX, 'Momentum of Particle 4')
         CALL XHINIT(3, 0.d0, pmax, NX, 'Momentum of Particle 5')
*--
         CALL XHINIT(4,-1.d0,1.d0, NX, 'cos_the of Particle 3')
         CALL XHINIT(5,-1.d0,1.d0, NX, 'cos_the of Particle 4')
         CALL XHINIT(6,-1.d0,1.d0, NX, 'cos_the of Particle 5')
*--
         CALL XHINIT(7, 0.d0, w, NX, 'Invariant Mass 3-4')
         CALL XHINIT(8, 0.d0, w, NX, 'Invariant Mass 3-5')
         CALL XHINIT(9, 0.d0, w, NX, 'Invariant Mass 4-5')
*--
         CALL XHINIT(10,-1.d0,1.d0, NX, 'cos_the between 3-4')
         CALL XHINIT(11,-1.d0,1.d0, NX, 'cos_the between 3-5')
         CALL XHINIT(12,-1.d0,1.d0, NX, 'cos_the between 4-5')
*--
         CALL DHINIT(21, -1.d0, 1.d0, NX, 0.d0, pmax, NX,
     .               'cos_th versus momentum for 3')
         CALL DHINIT(22, -1.d0, 1.d0, NX, 0.d0, pmax, NX,
     .               'cos_th versus momentum for 4')
         CALL DHINIT(23, -1.d0, 1.d0, NX, 0.d0, pmax, NX,
     .               'cos_th versus momentum for 5')
*--
         CALL DHINIT(24, 0.d0,pmax, NX, 0.d0,pmax, NX,
     .               'Dalitz plot partilce 3 versus 4')
         CALL DHINIT(25, 0.d0,pmax, NX, 0.d0,pmax, NX,
     .               'Dalitz plot partilce 3 versus 5')
         CALL DHINIT(26, 0.d0,pmax, NX, 0.d0,pmax, NX,
     .               'Dalitz plot partilce 4 versus 5')
*--
         CALL DHINIT(27, -1.d0, 1.d0, NX, -1.d0, 1.d0, NX,
     .               'cos_th correlation between 3-4')
         CALL DHINIT(28, -1.d0, 1.d0, NX, -1.d0, 1.d0, NX,
     .               'cos_th correlation between 3-5')
         CALL DHINIT(29, -1.d0, 1.d0, NX, -1.d0, 1.d0, NX,
     .               'cos_th correlation between 4-5')
      endif
      RETURN
      END
