      SUBROUTINE KINIT
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 3007
C   Date      : 1995.01.04
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
C
      IMPLICIT REAL*8(A-H,O-Z)
 
      PARAMETER ( MXDIM = 50 )
      COMMON / LOOP0 / LOOP
      COMMON / BPARM1 / XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     &                 IG(MXDIM),NCALL
      COMMON / BPARM2 / ACC1,ACC2,ITMX1,ITMX2
 
      CHARACTER XSTR*14
 
      INCLUDE 'inclk.f'
*-----------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS,ICOS4,ifrad
      COMMON/KINEM1/S,W,FACT
      COMMON/CUT001/COSCUT(2,3),ENGYCT(2,3),AMASCT(2),ARESNS(2)
     .,cosopn
      common /knmflg/ knmgvs, knmhst, knmsfp, knmisr
*-----------------------------------------------------------------------
* 3-body kinematics; for x gamma gamma
*   particles 3,4 are assumed to be photon. 
*
*--- 1. Initialize constants for kinematics.
* S = (P1+P2)**2
* W = SQRT(S)
      if( knmgvs .eq. 1 ) then
      W =1000.D0
      endif
      S = W*W
      totmas=amass1(5)
      if(totmas.gt.w) then
	write(6,*)
     .' CM energy is less than the sum of final particle masses.'
	stop
      end if
      if(amass1(3).gt.1.d-20) then
	write(6,*)
     .' Particle 3 should be photon!!'
	stop      
      end if
      if(amass1(4).gt.1.d-20) then
	write(6,*)
     .' Particle 4 should be photon!!'
	stop      
      end if
*******************************
* Angular cuts in Lab-frame.  *
*******************************
* particle 3
* minimum cos  cut
      COSCUT(1,1)= -1
* maximum cos  cut
      COSCUT(2,1)=  1
* particle 4
* minimum cos  cut
      COSCUT(1,2)= -1
* maximum cos  cut
      COSCUT(2,2)=  1
* particle 5
* minimum cos  cut
      COSCUT(1,3)= -1
* maximum cos  cut
      COSCUT(2,3)=  1
* opening angle cut between photon and particle 4,5
*  opmagl : opening angle cut in degree
      opnagl     =  0.d0
      cosopn     =  cos(opnagl*rad) 
*******************************
* Energy  cuts in Lab-frame.  *
*******************************
* particle 3
* minimum energy cut
      ENGYCT(1,1) = 1.d-3
* maximum energy cut
      ENGYCT(2,1) = (w-amass1(5))/2.d0
c     ENGYCT(2,1) = 1.d-1
* particle 4
* minimum energy cut
      ENGYCT(1,2) = (s-amass2(5))/4.d0/w
* maximum energy cut
      ENGYCT(2,2) = (s-amass2(5))/2.d0/w
* particle 5
* minimum energy cut
      ENGYCT(1,3) = AMASS1(5)
* maximum energy cut
      ENGYCT(2,3) = (s+amass2(5))/2.d0/w
 
 
******************************************
* Q2=(p4+p5)**2 singularity treatment    *
******************************************
* no-singularity             : IRESNS= 0
* 1/Q2 singularity only      : IRESNS= 1
* narrow resonance           : IRESNS= 2
* 1/Q2 singularity+resonance : IRESNS= 3
      IRESNS   = 0
      IF(IRESNS.ge.2) THEN
C If you want treat narrow resonance, you should set resonance mass
C and width.
        ARESNS(1)=AMzb
        ARESNS(2)=AGzb
      END IF
********************************
* t,u singularity treatment    *
********************************
*     t=(p1-p4)**2             *
*     u=(p1-p5)**2             *
********************************
* no-singularity      : icos4=0
* 1/t                 : icos4=1
* 1/t+1/u             : icos4=2
*
      icos4=2
***************************
* initial/final radiation *
***************************
* initial              : ifrad=1
* final                : ifrad=2
* initial+final        : ifrad=3
      ifrad=1

      WRITE(6,*)'*'
      WRITE(6,*)'* Kinematics initialization '
      WRITE(6,*)'* particle mass ',amass1
      WRITE(6,*)'* CM Energy ',W
      WRITE(6,*)'* COSCUT    '
      WRITE(6,'(2F10.3)')COSCUT
      WRITE(6,*)'* opening angle cut between photon and 4,5 '
     .,opnagl
      WRITE(6,*)'* ENGYCT    '
      WRITE(6,'(2F10.3)')ENGYCT
      write(6,*)'* Q2=(P4+P5)**2 treatment '
      if(iresns.eq.0)write(6,*)'* no-singularity '
      if(iresns.eq.1)write(6,*)'* 1/Q2 singularity only  '
      if(iresns.eq.2)write(6,*)'* narrow resonance      '
      if(iresns.eq.3)write(6,*)'* 1/Q2 singularity+resonance '
      write(6,*)'* 1/t,1/u treatment '
      if(icos4.eq.0)write(6,*)'* non '
      if(icos4.eq.1)write(6,*)'* 1/t '
      if(icos4.eq.2)write(6,*)'* 1/u ' 
      if(ifrad.eq.1)write(6,*)'* initial radiation '
      if(ifrad.eq.2)write(6,*)'* final   radiation '  
      if(ifrad.eq.3)write(6,*)'* initial/final   radiation '         
      WRITE(6,*)'*'
 
* Following flux factor is for a particle-antiparticle collision
* at s/m**2 >> 1. For an e-gamma collision or low energy interactions
* you should use appropriate formulae.
      VREL = 2
      FLUX = VREL*S
      FACT = GEVPB/FLUX
 
*----- BASES RELATED INITIALAZATIONS -----------------------------------
*--- 2. Dimension of integration variables.
 
          NDIM =   4
          NWILD=   4
 
C-----------------------------------------------------------------------
*--- 3. Region of integration.
 
        DO 1 I=1,NDIM
         XL(I)  =   0.D0
         XU(I)  =   1.D0
         IG(I)  =   1
1       CONTINUE
C-----------------------------------------------------------------------
*--- 4. Number of iterations
      ITMX1  =  10
      ITMX2  =  10
 
      NCALL  =10000
 
*--- 5. Set MXREG : the maximum number of values which are returned
*       by FUNC for one phase space point
 
      MXREG =   1
 
*--- 6. Set histograms
      if( knmhst .eq. 1 ) then
      NX = 50
      ND = 50
 
      DO 100 I = 1, NDIM
         WRITE(XSTR, 110) I
  110    FORMAT('X(',I2,') SPECTRUM')
         CALL XHINIT(I, XL(I), XU(I), NX, XSTR)
  100 CONTINUE
         CALL XHINIT(ndim+1, 0.d0, w, NX, 'Energy of Particle 3')
         CALL XHINIT(ndim+2, 0.d0, w, NX, 'Energy of Particle 4')
         CALL XHINIT(ndim+3, 0.d0, w, NX, 'Energy of Particle 5')
         CALL XHINIT(ndim+4,-1.d0,1.d0, NX, 'cos_the of Particle 3')
         CALL XHINIT(ndim+5,-1.d0,1.d0, NX, 'cos_the of Particle 4')
         CALL XHINIT(ndim+6,-1.d0,1.d0, NX, 'cos_the of Particle 5')
 
      endif
      RETURN
      END
