      SUBROUTINE KINEM(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 3007 initial/final control part
C   Date      : 1994.12.14
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
      IMPLICIT REAL* 8(A-H,O-Z)
************************************************************************
      INTEGER NEXTRN
      PARAMETER ( MXDIM = 50 )
 
      COMMON / BASE1 / XL(MXDIM),XU(MXDIM),NDIM
      REAL*8  X(MXDIM)
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)
      REAL*8  YACOB
      INTEGER NREG, IREG
      INTEGER JUMP
 
      INCLUDE 'inclk.f'
*--------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS,ICOS4,ifrad
      COMMON/KINEM1/S,W,FACT
      COMMON/CUT001/COSCUT(2,3),ENGYCT(2,3),AMASCT(2),ARESNS(2)
     .,cosopn     
      data icntl/3/
*--------------------------------------------------------------------
      if     (ifrad.eq.1) then
       call  KINEMi(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
      else if(ifrad.eq.2) then
       call  KINEMf(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
      else if(ifrad.eq.3) then
       x3=x(icntl)
       if(x3.lt.0.5d0) then
        x(icntl)=x3*2
        call  KINEMi(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
        yacob=yacob*2
        x(icntl)=x3
       else
        x(icntl)=2-x3*2
        call  KINEMf(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
        yacob=yacob*2
        x(icntl)=x3
       end if
      end if 
*
      return
      end
      SUBROUTINE KINEMi(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 3006-initial state radiation
C   Date      : 1994.12.14
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
      IMPLICIT REAL* 8(A-H,O-Z)
************************************************************************
      INTEGER NEXTRN
      PARAMETER ( MXDIM = 50 )
 
      COMMON / BASE1 / XL(MXDIM),XU(MXDIM),NDIM
      REAL*8  X(MXDIM)
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)
      REAL*8  YACOB
      INTEGER NREG, IREG
      INTEGER JUMP
 
      INCLUDE 'inclk.f'
*--------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS,ICOS4,ifrad
      COMMON/KINEM1/S,W,FACT
      COMMON/CUT001/COSCUT(2,3),ENGYCT(2,3),AMASCT(2),ARESNS(2)
     .,cosopn     
      DIMENSION pw(4),pp1(4),pp2(4),pp3(4)
* BETA FUNCTION
       BETA(Z1,Z2)=SQRT(1-2*(Z1+Z2)+(Z1-Z2)**2)
       data eini/1.d1/
*-----------------------------------------------------------------------
      NREG   =   1
      JUMP   =   0
      YACOB  =   0.D0
      AJACOB=    1
* set integration variables
************
* PHI3     *
************
      IF(NDIM.EQ.5) THEN
       PHI3=X(5)*2*PI
      ELSE
       PHI3=0
      END IF
                 AJACOB = AJACOB*2*PI
* Q2 ; some singularity
      if     (iresns.eq.0)then
       aaa=0
       bbb=0
      else if(iresns.eq.1) then
       aaa=0.5d0
       bbb=aaa
      else if(iresns.eq.2) then
       aaa=0
       bbb=0.5d0
      else if(iresns.eq.3) then
       aaa=1.d0/3.d0
       bbb=2.d0/3.d0
      end if
      if(eini.gt.engyct(2,1)) then
       aaa=0
       bbb=0
      end if
*************
* Q2,engy3  *
*************
*
* 1 <X(4)<aaa  ; 1/Q2
*
      if(x(4).lt.aaa) then
       if(aaa.le.0) goto 999
       x4=x(4)/aaa
       if(x4.gt.1)x4=1
       if(x4.lt.0)x4=0
                 AJACOB = AJACOB/aaa      
       Q2MIN=max((AMASS1(4)+AMASS1(5))**2,s-2*w*engyct(2,1))
      if     (iresns.eq.1)THEN
       Q2MAX=S+AMASS2(3)-2*W*(ENGYCT(1,1)+eini)
      else IF(IRESNS.EQ.3) then
       Q2MAX=(aresns(1)-aresns(2)*3)**2
      end if
      IF(Q2MIN.GE.Q2MAX) GOTO 999
      IF(Q2MIN.le.0    ) GOTO 999
       Q2  = Q2MIN*(Q2MAX/Q2MIN)**X4
                 AJACOB = AJACOB*Q2*LOG(Q2MAX/Q2MIN)

       E3   = (S+AMASS2(3)-Q2)/2.D0/W
       P3   = SQRT( (E3-AMASS1(3))*(E3+AMASS1(3)) )
*
* aaa<X(4)<bbb  ; narrow resonance
*
      else if(x(4).lt.bbb) then
       if(bbb-aaa.le.0) goto 999
       x4=(x(4)-aaa)/(bbb-aaa)
       if(x4.gt.1)x4=1
       if(x4.lt.0)x4=0
                 AJACOB = AJACOB/(bbb-aaa)   
       if     (iresns.eq.2) THEN
        Q2MIN=max((AMASS1(4)+AMASS1(5))**2,s-2*w*engyct(2,1))
       else if(iresns.eq.3) then
        Q2MIN=max((AMASS1(4)+AMASS1(5))**2,
     .            (aresns(1)-aresns(2)*3)**2)
       end if
       Q2MAX=S+AMASS2(3)-2*W*(ENGYCT(1,1)+eini)
       if(q2max.lt.q2min) goto 999                     
       AM    = ARESNS(1)
       AM2   =AM*AM
       AMG   =ARESNS(1)*ARESNS(2)
       THEMIN=ATAN((Q2MIN-AM2)/AMG)
       THEMAX=ATAN((Q2MAX-AM2)/AMG)
       THE   =THEMIN+(THEMAX-THEMIN)*X4
       Q2    =AMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+AMG**2)/AMG
     
       E3   = (S+AMASS2(3)-Q2)/2.D0/W
       P3   = SQRT( (E3-AMASS1(3))*(E3+AMASS1(3)) )
*
* bbb<X(4)< 1  ; soft photon
*
      else
       x4=(1-x(4))/(1-bbb)
       if(x4.gt.1)x4=1
       if(x4.lt.0)x4=0
                 AJACOB = AJACOB/(1-bbb)   

        e3min=ENGYCT(1,1)
       if(iresns.eq.0) THEN
        E3MAX=MIN(ENGYCT(2,1)
     . ,(S+AMASS2(3)-(AMASS1(4)+AMASS1(5))**2)/2.D0/W)
       else 
        E3MAX=min((S+AMASS2(3)-(AMASS1(4)+AMASS1(5))**2)/2.D0/W
     .,engyct(1,1)+eini,engyct(2,1))
       end if
       E3=E3MIN*(E3MAX/E3MIN)**X4
                 AJACOB = AJACOB*E3*log(E3max/E3min)*2.D0*W
       P3   = SQRT( (E3-AMASS1(3))*(E3+AMASS1(3)) ) 
       q2=s+amass2(3)-2*w*e3
      end if
*************
* ENERGY1   *
*************
       E1   = (S+AMASS2(1)-AMASS2(2))/2.D0/W
       P1   = SQRT( (E1-AMASS1(1))*(E1+AMASS1(1)) )
*************
* ENERGY2   *
*************
       E2   = (S+AMASS2(2)-AMASS2(1))/2.D0/W
*************
* C0S(the3) *
*************
       XI   = (E1+P1)/AMASS1(1)
       ABDB = 1+AMASS2(1)/P1/(E1+P1)
       TEMAX= (ABDB+COSCUT(2,1))/(ABDB-COSCUT(2,1))
       TEMIN= (ABDB+COSCUT(1,1))/(ABDB-COSCUT(1,1))
       YMAX = (LOG(TEMAX)/LOG(XI)+2)/4.D0
       YMIN = (LOG(TEMIN)/LOG(XI)+2)/4.D0
       if(coscut(1,1).lt.-1.d0+1.d-10)ymin=0
       if(coscut(2,1).gt. 1.d0-1.d-10)ymax=1
       Y    = YMIN+(YMAX-YMIN)*X(3)
                 AJACOB = AJACOB*(YMAX-YMIN)
       TETA = XI**(4*Y-2)
       COS3 = ABDB*(TETA-1)/(TETA+1)
       IF(ABS(COS3).GT.1) COS3=SIGN(1.D0,COS3)
       SIN3 = SQRT( (1-COS3)*(1+COS3) )
       D1   = 4*E3*E1/(TETA+1)
       D2   = TETA*D1
       D13  = 4   *E1/(TETA+1)
       D23  = TETA*D13
                 AJACOB = AJACOB*LOG(XI)/2.D0/E1/P1
     .*                   D13*D23
* Set four-vectors
*Particle 1
      PE(1,1) = 0
      PE(2,1) = 0
      PE(3,1) = P1
      PE(4,1) = E1
 
*Particle 2
      PE(1,2) = 0
      PE(2,2) = 0
      PE(3,2) =-P1
      PE(4,2) = E2
 
*Particle 3
      PE(1,3) = P3*SIN3*COS(PHI3)
      PE(2,3) = P3*SIN3*SIN(PHI3)
      PE(3,3) = P3*COS3
      PE(4,3) = E3
* to 4-5 CM frame from 1-2 CM frame (Lab-frame)
      pw(1)=-pe(1,3)
      pw(2)=-pe(2,3)
      pw(3)=-pe(3,3)
      pw(4)=sqrt( q2+p3**2 )
* Initial state particles after emiting photon
      if(cos3.gt.0) then
       pp3(1)=pe(1,2)
       pp3(2)=pe(2,2)
       pp3(3)=pe(3,2)
       pp3(4)=pe(4,2)
      else
       pp3(1)=pe(1,1)
       pp3(2)=pe(2,1)
       pp3(3)=pe(3,1)
       pp3(4)=pe(4,1)
      end if
      call labtok(pp3,pw,pe(1,1),pe(1,2), pp1,pp2)
************************
* PHI4 in 4-5 CM frame *
************************
      PHI4=X(2)*2*PI+PHI3
                 AJACOB = AJACOB*2*PI
 
************************
* COS4 in 4-5 CM frame *
************************
      if(cos3.gt.0) then
       aE1      = pp2(4)
       aP1      = pp2(3)
       aE3      = (q2+AMASS2(5)-AMASS2(4))/2.D0/sqrt(q2)
       aP3      = SQRT( (aE3-AMASS1(5))*(aE3+AMASS1(5)) )      
       aE4      = (q2+AMASS2(4)-AMASS2(5))/2.D0/sqrt(q2)
       aP4      = aP3
       amas21   = amass2(2)
       amas23   = amass2(5)
       amas24   = amass2(4)
      else
       aE1      = pp1(4)
       aP1      = pp1(3)
       aE3      = (q2+AMASS2(4)-AMASS2(5))/2.D0/sqrt(q2)
       aP3      = SQRT( (aE3-AMASS1(4))*(aE3+AMASS1(4)) )      
       aE4      = (q2+AMASS2(5)-AMASS2(4))/2.D0/sqrt(q2)
       aP4      = aP3
       amas21   = amass2(1)
       amas23   = amass2(4)
       amas24   = amass2(5)
      end if
*
      IF     (ICOS4.EQ.0) THEN
       COS4=-1 + 2*X(1)
       sin4=sqrt( (1-cos4)*(1+cos4) )
                 AJACOB = AJACOB*2
      ELSE IF(ICOS4.EQ.1) THEN
        x1=x(1)
        dmin=    2*(ae1*ae3-ap1*ap3)-amas23
        dmax=    2*(ae1*ae3+ap1*ap3)-amas23
        if(dmax.lt.dmin) goto 999
        if(dmin.le.0) goto 999
        d=dmin*(dmax/dmin)**x1
        cos4=(1+amas21/ap1/(ae1+ap1))*(1+amas23/ap3/(ae3+ap3))
     .       -(d+amas23)/2.d0/ap1/ap3
        if(abs(cos4).gt.1) cos4=sign(1.d0,cos4)
        sin4=sqrt( (1-cos4)*(1+cos4) )
                  AJACOB=AJACOB*d*log(dmax/dmin)/ap1/ap3/2.d0
      ELSE IF(ICOS4.EQ.2) THEN
       if(x(1).le.0.5d0) then
        x1=x(1)*2
       else
        x1=2-x(1)*2
       end if
       if((cos3.le.0 .and. x(1).le.0.5d0)
     ..or.(cos3.gt.0 .and. x(1).gt.0.5d0)) then
        dmin=    2*(ae1*ae3-ap1*ap3)-amas23
        dmax=    2*(ae1*ae3        )-amas23
        if(dmin.le.0) goto 999
        d=dmin*(dmax/dmin)**x1
        cos4=(1+amas21/pe1/(ae1+ap1))*(1+amas23/ap3/(ae3+ap3))
     .       -(d+amas23)/2.d0/ap1/ap3
        if(abs(cos4).gt.1) cos4=sign(1.d0,cos4)
        sin4=sqrt( (1-cos4)*(1+cos4) )
                   AJACOB=AJACOB*d*log(dmax/dmin)/ap1/ap3
       else
        dmin=    2*(ae1*ae4-ap1*ap4)-amas24
        dmax=    2*(ae1*ae4        )-amas24
        if(dmin.le.0) goto 999
        d=dmin*(dmax/dmin)**x1
        cos4=-(1+amas21/ap1/(ae1+ap1))*(1+amas24/ap4/(ae4+ap4))
     .       +(d+amas24)/2.d0/ap1/ap4
        if(abs(cos4).gt.1) cos4=sign(1.d0,cos4)
        sin4=sqrt( (1-cos4)*(1+cos4) )
                  AJACOB=AJACOB*d*log(dmax/dmin)/ap1/ap4
      end if
      ELSE
       GOTO 999
      END IF
* Set four-vectors
 
*Particle 4 in 4-5 CM frame
      E4      = (Q2+AMASS2(4)-AMASS2(5))/2.D0/SQRT(Q2)
      P4      = SQRT( (E4-AMASS1(4))*(E4+AMASS1(4)) )
      PE(1,4) = P4*SIN4*COS(PHI4)
      PE(2,4) = P4*SIN4*SIN(PHI4)
      PE(3,4) = P4*COS4
      PE(4,4) = E4
 
*Particle 5 in 4-5 CM frame
      E5      = (Q2+AMASS2(5)-AMASS2(4))/2.D0/SQRT(Q2)
      PE(1,5) =-PE(1,4)
      PE(2,5) =-PE(2,4)
      PE(3,5) =-PE(3,4)
      PE(4,5) = E5

      if(cos3.gt.0) then
       pe(1,4)=-pe(1,4)
       pe(2,4)=-pe(2,4)
       pe(3,4)=-pe(3,4)

       pe(1,5)=-pe(1,5)
       pe(2,5)=-pe(2,5)
       pe(3,5)=-pe(3,5)
      end if
* from 4-5 CM frame to 1-2 CM frame (Lab-frame)
      call ktolab(pp3,pw,pe(1,4),pe(1,5), pe(1,4),pe(1,5))
* cuts in Lab-frame
      if(pe(4,3).gt.pe(4,4)) goto 999
      if(pe(4,4).gt.pe(4,5)) goto 999
      COS4LB=PE(3,4)/SQRT(PE(1,4)**2+PE(2,4)**2+PE(3,4)**2)
      IF(COS4LB.LT.COSCUT(1,2) .OR. COS4LB.GT.COSCUT(2,2)) GOTO 999
      COS5LB=PE(3,5)/SQRT(PE(1,5)**2+PE(2,5)**2+PE(3,5)**2)
      IF(COS5LB.LT.COSCUT(1,3) .OR. COS5LB.GT.COSCUT(2,3)) GOTO 999
      IF(PE(4,3).LT.ENGYCT(1,1).OR.PE(4,3).GT.ENGYCT(2,1)) GOTO 999
      IF(PE(4,4).LT.ENGYCT(1,2).OR.PE(4,4).GT.ENGYCT(2,2)) GOTO 999
      IF(PE(4,5).LT.ENGYCT(1,3).OR.PE(4,5).GT.ENGYCT(2,3)) GOTO 999
      cosa1=pe(3,3)/sqrt(pe(1,3)**2+pe(2,3)**2+pe(3,3)**2)
      cosa4=(pe(1,3)*pe(1,4)+pe(2,3)*pe(2,4)+pe(3,3)*pe(3,4))
     ./ sqrt(pe(1,3)*pe(1,3)+pe(2,3)*pe(2,3)+pe(3,3)*pe(3,3)) 
     ./ sqrt(pe(1,4)*pe(1,4)+pe(2,4)*pe(2,4)+pe(3,4)*pe(3,4)) 
      cosa5=(pe(1,3)*pe(1,5)+pe(2,3)*pe(2,5)+pe(3,3)*pe(3,5))
     ./ sqrt(pe(1,3)*pe(1,3)+pe(2,3)*pe(2,3)+pe(3,3)*pe(3,3)) 
     ./ sqrt(pe(1,5)*pe(1,5)+pe(2,5)*pe(2,5)+pe(3,5)*pe(3,5)) 
      if(cosa4.gt.cosopn) goto 999
      if(cosa5.gt.cosopn) goto 999
      if(ifrad.eq.3 .and.
     .(abs(cosa1).lt.cosa4 .or. abs(cosa1).lt.cosa5))goto 999     
*Set invariants
      PP(1,1) = AMASS2(1)
      PP(1,2) = (S-AMASS2(1)-AMASS2(2))/2.D0
      PP(1,3) = D1/2.D0
      PP(1,4) = PE(4,1)*PE(4,4)-PE(3,1)*PE(3,4)
     .         -PE(1,1)*PE(1,4)-PE(2,1)*PE(2,4)
      PP(1,5) = PE(4,1)*PE(4,5)-PE(3,1)*PE(3,5)
     .         -PE(1,1)*PE(1,5)-PE(2,1)*PE(2,5)
 
      PP(2,1) = PP(1,2)
      PP(2,2) = AMASS2(2)
      PP(2,3) = D2/2.D0
      PP(2,4) = PE(4,2)*PE(4,4)-PE(3,2)*PE(3,4)
     .         -PE(1,2)*PE(1,4)-PE(2,2)*PE(2,4)
      PP(2,5) = PE(4,2)*PE(4,5)-PE(3,2)*PE(3,5)
     .         -PE(1,2)*PE(1,5)-PE(2,2)*PE(2,5)
 
      PP(3,1) = PP(1,3)
      PP(3,2) = PP(2,3)
      PP(3,3) = AMASS2(3)
      PP(3,4) = PE(4,3)*PE(4,4)-PE(3,3)*PE(3,4)
     .         -PE(1,3)*PE(1,4)-PE(2,3)*PE(2,4)
      PP(3,5) = PE(4,3)*PE(4,5)-PE(3,3)*PE(3,5)
     .         -PE(1,3)*PE(1,5)-PE(2,3)*PE(2,5)
 
      PP(4,1) = PP(1,4)
      PP(4,2) = PP(2,4)
      PP(4,3) = PP(3,4)
      PP(4,4) = AMASS2(4)
      PP(4,5) = (Q2-AMASS2(4)-AMASS2(5))/2.D0
 
      PP(5,1) = PP(1,5)
      PP(5,2) = PP(2,5)
      PP(5,3) = PP(3,5)
      PP(5,4) = PP(4,5)
      PP(5,5) = AMASS2(5)
*Set jacobian
      YACOB=FACT*AJACOB
     ./(2*PI)/(32*PI2)/(32*PI2)
     .*BETA(Q2       /S ,AMASS2(3)/S )
     .*BETA(AMASS2(4)/Q2,AMASS2(5)/Q2)

c     write(6,*)' P1 ',(pe(k,1),k=1,4)
c     write(6,*)' P2 ',(pe(k,2),k=1,4)
c     write(6,*)' P3 ',(pe(k,3),k=1,4)
c     write(6,*)' P4 ',(pe(k,4),k=1,4)
c     write(6,*)' P5 ',(pe(k,5),k=1,4)
c     write(6,*)'E init  ',pe(4,1)+pe(4,2) 
c     write(6,*)'E final ',pe(4,3)+pe(4,4)+pe(4,5) 
c     write(6,*)'Px ',pe(1,3)+pe(1,4)+pe(1,5) 
c     write(6,*)'Py ',pe(2,3)+pe(2,4)+pe(2,5) 
c     write(6,*)'Pz ',pe(3,3)+pe(3,4)+pe(3,5)
c     write(6,*)' mass3 in  ',amass2(3)
c     write(6,*)' mass4 in  ',amass2(4)      
c     write(6,*)' mass5 in  ',amass2(5)
c     write(6,*)' mass3 out '
c    .,(pe(4,3)**2-pe(1,3)**2-pe(2,3)**2-pe(3,3)**2)
c     write(6,*)' mass4 out '
c    .,(pe(4,4)**2-pe(1,4)**2-pe(2,4)**2-pe(3,4)**2)
c     write(6,*)' mass5 out '
c    .,(pe(4,5)**2-pe(1,5)**2-pe(2,5)**2-pe(3,5)**2)
      RETURN
999   CONTINUE
      JUMP=1
      YACOB=0
      RETURN
      END
      SUBROUTINE KINEMf(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
 
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 3006-final radiation
C   Date      : 1994.12.14
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
      IMPLICIT REAL* 8(A-H,O-Z)
************************************************************************
      INTEGER NEXTRN
      PARAMETER ( MXDIM = 50 )
 
      COMMON / BASE1 / XL(MXDIM),XU(MXDIM),NDIM
      REAL*8  X(MXDIM)
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)
      REAL*8  YACOB
      INTEGER NREG, IREG
      INTEGER JUMP
 
      INCLUDE 'inclk.f'
*--------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS,ICOS4,ifrad
      COMMON/KINEM1/S,W,FACT
      COMMON/CUT001/COSCUT(2,3),ENGYCT(2,3),AMASCT(2),ARESNS(2)
     .,cosopn     
      real*8 pa(4),rl2a(3,3),ra2l(3,3)
      data nnn/0/
* BETA FUNCTION
       BETA(Z1,Z2)=SQRT(1-2*(Z1+Z2)+(Z1-Z2)**2)
*-----------------------------------------------------------------------
      NREG   =   1
      JUMP   =   0
      YACOB  =   0.D0
      AJACOB=    1
* Set integration variables
      if(x(3).lt.0.5d0) then
       x3=x(3)*2
       ia=4
       io=5
      else
       x3=2-x(3)*2
       ia=5
       io=4
      end if       
      temp13=amass1(3)
      temp23=amass2(3)
      temp14=amass1(4)
      temp24=amass2(4)
      temp15=amass1(5)
      temp25=amass2(5)
                 AJACOB=AJACOB*2
********
* cosa *
********
       egammn=engyct(1,1)
       egammx=min(engyct(2,1)
     .,  (s+amass2(3)-(amass1(4)+amass1(5))**2)/2.d0/w )
       egam=egammn*(egammx/egammn)**x(4)
                  AJACOB=AJACOB*egam*log(egammx/egammn)
*****************
* Q2=(Pi+Pa)**2 *
*****************
       aaa=1-2*egam/w
       bbb=2*egam**2-egam/w
     .  *(w-amass1(io))*(w+amass1(io))+(egam-1)*amass2(ia)
       ccc=amass2(ia)
     .*(amass2(ia)+2*egam/w*(w-amass1(io))*(w+amass1(io)))
       rd=sqrt(bbb*bbb-aaa*ccc)
       ee1=(-bbb+rd)/aaa
       ee2=ccc/(-bbb+rd)
       
       q2min=max(ee2,amass2(ia))
       q2max=min(ee1,(w-amass1(io))**2)
       if(q2max.lt.q2min) goto 999
       if(q2min.le.0) goto 999
       q2   =q2min*(q2max/q2min)**x3 
                 AJACOB=AJACOB*q2*log(q2max/q2min) 
                 AJACOB=AJACOB/(32*pi2)/(2*pi)*beta(amass2(ia)/q2,0.d0)
       eac=(q2+amass2(ia))/2.d0/sqrt(q2)
       pac=(q2-amass2(ia))/2.d0/sqrt(q2)
       eml=(s+q2-amass2(io))/2.d0/w
       pml=sqrt( (eml-sqrt(q2))*(eml+sqrt(q2)) )
                  AJACOB=AJACOB*sqrt(q2)/pac/pml                 
       cosa=((1+q2/pml/(eml+pml))*((eml+pml)*egam
     ./pac-sqrt(q2))-sqrt(q2))*pac/(eml+pml)/egam
       if(abs(cosa).gt.1) goto 999
       sina=sqrt( (1-cosa)*(1+cosa) )


       temp1a    =amass1(ia)
       temp2a    =amass2(ia)
       
       amass1(ia)=sqrt(q2)
       amass2(ia)=     q2
        
       amass1(3)=amass1(4)
       amass2(3)=amass2(4)
       amass1(4)=amass1(5)
       amass2(4)=amass2(5)
************
* PHI      *
************
      IF(NDIM.EQ.5) THEN
       PHI3=X(5)*2*PI
      ELSE
       PHI3=0
      END IF
                 AJACOB = AJACOB*2*PI
************
* PHIa     *
************
       phia=2*pi*x(2) + phi3
                  AJACOB=AJACOB*2*pi
************
* C0S(the) *
************
      E1      = (S+AMASS2(1)-AMASS2(2))/2.D0/W
      P1      = SQRT( (E1-AMASS1(1))*(E1+AMASS1(1)) )
      E2      = (S+AMASS2(2)-AMASS2(1))/2.D0/W
      P2      = P1
      E3      = (AMASS2(3)-AMASS2(4)+s)/2.D0/W
      P3      = SQRT( (E3-AMASS1(3))*(E3+AMASS1(3)) )      
      E4      = (AMASS2(4)-AMASS2(3)+s)/2.D0/W
      P4      = P3

      IF     (ICOS4.EQ.0) THEN
       COS3=-1+2*x(1)
                 AJACOB = AJACOB*2
       pp13=E1*E3-P1*P3*COS3
       pp14=E1*E4+P1*P4*COS3
       pp23=E2*E3+P2*P3*COS3
       pp24=E2*E4-P2*P4*COS3
      ELSE IF(ICOS4.EQ.1) THEN
        x1=x(1)
        if(ifrad.eq.2) then
         dmin=    2*(e1*e3-p1*p3*coscut(2,ia-3))-amass2(3)
         dmax=    2*(e1*e3-p1*p3*coscut(1,ia-3))-amass2(3)
        else
         dmin=    2*(e1*e3-p1*p3)-amass2(3)
         dmax=    2*(e1*e3+p1*p3)-amass2(3)
        end if
        if(dmax.lt.dmin) goto 999
        if(dmin.le.0) goto 999
        d=dmin*(dmax/dmin)**x1
        cos3=(1+amass2(1)/p1/(e1+p1))*(1+amass2(3)/p3/(e3+p3))
     .       -(d+amass2(3))/2.d0/p1/p3
                  AJACOB=AJACOB*d*log(dmax/dmin)/p1/p3/2.d0
*        
        pp13=(d+amass2(3))/2.d0
        pp14=(s+amass2(1)-amass2(2)-amass2(3)-d)/2.d0
        pp23=(s-amass2(4)-d)/2.d0
        pp24=(amass2(2)+amass2(4)-amass2(1)+d)/2.d0
*
      ELSE IF(ICOS4.EQ.2) THEN
       if(x(1).le.0.5d0) then
        x1=x(1)*2
        dmin=    2*(e1*e3-p1*p3)-amass2(3)
        dmax=    2*(e1*e3      )-amass2(3)
        if(dmin.le.0) goto 999
        d=dmin*(dmax/dmin)**x1
        cos3=(1+amass2(1)/p1/(e1+p1))*(1+amass2(3)/p3/(e3+p3))
     .       -(d+amass2(3))/2.d0/p1/p3
                   AJACOB=AJACOB*d*log(dmax/dmin)/p1/p3
*        
        pp13=(d+amass2(3))/2.d0
        pp14=(s+amass2(1)-amass2(2)-amass2(3)-d)/2.d0
        pp23=(s-amass2(4)-d)/2.d0
        pp24=(amass2(2)+amass2(4)-amass2(1)+d)/2.d0
*                                  
       else
        x1=x(1)*2-1
        dmin=    2*(e1*e4-p1*p4)-amass2(4)
        dmax=    2*(e1*e4      )-amass2(4)
        if(dmax.lt.dmin) goto 999
        if(dmin.le.0) goto 999
        d=dmin*(dmax/dmin)**x1
        cos3=-(1+amass2(1)/p1/(e1+p1))*(1+amass2(4)/p4/(e4+p4))
     .        +(d+amass2(4))/2.d0/p1/p4
                  AJACOB=AJACOB*d*log(dmax/dmin)/p1/p4
*        
        pp14=(d+amass2(4))/2.d0
        pp13=(s+amass2(1)-amass2(2)-amass2(4)-d)/2.d0
        pp24=(s-amass2(3)-d)/2.d0
        pp23=(amass2(2)+amass2(3)-amass2(1)+d)/2.d0
*                  
      end if
      ELSE
       GOTO 999
      END IF
      if(abs(cos3).gt.1) goto 999
      SIN3=SQRT( (1-COS3)*(1+COS3) )
 
* Set four-vectors
*Particle 1
      PE(1,1) = 0
      PE(2,1) = 0
      PE(3,1) = P1
      PE(4,1) = E1
 
*Particle 2
      PE(1,2) = 0
      PE(2,2) = 0
      PE(3,2) =-P2
      PE(4,2) = E2
 
*Particle w/ and w/o photon
      if(ia.eq.4) then
      Pa(1) = P3*SIN3*COS(PHI3)
      Pa(2) = P3*SIN3*SIN(PHI3)
      Pa(3) = P3*COS3
      Pa(4) = E3

      PE(1,io) =-P4*SIN3*COS(PHI3)
      PE(2,io) =-P4*SIN3*SIN(PHI3)
      PE(3,io) =-P4*COS3
      PE(4,io) = E4
      else
      Pa(1) =-P4*SIN3*COS(PHI3)
      Pa(2) =-P4*SIN3*SIN(PHI3)
      Pa(3) =-P4*COS3
      Pa(4) = E4

      PE(1,io) = P3*SIN3*COS(PHI3)
      PE(2,io) = P3*SIN3*SIN(PHI3)
      PE(3,io) = P3*COS3
      PE(4,io) = E3
      end if
*Particle photon and his mother
      pe(1,3)= egam*sina*cos(phia)
      pe(2,3)= egam*sina*sin(phia)
      pe(3,3)= egam*cosa
      pe(4,3)= egam      
      
*pa-->lab frame
      call rotmtx(pa, rl2a)
      call minvr2(rl2a, ra2l)
      call mvmult(ra2l,pe(1,3), pe(1,3))
     
      pe(1,ia)= -pe(1,3)-pe(1,io) 
      pe(2,ia)= -pe(2,3)-pe(2,io) 
      pe(3,ia)= -pe(3,3)-pe(3,io) 
      pe(4,ia)=w-pe(4,3)-pe(4,io) 
*Set invariants
      PP(1,1) = AMASS2(1)
      PP(1,2) = (S-AMASS2(1)-AMASS2(2))/2.D0
      PP(1,3) = pe(4,1)*pe(4,3)-pe(3,1)*pe(3,3)
      PP(1,4) = pp13
      PP(1,5) = pp14       
      PP(1,ia) = pe(4,1)*pe(4,ia)-pe(3,1)*pe(3,ia)
  
      PP(2,1) = PP(1,2)
      PP(2,2) = AMASS2(2)
      PP(2,3) = pe(4,2)*pe(4,3)-pe(3,2)*pe(3,3)     
      PP(2,4) = pp23
      PP(2,5) = pp24
      PP(2,ia) = pe(4,2)*pe(4,ia)-pe(3,2)*pe(3,ia)      
 
      PP(3,1) = PP(1,3)
      PP(3,2) = PP(2,3)
      PP(3,3) = temp23
      PP(3,4) = pe(4,3)*pe(4,4)-pe(3,3)*pe(3,4)
     .                         -pe(2,3)*pe(2,4)
     .                         -pe(1,3)*pe(1,4)
      PP(3,5) = pe(4,3)*pe(4,5)-pe(3,3)*pe(3,5)
     .                         -pe(2,3)*pe(2,5)
     .                         -pe(1,3)*pe(1,5)     
      pp(3,ia)=(q2-temp23-temp2a)/2.d0 
      
      PP(4,1) = PP(1,4)
      PP(4,2) = PP(2,4)
      PP(4,3) = PP(3,4)
      PP(4,4) = temp24 
      PP(4,5) = pe(4,4)*pe(4,5)-pe(3,4)*pe(3,5)
     .                         -pe(2,4)*pe(2,5)
     .                         -pe(1,4)*pe(1,5)     

      PP(5,1) = PP(1,5)
      PP(5,2) = PP(2,5)
      PP(5,3) = PP(3,5)
      PP(5,4) = PP(4,5)
      PP(5,5) = temp25
* cuts
      if(pe(4,3).gt.pe(4,4)) goto 999
      if(pe(4,4).gt.pe(4,5)) goto 999
      cos13=(pe(1,1)*pe(1,3)+pe(2,1)*pe(2,3)+pe(3,1)*pe(3,3))
     ./ sqrt(pe(1,1)*pe(1,1)+pe(2,1)*pe(2,1)+pe(3,1)*pe(3,1))      
     ./ sqrt(pe(1,3)*pe(1,3)+pe(2,3)*pe(2,3)+pe(3,3)*pe(3,3))
      if(cos13.lt.coscut(1,1) .or. cos13.gt.coscut(2,1) ) goto 999
      cos14=(pe(1,1)*pe(1,4)+pe(2,1)*pe(2,4)+pe(3,1)*pe(3,4))
     ./ sqrt(pe(1,1)*pe(1,1)+pe(2,1)*pe(2,1)+pe(3,1)*pe(3,1))      
     ./ sqrt(pe(1,4)*pe(1,4)+pe(2,4)*pe(2,4)+pe(3,4)*pe(3,4))
      if(cos14.lt.coscut(1,2) .or. cos14.gt.coscut(2,2) ) goto 999
      cos15=(pe(1,1)*pe(1,5)+pe(2,1)*pe(2,5)+pe(3,1)*pe(3,5))
     ./ sqrt(pe(1,1)*pe(1,1)+pe(2,1)*pe(2,1)+pe(3,1)*pe(3,1))      
     ./ sqrt(pe(1,5)*pe(1,5)+pe(2,5)*pe(2,5)+pe(3,5)*pe(3,5))
      if(cos15.lt.coscut(1,3) .or. cos15.gt.coscut(2,3) ) goto 999
      if(pe(4,3).lt.engyct(1,1).or.pe(4,3).gt.engyct(2,1)) goto 999
      if(pe(4,4).lt.engyct(1,2).or.pe(4,4).gt.engyct(2,2)) goto 999
      if(pe(4,5).lt.engyct(1,3).or.pe(4,5).gt.engyct(2,3)) goto 999
      
      cos3a=(pe(1,ia)*pe(1, 3)+pe(2,ia)*pe(2, 3)+pe(3,ia)*pe(3, 3))
     ./ sqrt(pe(1,ia)*pe(1,ia)+pe(2,ia)*pe(2,ia)+pe(3,ia)*pe(3,ia))
     ./ sqrt(pe(1, 3)*pe(1, 3)+pe(2, 3)*pe(2, 3)+pe(3, 3)*pe(3, 3))
     
      cos3o=(pe(1,io)*pe(1, 3)+pe(2,io)*pe(2, 3)+pe(3,io)*pe(3, 3))
     ./ sqrt(pe(1,io)*pe(1,io)+pe(2,io)*pe(2,io)+pe(3,io)*pe(3,io))
     ./ sqrt(pe(1, 3)*pe(1, 3)+pe(2, 3)*pe(2, 3)+pe(3, 3)*pe(3, 3))
      if(cos3a.gt.cosopn) goto 999
      if(cos3o.gt.cosopn) goto 999
      if(ifrad.eq.3 .and.  cos3a.lt.abs(cos13) ) goto 999
      if(cos3a.lt.cos3o)goto 999 
           
      amass1(3)=temp13
      amass2(3)=temp23
      amass1(4)=temp14
      amass2(4)=temp24 
      amass1(5)=temp15
      amass2(5)=temp25
*Set jacobian
      YACOB=FACT*AJACOB
     ./32.D0/PI2
     .*BETA(AMASS2(io)/S,q2/S)
c     write(6,*)' P1 ',(pe(k,1),k=1,4)
c     write(6,*)' P2 ',(pe(k,2),k=1,4)
c     write(6,*)' P3 ',(pe(k,3),k=1,4)
c     write(6,*)' P4 ',(pe(k,4),k=1,4)
c     write(6,*)' P5 ',(pe(k,5),k=1,4)
c     write(6,*)'E init  ',pe(4,1)+pe(4,2) 
c     write(6,*)'E final ',pe(4,3)+pe(4,4)+pe(4,5) 
c     write(6,*)'Px ',pe(1,3)+pe(1,4)+pe(1,5) 
c     write(6,*)'Py ',pe(2,3)+pe(2,4)+pe(2,5) 
c     write(6,*)'Pz ',pe(3,3)+pe(3,4)+pe(3,5)
c     write(6,*)' mass3 in  ',amass2(3)
c     write(6,*)' mass4 in  ',amass2(4)      
c     write(6,*)' mass5 in  ',amass2(5)
c     write(6,*)' mass3 out '
c    .,(pe(4,3)-pe(3,3))*(pe(4,3)+pe(3,3))-pe(1,3)**2-pe(2,3)**2
c     write(6,*)' mass4 out '
c    .,(pe(4,4)-pe(3,4))*(pe(4,4)+pe(3,4))-pe(1,4)**2-pe(2,4)**2
c     write(6,*)' mass5 out '
c    .,(pe(4,5)-pe(3,5))*(pe(4,5)+pe(3,5))-pe(1,5)**2-pe(2,5)**2
      return
999   continue          
      amass1(3)=temp13
      amass2(3)=temp23
      amass1(4)=temp14
      amass2(4)=temp24
      amass1(5)=temp15
      amass2(5)=temp25
      jump=1 
      RETURN
      END
