      SUBROUTINE KINEM(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
 
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 4001
C   Date      : 1994.04.30
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
      IMPLICIT REAL* 8(A-H,O-Z)
************************************************************************
      INTEGER NEXTRN
      PARAMETER ( MXDIM = 50 )
 
      COMMON / BASE1 / XL(MXDIM),XU(MXDIM),NDIM
      REAL*8  X(MXDIM)
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)
      REAL*8  YACOB
      INTEGER NREG, IREG
      INTEGER JUMP
 
      INCLUDE 'inclk.f'
*--------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS(2),idummy(2),ICOSQ3
      COMMON/KINEM1/S,W,FACT
      COMMON/CUT001/COSCUT(2,4),ENGYCT(2,4),AMASCT(2,2),ARESNS(2,2)
      DIMENSION Q1(4),Q2(4)
      BETA(Z1,Z2)=SQRT(1-2*(Z1+Z2)+(Z1-Z2)**2)
*-----------------------------------------------------------------------
      NREG   =   1
      JUMP   =   0
      YACOB  =   0.D0
      AJACOB=    1
* Set integration variables
      E1      = (S+AMASS2(1)-AMASS2(2))/2.D0/W
      P1      = SQRT( (E1-AMASS1(1))*(E1+AMASS1(1)) )
      E2      = (S+AMASS2(2)-AMASS2(1))/2.D0/W
*******
* Q12 *
*******
       Q12MIN=MAX((  AMASS1(3)+AMASS1(4))**2,AMASCT(1,1)**2)
       Q12MAX=MIN((W-AMASS1(5)-AMASS1(6))**2,AMASCT(2,1)**2)
       IF     (IRESNS(1).EQ. 0) THEN
        Q12=Q12MIN+(Q12MAX-Q12MIN)*X(1)
                      AJACOB=AJACOB*(Q12MAX-Q12MIN)
       ELSE IF(IRESNS(1).EQ. 1) THEN
        AM    = ARESNS(1,1)
        AM2   =AM*AM
        AMG   =ARESNS(1,1)*ARESNS(2,1)
        THEMIN=ATAN((Q12MIN-AM2)/AMG)
        THEMAX=ATAN((Q12MAX-AM2)/AMG)
        THE   =THEMIN+(THEMAX-THEMIN)*X(1)
        Q12   =AMG*TAN(THE)+AM2
                      AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q12-AM2)**2+AMG**2)/AMG
       ELSE IF(IRESNS(1).EQ.-1) THEN
        Q12=Q12MIN*(Q12MAX/Q12MIN)**X(1)
                      AJACOB=AJACOB*Q12*LOG(Q12MAX/Q12MIN)
       ELSE
        GOTO 999
       END IF
*******
* Q22 *
*******
       Q22MIN=MAX((  AMASS1(5)+AMASS1(6))**2,AMASCT(1,2)**2)
       Q22MAX=MIN((W-     SQRT(Q12)     )**2,AMASCT(2,2)**2)
       IF     (IRESNS(2).EQ. 0) THEN
        Q22=Q22MIN+(Q22MAX-Q22MIN)*X(2)
                      AJACOB=AJACOB*(Q22MAX-Q22MIN)
       ELSE IF(IRESNS(2).EQ. 1) THEN
        AM    = ARESNS(1,2)
        AM2   =AM*AM
        AMG   =ARESNS(1,2)*ARESNS(2,2)
        THEMIN=ATAN((Q22MIN-AM2)/AMG)
        THEMAX=ATAN((Q22MAX-AM2)/AMG)
        THE   =THEMIN+(THEMAX-THEMIN)*X(2)
        Q22   =AMG*TAN(THE)+AM2
                      AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q22-AM2)**2+AMG**2)/AMG
       ELSE IF(IRESNS(2).EQ.-1) THEN
        Q22=Q22MIN*(Q22MAX/Q22MIN)**X(2)
                      AJACOB=AJACOB*Q22*LOG(Q22MAX/Q22MIN)
       ELSE
        GOTO 999
       END IF
 
***************
* COS(THE_P3) *
***************
       COS3 = -1+2*X(3)
       SIN3 = SQRT( (1-COS3)*(1+COS3) )
                      AJACOB=AJACOB*2
***************
*   PHI_P3    *
***************
       PHI3 = X(4)*2*PI
                      AJACOB=AJACOB*2*PI
***************
* COS(THE_P5) *
***************
       COS5 = -1+2*X(5)
       SIN5 = SQRT( (1-COS5)*(1+COS5) )
                      AJACOB=AJACOB*2
***************
*   PHI_P5    *
***************
       PHI5 = X(6)*2*PI
                      AJACOB=AJACOB*2*PI
 
***************
* COS(THE_Q1) *
***************
       if    (icosq3.eq.0) then
         COS1 = -1+2*X(7)
                      AJACOB=AJACOB*2
       else if(icosq3.eq.1) then                       
         Eq1   = (S+q12-q22)/2.D0/W
         Pq1   = SQRT( Eq1**2-q12 )
         t1max = -amass2(1)-amass2(3)+2*(e1*eq1+p1*pq1)
         t1min = -amass2(1)-amass2(3)+2*(e1*eq1-p1*pq1)
         t1    = t1min+(t1max-t1min)*x(7) 
                      AJACOB=AJACOB*(t1max-t1min)
     .                       /(2*p1*pq1)
         cos1 = (-t1-amass2(1)-amass2(3)+e1*eq1*2)/2.d0/p1/pq1
        else if(icosq3.eq.2) then                       
         Eq1   = (S+q12-q22)/2.D0/W
         Pq1   = SQRT( Eq1**2-q12 )
         t1max = -amass2(1)-amass2(3)+2*(e1*eq1+p1*pq1)
         t1min = -amass2(1)-amass2(3)+2*(e1*eq1-p1*pq1)
         t1    =  t1min*(t1max/t1min)**x(7)
                      AJACOB=AJACOB*t1*log(t1max/t1min)
     .                       /(2*p1*pq1)
         cos1 = (-t1-amass2(1)-amass2(3)+e1*eq1*2)/2.d0/p1/pq1
       end if
       SIN1 = SQRT( (1-COS1)*(1+COS1) )        
***************
*   PHI_Q1    *
***************
       IF(NDIM.EQ.8) THEN
        PHI1 = X(8)*2*PI
       ELSE
        PHI1 = 0
       END IF
                      AJACOB=AJACOB*2*PI
 
* Set four-vectors
*Particle 1
      PE(1,1) = 0
      PE(2,1) = 0
      PE(3,1) = P1
      PE(4,1) = E1
 
*Particle 2
      PE(1,2) = 0
      PE(2,2) = 0
      PE(3,2) =-P1
      PE(4,2) = E2
 
*Particle 3 in p3-p4 CM frame
      E3      = (Q12+AMASS2(3)-AMASS2(4))/2.D0/SQRT(Q12)
      P3      = SQRT( (E3-AMASS1(3))*(E3+AMASS1(3)) )
      PE(1,3) = P3*SIN3*COS(PHI3)
      PE(2,3) = P3*SIN3*SIN(PHI3)
      PE(3,3) = P3*COS3
      PE(4,3) = E3
 
*Particle 4 in p3-p4 CM frame
      E4      = (Q12+AMASS2(4)-AMASS2(3))/2.D0/SQRT(Q12)
      PE(1,4) =-PE(1,3)
      PE(2,4) =-PE(2,3)
      PE(3,4) =-PE(3,3)
      PE(4,4) = E4
 
*Particle 5 in 5-6 CM frame
      E5      = (Q22+AMASS2(5)-AMASS2(6))/2.D0/SQRT(Q22)
      P5      = SQRT( (E5-AMASS1(5))*(E5+AMASS1(5)) )
      PE(1,5) = P5*SIN5*COS(PHI5)
      PE(2,5) = P5*SIN5*SIN(PHI5)
      PE(3,5) = P5*COS5
      PE(4,5) = E5
 
*Particle 6 in 5-6 CM frame
      E6      = (Q22+AMASS2(6)-AMASS2(5))/2.D0/SQRT(Q22)
      PE(1,6) =-PE(1,5)
      PE(2,6) =-PE(2,5)
      PE(3,6) =-PE(3,5)
      PE(4,6) = E6
 
* Q1 Q2
       EQ1      = (S+Q12-Q22)/2.D0/W
       PQ1      = SQRT( EQ1*EQ1-Q12 )
       Q1(1)= PQ1*SIN1*COS(PHI1)
       Q1(2)= PQ1*SIN1*SIN(PHI1)
       Q1(3)= PQ1*COS1
       Q1(4)= EQ1
 
       EQ2      = (S+Q22-Q12)/2.D0/W
       Q2(1)=-Q1(1)
       Q2(2)=-Q1(2)
       Q2(3)=-Q1(3)
       Q2(4)= EQ2
 
* boost from 3-4 CM frame to 1-2 CM frame (Lab-frame)
      CALL WTOLAB(PE(1,3),PE(1,4),Q1, PE(1,3),PE(1,4))
 
* boost from 5-6 CM frame to 1-2 CM frame (Lab-frame)
      CALL WTOLAB(PE(1,5),PE(1,6),Q2, PE(1,5),PE(1,6))
 
* cuts in Lab-frame
      COS3LB=PE(3,3)/SQRT(PE(1,3)**2+PE(2,3)**2+PE(3,3)**2)
      IF(COS3LB.LT.COSCUT(1,1) .OR. COS3LB.GT.COSCUT(2,1)) GOTO 999
      COS4LB=PE(3,4)/SQRT(PE(1,4)**2+PE(2,4)**2+PE(3,4)**2)
      IF(COS4LB.LT.COSCUT(1,2) .OR. COS4LB.GT.COSCUT(2,2)) GOTO 999
      COS5LB=PE(3,5)/SQRT(PE(1,5)**2+PE(2,5)**2+PE(3,5)**2)
      IF(COS5LB.LT.COSCUT(1,3) .OR. COS5LB.GT.COSCUT(2,3)) GOTO 999
      COS6LB=PE(3,6)/SQRT(PE(1,6)**2+PE(2,6)**2+PE(3,6)**2)
      IF(COS6LB.LT.COSCUT(1,4) .OR. COS6LB.GT.COSCUT(2,4)) GOTO 999
      IF(PE(4,3).LT.ENGYCT(1,1).OR.PE(4,3).GT.ENGYCT(2,1)) GOTO 999
      IF(PE(4,4).LT.ENGYCT(1,2).OR.PE(4,4).GT.ENGYCT(2,2)) GOTO 999
      IF(PE(4,5).LT.ENGYCT(1,3).OR.PE(4,5).GT.ENGYCT(2,3)) GOTO 999
      IF(PE(4,6).LT.ENGYCT(1,4).OR.PE(4,6).GT.ENGYCT(2,4)) GOTO 999
 
*Set invariants
      DO 1 I1=1,6
      DO 1 J1=1,6
1      PP(I1,J1)=PE(4,I1)*PE(4,J1)
     .-          PE(1,I1)*PE(1,J1)
     .-          PE(2,I1)*PE(2,J1)
     .-          PE(3,I1)*PE(3,J1)
      PP(1,2) = (S  -AMASS2(1)-AMASS2(2))/2.D0
      PP(2,1) = (S  -AMASS2(1)-AMASS2(2))/2.D0
      PP(3,4) = (Q12-AMASS2(3)-AMASS2(4))/2.D0
      PP(4,3) = (Q12-AMASS2(3)-AMASS2(4))/2.D0
      PP(5,6) = (Q22-AMASS2(5)-AMASS2(6))/2.D0
      PP(6,5) = (Q22-AMASS2(5)-AMASS2(6))/2.D0
 
*Set jacobian
      YACOB=FACT*AJACOB
     ./(2*PI)**2/(32*PI2)**3
     .*BETA(Q12/S,Q22/S)
     .*BETA(AMASS2(3)/Q12,AMASS2(4)/Q12)
     .*BETA(AMASS2(5)/Q22,AMASS2(6)/Q22)
 
*********** DEBUG **********************************
c     WRITE(6,*)'*****************************'
c     WRITE(6,'(6(4E13.4/))')PE
c     WRITE(6,*)'*****************************'
c     WRITE(6,'(6(6E13.4/))')PP
c     WRITE(6,*)' YACOB ',YACOB
c     WRITE(6,*)' TOTAL ENERGY INI   ',PE(4,1)+PE(4,2)
c     WRITE(6,*)' TOTAL ENERGY FINAL ',PE(4,3)+PE(4,4)
c    .+                                PE(4,5)+PE(4,6)
c     WRITE(6,'(6E13.4)')(SQRT(abs(PP(KKK,KKK))),KKK=1,6)
c     WRITE(6,*)' INITIAL '
c     WRITE(6,*)' PX ',PE(1,1)+PE(1,2)
c     WRITE(6,*)' PY ',PE(2,1)+PE(2,2)
c     WRITE(6,*)' PZ ',PE(3,1)+PE(3,2)
c     WRITE(6,*)' FINAL   '
c     WRITE(6,*)' PX ',PE(1,3)+PE(1,4)+PE(1,5)+PE(1,6)
c     WRITE(6,*)' PY ',PE(2,3)+PE(2,4)+PE(2,5)+PE(2,6)
c     WRITE(6,*)' PZ ',PE(3,3)+PE(3,4)+PE(3,5)+PE(3,6)
*********** DEBUG **********************************
      RETURN
999   CONTINUE
      JUMP=1
      RETURN
      END
