* File kinem.f generated by GRACE Ver. 2.00(02)        1995/08/05/11:26
* 
*          Fortran source code generator
*     (c)copyright 1990-1995 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
      subroutine kinem(nextrn, x, pe, pp, yacob, nreg, ireg, jump) 
************************************************************************
      implicit real* 8(a-h,o-z)
      integer nextrn 
      parameter ( mxdim = 50 )
      real*8  x(mxdim) 
      real*8  pe(4,nextrn), pp(nextrn,nextrn) 
      real*8  yacob 
      integer nreg, ireg 
      integer jump 
      include 'inclk.f'
*=======================================================================
*     This subroutine calculates four momenta of external particles.
*
*     Arguments
*       NEXTRN : input  : The number of external particles.
*       X      : input  : Position in the integration volume.
*       PE     : output : Table of four momenta of external particles.
*       PP     : output : Table of inner products of four momenta
*                         between two external particles.
*       YACOB  : output : Normalization for converting square of
*                         amplitude to cross-section.
*       NREG   : in/out : Maximum number of points in the phase space
*                         which correspond to the integration point.
*                         This value is one for the first call
*                         for the same integration point.
*       IREG   : input  : Counter of calling this subroutine for the
*                         same integration point.
*                         same integration point.
*                         Function FUNC increments this variable,
*                         and call this subroutine while (IREG.LE.NREG)
*       JUMP   : output : If this integration point is rejected,
*                         one should set this variable other than one,
*                         otherwize it should be zero.
*=======================================================================
      jump = 0

*     if(reject this integration point) then
*       jump = 1 
*       return 
*     endif 

*-----------------------------------------------------------------------
*     if(ireg.eq.1) then

*       The first call for this phase space point. 
*       If you want to use this subroutine more than once for the same
*       phase space point, change the value of NREG.
*       This subroutine will be called NREG times.

*     else

*       IREG-th call for this phase space point.

*     endif
*-----------------------------------------------------------------------
*     Table of four momenta.
* PE(I, J) : I = 1 -> X, 2 -> Y, ... 4 -> energy, of J-th particle.
*-----------------------------------------------------------------------
*     1: initial electron mass=amel
      pe( 1, 1) =    
      pe( 2, 1) =    
      pe( 3, 1) =    
      pe( 4, 1) =    
*     2: initial positron mass=amel
      pe( 1, 2) =    
      pe( 2, 2) =    
      pe( 3, 2) =    
      pe( 4, 2) =    
*     3: final photon mass=ama
      pe( 1, 3) =    
      pe( 2, 3) =    
      pe( 3, 3) =    
      pe( 4, 3) =    
*     4: final w-plus mass=amw
      pe( 1, 4) =    
      pe( 2, 4) =    
      pe( 3, 4) =    
      pe( 4, 4) =    
*     5: final w-minus mass=amw
      pe( 1, 5) =    
      pe( 2, 5) =    
      pe( 3, 5) =    
      pe( 4, 5) =    
*-----------------------------------------------------------------------
*     PP(I,J) = inner product between I-th  and J-th particle's momenta
*
*     This table should be calculated from invariants.
*     When it is constructed from PE, it will not so accurate.
*-----------------------------------------------------------------------
      pp( 1, 1) = amass2(1)
      pp( 1, 2) = 
      pp( 1, 3) = 
      pp( 1, 4) = 
      pp( 1, 5) = 
*-----------------------------------------------------------------------
      pp( 2, 1) = pp( 1, 2)
      pp( 2, 2) = amass2(2)
      pp( 2, 3) = 
      pp( 2, 4) = 
      pp( 2, 5) = 
*-----------------------------------------------------------------------
      pp( 3, 1) = pp( 1, 3)
      pp( 3, 2) = pp( 2, 3)
      pp( 3, 3) = amass2(3)
      pp( 3, 4) = 
      pp( 3, 5) = 
*-----------------------------------------------------------------------
      pp( 4, 1) = pp( 1, 4)
      pp( 4, 2) = pp( 2, 4)
      pp( 4, 3) = pp( 3, 4)
      pp( 4, 4) = amass2(4)
      pp( 4, 5) = 
*-----------------------------------------------------------------------
      pp( 5, 1) = pp( 1, 5)
      pp( 5, 2) = pp( 2, 5)
      pp( 5, 3) = pp( 3, 5)
      pp( 5, 4) = pp( 4, 5)
      pp( 5, 5) = amass2(5)
*-----------------------------------------------------------------------
*     Normalization factor
*-----------------------------------------------------------------------

      yacob =

      return
      end
