* File kinit.f generated by GRACE Ver. 2.00(02)        1995/08/05/11:26
* 
*          Fortran source code generator
*     (c)copyright 1990-1995 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
      subroutine kinit
      implicit real*8(a-h,o-z)

*-----------------------------------------------------------------------
*     This subroutine is called by USERIN and initilizes kinematics.
*-----------------------------------------------------------------------
      parameter ( mxdim = 50 )
      common / loop0 / loop
      common / bparm1 / xl(mxdim),xu(mxdim),ndim,nwild,
     &                 ig(mxdim),ncall
      common / bparm2 / acc1,acc2,itmx1,itmx2
      COMMON / kinem1 / s,w,fact
      common / knmflg / knmgvs, knmhst, knmsph, knmisr

      include 'inclk.f'
      character xstr*14, dstr*24
*--- 1. inforamtion of Mass and width 
*     1: initial electron mass=amel
*     2: initial positron mass=amel
*     3: final photon mass=ama
*     4: final w-plus mass=amw
*     5: final w-minus mass=amw
*--- 2. Initialize constants for kinematics.
*        User's parameters, i.e. beam energy, cut-off parameters etc.,
*        can be given here.
*
*     S = (P1+P2)**2
*     W = SQRT(S)
*-----------------------------------------------------------------------
      if( knmgvs .eq. 1 ) then
          w = 200.d0
      endif
      s = w*w


*-----------------------------------------------------------------------
* Following flux factor is for a particle-antiparticle collision
* at s/m**2 >> 1. For an e-gamma collision or low energy interactions
* you should use appropriate formulae.
*-----------------------------------------------------------------------
      vrel = 2.d0
      flux = vrel*s
      fact = gevpb/flux

*--- 3. Set MXREG : the maximum number of values which are returned 
*       by FUNC for one phase space point

      mxreg = 

*=======================================================================
*          Parameters for BASES
*=======================================================================

*--- 4. Dimension of integration.

           ndim  =
           nwild =

*--- 5. Region of integration.

           xl(1)     =
           xu(1)     =
           xl(2)     =
           xu(2)     =
              ...     
           xl(ndim)  =
           xu(ndim)  =
                      
           ig(1)     =
           ig(2)     =
              ...  
           ig(ndim)  =

C          do 10 i  =   1, ndim
C             xl(i)  = 
C             xu(i)  = 
C             ig(i)  = 
C  10      continue 

*--- 6. Numbers of iterations and sampling points / iteration
*       and expected accuracies

           itmx1  =  15
           itmx2  = 100

           acc1   = 0.2d0
           acc2   = 0.01d0

           ncall  = 5000

*--- 7. Set histograms
      if( knmhst .eq. 1 ) then
           nx = 50
           nd = 50

           do 100 i = 1, ndim
              write(xstr, 110) I
  110         format('x(',i2,') Spectrum')
              call xhinit(i, xl(i), xu(i), nx, xstr)
  100      continue

           k = ndim
           do 200 i = 1, ndim - 1
           do 200 j = i + 1, ndim
              write(dstr, 210) i, j
  210         format('x(',i2,')-x(',i2,') Distribution')
              k = k + 1
              call dhinit(k, xl(i),xu(i),nd, xl(j),xu(j),nd,dstr)
  200      continue
      endif

      return
      end
