#include <X11/Xlib.h>
#include <Xm/DrawingA.h>  
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>

#define MXLEN  80
#define MXVTX  100
#define MXLINE 100
#define MXGRF  10000
#define MXEXTV 100
                                                                      /*
************************************************************************
*                                                                      *
*                       Global Variables                               *
*                                                                      *
************************************************************************
========================================================================
          Global variables for the graph information
========================================================================
                                                                      */  
struct vertex {
	int     flag;
	int     cntr_flag;
	char    kind[4];       
	float   x;         
	float   y;   
	int     no_line;   
        }      vtx[MXVTX];

struct vtx_line {
	int  vtxno[10];
        int  lineno[10];
	}    vtxline[MXVTX];

struct int_line {
	int   flag;
	char  kind[4];      
        float x;
        float y;
	int   direct;   
	char  species[4];  
	char  form[4];  
	int   print;  
        }     intline[MXLINE];

struct inl_vtx {
	int vtxno[2];
	}   inlvtx[MXLINE];

int no_vertex, no_line;
float xmax, ymax;
long addr_graph[5][MXGRF]; 
int unitary_guage[MXGRF], no_unitary;
int susy_included[MXGRF];
int vtx_table[6][MXEXTV];
float size[2][MXGRF];
                                                                      /*
========================================================================
          Global variables for Drawing the Feynman Diagrams
========================================================================
                                                                      */
Display *d;;
Window   w0, w1;
Widget toplevel, fm, da, da1; 
Widget pb0, pb1, pb2, pb3, pb4, pb5, pb6; 
Widget pb7, pb8, pb9, pb10;
FILE *psout;
int print_vtx, print_pname, print_graphn, print_final; 
int print_unitary, print_select, select_mode; 
int npage_ps, ps_file, print_ps;
float grymax;
int select_graph[MXGRF], graph_select;
int no_graph, no_select, no_draw;
int flag_rm;
int graph_no;
int First_graph;
int Nx_graph;
int Ny_graph;
int Fin_graph, ngraph;

int size_flag;

                                                                      /*
------------------------------------------------------------------------
         Global parameters for window layout
------------------------------------------------------------------------
                                                                      */
double pi2, xd, yd;
double pi, thetat, rdeg;
float leftmargin, rightmargin, topmargin, bottommargin;
float titlemargin, xbordermargin, ybordermargin;
float grwidth, grheight;
float arrow_size; 
float spiral_width, spiral_length, wave_length, wave_width, dott_length;
float circle_rs, circle_r1, circle_r2;
float xscale, yscale, xoff, yoff;
float xoff_ps, yoff_ps;
float ycenter, xcenter;
unsigned int ngheight, ngwidth;
int nwidth, nheight, nsize;
int xch[MXVTX+MXLINE], ych[MXVTX+MXLINE]; 
int wch[MXVTX+MXLINE], hch[MXVTX+MXLINE], nchar;
                                                                      /*
************************************************************************
*        ===================================================          */
           void   tgdxOption( w, client_data, call_data )
/*       =================================================== 
************************************************************************
* ( Function )                                                         *
*   To change the option parameters for                                *
*                                                                      *
************************************************************************
								      */
 Widget  w;
 caddr_t client_data, call_data;
{
 void tgdxgraph( );
 void tgdmessage( );


  if( strcmp( client_data, "Graphno" ) == 0 )
    {
      if( print_graphn == 1 )
	{
          print_graphn = 0;
          XClearWindow( d, w0 );
         }
      else
          print_graphn = 1;
     }
  else if( strcmp( client_data, "Final" ) == 0 )
    {
      if( print_final == 1 )
	{
          print_final = 0;
          XClearWindow( d, w0 );
         }
      else
	{
          print_final = 1;
          XClearWindow( d, w0 );
         }
     }
  else if( strcmp( client_data, "Vertex" ) == 0 )
    {
      if( print_vtx == 1 )
	{
          print_vtx = 0;
          XClearWindow( d, w0 );
         }
      else
	{
          print_vtx = 1;
          XClearWindow( d, w0 );
         }
     }
  else if( strcmp( client_data, "Particle" ) == 0 )
    {
      if( print_pname == 1 )
	{
          print_pname = 0;
          XClearWindow( d, w0 );
         }
      else
          print_pname = 1;
     }
  tgdmessage();

  tgdxgraph( );
}

                                                                      /*
************************************************************************
*          ================================================           */
            void   tgdxGraphs( w, client_data, call_data )
/*         ================================================ 
************************************************************************
* ( Function )                                                         *
*   To control drawing many Feynman graphs in a window                 *
*                                                                      *
************************************************************************
								      */
 Widget  w;
 caddr_t client_data, call_data;
{
								      /*
--------------------
 Local variables
--------------------
								     */
 int ng, ngy;
								      /*
--------------------
 Functions
--------------------
								     */
 void tgdxgraph( );
 void tgdmessage( );
								      /*
========================== Entry point of tgdxGraphs ===================
								      */

  if( strcmp( client_data, "Covariant" ) == 0 )
    {
          print_unitary = 0;
          print_select  = 0;
	  First_graph   = 0;
          no_draw = no_graph;
     }
  else if( strcmp( client_data, "Unitary" ) == 0 )
    {
          print_unitary = 1;
          print_select  = 0;
	  First_graph   = 0;
          no_draw = no_unitary;
     }
  else if( strcmp( client_data, "Selected" ) == 0 )
    {
      if( print_select == 0 ) 
        {
          print_select = 1;
          if( no_select > 0 )
            {
	      no_draw       = no_select;
              First_graph = 0;
             }
          else
            {
              tgdmessage();
              print_select = 0;
              return;
             }
         }
      else
        {
          print_select = 0;
          if( print_unitary == 1 ) 
            {
	      no_draw       = no_unitary;
             }
          else
            {
	      no_draw       = no_graph;
             }
          First_graph = 0;
         }
     }

  if( no_draw < 24 )
    {
      for( ng = 1; ng < 5; ng++)
         {
           ngy = ng* 1.5;
           if( no_draw <= ng*ngy )
             {
               Nx_graph =  ng;
               Ny_graph = ngy;
               ng      = 5;
              }
          }
     }
  else
      Nx_graph = 4, Ny_graph = 6;
  if( Nx_graph == 1 ) Ny_graph = 2;

  tgdmessage();

  XClearWindow( d, w0 );

  tgdxgraph( );
}
                                                                      /*
************************************************************************
*          ===================================================        */
              void   tgdxMode( w, client_data, call_data )
/*         =================================================== 
************************************************************************
* ( Function )                                                         *
*   To change the mode of drawing Feynman graphs on a window           *
*       mode "Drawing" : select_mode = 0                               *
*            "Select"  : select_mode = 1                               *
*                                                                      *
************************************************************************
								      */
 Widget  w;
 caddr_t client_data, call_data;
{
 void tgdmessage( );

  if( strcmp( client_data, "Drawing" ) == 0 )
    {
      if( select_mode == 1 ) 
        {
          select_mode = 0;
         }
     }
  else if( strcmp( client_data, "Select" ) == 0 )
    {
      if( select_mode == 0 ) 
        {
          select_mode = 1;
         }
     }

  tgdmessage();

  return;
}
int no_dott, no_dtarc, no_wave, no_wvarc, no_spiral, no_sparc;
int th_dott, th_dtarc, th_wave, th_wvarc, th_spiral, th_sparc;
                                                                      /*
************************************************************************
*           ==========================================                */
              void   tgdxButton( wd, d1, cdata )
/*          ==========================================
************************************************************************
* ( Function )                                                         *
*   To identify the pressed button, and set flags according to         *
*      the expected action for the pressed button                      *
*                                                                      *
*  i.   pb10  : output the postscript file of the graphs on a window   *
*  ii.  pb1   : draw the next pgae                                     *
*  iii. pb2   : draw the previous page                                 *
*  iv.  pb3   : draw the page advanced by 5 pages                      *
*  v.   pb4   : draw the page of 5 pages before                        *
*  vi.  pb5   : draw the graphs with scaled up by more one graph       *
*  vii. pb6   : draw the graphs with scaled down by less one graph     *
*  viii.none  : exposed event handler                                  *
*  ix.  none  : setect graph event ( Button press event )              *
*                                                                      *
************************************************************************
								      */
Widget  wd;
caddr_t d1;
XmDrawingAreaCallbackStruct *cdata;
{
int n, nx, ny, nc, nl;
int ng, ngx, draw_no;
int width, height;
float xr, yr;
Window root;
unsigned int xj, yj, border_width, depth;
char outps[40];
int A4_xsize, A4_ysize;
int ps_xsize, ps_ysize;
float xscale_ps, yscale_ps;
                                                                      /*
  ------------
    functions
  ------------
                                                                      */
 void tgdxgraph( );
 void tgdmessage( );
 void psdott_def( );
 void psdtarc_def( );
 void pswave_def( );
 void pswvarc_def( );
 void psspiral_def( );
 void pssparc_def( );

print_ps = 0;

                                                                      /*
=======================================================================
       Output the postscript data into "grcfig**.eps"
=======================================================================
                                                                      */
if( wd == pb10 )
  {
    A4_xsize = 600;
    A4_ysize = 800;

    sprintf( outps, "grcfig%d.eps", npage_ps);
    if( ( psout = fopen( outps, "w" ) ) == NULL )
      {
        fprintf( stderr, "tgdxButton : can't open the ps file %s\n",
                 outps );
                 exit( 2 );
       }
    print_ps = 1;

    fprintf( psout, "%%!PS\n");
    fprintf( psout, "%%Created by gracefig coded by S.Kawabata\n");

    npage_ps++;

    xoff_ps   = (float) ngwidth * 0.05;
    yoff_ps   = (float) ngheight * 0.05;
    xscale_ps = (float) A4_xsize / ( ngwidth + 2*xoff_ps );
    yscale_ps = (float) A4_ysize / ( ngheight + 2*yoff_ps);
    if( xscale_ps < yscale_ps )
        yscale_ps = xscale_ps;
    else
        xscale_ps = yscale_ps;

    ps_xsize = (int) ( xscale_ps* (ngwidth + 2*xoff_ps ));
    ps_ysize = (int) ( yscale_ps* (grymax  + 2*yoff_ps ));
    fprintf( psout, "%%%%BoundingBox: 0 0 %d %d\n",
	             ps_xsize, ps_ysize);
    fprintf( psout, "%%%% The information of Picture size\n");
    fprintf( psout,"%%%% left_margin(%8.1f) width (%8d) ",
                     xoff_ps, ngwidth );
    fprintf( psout,"right_margin (%8.1f)\n", xoff_ps );
    fprintf( psout,"%%%% top_margin (%8.1f) height(%8d)",
                     yoff_ps, ngheight );
    fprintf( psout," bottom_margin(%8.1f)\n", yoff_ps );
    fprintf( psout, "\n");
    fprintf( psout, "%%------------------------ Start Prolog");
    fprintf( psout, " ------------------------\n");
    fprintf( psout, " \n");
    fprintf( psout, " %4.2f  %4.2f scale\n", xscale_ps, yscale_ps);

    fprintf( psout, "\n");

   /*
    printf( "%%%%BoundingBox: 0 0 %d %d\n",
	             ps_xsize, ps_ysize);
    printf( "%%%% The information of Picture size\n");
    printf( "%%%% left_margin(%8.1f) width (%8d) ",
                     xoff_ps, ngwidth );
    printf( "right_margin (%8.1f)\n", xoff_ps );
    printf( "%%%% top_margin (%8.1f) height(%8d)",
                     yoff_ps, ngheight );
    printf( " bottom_margin(%8.1f)\n", yoff_ps );
    printf( " %4.2f  %4.2f scale\n", xscale_ps, yscale_ps);
    printf( "\n");
   */

    if( size_flag == 0 )
      {
        fprintf( psout, "/MainTimes\n");
        fprintf( psout, " /Times-Italic findfont 10 scalefont def\n");
        fprintf( psout, "/SubTimes\n");
        fprintf( psout, " /Times-Italic findfont  8 scalefont def\n");
        fprintf( psout, "/MainSymb\n");
        fprintf( psout, " /Symbol findfont 10 scalefont def\n");
        fprintf( psout, "/SubSymb\n");
        fprintf( psout, " /Symbol findfont  8 scalefont def\n");
        fprintf( psout, "0.1 setlinewidth\n");
       }
    else if( size_flag == 1 )
      {
        fprintf( psout, "/MainTimes\n");
        fprintf( psout, " /Times-Italic findfont 12 scalefont def\n");
        fprintf( psout, "/SubTimes\n");
        fprintf( psout, " /Times-Italic findfont 10 scalefont def\n");
        fprintf( psout, "/MainSymb\n");
        fprintf( psout, " /Symbol findfont 12 scalefont def\n");
        fprintf( psout, "/SubSymb\n");
        fprintf( psout, " /Symbol findfont 10 scalefont def\n");
        fprintf( psout, "0.2 setlinewidth\n");
       }
    else if( size_flag == 2 )
      {
        fprintf( psout, "/MainTimes\n");
        fprintf( psout, " /Times-Italic findfont 14 scalefont def\n");
        fprintf( psout, "/SubTimes\n");
        fprintf( psout, " /Times-Italic findfont 12 scalefont def\n");
        fprintf( psout, "/MainSymb\n");
        fprintf( psout, " /Symbol findfont 14 scalefont def\n");
        fprintf( psout, "/SubSymb\n");
        fprintf( psout, " /Symbol findfont 12 scalefont def\n");
        fprintf( psout, "0.5 setlinewidth\n");
       }
    else if( size_flag == 3 )
      {
        fprintf( psout, "/MainTimes\n");
        fprintf( psout, " /Times-Italic findfont 18 scalefont def\n");
        fprintf( psout, "/SubTimes\n");
        fprintf( psout, " /Times-Italic findfont 14 scalefont def\n");
        fprintf( psout, "/MainSymb\n");
        fprintf( psout, " /Symbol findfont 18 scalefont def\n");
        fprintf( psout, "/SubSymb\n");
        fprintf( psout, " /Symbol findfont 14 scalefont def\n");
        fprintf( psout, "1.0 setlinewidth\n");
       }
    else if( size_flag == 4 )
      {
        fprintf( psout, "/MainTimes\n");
        fprintf( psout, " /Times-Italic findfont 24 scalefont def\n");
        fprintf( psout, "/SubTimes\n");
        fprintf( psout, " /Times-Italic findfont 18 scalefont def\n");
        fprintf( psout, "/MainSymb\n");
        fprintf( psout, " /Symbol findfont 24 scalefont def\n");
        fprintf( psout, "/SubSymb\n");
        fprintf( psout, " /Symbol findfont 18 scalefont def\n");
        fprintf( psout, "2.0 setlinewidth\n");
       }
    fprintf( psout, "1 setlinejoin\n");

    if( no_dtarc  >= th_dtarc  ) psdtarc_def( );
    if( no_dott   >= th_dott   ) psdott_def( );
    if( no_wave   >= th_wave   ) pswave_def( );
    if( no_wvarc  >= th_wvarc  ) pswvarc_def( );
    if( no_spiral >= th_spiral ) psspiral_def( );
    if( no_sparc  >= th_sparc  ) pssparc_def( );

    fprintf( psout, "\n");
    fprintf( psout, "%%------------------------- End Prolog");
    fprintf( psout, " -------------------------\n");
    fprintf( psout, " \n");
}
else
{

 ngraph    = Nx_graph*Ny_graph;

  if( wd == pb1 || wd == pb2 )
    {
                                                                      /*
=======================================================================
       Draw the next page
=======================================================================
                                                                      */
      if( wd == pb1 )
        {
          First_graph = Fin_graph + 1;
          if( First_graph >= no_draw ) First_graph = 0;
         }
                                                                      /*
=======================================================================
       Draw the previous page
=======================================================================
                                                                      */
      else if( wd == pb2 )
        {
          First_graph = First_graph - ngraph;
          if( First_graph < 0 )
            {
	      ngx = no_draw / ngraph;
              if( ngx == 0 )
                  First_graph = 0;
              else
                {
	          First_graph = ngx * ngraph;
                  if( First_graph == no_draw )
		      First_graph = First_graph - ngraph;
                 }
             }
         }
      }
                                                                      /*
=======================================================================
       Skip to the next 5 pages
=======================================================================
                                                                      */
  else if( wd == pb3 )
    {
      First_graph = First_graph + 5 * ngraph;
      if( First_graph >= no_draw ) First_graph = 0;
     }
                                                                      /*
=======================================================================
       Back to the previous 5 pages
=======================================================================
                                                                      */
  else if( wd == pb4 )
    {
      First_graph = First_graph - 5 * ngraph;
      if( First_graph < 0 )
        {
	  ngx = no_draw / ngraph;
          if( ngx == 0 )
              First_graph = 0;
          else
            {
	      First_graph = ngx * ngraph;
              if( First_graph == no_draw )
		  First_graph = First_graph - ngraph;
             }
         }
      }
  else
   {
                                                                      /*
=======================================================================
         Exposed event was appeared
=======================================================================
                                                                      */
     if( cdata->reason == XmCR_EXPOSE )
       {
         XGetGeometry( d, w0, &root, &xj, &yj, &ngwidth, &ngheight,
                                          &border_width, &depth );
        }
                                                                      /*
=======================================================================
         Some graph was selected
=======================================================================
                                                                      */
     else if( cdata->reason == XmCR_INPUT )
       {
         if( cdata->event->type == ButtonPress )
           {
             if( select_mode == 1 && print_select != 1 )
               {
                 xj = cdata->event->xbutton.x;
                 yj = cdata->event->xbutton.y;
                 xr = (float) xj, yr = (float) yj;
	         xr = xr -  leftmargin;
	         nx = (int) ( xr / ( 2.0*xbordermargin + grwidth ));
                 if( nx > Nx_graph-1 ) nx = Nx_graph-1;
	         yr = yr -  topmargin;
	         ny = (int) yr / 
		  ( titlemargin + 2.0*ybordermargin + grheight );
                 if( ny > Ny_graph-1 ) ny = Ny_graph - 1;
                 ng = Nx_graph*ny + nx + First_graph;
                 if( print_unitary == 1 )
                     draw_no = unitary_guage[ng];
                 else
                     draw_no = ng;

                 flag_rm = -1000;
                 for( n = 0; n < no_select; n++ )
                    {
                      if( draw_no == select_graph[n] )
                        {
                          flag_rm = n;
                          n = no_select;
                         }
                     }

                 graph_select = addr_graph[0][draw_no];

                 if( flag_rm != -1000 )
                   {
                     no_select--;
                     for( n = flag_rm; n < no_select; n++ )
                          select_graph[n] = select_graph[n+1];
                    }
                 else
                   {
                     select_graph[no_select] = draw_no;
                     no_select++;
                    }
                }
             tgdmessage();
             return;
            }
        }
                                                                      /*
=======================================================================
         Scale up
=======================================================================
                                                                      */
     else if( wd == pb5 )
       {
         Nx_graph = Nx_graph - 1 ;
         if( Nx_graph <= 0 ) Nx_graph = 1;
        }
                                                                      /*
=======================================================================
         Scale down
=======================================================================
                                                                      */
     else if( wd == pb6 )
       {
         Nx_graph = Nx_graph + 1;
         if( Nx_graph <= 0 ) Nx_graph = 1;
        }
    }

 XClearWindow( d, w0 );
}

 tgdxgraph( );

}

                                                                      /*
************************************************************************
*                   =====================                             */
                      void tgdxgraph( )
/*                  =====================
************************************************************************
* ( Function )                                                         *
*   To control drawing Feynman graphs on a window                      *
*                                                                      *
************************************************************************
								      */
{
int n, nx, ny, nc, nl;
int ng, ngx, draw_no;
float width, height, off_x, off_y;
float ur_size, ur_temp, dum;
double theta;
char string[60];
                                                                      /*
  --------------
    functions
  --------------
                                                                      */
void   gfrestore(  );
void   tgdmessage( );
void   tgdxdraw( );
void   FillRectangle( );
void   urtxts( );

 nsize  = ngwidth / Nx_graph;

 if( nsize > 0 && nsize < 180 )
   {
     size_flag = 0;
    } 
 else if( nsize >= 180 && nsize < 240 )
   {
     size_flag = 1;
    } 
 else if( nsize >= 240 && nsize < 300 )
   {
     size_flag = 2;
    } 
 else if( nsize >= 300 && nsize < 400 )
   {
     size_flag = 3;
    } 
 else if( nsize >= 400 )
   {
     size_flag = 4;
    } 
  
  theta = -1.0;
  pi    = acos( theta );
  rdeg  = 180.0/pi;
  pi2   = 2.0*pi;

  theta = atan2( 2.0, 1.0 );
  thetat= 2.0*( pi - 2.0*theta );
  thetat= thetat + 1.0e-5;
 /*
  printf(" thetat = %15.6f\n", thetat*rdeg );
 */

  topmargin  = 10.0, bottommargin = 10.0;
  if( size_flag == 0 )
    {
      titlemargin  = 10.0;
      leftmargin   = 25.0;
      rightmargin  = 25.0;
      xbordermargin = 20.0;
      ybordermargin =  15.0;
     }
  else if( size_flag == 1 )
    {
      titlemargin  = 12.0;
      leftmargin   = 30.0;
      rightmargin  = 30.0;
      xbordermargin = 24.0;
      ybordermargin =  18.0;
     }
  else if( size_flag == 2 )
    {
      titlemargin  = 14.0;
      leftmargin   = 35.0;
      rightmargin  = 35.0;
      xbordermargin = 28.0;
      ybordermargin =  21.0;
     }
  else if( size_flag == 3 )
    {
      titlemargin  = 17.0;
      leftmargin   = 42.0;
      rightmargin  = 42.0;
      xbordermargin =  34.0;
      ybordermargin =  25.0;
     }
  else if( size_flag == 4 )
    {
      titlemargin = 23.0;
      leftmargin   = 57.0;
      rightmargin  = 57.0;
      xbordermargin = 46.0;
      ybordermargin = 35.0;
     }

  grwidth = ( float ) ngwidth  
	    -  2.0*( float ) Nx_graph * xbordermargin - leftmargin
		 - rightmargin ;
  grwidth = grwidth / Nx_graph;

  grheight = ( float ) ngheight - topmargin - bottommargin;

  Ny_graph = (int) ( grheight / ( grwidth + 2.0*ybordermargin + titlemargin ));
  if( Ny_graph == 0 ) Ny_graph = 1;

  grheight = grwidth;

  ngraph    = Nx_graph*Ny_graph;
     nwidth  = ngwidth / Nx_graph;
     nheight = ngheight/ Ny_graph;

  Fin_graph = First_graph + ngraph - 1;
  if( Fin_graph >= no_draw ) Fin_graph = no_draw-1;

  ng = Fin_graph - First_graph + 1;
  nl = ng / Nx_graph;
  if( ng > nl*Nx_graph )
      nl = nl + 1;
  grymax = ( (float) nl + 1.0 )* ybordermargin + topmargin + bottommargin
           + (float) nl * ( titlemargin + ybordermargin + grheight );

  /*
  printf("print_ps = %2d  nl  = %d  grymax = %8.2f\n", 
          print_ps, nl, grymax );
  printf("Nx_graph = %d  Ny_graph = %d  First_graph = %d Fin_graph = %d\n",
          Nx_graph, Ny_graph, First_graph, Fin_graph );
  printf("ybordermargin = %6.1f  topmargin = %6.1f  bottommargin = %6.1f\n",
          ybordermargin, topmargin, bottommargin );
  printf("titlemargin   = %6.1f  grheight  = %6.1f\n",
          titlemargin, grheight );
  */


  tgdmessage();

/*
  ur_size = 10000.0;
  for( ng = First_graph; ng < Fin_graph+1; ng++ )
     {
       if( addr_graph[0][ng] >= 0 )
         {
           xscale = grwidth/ size[0][ng];
           yscale = grwidth/ size[1][ng];
           if( xscale < yscale )
               ur_temp = 60.0*xscale;
           else
               ur_temp = 60.0*yscale;

           if( ur_temp < ur_size ) ur_size = ur_temp;
          }
       }

  ur_temp  = grwidth / 3.6;

    printf(" ur_size  =%8.2f ur_temp =%8.2f\n", ur_size, ur_temp );

  if( ur_size > ur_temp ) ur_size  = ur_temp;
*/

  ur_size       = grwidth / 3.6;

  arrow_size    = 0.25*ur_size;
  spiral_length = 0.32*ur_size;
  spiral_width  = 0.25*spiral_length;
  wave_length   = 0.32*ur_size;
                  if( wave_length < 6.0 ) wave_length = 6.0;
  wave_width    = 0.2*wave_length;
  dott_length   = 0.20*ur_size;
  circle_rs     = 0.07*ur_size;
                  if( circle_rs < 2.0 ) circle_rs = 2.0;
  circle_r1     = 0.6*circle_rs;
  circle_r2     = 0.14*ur_size;
                  if( circle_r2 < 3.0 ) circle_r2 = 3.0;

   /*
    printf("=============================================\n");
    printf(" size_flag     =%8d\n", size_flag );
    printf(" grwidth       =%8.2f\n", grwidth );
    printf(" ur_size       =%8.2f\n", ur_size );
    printf(" arrow_size    =%8.2f\n", arrow_size );
    printf(" sipral_length =%8.2f\n", spiral_length );
    printf(" sipral_width  =%8.2f\n", spiral_width );
    printf(" wave_length   =%8.2f\n", wave_length );
    printf(" wave_width    =%8.2f\n", wave_width );
    printf(" dott_length   =%8.2f\n", dott_length );
    printf(" circle_r1     =%8.2f\n", circle_r1 );
    printf(" circle_r2     =%8.2f\n", circle_r2 );
   */

 ng = First_graph;
 width = 2.0*xbordermargin + grwidth;
 height = titlemargin + 2.0*ybordermargin + grheight;
 off_x  = xbordermargin;
 off_y = titlemargin + ybordermargin;

 th_dott   =   3, th_dtarc =   3;
 th_wave   =   2, th_wvarc =   2;
 th_spiral =   2, th_sparc =   2;

 if( print_ps == 0 )
   {
     no_dott   =     0;
     no_dtarc  =     0;
     no_wave   =     0;
     no_wvarc  =     0;
     no_spiral =     0;
     no_sparc  =     0;
    }

 for( ny = 0; ny < Ny_graph; ny++ )
    {
      yoff = topmargin + ( titlemargin + 2.0*ybordermargin + grheight )* ny
             + titlemargin + ybordermargin;
      for( nx = 0; nx < Nx_graph; nx++ )
         {
	   xoff =  leftmargin + xbordermargin*( 2*nx + 1 )
		   + grwidth*nx;

	   if( print_select == 1 && no_select > 0 )
             {
	       draw_no = select_graph[ng];
              }
	   else if( print_unitary == 1 )
	       draw_no = unitary_guage[ng];
           else
               draw_no = ng;

	   if( select_mode == 1 && no_select > 0 )
             {
               for( n = 0; n < no_select; n++ )
                if( draw_no == select_graph[n] ) 
                  {
                    FillRectangle( xoff-off_x, yoff-off_y, width, height );
                   }
              }

           gfrestore( draw_no );

           tgdxdraw( draw_no ); 

           ng = ng + 1;
 
           if( ng >  Fin_graph )
               nx = Nx_graph+1;
         }
      if( ng >  Fin_graph )
          ny = Ny_graph+1;
    }

  if( print_ps == 1 )
    {
       sprintf( string, "produced by GRACEFIG");
      xoff  = leftmargin;
      yoff  = grymax - 5.0;
      nc = strlen( string );
      urtxts( -1, xoff, yoff, nc, string, "white" );

      fprintf( psout, "showpage\n");

      fclose( psout );
     }
  else
    {
       sprintf( string, 
        "GRACEFIG : Coded by S.Kawabata, Minamitateya, KEK, JAPAN" );
      xoff = 5.0;
      yoff = (float) ngheight - 5;
      nc = strlen( string );
      urtxts( 0, xoff, yoff, nc, string, "white" );
     }

}
                                                                      /*
************************************************************************
*                   =====================                             */
                     void tgdmessage( )
/*                  =====================
************************************************************************
* ( Function )                                                         *
*   To write essages on the message board                              *
*                                                                      *
************************************************************************
								      */
{
  char string[40];
  int  nc;

  XClearWindow( d, w1 );

  sprintf( string, "* Number of graphs \n");
  nc = strlen( string );
  urtxtda( 0.0, 14.0, nc, string, "blue" );
  sprintf( string, "  Covariant : %3d\n", no_graph );
  nc = strlen( string );
  urtxtda( 0.0, 28.0, nc, string, "black" );
  sprintf( string, "  Unitary     : %3d\n", no_unitary );
  nc = strlen( string );
  urtxtda( 0.0, 42.0, nc, string, "black" );
  sprintf( string, "  Selected   : %3d\n", no_select );
  nc = strlen( string );
  urtxtda( 0.0, 56.0, nc, string, "black" );
  sprintf( string, "* mode :\n");
  nc = strlen( string );
  urtxtda( 0.0, 70.0, nc, string, "blue" );
     
  if( select_mode == 0 )
    {
      if( print_select == 1 )
        { 
          sprintf( string, "   Draw selected\n");
          nc = strlen( string );
          urtxtda( 0.0, 84.0, nc, string, "blue" );
         if( no_select == 0 )
           {
             sprintf( string, "   0 graph selected !!");
             nc = strlen( string );
             urtxtda( 0.0, 98.0, nc, string, "red" );
            }
         else
           {
             sprintf( string, "    %d-th out of %d\n", First_graph+1, no_draw);
             nc = strlen( string );
             urtxtda( 0.0, 98.0, nc, string, "black" );
            }
        }
     else if( print_unitary == 1 )
       { 
         sprintf( string, "   Draw Unitary\n");
         nc = strlen( string );
         urtxtda( 0.0, 84.0, nc, string, "blue" );
         sprintf( string, "    %d-th out of %d\n", First_graph+1, no_draw);
         nc = strlen( string );
         urtxtda( 0.0, 98.0, nc, string, "black" );
        }
     else      
       { 
         sprintf( string, "   Draw Covariant\n");
         nc = strlen( string );
         urtxtda( 0.0, 84.0, nc, string, "blue" );
         sprintf( string, "    %d-th out of %d\n", First_graph+1, no_draw);
         nc = strlen( string );
         urtxtda( 0.0, 98.0, nc, string, "black" );
        }
     }
  else 
    {
      if( print_select == 1 )
        { 
          sprintf( string, "   Select from selected\n");
          nc = strlen( string );
          urtxtda( 0.0, 84.0, nc, string, "red" );
          sprintf( string, "   not allowed !!");
          nc = strlen( string );
          urtxtda( 0.0, 98.0, nc, string, "red" );
        }
     else if( print_unitary == 1 )
       { 
         sprintf( string, "   Select Unitary\n");
         nc = strlen( string );
         urtxtda( 0.0, 84.0, nc, string, "blue" );
         if( flag_rm != -1000 )
             sprintf( string, "    graph %d removed\n", graph_select);
         else
             sprintf( string, "    graph %d selcted\n", graph_select);
         nc = strlen( string );
         urtxtda( 0.0, 98.0, nc, string, "black" );
        }
     else      
       { 
         sprintf( string, "   Select Covariant\n");
         nc = strlen( string );
         urtxtda( 0.0, 84.0, nc, string, "blue" );
         if( flag_rm != -1000 )
             sprintf( string, "    graph %d removed\n", graph_select);
         else
             sprintf( string, "    graph %d selcted\n", graph_select);
         nc = strlen( string );
         urtxtda( 0.0, 98.0, nc, string, "black" );
        }
     }

  sprintf( string, "* EPS-out : %d files\n", npage_ps );
  nc = strlen( string );
  urtxtda( 0.0, 112.0, nc, string, "blue" );
}    
                                                                      /*
************************************************************************
*                   ======================                            */
                     void tgdxdraw( ng  )
/*                  ======================
************************************************************************
* ( Function )                                                         *
*   To draw one ng-th Feynman graph on a position ( nx, ny )           *
*                                                                      *
************************************************************************
								      */
int ng;
{
  int k, mod, n, nc, nv, nl, v0, v1, ok;
  float  x,  y, x0, y0, x1, y1, xp, yp, xt; 
  float  xsize, ysize ;
  float dx, dy, dum, slope, ratio;
  double dx1, dy1, qpi1, qpi3, angle;
  char graphn[40], string1[40], string2[40];
  char *external = "ext", *initial = "ini";
  char *point;
  int  i, direct, adirect, size_f;
  float  xflag, yflag, width;
  int  self;
  int  w, h, dcs;
                                                                      /*
  -------------
    functions
  -------------
                                                                      */
  int   iabs    ( );
  int   mode    ( );
  void  urplot  ( );
  float urarrow ( );
  float urwave  ( );
  float urspiral( );
  void  urdott  ( );
  float  Drawsusy  ( );
  void  urtxts  ( );
  void  urcircle ( );
  void  urcircle2( );
  int   Draw_pname( );
  void  urDrawString( );
  void  urStringSize( );
  void  tgdxself( );
                                                                             /*
  -------------------
    Initialization 
  -------------------
                                                                             */
  nchar     = 0;
  qpi1      = pi / 4.0;
  qpi3      = 3.0 * qpi1;
  graph_no  = addr_graph[0][ng];
                                                                             /*
===============================================================================
(I)         print the graph number
===============================================================================
                                                                             */
  if( graph_no < 0 )
    {
      if( print_graphn == 1 )
        {
          graph_no = -graph_no;

          sprintf( graphn, "Graph   %d", graph_no );
          x0 = xoff;
          y0 = yoff - ybordermargin;
          nc = strlen( graphn );
          urtxts( size_flag, x0, y0, nc, graphn, "black" );

	  return;
        }
     }

  if( print_graphn == 1 )
    {
      sprintf( graphn, "Graph   %d", graph_no );
      x0 = xoff;
      y0 = yoff - ybordermargin;
      nc = strlen( graphn );
      urtxts( size_flag, x0, y0, nc, graphn, "blabk" );
    }
  no_vertex = addr_graph[2][ng];
  no_line   = addr_graph[4][ng];
  xsize     = size[0][ng];
  ysize     = size[1][ng];
  xscale    = grwidth / xsize;
  yscale    = grheight / ysize;

                                                                             /*
===============================================================================
(II)        Only for Debugging :  Draw the grid
===============================================================================

     size_f = size_flag;
     size_flag = 0;
     if( print_ps == 1 ) 
       {
        fprintf( psout, "0.1 setlinewidth\n");
        fprintf( psout, "/SubTimes\n");
        fprintf( psout, " /Times-Italic findfont 8 scalefont def\n");
       }
     xp  = 0.0,  yp = 0.0;
     y0  = yoff, y1 = yoff + grheight;
     for( nv = 0; nv < 80; nv++ )
        {
          n  = nv*25;
          x0 = (float) n;
          x0 = xoff + xscale*x0;
        /*********************************
          n  = (int) xoff + nv*50;
          n  = n/50;
          n  = n*50;
          x0 = (float) n;
        *********************************
          if( x0 < xoff ) ;
          else if( x0 > xoff + grwidth )
              nv = 80;
          else
            {
              urplot( x0, y0, xp, yp, x0, y1 );
              sprintf( string1, "%d", n );
              nc = strlen( string1 );
              urtxts( size_flag, x0, y0, nc, string1, "black" );
             }
         }

     x0  = xoff, x1 = xoff + grwidth;
     for( nv = 0; nv < 80; nv++ )
        {
          n  = nv*25;
          y0 = (float) n;
          y0 = yoff + yscale*y0;
        /*******************************
          n  = (int) yoff + nv*50;
          n  = n/50;
          n  = n*50;
          y0 = (float) n;
        *******************************
          if( y0 < yoff ) ;
          else if( y0 > yoff + grheight )
              nv = 80;
          else
            {
              urplot( x0, y0, xp, yp, x1, y0 );
              sprintf( string1, "%d", n );
              nc = strlen( string1 );
              urtxts( size_flag, x1, y0, nc, string1, "black" );
             }
         }
     size_flag = size_f;
     if( print_ps == 1 ) 
       {
         if( size_flag == 0 )
           {
             fprintf( psout, "/SubTimes\n");
             fprintf( psout, " /Times-Italic findfont 8 scalefont def\n");
             fprintf( psout, "0.1 setlinewidth\n");
            }
         else if( size_flag == 1 )
           {
             fprintf( psout, "/SubTimes\n");
             fprintf( psout, " /Times-Italic findfont 10 scalefont def\n");
             fprintf( psout, "/SubSymb\n");
             fprintf( psout, " /Symbol findfont 10 scalefont def\n");
             fprintf( psout, "0.2 setlinewidth\n");
            }
         else if( size_flag == 2 )
           {
             fprintf( psout, "/SubTimes\n");
             fprintf( psout, " /Times-Italic findfont 14 scalefont def\n");
             fprintf( psout, "0.5 setlinewidth\n");
            }
         else if( size_flag == 3 )
           {
             fprintf( psout, "/SubTimes\n");
             fprintf( psout, " /Times-Italic findfont 14 scalefont def\n");
             fprintf( psout, "1.0 setlinewidth\n");
            }
         else if( size_flag == 4 )
           {
             fprintf( psout, "/SubTimes\n");
             fprintf( psout, " /Times-Italic findfont 18 scalefont def\n");
             fprintf( psout, "2.0 setlinewidth\n");
            }
       }

    /*
      printf(" ng(%d)  graph_no(%d)\n", ng, graph_no );
      printf(" no_line(%d)\n", no_line );
      printf(" xsize(%6.1f) ysize(%6.1f) xscale(%8.5f) yscale(%8.5f)\n",
	           size[0][ng], size[1][ng], xscale, yscale );
******************************************************************************/

ycenter = 0.5*ysize*yscale + yoff;
xcenter = 0.5*xsize*xscale + xoff;

                                                                             /*
===============================================================================
(III)       determin the middle point of the internal line 
===============================================================================
                                                                             */
for( n = 0; n < no_line; n++ )
   {
     direct  =  iabs( intline[n].direct );
     if( intline[n].flag >= 0 && intline[n].x != 0.0 )
       {
         v0  =  inlvtx[n].vtxno[0];
         v1  =  inlvtx[n].vtxno[1];

         x0  =  vtx[v0].x*xscale + xoff;
         y0  =  vtx[v0].y*yscale + yoff;
         x1  =  vtx[v1].x*xscale + xoff;
         y1 =   vtx[v1].y*yscale + yoff;

         xp  = intline[n].x*xscale + xoff;
         yp  = intline[n].y*yscale + yoff;

             /*
              printf("** before tgdxself\n");
              printf(" line_no = %3d, x0 = %6.1f, xp = %6.1f, x1 = %6.1f\n",
                              n, x0, xp, x1 );
              printf("                y0 = %6.1f, yp = %6.1f, y1 = %6.1f\n",
                                 y0, yp, y1 );
             */

         tgdxself( n, x0, y0, x1, y1, xp, yp  );

             /*
              printf("   after tgdxself\n");
              printf(" line_no = %3d, x0 = %6.1f, xp = %6.1f, x1 = %6.1f\n",
                              n, x0, intline[n].x, x1 );
              printf("                y0 = %6.1f, yp = %6.1f, y1 = %6.1f\n",
                                 y0, intline[n].y, y1 );
             */

         if( print_ps == 0 )
           {
             if(      direct == 4 ) no_wvarc+= 1;
             else if( direct == 5 ) no_sparc+= 1;
             else if( direct == 3 || direct == 2 || direct == 13 )
                                    no_dtarc+= 1;
            }

         }
      else if( print_ps == 0 )
        {
          if(      direct == 4 ) no_wave  += 1;
          else if( direct == 5 ) no_spiral+= 1;
          else if( direct == 3 || direct == 2 || direct == 13 )
                                 no_dott+= 1;
         }
   }
                                                                             /*
===============================================================================
(IV)  Set SUSY flag for the SUSY vertices
===============================================================================
                                                                             */

if( susy_included[ng] > 0 )
  {
    for( nv = 0; nv < no_vertex; nv++ )
       {
         if( vtx[nv].flag >= 0 )
           {
             nl  = vtx[nv].no_line;
             for( k = 0; k < nl; k++ )
                {
                  n       =  vtxline[nv].lineno[k];
                  direct  =  iabs( intline[n].direct );

                  if( direct  == 11 || direct == 12 )
                    {
                      vtx[nv].cntr_flag += 10;
                      n                 = nl;
                     }
                 }
            }
        }
    }
                                                                             /*
===============================================================================
(V) draw vertex poistion with circles 
    and print the particle names in the initial and final states
===============================================================================
                                                                             */
for( nv = 0; nv < no_vertex; nv++ )
   {
     x0  =  vtx[nv].x*xscale + xoff;
     y0  =  vtx[nv].y*yscale + yoff;

     if( vtx[nv].flag >= 0 )
       {                                                                    /*
        +--------------------------------------------------------------------+
        |(1)  print vertex with circle                                       |
        +--------------------------------------------------------------------+
                                                                            */
         if( vtx[nv].cntr_flag > 9 )
             urcircle( x0, y0, circle_rs );
         else
             urcircle( x0, y0, circle_r1 );

         mod   = mode( vtx[nv].cntr_flag, 10 );
         if( mod == 1 || mod == 2 )
             urcircle2( x0, y0, circle_r2 );
                                                                            /*
        +--------------------------------------------------------------------+
        |(2)  print particle names for initial and final particles           |
        +--------------------------------------------------------------------+
                                                                            */
         if( print_pname == 1 )
           {
             if( vtx[nv].no_line == 1 )
               {
                 nl    = vtxline[nv].lineno[0];
                 sprintf( string1, "%s", intline[nl].species );
                 sprintf( string2, "%s", intline[nl].form );
                 nc = strlen( string1 );

                 urStringSize( size_flag, nc, string1, string2, &dcs, &w, &h );

                 xflag = (float) w;
                 yflag =      0.0;
                 point = vtx[nv].kind;
                 if( strcmp( initial, point ) != 0 )
                   {
                     if( print_final == 1 || print_vtx == 1 )
                         xflag = xbordermargin*0.5;
                         /*xflag = 1.0*xflag;*/
                     else
                         xflag = xbordermargin*0.3;
                    }
                 else
                   {
                     if( print_final == 1 || print_vtx == 1 )
                         xflag = -xbordermargin*0.9;
                         /*xflag = -3.0*xflag;*/
                     else
                         xflag = -xbordermargin*0.6;
                         /*xflag = -2.0*xflag;*/
                    }

                 x0 = x0 + xflag;
                 y0 = y0 + yflag;
								      
                 sprintf( string1, "%s", intline[nl].species );
                 sprintf( string2, "%s", intline[nl].form );
                 nc = strlen( string1 );

                 urDrawString( size_flag, x0, y0, nc, string1, string2 );

		 xch[nchar] = (int) x0 + w;
		 ych[nchar] = (int) y0 - h;
		 wch[nchar] = w;
		 hch[nchar] = h;
                 nchar++;

                }
            }	
        }
    }
                                                                             /*
===============================================================================
(VI)    Draw the internal lines and their particle names
===============================================================================
                                                                             */
for( n = 0; n < no_line; n++ )
   {
     if( intline[n].flag >= 0 )
       {
         v0  =  inlvtx[n].vtxno[0];
         v1  =  inlvtx[n].vtxno[1];
         direct  =  intline[n].direct;

         x0  =  vtx[v0].x*xscale + xoff;
         y0  =  vtx[v0].y*yscale + yoff;
         x1  =  vtx[v1].x*xscale + xoff;
         y1 =   vtx[v1].y*yscale + yoff;

         if( x0 != x1 || y0 != y1 )
           {
                                                                             /*
           +------------------------------------------------------------------+
           |(1)  get the middle point of the internal line                    |
           +------------------------------------------------------------------+
                                                                             */
             xp  = 0.0, yp = 0.0;
             self = 0;
             if( intline[n].x != 0.0 )
               {
                 self = 1;
                 xp  = intline[n].x;
                 yp  = intline[n].y;
                     /*
                       printf(" line_no = %d, xp = %6.1f, yp = %6.1f\n",
                                 n, xp, yp );
                     */
                }

                                                                             /*
           +------------------------------------------------------------------+
           |(2)  Draw the internal lines                                      |
           |     draw a wave line                       for bosons            |
           |          a dotted line                     for scalars           |
           |          a straight line with an arrow     for fermions          |
           +------------------------------------------------------------------+
                                                                             */
             width = 0.0;
             adirect = iabs( direct );
             if( adirect == 1 )
               {
                   urplot( x0, y0, xp, yp, x1, y1 );
                   width = urarrow( x0, y0, xp, yp, x1, y1, direct );
                    /*
                      printf(" urarrow  : width = %9.3f, v0(%d) ==> v1(%d)\n", 
		 	       width, v0, v1 );
                    */
                }
             else if( adirect == 4 )
               {
                   width = urwave( x0, y0, xp, yp, x1, y1 );

                   /*
                   printf(" urwave   : width = %9.3f, v0(%d) ==> v1(%d)\n", 
		  	       width, v0, v1 );
                   */
                }
             else if( adirect == 3 || adirect == 2 || adirect == 13 )
               {
                     urdott( x0, y0, xp, yp, x1, y1 );

                  /*
                   printf(" urdott   : width = %9.3f, v0(%d) ==> v1(%d)\n", 
	   		       width, v0, v1 );
                  */
                }
             else if( adirect == 5 )
               {
                   width = urspiral( x0, y0, xp, yp, x1, y1 );

                 /*
                 printf(" urspiral : width = %9.3f, v0(%d) ==> v1(%d)\n", 
			       width, v0, v1 );
                 */
                }
             else if( adirect > 10 )
               {
                   width = Drawsusy( v0, x0, y0, xp, yp, x1, y1, direct );
                }
                                                                             /*
           +------------------------------------------------------------------+
           |(3)  Draw the particle names of the internal lines                |
           |       if the flag print_name == 1 and print_flag == 1.           |
           +------------------------------------------------------------------+
                                                                             */
             if( print_pname  == 1 && intline[n].print == 1   )
               {
                 /*
                   printf("internal line number =%d\n", n );
                   printf(" vtx[%d]  x = %8.2f  y = %8.2f\n",
                            v0, x0, y0 );
                   printf(" vtx[%d]  x = %8.2f  y = %8.2f\n",
                             v1, x1, y1 );
                   printf(" line_no = %d, xp = %6.1f, yp = %6.1f\n",
                            n, xp, yp );
                 */

                point = intline[n].kind;
                if( strcmp( external, point ) != 0 )
	          {
                    sprintf( string1, "%s", intline[n].species );
                    sprintf( string2, "%s", intline[n].form );
	            nc = strlen( string1 );

                    if( self == 0 )
                      {
                        for( k = 0; k < 3; k++ )
                           {
                             ratio = 0.5;
                             if( k == 1 ) ratio = 0.75;
                             if( k == 2 ) ratio = 0.25;
                             xp = ratio*( x1 - x0 ) + x0;
                             yp = ratio*( y1 - y0 ) + y0;

	                     ok = Draw_pname( n, x0, y0, 
                                          x1, y1, xp, yp, width, 
                                          nc, string1, string2 );
                             if( ok != 0 ) k = 3;
                            }
                       }
                    else
                        ok = Draw_pname( n, x0, y0, 
                                     x1, y1, xp, yp, width, 
                                     nc, string1, string2 );
                      
                       /*
                        printf("***>>>> line_no  =%5d  <<<<***\n", n);
                        printf(" ( x0, y0 )   = (%6.1f,%6.1f)\n", 
			    x0, y0);
                        printf(" ( x1, y1 )   = (%6.1f,%6.1f)\n",
                               x1, y1);
                        printf("      width   =  %6.1f\n", width);
                        printf(" ( xp, yp )   = (%6.1f,%6.1f)\n",
                                xp, yp);
                       */

                                                                      /*
		    --- Print line number on Display Just for debugging
                                                                      */
                        /*
                          sprintf( string1, "%d", n );
                          nc = strlen( string1 );
                          urtxts( size_flag, xp, yp, nc, string1, "black" );
                       */
                   }    
               }
            }
          else
           {
             printf("***************** Warning Warning *******************\n");
                    printf("internal line number [%3d]\n", n );
                    printf(" from vtx[%3d](%8.2f,%8.2f )",
                             v0, x0, y0 );
                    printf(" to vtx[%3d](%8.2f,%8.2f )",
                             v1, x1, y1 );
                    printf(" direct[%2d]\n", direct );
             printf("***************** Warning Wrning *******************\n");
            }
       }
   }
                                                                             /*
===============================================================================
(VII)         print vertex numbers
===============================================================================
                                                                             */
if( print_final == 1 || print_vtx == 1 )
  {
    for( nv = 0; nv < no_vertex; nv++ )
       {
         x0  =  vtx[nv].x*xscale + xoff;
         y0  =  vtx[nv].y*yscale + yoff;

         if( vtx[nv].flag >= 0 )
           {                                                                /*
             +---------------------------------------------------------------+
             |(1)  print vertex numbers                                      |
             +---------------------------------------------------------------+
                                                                            */
             if( print_vtx == 1 && print_final == 0 )
               {
                 sprintf( string1, "%d", nv );
                 x0  =  vtx[nv].x*xscale + xoff;
                 y0  =  vtx[nv].y*yscale + yoff;
                 nc = strlen( string1 );
                 urtxts( size_flag, x0, y0, nc, string1, "black" );
                }
                                                                            /*
             +---------------------------------------------------------------+
             |(1)  print vertex numbers of initial and final vertices        |
             +---------------------------------------------------------------+
                                                                            */
             if( print_pname == 1 )
               {
                 if( vtx[nv].no_line == 1 )
                   {
                     nl    = vtxline[nv].lineno[0];
                     sprintf( string1, "%s", intline[nl].species );
                     sprintf( string2, "%s", intline[nl].form );
                     nc = strlen( string1 );

                     urStringSize( size_flag, 
                                   nc, string1, string2, &dcs, &w, &h );

                     xflag = (float) w;
                     yflag =      0.0;
                     point = vtx[nv].kind;
                     if( strcmp( initial, point ) != 0 )
                       {
                         if( vtx[nv].cntr_flag < 10 )
                             dx    =  circle_r1;
                         else
                             dx    =  circle_rs;
                         if( print_final == 1 || print_vtx == 1 )
                             xflag = xbordermargin*0.5;
                             /*xflag = 1.0*xflag;*/
                         else
                             xflag = xbordermargin*0.3;
                        }
                     else
                       {
                         if( vtx[nv].cntr_flag < 10 )
                             dx    = - 4.0*circle_r1;
                         else
                             dx    = - 4.0*circle_rs;
                         if( print_final == 1 || print_vtx == 1 )
                             xflag = -xbordermargin*0.9;
                             /*xflag = -3.0*xflag;*/
                         else
                             xflag = -xbordermargin*0.6;
                             /*xflag = -2.0*xflag;*/
                        }

                     xt  =  x0 + dx;

                     if( print_final == 1 && print_vtx == 0 )
                       {
                         sprintf( string1, "%d", nv+1 );
                         nc = strlen( string1 );

                         urtxts( size_flag, xt, y0, nc, string1, "black" );

                        }
                    }
                }	
        }
    }
  }
}
                                                                      /*
************************************************************************
*            ==============================================           */
              void tgdxself( nl, x0, y0, x1, y1, xp, yp  )
/*           ==============================================
************************************************************************
* ( Function )                                                         *
*   To draw one ng-th Feynman graph on a position ( nx, ny )           *
*                                                                      *
************************************************************************
								      */
int nl;
float x0, y0, x1, y1, xp, yp;
{
double a, b, ratio, d, xx, yy, xx0, yy0;
double aa, bb;
int ok;
int chk_clossing( );

 d  = (double) ( (x1 - x0)*(x1 - x0) + (y1 -y0)*(y1-y0) );
 d  = sqrt( d )*0.25;
    
      /*
       printf(" x0  = %6.1f    x1  = %6.1f     xp  = %6.1f\n", x0, x1, xp );
       printf(" y0  = %6.1f    y1  = %6.1f     yp  = %6.1f\n", y0, y1, yp );
       printf(" d   = %6.1f\n", d );
      */
 
 if( y0 == y1 )
   {
     xx = 0.5*(x1 -x0) + x0;
     intline[nl].x = xx;
     if( intline[nl].flag == 1 )
       {
         if( y0 > ycenter )
             intline[nl].y = y0 + d;
         else
             intline[nl].y = y0 - d;
        }
     else
       {
         if( yp > y0 )
             intline[nl].y = y0 + d;
         else
             intline[nl].y = y0 - d;
        }
    }
 else if( x0 == x1 )
   {
     yy = 0.5*(y1 -y0) + y0;
     intline[nl].y = yy;
     if( intline[nl].flag == 1 )
       {
         if( x0 > xcenter )
             intline[nl].x = x0 + d;
         else
             intline[nl].x = x0 - d;
        }
     else
       {
         if( xp > x0 )
             intline[nl].x = x0 + d;
         else
             intline[nl].x = x0 - d;
        }
    }
 else
   {
     aa    = ( y1 - y0 )/( x1 - x0 );
     bb    = y0 - aa*x0;
     yy    = aa*xp + bb;

     a     = (x0 - x1)/(y1 - y0);
     xx0   = 0.5*(x1 - x0) + x0;
     yy0   = 0.5*(y1 - y0) + y0;
     b     = yy0 - a*xx0;
     ratio = a*a + 1.0;
     ratio = sqrt( ratio );
     ratio = d/ratio;
         /*
          printf("  xx0  = %6.1f   -a  = %6.1f\n", xx0, -a );
          printf("  yy0  = %6.1f    b  = %6.1f\n", yy0,  b );
          printf("  xp   = %6.1f\n", xp );
          printf("  yy   = %6.1f    yp = %6.1f\n", yy, yp );
         */
     if( yy > yp )
       {
         if( -a > 0.0 )
           {
             xx  = xx0 + ratio;
             yy  = a*xx + b;

             if( chk_clossing( nl, x0, y0, xx, yy, x1, y1 ))
               {
                 xx = xx0 - ratio;
                 yy = a*xx + b;
                }
            }
         else
           {
             xx  = xx0 - ratio; 
             yy  = a*xx + b;

             if( chk_clossing( nl, x0, y0, xx, yy, x1, y1 ))
               {
                 xx = xx0 + ratio;
                 yy = a*xx + b;
                }
            }
        }
     else
       {
         if( -a > 0.0 )
           {
             xx  = xx0 - ratio;
             yy  = a*xx + b;

             if( chk_clossing( nl, x0, y0, xx, yy, x1, y1 ))
               {
                 xx = xx0 + ratio;
                 yy = a*xx + b;
                }
            }
         else
           {
             xx  = xx0 + ratio; 
             yy  = a*xx + b;

             if( chk_clossing( nl, x0, y0, xx, yy, x1, y1 ))
               {
                 xx = xx0 - ratio;
                 yy = a*xx + b;
                }
            }
        }

 /**********************************************************
     if( -a > 0.0 )
       {
          if( yp > yy0 )
	    {
	      xx = xx0 - ratio;
              yy = a*xx + b;

              ok =  chk_clossing( nl, x0, y0, xx, yy, x1, y1 );

              if( ok == 1 )
                {
                  xx = xx0 + ratio;
                  yy = a*xx + b;
                 }
             }
          else
            {
              xx  = xx0 + ratio;
              yy = a*xx + b;

              ok =  chk_clossing( nl, x0, y0, xx, yy, x1, y1 );

              if( ok == 1 )
                {
                  xx = xx0 - ratio;
                  yy = a*xx + b;
                 }
             }
        }
     else
       {
          if( yp > yy0 )
	    {
	      xx = xx0 + ratio;
              yy = a*xx + b;

              ok =  chk_clossing( nl, x0, y0, xx, yy, x1, y1 );

              if( ok == 1 )
                {
                  xx = xx0 - ratio;
                  yy = a*xx + b;
                 }
             }
          else
            {
              xx  = xx0 - ratio;
              yy = a*xx + b;

              ok =  chk_clossing( nl, x0, y0, xx, yy, x1, y1 );

              if( ok == 1 )
                {
                  xx = xx0 + ratio;
                  yy = a*xx + b;
                 }
             }
        }
********************************/
     intline[nl].x = (float) xx;
     intline[nl].y = (float) yy;
        /*
         printf("  ok = %d\n", ok );
        */
    }
}
float xsusy, ysusy;
int   nsusy;
                                                                           /*
*****************************************************************************
*           ==============================================                 */
              float Drawsusy( v, xx1, yy1, xx2, yy2, xx3, yy3, direct )
/*          ==============================================
*****************************************************************************
* ( Function )                                                              *
*   To draw a dotted line from ( xx1, yy1 ) to ( xx3, yy3 ),                *
*      and ( xx2, yy2 ) defines the middle point of the wave arc.           *
*                                                                           *
*****************************************************************************
									   */
float xx1, yy1, xx2, yy2, xx3, yy3;
int   v, direct;
{
int n, ndott, adirect, size_f;
float x0[2], y0[2], xp[2], yp[2], x1[2], y1[2], wid;
float sq[2];
float dx, dy;
float width;
double theta;

int iabs( );
void urplot( );
void urdott( );
float urarrow( );
void trace_susy( );

  adirect = iabs( direct );
  wid     = circle_rs*0.5;
  width   = 0.0;
  xp[0]   = 0.0,   xp[1]  = 0.0;
  yp[0]   = 0.0,   yp[1]  = 0.0;

  if( yy1 == yy3 )
    {
      dx = 0.0, dy = wid;
     }
  else if( xx1 == xx3 )
    {
      dx = wid, dy = wid;
     }
  else
    {
      theta = atan2( (double )( yy3 - yy1 ), (double)( xx3 - xx1 ));
      dx = wid*(float) sin( theta );
      dy = -wid*(float) cos( theta );
     }

  nsusy  =   0;
  xsusy  = 0.0;
  ysusy  = 0.0;
/*
  size_f = size_flag;
  size_flag--;
  if( size_flag < 0 ) size_flag = 0;
*/
  trace_susy( v, v );

  xsusy = xsusy / nsusy;
  ysusy = ysusy / nsusy;

     /*
      printf("** Drawsusy: after trace_susy\n");
      printf("   ( xsusy, ysusy ) = ( %5.1f, %5.1f )\n", xsusy, ysusy );
     */

  x0[0]  = xx1 + dx, y0[0] = yy1 + dy;
  if( xx2 != 0.0 )
  xp[0]  = xx2 + dx, yp[0] = yy2 + dy;
  x1[0]  = xx3 + dx, y1[0] = yy3 + dy;

  x0[1]  = xx1 - dx, y0[1] = yy1 - dy;
  if( xx2 != 0.0 )
  xp[1]  = xx2 - dx, yp[1] = yy2 - dy;
  x1[1]  = xx3 - dx, y1[1] = yy3 - dy;

  for( n = 0; n < 2; n++ )
       sq[n] = ( x0[n] - xsusy )*( x0[n] - xsusy ) +
                                 ( y0[n] - ysusy )*( y0[n] - ysusy );

  if( sq[0] < sq[1] )
    {
      urdott( x0[0], y0[0], xp[0], yp[0], x1[0], y1[0] );
      urplot( x0[1], y0[1], xp[1], yp[1], x1[1], y1[1] );
     }
  else
    {
      urdott( x0[1], y0[1], xp[1], yp[1], x1[1], y1[1] );
      urplot( x0[0], y0[0], xp[0], yp[0], x1[0], y1[0] );
     }


  if( adirect == 11 )
      width = urarrow( xx1, yy1, xx2, yy2, xx3, yy3, direct );

  wid = 2.0*wid;
  if( wid > width ) width = wid;
/*
  size_flag = size_f;
*/
  return width;
}
                                                                           /*
*****************************************************************************
*           ==============================================                 */
              void trace_susy( parentv, currentv )
/*          ==============================================
*****************************************************************************
* ( Function )                                                              *
*   To trace the susy particle from a vertex and calculate the              *
*      center of gravity of ( x, y ) positions of susy vertices.            *
*                                                                           *
*****************************************************************************
									   */
int parentv, currentv;
{
 int n, nl, nv, v;

 void trace_susy( );
 int  iabs( );

  if( parentv == currentv )
    {
      nsusy = 0;
      xsusy = 0.0,  ysusy = 0.0;
     }

  nsusy++;
  xsusy  = xsusy + vtx[currentv].x*xscale + xoff;
  ysusy  = ysusy + vtx[currentv].y*yscale + yoff;

  nv = vtx[currentv].no_line;

  for( n = 0; n < nv; n++ )
     {
       v  = vtxline[currentv].vtxno[n];
       if( v != parentv )
         {
           nl = vtxline[currentv].lineno[n];
           if( iabs( intline[nl].direct ) > 10 )
             {                                                              /*
                <<<<<<<<<<<<<<>>>>>>>>>>>>>>                                */
                  trace_susy( currentv, v );                                /*
                <<<<<<<<<<<<<<>>>>>>>>>>>>>>                                */
               }
          }
      }
}
                                                                             /*
*******************************************************************************
*        ==============================================================      */
         int Draw_pname( nl, x0, y0, x1, y1, xp, yp, d0, nc, code, form )
/*       ==============================================================
*******************************************************************************
* ( Function )                                                                *
*   To determin the x-y position of the particle name of                      *
*      the propagator, and                                                    *
*   to draw the particle name at the position if it is found.                 *
*                                                                             *
*******************************************************************************
								             */
float x0, y0, x1, y1, xp, yp, d0;
int   nl, nc;
char  code[], form[];
{
 void urStringSize( );
 void urDrawString( );
 int  Chk_position( );

 void urplot( );

int  w, h, dcs; 
float xc, yc;
float xc1, yc1;
double  dd, a0, b0, a1, b1, a2, b2, theta;
double  xx0, yy0, xx1, yy1, xx2, yy2, xxc, yyc, xxp, yyp; 
double  ww, hh, sint, cost, aww, ahh, add;
double  wx, hx, dx;
int size_f, loop1, loop2, ok;

   /*
   if( nl == 10 )
     {
      printf("** Draw_pname code[%s]  form[%s]\n", code, form );
      printf("   d0( width ) = %5.1f\n", d0 );
      printf("   ( x0, y0 )  = (%8.1f, %8.1f )\n", x0, y0 );
      printf("   ( x1, y1 )  = (%8.1f, %8.1f )\n", x1, y1 );
      printf("   ( xp, yp )  = (%8.1f, %8.1f )\n", xp, yp );
      printf("   ( xp, yp )  = (%8.1f, %8.1f )\n", 
                  intline[nl].x, intline[nl].y );
     }
    */

 add = (double) d0;
 xx0 = (double) x0;
 yy0 = (double) -y0;
 xx2 = (double) x1;
 yy2 = (double) -y1;
 xxp = (double) xp;
 yyp = (double) -yp;

 size_f = size_flag;

for( loop1 = 0; loop1 < 2; loop1++ )
   {
     ok = 0;

     if( loop1 == 1 ) size_f = size_f - 1;

     if( size_f >= 0 )
       {
								      /*
========================================================================
        Obtain the half_width and half_height of the string
========================================================================
								      */
        urStringSize( size_f, nc, code, form, &dcs, &w, &h );

        aww = (double) w;
        ahh = (double) h;
        if( d0 == 0.0 )
            add = 0.5*aww;

	wx  = aww;
        hx  = ahh;
        dx  = add;
        if( yp+ahh+add > grheight+yoff )
          {
	    wx  = -aww;
            hx  = -ahh;
            dx  = -add;
           }

	ww  = wx;
        hh  = hx;
        dd  = dx;

	for( loop2 = 0; loop2 < 2; loop2++ )
           {
                /*
		 printf("**** loop1 =%5d  loop2 =%5d\n", loop1, loop2 );
                */

             if( loop2 == 1 )
               {
                 ww = -wx;
                 hh = -hx;
                 dd = -dx;
                }
             /*
	      printf("    ww = %5.1f, hh = %5.1f, dd = %5.1f\n", ww, hh, dd );
             */
								             /*
===============================================================================
    Determin the center point of string
===============================================================================
					          	                     */
             if( y0 == y1 )
               {
                 xxc =  xxp;
                 yyc =  yyp - 1.5*dd - hh;
                }
             else if( x0 == x1 )
               {
                 xxc = xxp + 1.5*dd + ww;
                 yyc = yyp;
                }
             else
               {
                 a0    = ( yy2 - yy0 )/( xx2 - xx0 );
                 theta = atan2( yy2 - yy0, xx2 - xx0 );
                 sint  = sin( theta );
                 if( sint < 0.0 ) sint = -sint;
                 cost  = cos( theta );
                 if( cost < 0.0 ) cost = -cost;

                 b0    = yyp - a0*xxp;
                 a1    = a0;
                 a2    = - 1.0/ a0;

                 if( a0 > 0.0 )
                   {
                     b1    = b0 - dd*cost - a0*dd*sint;

                     xx1   = xxp + dd*sint;
                     yy1   = yyp - dd*cost;

                     a2    = - 1.0/ a0;
                     b2    = yy1 - a2*xx1;

                     xxc   = ( hh + a1*ww - b1 + b2 )/( a1 - a2 );
                     yyc   = a2*xxc + b2;

                    }
                 else
                   {
                     b1    = b0 - dd*cost + a0*dd*sint;

                     xx1   = xxp - dd*sint;
                     yy1   = yyp - dd*cost;

                     b2    = yy1 - a2*xx1;

                     xxc   = ( hh - a1*ww - b1 + b2 )/( a1 - a2 );
                     yyc   = a2*xxc + b2;

                    }
                      /*
		       printf("   a0  =%5.1f a2  =%5.1f\n",-a0,-a2);
		       printf("   xxp =%5.1f yyp =%5.1f\n",xxp,-yyp);
		       printf("   xx1 =%5.1f yy1 =%5.1f\n",xx1,-yy1);
		       printf("   xxc =%5.1f yyc =%5.1f\n",xxc,-yyc);
                      */
                }


             xc  = (float)  xxc;
             yc  = (float) -yyc;

	     ok  = Chk_position( nl, d0, xc, yc, w, h );

             if( ok == 1 ) 
	       { 
		 loop2 = 2;
                 xc1 = xc,   yc1 = yc;

                 xxc = xxc - aww;
                 yyc = yyc - ahh;

                 xc  = (float) xxc;
                 yc  = (float) -yyc - (float) dcs ;

                }
            }

          if( ok == 1 ) loop1 = 2;
        }
   }

								      /*
========================================================================
  Draw the character string code in the format of form
========================================================================
								      */
 if( ok != 0 )
   {
       /*
         x0 = xc,                 y1 = yc + (float) dcs;
         x1 = xc + (float) 2*ww,  y0 = y1 - (float) 2*hh;
         urplot( x0, y0, 0.0, 0.0, x1, y0 );
         urplot( x1, y0, 0.0, 0.0, x1, y1 );
         urplot( x1, y1, 0.0, 0.0, x0, y1 );
         urplot( x0, y1, 0.0, 0.0, x0, y0 );
       /*
         printf("Draw_pname code[%s]  xp =%8.2f   xc =%8.2f\n",code, xp, xc);
         printf("           form[%s]  yp =%8.2f   yc =%8.2f\n",form, yp, yc);
         printf("           ww =%8.1f  hh =%8.2f\n",ww, hh);
      */

     urDrawString( size_f, xc, yc, nc, code, form );

     xch[nchar] = (int) xc1;
     ych[nchar] = (int) yc1;
     wch[nchar] = w;
     hch[nchar] = h;
     nchar++;
    }

 return ok;
}
                                                                      /*
************************************************************************
*             ======================================                  */
                 int Chk_position( nl, d0, xc, yc, w, h )
/*            ======================================
************************************************************************
* ( Function )                                                         *
*   To check the x-y position of the particle name of                  *
*      the propagator, and                                             *
*   to return the result as a function value.                          *
*                                                                      *
************************************************************************
								      */
float  d0, xc, yc;
int    nl, w,  h;
{
int l, m, n, v0, v1, returnf;
float x0, y0, x1, y1, x2, y2, x3, y3;
float xx0, yy0, xx1, yy1, ww, hh;
float  a, b, xb, yb;
float a0, b0, a1, b1, xxc, yyc, r2;
double tt;
float xch0, ych0, xch1, ych1, w1, h1;

ww = (float) w;
hh = (float) h;
returnf = 1;

xx0 = xc - ww - d0;
xx1 = xc + ww + d0;
yy0 = yc - hh - d0;
yy1 = yc + hh + d0;

      /*
         if( nl == 9 || nl == 10 )
           {
              printf("** nl  =%8d\n", nl );
              printf("   xc  =%8.2f  yc  =%8.2f", xc, yc );
              printf("   ww  =%8.2f  hh =%8.2f  d0 =%8.2f\n", 
	                 ww, hh, d0 );
              printf("   xx0 =%8.2f  xx1 =%8.2f\n", xx0, xx1 );
              printf("   yy0 =%8.2f  yy1 =%8.2f\n", yy0, yy1 );
              printf("   nl( %d )  x2( %6.1f )  y2( %6.1f )\n", 
                           nl, intline[nl].x, intline[nl].y );
            }
      */

for( n = 0; n < no_line; n++ )
   {
     if( intline[n].flag >= 0 && n != nl )
       {
         v0  =  inlvtx[n].vtxno[0];
         v1  =  inlvtx[n].vtxno[1];

         x0  =  vtx[v0].x*xscale + xoff;
         y0  =  vtx[v0].y*yscale + yoff;
         x1  =  vtx[v1].x*xscale + xoff;
         y1  =   vtx[v1].y*yscale + yoff;
         x2  =  intline[n].x;

	 if( x2 == 0.0 )
           {
	     if(      x0 > xx1 && x1 > xx1 ) ;
             else if( x0 < xx0 && x1 < xx0 ) ;
	     else if( y0 > yy1 && y1 > yy1 ) ;
             else if( y0 < yy0 && y1 < yy0 ) ;
             else
               {
	          if( y0 == y1 )
                    {
                      if( ( y0 > yy0 && y0 < yy1 ) &&
                          (( xc > x0 && xc < x1 ) || ( xc > x1 && xc < x0 )) )
                              returnf = 0;
                     }
	          else if( x0 == x1 )
                    {
                      if( ( x0 > xx0 && x0 < xx1 ) &&
                          (( yc > y0 && yc < y1 ) || ( yc > y1 && yc < y0 )) )
                              returnf = 0;
                     }
                  else
                    {
                      a = ( y1 - y0 )/( x1 - x0 );
                      b = y1 - a*x1;

	              for( m = 0; m < 2; m++ )
                         {
                           if( m == 0 ) yb = yy0;
                           else         yb = yy1;

                           xb = ( yb - b )/ a;

                           if( (  xb > xx0 && xb < xx1 ) &&
                               (( xb >  x0 && xb <  x1 ) ||
		                            ( xb > x1 && xb < x0 )) )
                                  returnf = 0;
                           if( returnf == 0 ) m = 2;
                          }

	              for( m = 0; m < 2; m++ )
                         {
                           if( m == 0 ) xb = xx0;
                           else         xb = xx1;

                           yb = a*xb + b;

                           if( (  yb > yy0 && yb < yy1 ) &&
                               (( yb >  y0 && yb <  y1 ) ||
			                    ( yb > y1 && yb < y0 )) )
                                  returnf = 0;
                           if( returnf == 0 ) m = 2;
                          }

                     }

                 }
            }
         else
           {
             x2  =  intline[n].x;
             y2  =  intline[n].y;

             /*
              if( ( nl == 9 || nl == 10 ) && ( n == 9 || n == 10 ) )
                {
                   printf(" Line#( %3d )  from v( %3d ) to v( %3d )\n",
                            n, v0, v1 );
                   if( x0 > x1 )
                       printf(" x1( %6.1f ) < xx0( %6.1f ) < x0( %6.1f ) ?\n",
                                x1, xx0, x0 );
                   else
                       printf(" x0( %6.1f ) < xx0( %6.1f ) < x1( %6.1f ) ?\n",
                                x0, xx0, x1 );
                   printf(" x2( %6.1f )  y2( %6.1f )\n", x2, y2 );
                   printf(" n( %d )  x2( %6.1f )  y2( %6.1f )\n", 
                            n, intline[n].x, intline[n].y );
                   if( x0 > x1 )
                       printf(" x1( %6.1f ) < xx1( %6.1f ) < x0( %6.1f ) ?\n",
                                x1, xx1, x0 );
                   else
                       printf(" x0( %6.1f ) < xx1( %6.1f ) < x1( %6.1f ) ?\n",
                                x0, xx1, x1 );
                   if( y0 > y1 )
                       printf(" y1( %6.1f ) < yy0( %6.1f ) < y0( %6.1f ) ?\n",
                                y1, yy0, y0 );
                   else
                       printf(" y0( %6.1f ) < yy0( %6.1f ) < y1( %6.1f ) ?\n",
                                y0, yy0, y1 );
                   if( y0 > y1 )
                       printf(" y1( %6.1f ) < yy1( %6.1f ) < y0( %6.1f ) ?\n",
                                y1, yy1, y0 );
                   else
                       printf(" y0( %6.1f ) < yy1( %6.1f ) < y1( %6.1f ) ?\n",
                                y0, yy1, y1 );
                 }
              */

	     if(      x0 > xx1 && x1 > xx1 && x2 > xx1 ) ;
             else if( x0 < xx0 && x1 < xx0 && x2 < xx0 ) ;
	     else if( y0 > yy1 && y1 > yy1 && y2 > yy1 ) ;
             else if( y0 < yy0 && y1 < yy0 && y2 < yy0 ) ;
             else
               {
                 if( y0 == y2 )
                   {
	             a1 = ( x2 - x1 )/(y1 - y2);
                     x3 = 0.5*( x1 + x2 ), y3 = 0.5*( y1 + y2 );
                     b1 = y3 - a1*x3;
                     xxc = 0.5*( x0 + x2 );
                     yyc = a1*xxc + b1;
                    }
                 else if( y1 == y2 )
                   {
                     a0 = ( x2 - x0 )/(y0 - y2);
                     x3 = 0.5*( x0 + x2 ), y3 = 0.5*( y0 + y2 );
                     b0 = y3 - a0*x3;
	             xxc = 0.5*( x1 + x2 );
	             yyc = a0*xxc + b0;
                    }
                 else
                   {
                     a0 = ( x2 - x0 )/(y0 - y2);
                     x3 = 0.5*( x0 + x2 ), y3 = 0.5*( y0 + y2 );
	             b0 = y3 - a0*x3;
                     a1 = ( x2 - x1 )/(y1 - y2);
	             x3 = 0.5*( x1 + x2 ), y3 = 0.5*( y1 + y2 );
	             b1 = y3 - a1*x3;
	             xxc = ( b0 - b1 )/( a1 - a0 );
	             yyc = a0*xxc + b0;
                    }
                 r2 = ( x0 - xxc )*( x0 -xxc ) 
		              + ( y0 - yyc )*( y0 - yyc );

                 for( m = 0; m < 2; m++ )
                    {
                      if( m == 0 ) yb = yy0;
                      else         yb = yy1;

		      tt = (double)( r2 - ( yb - yyc )*( yb - yyc ));
                      if( tt > 0.0 )
                        {
                          tt = sqrt( tt );
	                  for( l = 0; l < 2; l++ )
                             {
                               if( l == 0 ) xb = xxc + (float) tt;
                               else         xb = xxc - (float) tt;

                               if( xb > xx0 && xb < xx1 )
                                   returnf = 0;
                               if( returnf == 0 ) l = 2;

                              }
                         }
                      if( returnf == 0 ) m = 2;
                     }

                 for( m = 0; m < 2; m++ )
                    {
                      if( m == 0 ) xb = xx0;
                      else         xb = xx1;

		      tt = (double)( r2 - ( xb - xxc )*( xb - xxc ));
                      if( tt > 0.0 )
                        {
                          tt = sqrt( tt );

	                  for( l = 0; l < 2; l++ )
                             {
                               if( l == 0 ) yb = yyc + (float) tt;
                               else         yb = yyc - (float) tt;

                               if( yb > yy0 && yb < yy1 )
                                   returnf = 0;
                               if( returnf == 0 ) l = 2;

                              }
                         }
                      if( returnf == 0 ) m = 2;
                     }

                }
            }
        }
     if( returnf == 0 ) n = no_line;
    }

 if( returnf != 0 )
   {
     for( n = 0; n < nchar; n++ )
        {
          x2   = (float) xch[n];
          y2   = (float) ych[n];
          w1   = (float) wch[n];
          h1   = (float) hch[n];
          xch0 = x2 - w1;
          xch1 = x2 + w1;
          ych0 = y2 - h1;
          ych1 = y2 + h1;
          if(      xch0 > xx1 && xch1 > xx1 ) ;
          else if( xch0 < xx0 && xch1 < xx0 ) ;
          else if( ych0 > yy1 && ych1 > yy1 ) ;
          else if( ych0 < yy0 && ych1 < yy0 ) ;
          else
             returnf = 0;
         }
    }
    /*
    printf(" Chk_position  returnf =%3d\n", returnf );
    */

return returnf;
}
                                                                      /*
************************************************************************
*       =================================================             */
         int chk_clossing( nl, x0, y0, xc, yc, x1, y1 )
/*      =================================================
************************************************************************
* ( Function )                                                         *
*   To check whether the curved line nl closses other internal lines   *
*      or not.                                                         *
*   to return the result as a function value.                          *
*                                                                      *
************************************************************************
								      */
float  x0, y0, xc, yc, x1, y1;
int    nl;
{
int n, v0, v1, returnf;
float x2, y2, x3, y3;
float xmin0, xmax0, ymin0, ymax0;
float xx0, yy0, xx1, yy1, xx, yy;
float  a, b, aa, bb, cc;
float a0, b0, a1, b1, xxc, yyc, r2, r;
float dis;
double tt;

returnf = 0;
tt      = ( x1 - x0 )*( x1 - x0 ) + ( y1 - y0 )*( y1 - y0 );
tt      = sqrt( tt );
dis     = 0.1*tt;

xmin0 = 1.0e10, xmax0 = -1.0e10;
ymin0 = xmin0,  ymax0 =  xmax0;
if( xmin0 > x0 ) xmin0 = x0;
if( xmin0 > xc ) xmin0 = xc;
if( xmin0 > x1 ) xmin0 = x1;
if( xmax0 < x0 ) xmax0 = x0;
if( xmax0 < xc ) xmax0 = xc;
if( xmax0 < x1 ) xmax0 = x1;
if( ymin0 > y0 ) ymin0 = y0;
if( ymin0 > yc ) ymin0 = yc;
if( ymin0 > y1 ) ymin0 = y1;
if( ymax0 < y0 ) ymax0 = y0;
if( ymax0 < yc ) ymax0 = yc;
if( ymax0 < y1 ) ymax0 = y1;

     /*
      printf("**** line no.(%3d ) ******\n", nl );

      printf("x0     =%8.2f  y0     =%8.2f\n", x0, y0 );
      printf("xc     =%8.2f  yc     =%8.2f\n", xc, yc );
      printf("x1     =%8.2f  y1     =%8.2f\n", x1, y1 );
      printf("xmax0  =%8.2f  ymax0  =%8.2f\n", xmax0, ymax0 );
      printf("xmin0  =%8.2f  ymin0  =%8.2f\n", xmin0, ymin0 );
     */

if( y0 == yc )
  {
    a1 = ( xc - x1 )/(y1 - yc);
    x3 = 0.5*( x1 + xc ), y3 = 0.5*( y1 + yc );
    b1 = y3 - a1*x3;
    xxc = 0.5*( x0 + xc );
    yyc = a1*xxc + b1;
   }
else if( y1 == yc )
  {
    a0 = ( xc - x0 )/(y0 - yc);
    x3 = 0.5*( x0 + xc ), y3 = 0.5*( y0 + yc );
    b0 = y3 - a0*x3;
    xxc = 0.5*( x1 + xc );
    yyc = a0*xxc + b0;
   }
else
  {
    a0 = ( xc - x0 )/(y0 - yc);
    x3 = 0.5*( x0 + xc ), y3 = 0.5*( y0 + yc );
    b0 = y3 - a0*x3;
    a1 = ( xc - x1 )/(y1 - yc);
    x3 = 0.5*( x1 + xc ), y3 = 0.5*( y1 + yc );
    b1 = y3 - a1*x3;
    xxc = ( b0 - b1 )/( a1 - a0 );
    yyc = a0*xxc + b0;
   }
r2 = ( x0 - xxc )*( x0 -xxc ) 
            + ( y0 - yyc )*( y0 - yyc );
tt =(double) r2;
tt = sqrt( tt );
r  = (float) tt;

        /*
	 printf("  xxc = %6.1f  yyc = %6.1f  r = %6.1f\n", xxc, yyc, r );
        */

if( xxc > xmin0 && xxc < xmax0 )
  {
    if(  0.5*( ymin0 + ymax0 ) - yyc < 0.0 ) ymin0 = yyc - r;
    else                     ymax  = yyc + r;

      /*
       printf(" xmin0( %6.1f ) < xxc( %6.1f ) < xmax0( %6.1f )\n",
                xmin0, xxc, xmax0 );
       printf("xmax0  =%8.2f  ymax0  =%8.2f\n", xmax0, ymax0 );
       printf("xmin0  =%8.2f  ymin0  =%8.2f\n", xmin0, ymin0 );
      */
 
   }
else if( yyc > ymin0 && yyc < ymax0 )
  {
    if(  0.5*( xmin0 + xmax0 ) - xxc < 0.0 ) xmin0 = xxc - r;
    else                     xmax  = xxc + r;

      /*
       printf(" ymin0( %6.1f ) < yyc( %6.1f ) < ymax0( %6.1f )\n",
                ymin0, yyc, ymax0 );
       printf("xmax0  =%8.2f  ymax0  =%8.2f\n", xmax0, ymax0 );
       printf("xmin0  =%8.2f  ymin0  =%8.2f\n", xmin0, ymin0 );
      */

   }
 
for( n = 0; n < no_line; n++ )
   {
     if( intline[n].flag >= 0 && n != nl )
       {
         v0  =  inlvtx[n].vtxno[0];
         v1  =  inlvtx[n].vtxno[1];

              /*
	       printf("  n =%3d  from v(%3d ) to v(%3d )\n", n, v0, v1);
              */

         xx0  =  vtx[v0].x*xscale + xoff;
         yy0  =  vtx[v0].y*yscale + yoff;
         xx1  =  vtx[v1].x*xscale + xoff;
         yy1  =   vtx[v1].y*yscale + yoff;
         x2   =  intline[n].x;

	 if( x2 == 0.0 )
           {
	     if( xx0 == xx1 )
               {
                 if( xx0 < xmax0 && xx0 > xmin0 )
                   {
                     tt = (double) ( r2 - ( xx0 - xxc )*( xx0 - xxc ));
                     if( tt > 0.0 )
                       {
                         tt = sqrt( tt );

                         yy = yyc + tt;

                         /*
	        	      printf("** chk_clossing** xx0 = xx1 case\n");
                          printf("  yy0(%8.2f ) yy(%8.2f ) yy1 (%8.2f)\n",
                                    yy0, yy, yy1 );
                         */

                         if( yy > ymin0 && yy < ymax0 )
                           {
                             if( yy0 > yy1 && yy < yy0-dis && yy > yy1+dis )
                                 returnf = 1;
                             if( yy0 < yy1 && yy < yy1-dis && yy > yy0+dis )
                                 returnf = 1;
                            }

                         if( returnf == 0 )
                           {
                             yy = yyc - tt;

                             /*
	        	      printf("** chk_clossing** xx0 = xx1 case\n");
                              printf("  yy0(%8.2f ) yy(%8.2f ) yy1 (%8.2f)\n",
                                yy0, yy, yy1 );
                             */

                             if( yy > ymin0 && yy < ymax0 )
                               {
                                 if( yy0 > yy1 && yy < yy0-dis && yy > yy1+dis )
                                     returnf = 1;
                                 if( yy0 < yy1 && yy < yy1-dis && yy > yy0+dis )
                                     returnf = 1;
                                }
                           }
                        }
                    }
                }
             else
               {
                 a = ( yy1 - yy0 )/( xx1 - xx0 );
                 b = yy1 - a*xx1;

                 aa = 1.0 + a*a;
                 bb = a*b - xxc - a*yyc;
                 cc = xxc*xxc + ( yyc - b )*( yyc - b ) - r2;

		 tt = (double)( bb*bb - aa*cc );
                 if( tt > 0.0 )
                   {
                     tt = sqrt( tt );

		     xx = ( -bb - tt )/aa;
                     yy = a*xx + b;

                     /*
		      printf("** chk_clossing**\n");
                      printf("  xx0(%8.2f ) xx(%8.2f ) xx1 (%8.2f)\n",
                                xx0, xx, xx1 );
                      printf("  yy0(%8.2f ) yy(%8.2f ) yy1 (%8.2f)\n",
                                yy0, yy, yy1 );
                     */

                     if( xx > xmin0 && xx < xmax0 &&
                         yy > ymin0 && yy < ymax0 )
                       {
                         if( xx0 > xx1 && xx < xx0-dis && xx > xx1+dis )
                           {
                             if( yy0 > yy1 && yy < yy0-dis && yy > yy1+dis )
                                 returnf = 1;
                             if( yy0 < yy1 && yy < yy1-dis && yy > yy0+dis )
                                 returnf = 1;
                            }
                         else if( xx0 < xx1 && xx > xx0+dis && xx < xx1-dis )
                           {
                             if( yy0 > yy1 && yy < yy0-dis && yy > yy1+dis )
                                 returnf = 1;
                             if( yy0 < yy1 && yy < yy1-dis && yy > yy0+dis )
                                 returnf = 1;
                            }
                        }

                     if( returnf == 0 )
                       {
                         xx = ( -bb + tt )/aa;
                         yy = a*xx + b;

                            /*
                             printf("  xx0(%8.2f ) xx(%8.2f ) xx1 (%8.2f)\n",
                                       xx0, xx, xx1 );
                             printf("  yy0(%8.2f ) yy(%8.2f ) yy1 (%8.2f)\n",
                                       yy0, yy, yy1 );
                            */



                        if( xx > xmin0 && xx < xmax0 &&
                            yy > ymin0 && yy < ymax0 )
                          {
                            if( xx0 > xx1 && xx < xx0-dis && xx > xx1+dis )
                              {
                                if( yy0 > yy1 && yy < yy0-dis && yy > yy1+dis )
                                    returnf = 1;
                                if( yy0 < yy1 && yy < yy1-dis && yy > yy0+dis )
                                    returnf = 1;
                               }
                            else if( xx0 < xx1 && xx > xx0+dis && 
				     xx < xx1-dis )
                              {
                                if( yy0 > yy1 && yy < yy0-dis && yy > yy1+dis )
                                    returnf = 1;
                                if( yy0 < yy1 && yy < yy1-dis && yy > yy0+dis )
                                    returnf = 1;
                               }
                           }
                        }
                    }
                }
            }
         }
       /*
	 printf("          returnf =%3d\n",  returnf );
       */

      if( returnf == 1 ) n = no_line;
    }
    /*
    printf(" chk_clossing  returnf =%3d\n", returnf );
    */

return returnf;
}
