/****************************************************************************
   ======================================================================  */
     int gfname( name, general, gform, partcl, pform, anti, aform ) 
/* ======================================================================
*****************************************************************************
* (Function)                                                                *
*   To get the general name and its format,                                 *
*          the name of particle and its format,                             *
*          the name of anti-particle and its format, and  particle kind.    *
*                                                                           *
*****************************************************************************
									     */
char *name, *general, *gform, *partcl, *pform, *anti, *aform;
{
									     /*
-----------------------------------------------------------------------------
  structure for the particle_table
-----------------------------------------------------------------------------
									     */
static struct particle_list {
   char *callname;
   char *gname;
   char *gform;
   char *particle;
   char *paform;
   char *antip;
   char *anform;
   int  prop;
   }  particle_table[] = {
                                                                             /*
+-------------------+-----+-----+---------+-----+--------------+-----+-------+
         call       generl gform  particle pform  anti_particle  form  direct
+0------------------+-----+-----+---------+-----+--------------+-----+-------+
                                                                              */
"anti-chargino1",    "c1", "Wl",     "c1+", "Wla",        "c1-", "Wla", -11,/**/
"anti-chargino2",    "c2", "Wl",     "c2+", "Wla",        "c2-", "Wla", -11,/**/
"anti-muon",         "m",  "s",      "m+", "su",          "m-",  "su",   -1,
"anti-sb1",          "b1", "wl",     "b1*", "wla",        "b1",  "wl",  -13,/**/
"anti-sb2",          "b2", "wl",     "b1*", "wla",        "b1",  "wl",  -13,/**/
"anti-scl",          "cL", "wl",     "cL*", "wla",        "cL",  "wl",  -13,/**/
"anti-scr",          "cR", "wl",     "cR*", "wla",        "cR",  "wl",  -13,/**/
"anti-sdl",          "dL", "wl",     "dL*", "wla",        "dL",  "wl",  -13,/**/
"anti-sdr",          "dR", "wl",     "dR*", "wla",        "dR",  "wl",  -13,/**/
"anti-selectronl",   "eL", "wl",     "eL+", "wla",        "eL-", "wla", -13,/**/
                                                                              /*
+1------------------+-----+-----+---------+-----+--------------+-----+-------+
                                                                              */
"anti-selectronr",   "eR", "wl",     "eR+", "wla",        "eR-", "wla", -13,/**/
"anti-smuonl",       "mL", "Wl",     "mL+", "Wla",        "mL-", "Wla", -13,/**/
"anti-smuonr",       "mR", "Wl",     "mR+", "Wla",        "mR-", "Wla", -13,/**/
"anti-snu-e",        "ne", "Wl",     "ne*", "Wla",        "ne",  "Wl",  -13,/**/
"anti-snu-mu",       "nm", "WL",     "nm*", "WLa",        "nm",  "WL",  -13,/**/
"anti-snu-tau",      "nt", "WL",     "nt*", "WLa",        "nt",  "WL",  -13,/**/
"anti-ssl",          "sL", "wl",     "sL*", "wla",        "sL",  "wl",  -13,/**/
"anti-ssr",          "sR", "wl",     "sR*", "wla",        "sR",  "wl",  -13,/**/
"anti-st1",          "t1", "wl",     "t1*", "wla",        "t1",  "wl",  -13,/**/
"anti-st2",          "t2", "wl",     "t2*", "wla",        "t2",  "wl",  -13,/**/
                                                                              /*
+2------------------+-----+-----+---------+-----+--------------+-----+-------+
                                                                              */
"anti-stau1",        "t1", "Wl",     "t1*", "Wla",        "t1",  "Wl",  -13,/**/
"anti-stau2",        "t2", "Wl",     "t2*", "Wla",        "t2",  "Wl",  -13,/**/
"anti-sul",          "uL", "wl",     "uL*", "wla",        "uL",  "wl",  -13,/**/
"anti-sur",          "uR", "wl",     "uR*", "wla",        "uR",  "wl",  -13,/**/
"anti-tau",          "t",  "s",      "t+",  "su",         "t-",  "su",   -1,
"b",                 "b",  "t",      "b",   "t",          "b",   "t",     1,
"b-bar",             "b",  "t",      "b",   "o",          "b",   "o",    -1,
"c",                 "c",  "t",      "c",   "t",          "c",   "t",     1, 
"c-a",               "cg", "tU",     "cg",  "tU",         "cg",  "oU",    2,
"c-a-bar",           "cg", "tU",     "cg",  "oU",         "cg",  "tU",   -2,
                                                                              /*
+3------------------+-----+-----+---------+-----+--------------+-----+-------+
                                                                              */
"c-bar",             "c",  "t",      "c",   "o",          "c",   "t",    -1,
"c-g",               "cg", "tu",     "cg",  "tu",         "cg",  "ou",    2,
"c-g-bar",           "cg", "tu",     "cg",  "ou",         "cg",  "tu",   -2, 
"c-minus",           "c-", "tu",     "c-",  "tu",         "c+",  "ou",    2,
"c-minus-bar",       "c-", "tu",     "c+",  "ou",         "c-",  "tu",   -2,
"c-plus",            "c+", "tu",     "c+",  "tu",         "c-",  "ou",    2,
"c-plus-bar",        "c+", "tu",     "c-",  "ou",         "c+",  "tu",   -2,
"c-z",               "cZ", "tu",     "cZ",  "tu",         "cZ",  "ou",    2, 
"c-z-bar",           "cZ", "tu",     "cZ",  "ou",         "cZ",  "tu",   -2,
"charged-higgs-minus","H", "t",      "H-",  "tu",         "H+",  "tu",  -13,/**/
                                                                              /*
+4------------------+-----+-----+---------+-----+--------------+-----+-------+
                                                                              */
"charged-higgs-plus","H",  "t",      "H+",  "tu",         "H-",  "tu",   13,/**/
"chargino1",         "c1", "Wl",     "c1-", "Wla",        "c1+", "Wla",  11,/**/
"chargino2",         "c2", "Wl",     "c2-", "Wla",        "c2+", "Wla",  11,/**/
"chi-3",             "c3", "sl",     "c3",  "sl",         "c3",  "sl",    2,
"chi-minus",         "c",  "s",      "c-",  "su",         "c+",  "su",   -2,
"chi-plus",          "c",  "s",      "c+",  "su",         "c-",  "su",    2,
"d",                 "d",  "t",      "d",   "t",          "d",   "o",     1,   
"d-bar",             "d",  "t",      "d",   "o",          "d",   "t",    -1,
"electron",          "e",  "t",      "e-",  "tu",         "e+",  "tu",    1,
"gluino",            "g",  "W",      "g",   "W",          "g",   "W",    12,/**/
                                                                              /*
+5------------------+-----+-----+---------+-----+--------------+-----+-------+
                                                                              */
"gluon",             "g",  "t",      "g",   "t",          "g",   "t",     5,
"higgs",             "H",  "t",      "H",   "t",          "H",   "t",     3,
"muon",              "m",  "s",      "m-",  "su",         "m+",  "su",    1, 
"neutral-higgs1",    "ho", "tu",     "ho",  "tu",         "ho",  "tu",   13,/**/
"neutral-higgs2",    "Ho", "tu",     "Ho",  "tu",         "Ho",  "tu",   13,/**/
"neutral-higgs3",    "Po", "tu",     "Po",  "tu",         "Po",  "tu",   13,/**/
"neutralino1",       "c 1", "Wtl",   "c 1o","Wtla",       "c 1o","Wtla", 12,/**/
"neutralino2",       "c 2", "Wtl",   "c 2o","Wtla",       "c 2o","Wtla", 12,/**/
"neutralino3",       "c 3", "Wtl",   "c 3o","Wtla",       "c 3o","Wtla", 12,/**/
"neutralino4",       "c 4", "Wtl",   "c 4o","Wtla",       "c 4o","Wtla", 12,/**/
                                                                              /*
+6------------------+-----+-----+---------+-----+--------------+-----+-------+
                                                                              */
"nu-e",              "ne", "sl",     "ne",  "sl",         "ne",  "Ol",    1,
"nu-e-bar",          "ne", "sl",     "ne",  "Ol",         "ne",  "sl",   -1,
"nu-mu",             "nm", "sL",     "nm",  "sL",         "nm",  "OL",    1,
"nu-mu-bar",         "nm", "sL",     "nm",  "OL",         "nm",  "sL",   -1,
"nu-tau",            "nt", "sL",     "nt",  "sL",         "nt",  "OL",    1,   
"nu-tau-bar",        "nt", "sL",     "nt",  "OL",         "nt",  "sL",   -1,
"photino",           "g",  "W",      "g",   "W",          "g",   "W",    12,/**/
"photon",            "g",  "s",      "g",   "s",          "g",   "s",     4,
"positron",          "e",  "t",      "e+",  "tu",         "e-",  "tu",   -1,
"s",                 "s",  "t",      "s",   "t",          "s",   "o",     1,
                                                                              /*
+7------------------+-----+-----+---------+-----+--------------+-----+-------+
                                                                              */
"s-bar",             "s",  "t",      "s",   "o",          "s",   "t",    -1, 
"sb1",               "b1", "wl",     "b1",  "wl",         "b1*", "wla",  13,/**/
"sb2",               "b2", "wl",     "b1",  "wl",         "b1*", "wla",  13,/**/
"scl",               "cL", "wl",     "cL",  "wl",         "cL*", "wla",  13,/**/
"scr",               "cR", "wl",     "cR",  "wl",         "cR*", "wla",  13,/**/
"sdl",               "dL", "wl",     "dL",  "wl",         "dL*", "wla",  13,/**/
"sdr",               "dR", "wl",     "dR",  "wl",         "dR*", "wla",  13,/**/
"selectronl",        "eL", "wl",     "eL-", "wla",        "eL+", "wla",  13,/**/
"selectronr",        "eR", "wl",     "eR-", "wla",        "eR+", "wla",  13,/**/
"smuonl",            "mL", "Wl",     "mL-", "Wla",        "mL+", "Wla",  13,/**/
                                                                              /*
+8------------------+-----+-----+---------+-----+--------------+-----+-------+
                                                                              */
"smuonr",            "mR", "Wl",     "mR-", "Wla",        "mR+", "Wla",  13,/**/
"snu-e",             "ne", "Wl",     "ne",  "Wl",         "ne*", "Wla",  13,/**/
"snu-mu",            "nm", "WL",     "nm",  "WL",         "nm*", "WLa",  13,/**/
"snu-tau",           "nt", "WL",     "nt",  "WL",         "nt*", "WLa",  13,/**/
"ssl",               "sL", "wl",     "sL",  "wl",         "sL*", "wla",  13,/**/
"ssr",               "sR", "wl",     "sR",  "wl",         "sR*", "wla",  13,/**/
"st1",               "t1", "wl",     "t1",  "wl",         "t1*", "wla",  13,/**/
"st2",               "t2", "wl",     "t2",  "wl",         "t2*", "wla",  13,/**/
"stau1",             "t1", "Wl",     "t1",  "Wl",         "t1*", "Wla",  13,/**/
"stau2",             "t2", "Wl",     "t2",  "Wl",         "t2*", "Wla",  13,/**/
                                                                              /*
+9------------------+-----+-----+---------+-----+--------------+-----+-------+
                                                                              */
"sul",               "uL", "wl",     "uL",  "wl",         "uL*", "wla",  13,/**/
"sur",               "uR", "wl",     "uR",  "wl",         "uR*", "wla",  13,/**/
"t",                 "t",  "t",      "t",   "t",          "t",   "o",     1,
"t-bar",             "t",  "t",      "t",   "o",          "t",   "t",    -1,
"tau",               "t",  "s",      "t-",  "su",         "t+",  "su",    1,
"u",                 "u",  "t",      "u",   "t",          "u",   "o",     1,
"u-bar",             "u",  "t",      "u",   "o",          "u",   "t",    -1,   
"w-minus",           "W",  "t",      "W-",  "tu",         "W+",  "tu",   -4,
"w-plus",            "W",  "t",      "W+",  "tu",         "W-",  "tu",    4,
"z",                 "Z",  "t",      "Z",   "t",          "Z",   "t",     4  }; 
                                                                              /*
10------------------+-----+-----+---------+-----+--------------+-----+-------+

  direct code
      {  1 /  -1 } = { fermion / anti }
      {  2 /  -2 } = { Ghost }
      {  3 }       = { Higgs }
      {  4 }       = { photon, W, and Z }
      {  5 }       = { Gluon }
      { 11 / -11 } = { SUSY Dirac fermion}
      { 12 }       = { SUSY Majorana particles}
      { 13 / -13 } = { SUSY scalar }
                                                                             */
                                                                             /*
========================= Entry of gfname =====================================
                                                                             */

int cond, low, high, mid, n, no_name, ret;

ret     =  0;
low     =  0;
no_name = 100;
high    = no_name - 1;

while( low <= high )
 {
   mid = ( low + high ) / 2;

          /*
           printf(" low[ %3d ] < mid[ %3d ] < high[ %3d ]\n",
                    low, mid, high );
           printf(" name (%s)      particle_table[%d].callname (%s)\n", 
	            name, mid, particle_table[mid].callname );
          */

   cond = strcmp( name, particle_table[mid].callname );

   if(   cond  < 0 )
         high = mid - 1;
   else if( cond > 0 )
         low  = mid + 1;
   else
      {
         strcpy( general, particle_table[mid].gname );
         strcpy( gform,   particle_table[mid].gform );
         strcpy( partcl,  particle_table[mid].particle );
         strcpy( pform,   particle_table[mid].paform );
         strcpy( anti,    particle_table[mid].antip);
         strcpy( aform,   particle_table[mid].anform);

         ret =  particle_table[mid].prop;

           /*
            printf(" name (%s) general (%s) gform(%s)  mid = %d ret = %d\n",
                     name, general, gform, mid, ret );
            printf(" name (%s)  partcl (%s) pform(%s)\n",
                     name, partcl, pform );
            printf(" name (%s)    anti (%s) aform(%s)\n",
                     name, anti, aform );
           */

         return ret;
       }
          /*
           printf(" low[ %3d ] < high[ %3d ]\n",
                    low, high );
          */
  }

  printf("************* Fatal Error at gfname **************\n" );
  printf("\n" );
  printf("  Searched particle name : %s\n", name );
  printf("    was not found in the name_list of particles.\n" );
  printf("  When you could not find any mistake,\n" );
  printf("    ask  Setsuya Kawabata at KEK\n" );
  printf("\n" );

  low     =  0;
  high    = no_name - 1;
  while( low+10 <= high )
   {
     mid = ( low + high ) / 2;

     cond = strcmp( name, particle_table[mid].callname );

     if(   cond  < 0 )
           high = mid - 1;
     else if( cond > 0 )
           low  = mid + 1;
    }

  printf("  The particle names in the table are :\n" );
  printf("\n" );
    for( n = low; n < high; n++ )
         printf(" %4d  %s\n", n, particle_table[n].callname );
  printf("\n" );
  printf("************* Fatal Error at gfname **************\n" );

 exit( 0 );

}
