
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#define MXLEN  80
#define MXVTX  100
#define MXLINE 100
#define MXGRF  10000
#define MXEXTV 100
  
FILE *input, *fp;
int  read_flag;
long addr_graph[5][MXGRF], no_graph;
int  unitary_guage[MXGRF], no_unitary;
int  susy_included[MXGRF];
	
char inputfile[100];
                                                                            /*
==============================================================================
    Buffer for the process information
==============================================================================
                                                                            */
struct ext_vtx {
	char kind[4];         /* kind = "ini" / "fin" / "vtx"  */
	}     extv[MXEXTV];

                                                                            /*
==============================================================================
    Buffer for the graph information
==============================================================================
                                                                            */
struct vertex {
	int     flag;          /* to be appeared in the drawing graph     */
	int     cntr_flag;     /* flg > 9 then SUSU, flg = 1 / 11 then C-V*/
	char    kind[4];       /* kind = "ini" / "fin" / "vtx"  */
	float   x;             /* x position of the vertex in the graph   */
	float   y;             /* y position of the vertex in the graph   */
	int     no_line;       /* the number of internal lines connected  */
        }       vtx[MXVTX];

long vtx_size = sizeof( struct vertex );

struct vtx_line {
	int    vtxno[10];
        int    lineno[10];
       }  vtxline[MXVTX];

long vtxline_size = sizeof( struct vtx_line );

struct int_line {
	int   flag;
	char  kind[4];      /* kind = "int" / "ext"                */
        float x;
        float y;
	int   direct;       /* = 1 / -1 / 0 = [0]->[1]/[1]->[0]/no */
	char  species[4];   /* particle name                       */
	char  form[4]   ;   /* format of particle name             */
	int   print;
        }     intline[MXLINE];

long intl_size = sizeof( struct int_line );

struct inl_vtx {
	int    vtxno[2];
       }  inlvtx[MXLINE];

long inlvtx_size = sizeof( struct inl_vtx );

                                                                            /*
==============================================================================
   global parameters 
==============================================================================
                                                                            */
int graph_no, no_extern, no_vertex, no_line;
int no_initial, no_final;
                                                                            /*
******************************************************************************
*                      ===================                                  */
                         void gfinit( )
/*                     ===================
******************************************************************************
* (Function )                                                                *
*  Read the process information                                              *
*  at the beginning of reading the out.grf                                   *
*        i.e. initial and final states information                           *
*                                                                            *
*****************************************************************************/
{
                                                                            /*
  ----------------------
     Local variables
  ----------------------
                                                                            */
/*   char *definput = "out.grf";*/
     char definput[100];
                                                                            /*
  ----------------------
       Functions
  ----------------------
                                                                            */
   int  strindex  (  );
   int  strnext   (  );
   int  strtoi    (  );
   void strcopy   (  );

     strcpy(definput,inputfile);
                                                                            /*
=======================  Entry point of gfinit ===============================

==============================================================================
      Open the input file
==============================================================================
                                                                            */
   if( ( input = fopen( definput, "r" ) ) == NULL )
       {
	 fprintf( stderr,"tgdinit : can't open default input file %s\n",
                   definput );
                  exit( 2 );
        }
                                                                            /*
==============================================================================
      Initialization
==============================================================================
                                                                            */
   no_graph   =  0;   /* the number of graphs - 1                           */
   no_unitary =  0;   /* the number of graphs in unitary guage              */
   no_initial =  0;   /* the number of initial state particles              */
   no_final   =  0;   /* the number of final state particles                */
   no_vertex  =  0;   /* the number of vertecies                            */
                                                                            /*
==============================================================================
     open the temporary file for the graph
==============================================================================
                                                                            */
 if(( fp = tmpfile() ) == NULL )
   {
     fprintf( stderr, " gfinit : fopen error  tmpfile\n" );
     exit(1);
    }
}

/*****************************************************************************
*                     ===================                                   */
                        int gfread(  )
/*                    ===================
******************************************************************************
* (Function )                                                                *
*  Read one graph information from the input file "out.grf"                  *
*                                                                            *
*****************************************************************************/
{
                                                                            /*
  ----------------------
     Local variables
  ----------------------
                                                                            */
int rflag, unitary, susy;
char *vertx = "vtx" ;
char *internal = "int", *external = "ext";
char line[MXLEN];
int  vertex_no;
int  line_n[10], line_no, n_line;
int  i, j, nv, nl, n, pos, pot, *intp, *intp1;
int  mxlineno;
char *point, *pnt, temp[40], temp0[40], temp1[40], temp2[40];
char gname[40], prtcl[40], antip[40];
char gform[40], pform[40], aform[40];
int  direct, unitaty;
char *initial  = "initial", *final = "final" ;
char *ini  = "ini", *fin = "fin" ;
                                                                            /*
---------------
  Functions
---------------
                                                                            */
int  strindex  ( );
int  strnext   ( );
int  strtoi    ( );
void strcopy   ( );
int  strlength ( );
void stcopy    ( );
void strcntr   ( );
void vtx_print ( );
void intl_print( );
int  tgdname   ( ); 
/*
int  strset    ( );
*/
                                                                            /*
=======================  Entry point of gfread ===============================
==============================================================================
    Initialization before read one graph information
==============================================================================
                                                                            */
for( nv = 0 ; nv < no_extern+1 ; nv++ )
   {
     strcpy( vtx[nv].kind, extv[nv].kind );
    }

for( nv = 0 ; nv < MXVTX ; nv++ )
   {
     vtx[nv].x       = 0.0;
     vtx[nv].y       = 0.0;
     vtx[nv].no_line = 0;
    }

for( n = 0 ; n < MXLINE; n++ )
   {
     inlvtx[n].vtxno[0]    = -1;
     intline[n].direct     =  0;
    }

unitary = 1;
susy    = 0;

                                                                            /*
==============================================================================
    Read graph informatiom from the input file out.grf
==============================================================================
                                                                            */
read_flag = 0, no_vertex = 0, mxlineno = 0;
                                                                      
         /*
          printf("***** no_graph = %d *******\n", no_graph );
         */
                                                                            /*
------------------------------------------------------------------------------
   read one line of graph information 
------------------------------------------------------------------------------
                                                                            */
while( ( fgets( line, MXLEN, input ) != NULL) && read_flag < 2 )
 {
      /*
       printf("%s", line );
      */

   pot  = strnext( line, 0, 1 );

                                                                            /*
   +------------------------------------------------------------------------+
   | (A) if the first character is digital number                           |
   +------------------------------------------------------------------------+
                                                                            */
   if( isdigit( line[pot] ) != 0 )
     {
                                                                            /*
       +---------------------------------------------------------------------+
       |(I)  get new vertex information                                      |
       +---------------------------------------------------------------------+
                                                                            */
       if( read_flag == 0 )
         {                                                                  /*
          +------------------------------------------------------------------+
          | (1) resolve the vertex numberr: vertex_no                        |
          +------------------------------------------------------------------+
                                                                            */
           n_line    = 0;
	   vertex_no = strtoi( line, pot );
                                                                            /*
          +------------------------------------------------------------------+
          | (2) set kind = "vertex" if it is not external.                   |
          +------------------------------------------------------------------+
                                                                            */
	   if( no_vertex > no_extern )
	     {
               strcpy( vtx[vertex_no].kind, vertx );
               strcpy( temp, vertx );
              }
           else
	     {
               strcpy( temp, vtx[vertex_no].kind );
              }

           while( isdigit( line[pot] ) )
                  pot++;
           strcopy( temp0, line, pot, pot );

           vtx[vertex_no].cntr_flag = 0;
           if( strcmp( "[", temp0) == 0 )
             {
               pos = strindex( line, "loop", pot );
               pot = strindex( line, "]", pot );
               if( pos > 0 )
                   vtx[vertex_no].cntr_flag = 1;
              }

           pos = strindex( line, "{", pot );
           pos = strnext ( line, pos+1, 1 );

                     /*
                      printf("  vtx[vertex_no = %d].kind = %s\n", 
                               vertex_no, vtx[vertex_no].kind );
                     */
                                                                            /*
          +------------------------------------------------------------------+
          | (3) resolve the internal line information                        |
          +------------------------------------------------------------------+
                                                                            */
           for( n = 0; n < 4; n++) 
              {
                       /*
                        printf("   n = %d\n", n );
                       */
                                                                            /*
                +------------------------------------------------------------+
                | (i) get the internal line number : line_no                 |
                |         (( caution )) line_no = Ninput - 1                 |
                +------------------------------------------------------------+
                                                                            */
		line_no    = strtoi( line, pos )-1;
		vtxline[vertex_no].lineno[n]  = line_no;
                if( line_no > mxlineno )
                    mxlineno = line_no;
                n_line++;
                                                                            /*
                +------------------------------------------------------------+
                | (ii) save vertex_no in buff intl_vtxno[][]                 |
	        |      and kind into the struct intline                      |
                +------------------------------------------------------------+
                                                                            */
                       /*
                       printf("   inlvtx[line_no = %d].vtxno[0] = %d\n",
                                  line_no, inlvtx[line_no].vtxno[0] );
                       */

                if( inlvtx[line_no].vtxno[0] < 0 )
		  {
                    inlvtx[line_no].vtxno[0] = vertex_no;
                    if( strcmp( vertx, temp) == 0 )
		        strcpy( temp1, internal );
                    else
		        strcpy( temp1, external );
                   }
                else
                  {
	            inlvtx[line_no].vtxno[1] = vertex_no;
		    if( strcmp( vertx, temp) == 0 && 
		        strcmp( intline[line_no].kind, internal ) == 0 )
		        strcpy( temp1, internal );
                    else
		        strcpy( temp1, external );

                          /*
                            printf("   inlvtx[line_no = %d].",
                               line_no );
                            printf("vtxno[1] = %d\n",
                               inlvtx[line_no].vtxno[1] );
                          */
                   }

                strcpy( intline[line_no].kind, temp1 );

                       /*
                        printf("   intline[line_no = %d].kind = %s\n", 
                                   line_no, intline[line_no].kind );
                       */
                                                                            /*
                +------------------------------------------------------------+
                | (iii) get particle species and determine direction         |
                +------------------------------------------------------------+
                                                                            */
                 pot = strindex( line, "[", pos )+1;
                 pos = strnext ( line, pot,   1 );
                 pot = strindex( line, "]", pos )-1;
		 if( intline[line_no].direct == 0 )
		   {
                     strcopy( temp0, line, pos, pot );
     
                     direct = gfname( temp0, gname, gform, 
				       prtcl, pform, antip, aform );
                           /*
                             printf("   name (%s)  dir (%d) gname (%s)",
                                        temp0, direct, gname );
                             printf("  particle (%s)  anti (%s)\n",
                                        prtcl, antip );
                           */

                     if( iabs( direct ) == 2 )
                         unitary = 0;
                     if( iabs( direct ) > 10 )
                         susy    = 1;

		     if( strcmp( ini,  extv[vertex_no].kind ) == 0 )
                       {
                         strcpy( temp1, antip );
			 strcpy( temp2, aform );
                        }
                     else if( strcmp( fin,  extv[vertex_no].kind ) == 0 )
                       {
                         strcpy( temp1, prtcl );
                         strcpy( temp2, pform );
                        }
		     else
                       {
                         strcpy( temp1, gname );
                         strcpy( temp2, gform );
                        } 
                     strcpy( intline[line_no].species, temp1 ); 
                     strcpy( intline[line_no].form, temp2 ); 
                     if( direct > -4 && direct < 4 )
                         direct = - direct;
                     intline[line_no].direct = direct;
                     intline[line_no].print   = 1;

                         /*
                          printf(" line_no = %d, intline[ species = %s,", 
                                   line_no, intline[line_no].species );
                          printf("  kind = %s], direct = %d\n", 
                                    intline[line_no].kind, direct );
                         */
                    }
		
                 if( vtx[vertex_no].cntr_flag == 1 && n > 1 )
                     vtx[vertex_no].cntr_flag = 2 ;
                 pot = pot + 3;
		 pos = strnext ( line, pot,   1 );
		 if( pos == pot )
                     n = 4;
                }
                
                                                                            /*
          +------------------------------------------------------------------+
          | (4) save the internal line information                           |
          +------------------------------------------------------------------+
                                                                            */
             vtx[vertex_no].no_line = n_line;
             no_vertex++;
           }
                                                                            /*
       +---------------------------------------------------------------------+
       |(II)  get the process information                                    |
       +---------------------------------------------------------------------+
                                                                            */
       else if( read_flag == 1 )
         {
           vertex_no = strtoi( line, pot );
  
           if( ( pos = strindex( line, initial, pot ) ) > pot )
             {
                strcpy( extv[vertex_no].kind, ini ), no_initial++;
              }
           else if( ( pos = strindex( line, final, pot ) ) > pot )
	     {
                strcpy( extv[vertex_no].kind, fin), no_final++;
              }
           no_vertex++;
          }
      }
                                                                            /*
   +-------------------------------------------------------------------------+
   | (B) get the graph number : graph_no                                     |
   +-------------------------------------------------------------------------+
                                                                            */
   else if( ( pos = strindex( line, "Graph", pot )) >= 0 )
     {
       pos = strindex( line, "=", pos ) + 1;
       graph_no = strtoi( line, pos );
           /*
            printf(" graph_no =%5d\n", graph_no );
           */
      }
                                                                            /*
   +-------------------------------------------------------------------------+
   | (C) The end of graph information was recognized.                        |
   +-------------------------------------------------------------------------+
                                                                            */
   else if( ( pos = strindex( line, "Gend", pot )) >= 0 )
     {
             read_flag = 2;
           /*
            printf(" Gend was found\n" );
           */
      }
                                                                            /*
   +-------------------------------------------------------------------------+
   | (D) The end of Process information was recognized.                      |
   +-------------------------------------------------------------------------+
                                                                            */
   else if( ( pos = strindex( line, "Process", pot )) >= 0 )
     {
            read_flag = 1;
            no_initial =  0;   /* the number of initial state particles     */
            no_final   =  0;   /* the number of final state particles       */
            no_vertex  =  0;   /* the number of vertecies                   */
           /*
            printf(" Procces information starts\n" );
           */
      }
   else if( ( pos = strindex( line, "Eend", pot )) >= 0 )
     {
            no_extern = no_initial + no_final - 1;
            read_flag = 3;
              /*
               printf(" Procces information starts\n" );
               printf(" no_initial = %d, no_final = %d\n", 
	       no_initial, no_final );
               for( n = 0; n <= no_extern; n++ ) 
                  {
                    printf(" vertex[%d]   %s\n", n, extv[n].kind );
                   }
             */
      }
  }
                                                                            /*
------------------------------------------------------------------------------
       save vertex numbers in struct intline 
------------------------------------------------------------------------------
                                                                            */
if( read_flag == 2 )
  {
    nl  =  0;
    for( n = 0; n < mxlineno+1; n++ )
       {
         if( inlvtx[n].vtxno[0] >= 0 ) 
           {
             intline[nl].print   = 1;
             intline[nl].flag    = 0;
             intline[nl].x       = 0.0;
             intline[nl].y       = 0.0;
             nl++;
            }
        }

    no_line = nl;
                                                                            /*
------------------------------------------------------------------------------
   save connected vertex_no in struct vtx[n].vertex_no
------------------------------------------------------------------------------
                                                                            */
    for( vertex_no = 0; vertex_no < no_vertex; vertex_no++ )
       {
         n_line = vtx[vertex_no].no_line;
         vtx[vertex_no].flag  =        0;
         for( i = 0; i < n_line; i++ )
            {
	      line_no = vtxline[vertex_no].lineno[i];
	      n       = inlvtx[line_no].vtxno[0];
	      if( vertex_no != n )
                  vtxline[vertex_no].vtxno[i] = n;
              else
                  vtxline[vertex_no].vtxno[i] = inlvtx[line_no].vtxno[1];
             }
        }

    addr_graph[0][no_graph] = graph_no;
    susy_included[no_graph] = susy;
    if( unitary == 1 )
      {
        unitary_guage[no_unitary] = no_graph;
        no_unitary++;
       }
    no_graph++;

   }
                                                                            /*
==============================================================================
     Return from read graph  
	      return code = ( 0 / 1 ) = ( normal / EOF )
==============================================================================
                                                                            */
rflag = 1;
if( read_flag < 2 )
    return rflag;
  
rflag = 0;
return rflag;

}

/*****************************************************************************
*                       ===================                                 */
                         void gfclose(  )
/*                      ===================
******************************************************************************
* (Function )                                                                *
*  To close the input file out.grf                                           *
*                                                                            *
*****************************************************************************/
{
  fclose( input );

}

/*****************************************************************************
*                       ===================                                 */
                          void gfsave( g )
/*                      ===================
******************************************************************************
* (Function )                                                                *
*  To save the current graph information                                     *
*      into the temporary file for the later use                             *
*                                                                            *
*****************************************************************************/
int g;
{
 int m = addr_graph[2][g];
 int n = addr_graph[4][g];

 if( fseek( fp, 0L, SEEK_END ) != 0 )
   {
     fprintf(stderr, " save : fseek error\n" );
     exit(1);
    }
 addr_graph[1][g] = ftell( fp );
 if( fwrite( vtx, vtx_size, m, fp ) != m )
   {
     fprintf(stderr, " save : fwrite error vtx\n" );
     exit(1);
    }
 if( fwrite( vtxline, vtxline_size, m, fp ) != m )
   {
     fprintf(stderr, " save : fwrite error vtxline\n" );
     exit(1);
    }
 if( fwrite( intline, intl_size, n, fp ) != n )
   {
     fprintf(stderr, " save : fwrite error intline\n" );
     exit(1);
    }
 if( fwrite( inlvtx, inlvtx_size, n, fp ) != n )
   {
     fprintf(stderr, " save : fwrite error inlvtx\n" );
     exit(1);
    }
}

/*****************************************************************************
*                       ====================                                */
	                 void gfrestore( g )
/*                      ===================
******************************************************************************
* (Function )                                                                *
*  To restore the g-th graph information from the temporary file             *
*                                                                            *
*****************************************************************************/
int g;
{
 int m = addr_graph[2][g];
 int n = addr_graph[4][g];

 if( fseek( fp, addr_graph[1][g], SEEK_SET ) != 0 )
   {
     fprintf( stderr, " restore : seek error\n" );
     exit(1);
    }
 if( fread( vtx, vtx_size, m, fp ) != m )
   {
     fprintf(stderr, " restore : fread error vtx\n" );
     exit(1);
    }
 if( fread( vtxline, vtxline_size, m, fp ) != m )
   {
     fprintf(stderr, " restore : fread error vtxline\n" );
     exit(1);
    }
 if( fread( intline, intl_size, n, fp ) != n )
   {
     fprintf(stderr, " restore : fread error intline\n" );
     exit(1);
    }
 if( fread( inlvtx, inlvtx_size, n, fp ) != n )
   {
     fprintf(stderr, " restore : fread error inlvtx\n" );
     exit(1);
    }
}

/*****************************************************************************
*                       ===================                                 */
                           void gflist( )
/*                      ===================
******************************************************************************
* (Function )                                                                *
*  To print the content of structures for debug                              *
*                                                                            *
*****************************************************************************/
{
  int n, n1, n2;

  void vtx_print ( );
  void intl_print( );


   printf("*** Graph number [%3d] serial number [%d]\n",
	   graph_no, no_graph);
   printf("====== Struct Vertex ============\n");
   for( n = 0; n < no_vertex; n++ ) {
        vtx_print( n );
	n1++;
       }

   printf("====== Struct Int_line ==========\n");
   for( n = 0; n < no_line; n++ )
      {
        intl_print( n );
	n2++;
       }

}

/*****************************************************************************
*                       ===================                                 */
                        void vtx_print( no )
/*                      ===================
******************************************************************************
* (Function )                                                                *
*  To print the content of structures vtx[] of vtx no for debug              *
*                                                                            *
*****************************************************************************/
int no;
{
  int n;

  printf("-------------------------------------------------------\n");
  printf("vertex ( %2d )  flag ( %d )  kind ( %s )", 
	  no, vtx[no].flag, vtx[no].kind );
  printf("  ( x, y ) = ( %5.1f, %5.1f )\n", vtx[no].x, vtx[no].y );
  printf("no_line ( %2d)",vtx[no].no_line);
  for( n = 0; n < vtx[no].no_line; n++ )
       printf("    line( %2d) ", vtxline[no].lineno[n] );
  printf("\n");
  printf("             ");
  for( n = 0; n < vtx[no].no_line; n++ )
       printf("    Vtex( %2d) ", vtxline[no].vtxno[n] );
  printf("\n");
}

/*****************************************************************************
*                       ===================                                 */
                        void intl_print( no )
/*                      ===================
******************************************************************************
* (Function )                                                                *
*  To print the content of structures intline[] of line no for debug         *
*                                                                            *
*****************************************************************************/
int no;
{
  int n;

  printf("-------------------------------------------------------\n");
  printf("line numbr ( %2d ) flag ( %d )  kind ( %s )  species ( %s )\n", 
	      no, intline[no].flag, intline[no].kind, intline[no].species );
  printf("direct ( %d )", intline[no].direct );
  if( intline[no].direct > 0 )
    {
      printf("   vtx( %d ) ===>", inlvtx[no].vtxno[0] );
      printf(" vtx( %d )\n",   inlvtx[no].vtxno[1] );
     }
  else
    {
      printf("   vtx( %d ) <===", inlvtx[no].vtxno[0] );
      printf(" vtx( %d )\n",   inlvtx[no].vtxno[1] );
     }
}
