/*********************************************************************
 * File : alist.c
 *
 *  Manipulate list data
 *
 *                                                  Kaneko Toshiaki
 */

#include <stdlib.h>
#include <stdio.h>
#include "grch.h"

/*====================================================================
        Entry points
*/

/*      Initialization */
Public  Void    alinit       ARG((NoArg));
Public  alist   alcons       ARG((int, int, alist));
Public  Void    alfree       ARG((alist));
Public  Void    alprint      ARG((alist,FILE*));

/*------------------------------------------------------------------*/

/* External references */
/* ergrf.c */
Extern  Void    erfail       ARG((NoArg));
Extern  Void    error        ARG((string, string));

/* Local functions */

/*==================================================================*/
Public  Void    alinit(NoArg)
/*--------------------------------------------------------------------
 *  initialization
 */
{
    alist a;

    for(a = 0; a < LALIST; a++)
        alcell[a].next = a + 1;
    alcfree = 0;
}

/*==================================================================*/
Public  alist   alcons(level, noden, next)
int     level;
int     noden;
alist   next;
/*--------------------------------------------------------------------
 */
{
    alist c;

    if(alcfree >= LALIST) {
        error("alcons", "free cell exhausted");
        erfail();
    }
    c = alcfree;
    alcfree = alcell[c].next;

    alcell[c].level = level;
    alcell[c].aleg  = noden;
    alcell[c].next  = next;

    return c;
}

/*==================================================================*/
Public  Void    alfree(l)
alist   l;
/*--------------------------------------------------------------------
 */
{
    alcell[l].next = alcfree;
    alcfree = l;
}

/*==================================================================*/
Public  Void    alprint(l, fp)
alist   l;
FILE   *fp;
/*--------------------------------------------------------------------
--------------------------------------------------------------------*/
{
    if(l >= LALIST) {
        fprintf(fp, "ALNULL");
        return;
    }
    fprintf(fp,"[ ");
    for(;l != LALIST; l = alnext(l))
        fprintf(fp,"(%d,%d) ", allevel(l), alleg(l));
    fprintf(fp,"]");
}
