
EXEC=	grcfort 

OFRT=   genfort.o rdgrf.o rdptbl.o token.o ergrf.o putid.o cfgrf.o rational.o\
        matchv.o dagrf.o flgrf.o ilgrf.o ftgrf.o args.o cmfort.o \
	cmutl.o path.o cmfin.o cfbase.o cfconv.o

SFRT=   $(OFRT:.o=.c)
SMK =   $(OMK:.o=.c)

#---------------------------------------------------------------

.SUFFIXES: .c .o .hd

.c.o:
	$(CC) $(OPTC) -c $*.c

.c.hd:
	grep 'Public' $*.c | grep 'ARG' | sed 's/^.*://' > $*.hd

#===============================================================

all: $(EXEC)

grcfort: $(OFRT) $(OMK)
	$(CC) $(OPTC) -o grcfort $(OFRT) $(OMK)

install: all
	cp $(EXEC) $(BINDIR)

version: mkver
	./mkver

mkver: mkver.c
	$(CC) -o mkver mkver.c

setgrcfort: Makefile
	echo alias grcfort $(BINDIR)/grcfort >> setgrcfort

clean: 
	rm -f *.o $(EXEC) core tmp* junk*
#===============================================================

lint: lgrc

lfrt:
	lint $(SFRT)
	lint $(SMK)

#================================================================

HGRCH = grch.h common.h dbgh.h ptable.h ptable.h
HGRDT = grdata.h ptable.h
HVRH  = vrh.h common.h

args.o: args.c args.h common.h version.h

cfgrf.o: cfgrf.c common.h dbgh.h glue4.h $(HGRDT) ptable.h rational.h

cmfort.o: cmfort.c common.h config.h dbgh.h gensc.h $(HGRDT) ptable.h

cmfin.o: cmfin.c common.h config.h dbgh.h gensc.h $(HGRDT) ptable.h putidh.h

cmutl.o: cmutl.c common.h config.h dbgh.h gensc.h $(HGRDT) ptable.h putidh.h version.h

ergrf.o: ergrf.c common.h dbgh.h

flgrf.o: flgrf.c common.h dbgh.h $(HGRDT) ptable.h

ftgrf.o: ftgrf.c common.h config.h dbgh.h gensc.h glue4.h $(HGRDT) \
	ptable.h putidh.h

genfort.o: genfort.c args.h common.h config.h dbgh.h gensc.h glue4.h $(HGRDT) \
	ptable.h tokenh.h version.h

ilgrf.o: ilgrf.c common.h dbgh.h $(HGRDT) ptable.h

matchv.o: matchv.c common.h dbgh.h $(HGRDT) ptable.h tokenh.h

mkver.o: mkver.c common.h

path.o: path.c common.h

putid.o: putid.c common.h putidh.h

rational.o: rational.c common.h rational.h

rdgrf.o: rdgrf.c common.h dbgh.h $(HGRDT) ptable.h tokenh.h

rdprocs.o: rdprocs.c $(HGRCH) tokenh.h

rdptbl.o: rdptbl.c common.h config.h dbgh.h $(HGRDT) ptable.h tokenh.h

tlgrf.o: tlgrf.c common.h dbgh.h $(HGRDT) ptable.h

token.o: token.c common.h dbgh.h escchar.h tokenh.h

cfbase.o: common.h cfbase.h

cfconv.o: common.h cfbase.h
