/********************************************************************
 *  File : ftmakes_hpux.c *
 *  Makefile generation for hpux
 *                           by Kaneko Toshiaki   95/07/13 (LAPP)
 *                                     Rev.  TI   95/07/17 (LAPP)
 *                                     Rev.  TI   95/08/04 (KEK)
 */

#include <stdlib.h>
#include <stdio.h>
#include "common.h"
#include "config.h"
#include "dbgh.h"
#include "ptable.h"
#include "grdata.h"
#include "gensc.h"

/*------------------------------------------------------------------*/
/* Entry points */
Public  Void    ftmakes ARG((NoArg));

/*------------------------------------------------------------------*/
/* External references */
/* cmutl.c */
Extern  Void    cmopen     ARG((int,string));
/* cmfin.c */
Extern  Void    cmamparm   ARG((NoArg));
/* ftgrf.c */
Extern  Void    cmfobj     ARG((FILE*));
Extern  Void    cmmkrnw    ARG((NoArg));
/*------------------------------------------------------------------*/
/* Local variable */
#define TCUT	(100)
/*==================================================================*/
Public  Void    ftmakes(NoArg)
/*------------------------------------------------------------------*
 * generate makefiles : "Makefile".
 *------------------------------------------------------------------*/
{
    int  g0, lp, l0, gn;
    char c;

    cmopen(ROMAKE, "Makefile");

    fprintf(redfp, "\n");
    fprintf(redfp, "F77       = f77\n");
    fprintf(redfp, "F77OPTS   = -i,E,L,U,K,CL,CU,EU -W0,'LANGLVL(DARG(L))'\n\n");
    fprintf(redfp, "GRACELDIR  = %s\n", gracedir);
/*    fprintf(redfp, "GRACELDIR = $(GRACEDIR)/lib\n\n");*/
    fprintf(redfp, "BASESLIB  = bases\n");
    fprintf(redfp, "CHANELIB  = chanel\n");
    fprintf(redfp, "KINEMLIB  = kinem\n\n");
    fprintf(redfp, "SUSYLIB   = susy\n\n");
    if( CERNLIB == 1 ) {
        fprintf(redfp, "CERNLIBDIR = /keklib/cern/pro/lib\n\n");
    }

    puinit(redfp, "OBJA      = ", "            ", " ", "\\", "",
                  64, -1);

    c = 'a';
    for(lp = 0; lp <= maxloop; lp++) {
        for(l0 = lp0min(lp); l0 <= lp0max(lp); l0++) {
            for(g0 = 0; g0 < reprocg[l0]; g0++) {
                sprintf(momstr, "%c%d.o ", c, g0+1);
                putid(momstr);
            }
            c++;
        }
    }
    putend();
    puinit(redfp, "OBJF      = ", "            ", " ", "\\", "",
                  64, -1);
    cmfobj(redfp);
    puinit(redfp, "OBJU      = ", "            ", " ", "\\", "",
                  64, -1);
    putid("kinit.o");
    putid("kinem.o");
    putid("kfill.o");
    putid("func.o");
    putid("userin.o");
    putid("usrout.o");
    putid("setmas.o");
/*
    putid("modmas.o");
*/
    putid("ampord.o");
/*
    if(cpol)
        putid("smcpol.o");
*/
    putid("ampsum.o");
    putid("amparm.o");
    if( colorv == 0 ) {
    if(cprocess->extcol > 0 && cprocess->qcd < 1)
        putid("cfcalc.o");
    }
    putid("amptbl.o");

    c = 'a';
    for(lp = 0; lp <= maxloop; lp++) {
        for(l0 = lp0min(lp); l0 <= lp0max(lp); l0++) {
            gn = (reprocg[l0] + TCUT - 1)/TCUT;
            for(g0 = 0; g0 < gn; g0++) {
                sprintf(momstr, "%cmpt%d.o ", c, g0);
                putid(momstr);
            }
            c++;
        }
    }
    putend();

    fprintf(redfp, "\n");
    puinit(redfp, "OBJM      = ", "            ", " ", "\\", "",
                  64, -1);
    putid("modmas.o");
    putend();
    puinit(redfp, "OBJMC     = ", "            ", " ", "\\", "",
                  64, -1);
    putid("modmasc.o");
    putend();
    fprintf(redfp, "\n");

    puinit(redfp, "OBJG      = ", "            ", " ", "\\", "",
                  64, -1);
    putid("gauge.o");
    putid("prmass.o");
    putend();

    puinit(redfp, "OBJI      = ", "            ", " ", "\\", "",
                  64, -1);
    putid("mainbs.o");
    putend();

    puinit(redfp, "OBJS      = ", "            ", " ", "\\", "",
                  64, -1);
    putid("mainsp.o");
    putend();
    if( CATALOG == 1 ) {
    puinit(redfp, "OBJT      = ", "            ", " ", "\\", "",
                  64, -1);
    putid("maintc.o");
    putend();
    puinit(redfp, "OBJC      = ", "            ", " ", "\\", "",
                  64, -1);
    putid("maincs.o");
    putend();
    }
    fprintf(redfp, "\n");

    fprintf(redfp, "GOBJS     = $(OBJF) $(OBJA) $(OBJU) $(OBJM) $(OBJG)\n");
    fprintf(redfp, "IOBJS     = $(OBJF) $(OBJA) $(OBJU) $(OBJM) $(OBJI)\n");
    fprintf(redfp, "SOBJS     = $(OBJF) $(OBJA) $(OBJU) $(OBJM) $(OBJS)\n");
    if( CATALOG == 1 ) {
        fprintf(redfp, "TOBJS     = $(OBJF) $(OBJA) $(OBJU) ");
        fprintf(redfp, "$(OBJMC) $(OBJT)\n");
        fprintf(redfp, "COBJS     = $(OBJF) $(OBJA) $(OBJU) ");
        fprintf(redfp, "$(OBJMC) $(OBJC)\n");
    }
    fprintf(redfp, "\n");

    fprintf(redfp, "GAUGE     = gauge\n");
    fprintf(redfp, "INTEG     = integ\n");
    fprintf(redfp, "SPRING    = spring\n");
    if( CATALOG == 1 ) {
    fprintf(redfp, "ROOTS     = roots\n");
    fprintf(redfp, "DSDX      = dsdx\n");
    }
    fprintf(redfp, "\n");

    fprintf(redfp, ".SUFFIXES: .f .o\n\n");

    fprintf(redfp, ".f.o:\n");
    fprintf(redfp, "\t$(F77) $(F77OPTS) -c $*.f\n\n");

    fprintf(redfp, "all: $(GAUGE) $(INTEG) $(SPRING) ");
    if( CATALOG == 1 ) {
    fprintf(redfp, "$(ROOTS) $(DSDX)");
    }
    fprintf(redfp, "\n\n");

    fprintf(redfp, "$(GAUGE): $(GOBJS)\n");
    fprintf(redfp, "\t$(F77) $(FOPT) -o $(GAUGE) $(GOBJS) \\\n");
    fprintf(redfp, "\t  -L$(GRACELDIR) -l$(BASESLIB) -l$(CHANELIB)");
    fprintf(redfp, " -l$(KINEMLIB) -l$(SUSYLIB)");
    if( CERNLIB == 1 ) {
        fprintf(redfp, " \\\n\t  -L$(CERNLIBDIR) -lkernlib");
    }
    fprintf(redfp, "\n\n");

    fprintf(redfp, "$(INTEG): $(IOBJS)\n");
    fprintf(redfp, "\t$(F77) $(FOPT) -o $(INTEG) $(IOBJS) \\\n");
    fprintf(redfp, "\t  -L$(GRACELDIR) -l$(BASESLIB) -l$(CHANELIB)");
    fprintf(redfp, " -l$(KINEMLIB) -l$(SUSYLIB)");
    if( CERNLIB == 1 ) {
        fprintf(redfp, " \\\n\t  -L$(CERNLIBDIR) -lkernlib");
        fprintf(redfp, " -lpacklib");
    }
    fprintf(redfp, "\n\n");

    fprintf(redfp, "$(SPRING): $(SOBJS)\n");
    fprintf(redfp, "\t$(F77) $(FOPT) -o $(SPRING) $(SOBJS) \\\n");
    fprintf(redfp, "\t  -L$(GRACELDIR) -l$(BASESLIB) -l$(CHANELIB)");
    fprintf(redfp, " -l$(KINEMLIB) -l$(SUSYLIB)");
    if( CERNLIB == 1 ) {
        fprintf(redfp, " \\\n\t  -L$(CERNLIBDIR) -lkernlib");
        fprintf(redfp, " -lpacklib");
    }
    fprintf(redfp, "\n\n");

    if( CATALOG == 1 ) {
    fprintf(redfp, "$(ROOTS): $(TOBJS)\n");
    fprintf(redfp, "\t$(F77) $(FOPT) -o $(ROOTS) $(TOBJS) \\\n");
    fprintf(redfp, "\t  -L$(GRACELDIR) -l$(BASESLIB) -l$(CHANELIB)");
    fprintf(redfp, " -l$(KINEMLIB) -l$(SUSYLIB)");
    if( CERNLIB == 1 ) {
        fprintf(redfp, " \\\n\t  -L$(CERNLIBDIR) -lkernlib");
        fprintf(redfp, " -lpacklib");
    }
    fprintf(redfp, "\n\n");

    fprintf(redfp, "$(DSDX): $(COBJS)\n");
    fprintf(redfp, "\t$(F77) $(FOPT) -o $(DSDX) $(COBJS) \\\n");
    fprintf(redfp, "\t  -L$(GRACELDIR) -l$(BASESLIB) -l$(CHANELIB)");
    fprintf(redfp, " -l$(KINEMLIB) -l$(SUSYLIB)");
    if( CERNLIB == 1 ) {
        fprintf(redfp, " \\\n\t  -L$(CERNLIBDIR) -lkernlib");
        fprintf(redfp, " -lpacklib");
    }
    fprintf(redfp, "\n\n");
    }

    fprintf(redfp, "clean:\n");
    fprintf(redfp, "\trm -f $(GAUGE) $(INTEG) $(SPRING) ");
    if( CATALOG == 1 ) {
    fprintf(redfp, "$(ROOTS) $(DSDX) ");
    }
    fprintf(redfp, "*.o junk* tmp* core\n\n");

    cmmkrnw();
}
