/********************************************************************
 *  File : ftmakes_hpux.c *
 *  Makefile generation for hpux
 *                           by Kaneko Toshiaki   95/07/13 (LAPP)
 *                                     Rev.  TI   95/07/17 (LAPP)
 *                                     Rev.  TI   95/08/04 (KEK)
 */

#include <stdlib.h>
#include <stdio.h>
#include "common.h"
#include "config.h"
#include "dbgh.h"
#include "ptable.h"
#include "grdata.h"
#include "gensc.h"
#include "version.h"

/*------------------------------------------------------------------*/
/* Entry points */
Public  Void    ftmakes    ARG((NoArg));
Private Void    ftmainvpp  ARG((NoArg));
Private Void    ftmavbvpp  ARG((int));
Private Void    ftmavsvpp  ARG((int));
Private Void    ftnqsshvpp ARG((int));

/*------------------------------------------------------------------*/
/* External references */
/* cmutl.c */
Extern  Void    cmopen     ARG((int,string));
/* cmfin.c */
Extern  Void    cmamparm   ARG((NoArg));
/* ftgrf.c */
Extern  Void    cmfobj     ARG((FILE*));
Extern  Void    cmmkrnw    ARG((NoArg));
/*------------------------------------------------------------------*/
/* Local variable */
#define TCUT	(100)
/*==================================================================*/
Public  Void    ftmakes(NoArg)
/*------------------------------------------------------------------*
 * generate makefiles : "Makefile".
 *------------------------------------------------------------------*/
{
    int  g0, lp, l0, gn;
    char c;

    cmopen(ROMAKE, "Makefile");

    fprintf(redfp, "\n");
    fprintf(redfp, "F77       = frtpx\n");
    fprintf(redfp, "FOPT      = -Ob -Wx -J -lm\n\n");
    fprintf(redfp, "GRACELDIR  = %s\n", gracedir);
/*    fprintf(redfp, "GRACELDIR = $(GRACEDIR)/lib\n\n");*/
    if( basesv == 0 ) {
        fprintf(redfp, "BASES1LIB  = vb1\n");
        fprintf(redfp, "BASES4LIB  = vb4\n");
        fprintf(redfp, "BASES8LIB  = vb8\n");
    } else {
        fprintf(redfp, "BASES1LIB  = vbh1\n");
        fprintf(redfp, "BASES4LIB  = vbh4\n");
        fprintf(redfp, "BASES8LIB  = vbh8\n");
    }
    fprintf(redfp, "CHANELIB   = vchaneld\n");
    fprintf(redfp, "KINEMLIB   = kinem\n\n");
    fprintf(redfp, "SUSYLIB    = susy\n\n");

    puinit(redfp, "OBJA      = ", "            ", " ", "\\", "",
                  64, -1);

    c = 'a';
    for(lp = 0; lp <= maxloop; lp++) {
        for(l0 = lp0min(lp); l0 <= lp0max(lp); l0++) {
            for(g0 = 0; g0 < reprocg[l0]; g0++) {
                sprintf(momstr, "%c%d.o ", c, g0+1);
                putid(momstr);
            }
            c++;
        }
    }
    putend();
    puinit(redfp, "OBJF      = ", "            ", " ", "\\", "",
                  64, -1);
    cmfobj(redfp);
    puinit(redfp, "OBJU      = ", "            ", " ", "\\", "",
                  64, -1);
    putid("kinit.o");
    putid("kinem.o");
    putid("kinemv.o");
    if( !vcode )
        putid("kfill.o");
    else
        putid("kfillv.o");
    putid("vbfnct.o");
    putid("userin.o");
    putid("usrout.o");
    putid("usrprm.o");
    putid("setmas.o");
/*
    putid("modmas.o");
*/
    putid("ampord.o");
/*
    if(cpol)
        putid("smcpol.o");
*/
    putid("ampsum.o");
    putid("amparm.o");
/* CF */
    if( colorv == 0 ) {
        if(cprocess->extcol > 0 && cprocess->qcd < 1)
           putid("cfcalc.o");
    }
    putid("amptbl.o");

    c = 'a';
    for(lp = 0; lp <= maxloop; lp++) {
        for(l0 = lp0min(lp); l0 <= lp0max(lp); l0++) {
            gn = (reprocg[l0] + TCUT - 1)/TCUT;
            for(g0 = 0; g0 < gn; g0++) {
                sprintf(momstr, "%cmpt%d.o ", c, g0);
                putid(momstr);
            }
            c++;
        }
    }
    putend();

    fprintf(redfp, "\n");
    puinit(redfp, "OBJM      = ", "            ", " ", "\\", "",
                  64, -1);
    putid("modmas.o");
    putend();
    fprintf(redfp, "\n");

    puinit(redfp, "OBJI1     = ", "            ", " ", "\\", "",
                  64, -1);
    putid("mainvb1.o");
    putend();

    puinit(redfp, "OBJI4     = ", "            ", " ", "\\", "",
                  64, -1);
    putid("mainvb4.o");
    putend();

    puinit(redfp, "OBJI8     = ", "            ", " ", "\\", "",
                  64, -1);
    putid("mainvb8.o");
    putend();

    fprintf(redfp, "\n");

    fprintf(redfp, "IOBJS1    = $(OBJF) $(OBJA) $(OBJU) $(OBJM) $(OBJI1)\n");
    fprintf(redfp, "IOBJS4    = $(OBJF) $(OBJA) $(OBJU) $(OBJM) $(OBJI4)\n");
    fprintf(redfp, "IOBJS8    = $(OBJF) $(OBJA) $(OBJU) $(OBJM) $(OBJI8)\n");
    fprintf(redfp, "\n");

    fprintf(redfp, "INTEG1    = integ1\n");
    fprintf(redfp, "INTEG4    = integ4\n");
    fprintf(redfp, "INTEG8    = integ8\n");
    fprintf(redfp, "\n");

    fprintf(redfp, ".SUFFIXES: .f .o\n\n");

    fprintf(redfp, ".f.o:\n");
    fprintf(redfp, "\t$(F77) $(FOPT) -c $*.f\n\n");

    fprintf(redfp, "all: $(INTEG1) $(INTEG4) $(INTEG8)\n\n");

    fprintf(redfp, "$(INTEG1): $(IOBJS1)\n");
    fprintf(redfp, "\t$(F77) $(FOPT) -o $(INTEG1) $(IOBJS1) \\\n");
    fprintf(redfp, "\t  -L$(GRACELDIR) -l$(BASES1LIB) -l$(CHANELIB)");
    fprintf(redfp, " -l$(KINEMLIB) -l$(SUSYLIB)");
    fprintf(redfp, "\n\n");

    fprintf(redfp, "$(INTEG4): $(IOBJS4)\n");
    fprintf(redfp, "\t$(F77) $(FOPT) -o $(INTEG4) $(IOBJS4) \\\n");
    fprintf(redfp, "\t  -L$(GRACELDIR) -l$(BASES4LIB) -l$(CHANELIB)");
    fprintf(redfp, " -l$(KINEMLIB) -l$(SUSYLIB)");
    fprintf(redfp, "\n\n");

    fprintf(redfp, "$(INTEG8): $(IOBJS8)\n");
    fprintf(redfp, "\t$(F77) $(FOPT) -o $(INTEG8) $(IOBJS8) \\\n");
    fprintf(redfp, "\t  -L$(GRACELDIR) -l$(BASES8LIB) -l$(CHANELIB)");
    fprintf(redfp, " -l$(KINEMLIB) -l$(SUSYLIB)");
    fprintf(redfp, "\n\n");

    fprintf(redfp, "clean:\n");
    fprintf(redfp, "\t\\rm -f $(INTEG1) $(INTEG4) $(INTEG8) ");
    fprintf(redfp, "*.s *.o junk* tmp* core\n\n");

    cmmkrnw();

    /* create for main-program for VPP */
    ftmainvpp();
}
/*==================================================================*/
Private Void    ftmainvpp(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    ftmavbvpp(1);
    ftmavbvpp(4);
    ftmavbvpp(8);

    ftmavsvpp(1);

    ftnqsshvpp(1);
    ftnqsshvpp(4);
    ftnqsshvpp(8);
}
/*==================================================================*/
#define MXPWD 100
Private Void    ftnqsshvpp(numpe)
int numpe;
/*------------------------------------------------------------------*
    make NQS shell for VPP500
 *------------------------------------------------------------------*/
{
    char   c[5];
    char   filenm[20];
    char   pwdbuf[MXPWD];
    FILE   *temp_file;

    strcpy( filenm , "vpp");

    sprintf(c,"%d",numpe);
    strcat(filenm,c);
    cmopen(RONQS, filenm);

    system("pwd > tmp");
    temp_file = fopen("tmp","r");
/*    fgets( pwdbuf , MXPWD, temp_file);*/
    fscanf( temp_file ,"%s", pwdbuf );
    printf(" %d :%s END\n",strlen(pwdbuf),pwdbuf);
    fclose( temp_file );
    system("/bin/rm -f tmp");
    
    fprintf(redfp,"##\n");
    fprintf(redfp,"#@$-s /bin/csh\n");
    fprintf(redfp,"#@$-q q%d%c\n",numpe,(numpe == 1 ? 'c':' '));
    fprintf(redfp,"#@$-o %s/xxx%d.out\n",pwdbuf,numpe);
    fprintf(redfp,"#@$-eo\n");
    fprintf(redfp,"#@$-me\n");
    fprintf(redfp,"#@$\n");
    fprintf(redfp,"cd %s\n",pwdbuf);
    fprintf(redfp,"timex -H integ%d -W1, -Pm0\n",numpe);
    fprintf(redfp,"time\n");
}
/*==================================================================*/
Private Void    ftmavbvpp(numpe)
int numpe;
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    pindex pa;
    int    n;
    char   c[5];
    char   filenm[20];

    
    if( !vcode )
        strcpy( filenm , "mainbs");
    else
        strcpy( filenm , "mainvb");

    sprintf(c,"%d",numpe);
    strcat(filenm,c);
    strcat(filenm,".f");

    cmopen(ROFORT, filenm);

    cmsepar('*');
    if( !vcode )
        fprintf(redfp,"* main program for BASES 5.1\n");
    else
        fprintf(redfp,"* main program for vector BASES 5.1\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);
    fprintf(redfp,"      parameter ( numpe = %d )\n",numpe);

    if(lang != ROFORT && lang != ROREDA )
        fprintf(redfp,"      include 'incomm.f'\n");
    fprintf(redfp,"      common / loop0  / loop\n");
    fprintf(redfp,"      common / knmflg / ");
    fprintf(redfp,"knmgvs, knmhst, knmsph, knmisr\n");
    fprintf(redfp,"      external func\n");
    putc(EOL, redfp);
    if( CERNLIB == 1 && !vcode ) {
        fprintf(redfp,"      parameter ( mhsize = 100000 )\n");
        fprintf(redfp,"      common /pawc/ memory(mhsize)\n");
    }

    if( vcode ) {
       fprintf(redfp,"*    Control for number of nodes\n");
       fprintf(redfp,"      common/ninfo/ nodeid, numnod, ipflag\n");
       fprintf(redfp,"*xocl processor pe(numpe)\n");
       fprintf(redfp,"*xocl parallel region\n");
    }
    fprintf(redfp,"      write(*,'(20x,a/)') 'grace %d.%2d(%02d)'\n",
            GRCVER0,GRCVER1,GRCVER2);
    fprintf(redfp,"      write(*,'(10x,a/)')\n");
    fprintf(redfp,"     .'(c)Copyright 1990-1996 Minami-Tateya ");
    fprintf(redfp,"Group (Japan)     '\n");
    cmsepar('*');


 
    fprintf(redfp,"      write(*,'(5x,a/)')\n");
    fprintf(redfp,"     .'Process: ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp, " --> ',\n     .  '");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n");
    cmsepar('*');
    fprintf(redfp,"*               initialization Kinematics Flags\n");
    fprintf(redfp,"*     knmgvs  : (=1)sqrt(S) is given in kinit.f\n");
    fprintf(redfp,"*     knmhst  : (=1)Fill historgram \n");
    fprintf(redfp,"*     knmsph  : reserved for soft photon check \n");
    fprintf(redfp,"*     knmisr  : reserved for initial state ");
    fprintf(redfp,"radiation\n");
    fprintf(redfp,"      knmgvs = 1\n");
    fprintf(redfp,"      knmhst = 0\n");
    fprintf(redfp,"      knmsph = 0\n");
    fprintf(redfp,"      knmisr = 0\n");
    fprintf(redfp,"      loop   = 1\n");

    if( CERNLIB == 1 && !vcode ) {
        cmsepar('*');
        fprintf(redfp,"*               initialization of HBOOK\n");
        fprintf(redfp,"      call hlimit( mhsize )\n");
        fprintf(redfp,"      call htitle('Histograms generated by ");
        fprintf(redfp,"BASES')\n");
    }
    cmsepar('*');
    fprintf(redfp,"*               initialization of BASES/SPRING");
    fprintf(redfp," 5.1\n");
    cmsepar('*');

    cmsepar('=');
    fprintf(redfp,"*          initialization of bases by calling ");
    fprintf(redfp,"bsinit\n");
    cmsepar('=');
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           call bsinit\n");
    fprintf(redfp,"*         -------------\n");
    if( vcode ) {
        fprintf(redfp,"      numnod = numpe\n");
    }

    cmsepar('=');
    fprintf(redfp,"*      initialization of parameters\n");
    fprintf(redfp,"*          for kinematics and matrix elements\n");
    fprintf(redfp,"*      initialization of histograms\n");
    cmsepar('=');
    fprintf(redfp,"*     lu     = 11\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     open(lu,file='bases.result',status='");
    fprintf(redfp,"unknown',form='formatted')\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*         ------------------\n");
    fprintf(redfp,"           call userin( 6 )\n");
    fprintf(redfp,"*         ------------------\n");

    cmsepar('*');
    fprintf(redfp,"*              numerical integration by ");
    fprintf(redfp,"BASES 5.1\n");
    cmsepar('*');
    fprintf(redfp,"\n");
    if( !vcode )
        fprintf(redfp,"      call bases( func, estim, sigma, ctime, ");
    else
        fprintf(redfp,"      call vbases( func, estim, sigma, ctime, ");
    fprintf(redfp,"it1, it2 )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     call bsinfo( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     call bhplot( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     close( lu )\n");
    fprintf(redfp,"\n");

    cmsepar('*');
    fprintf(redfp,"*             event generation by SPRING 5.1\n");
    cmsepar('*');
    cmsepar('=');
    fprintf(redfp,"*     save the probability information to the ");
    fprintf(redfp,"file\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    fprintf(redfp,"*     lun = 23\n");
    fprintf(redfp,"*     open(lun,file='bases.data',status='");
    fprintf(redfp,"unknown',form='unformatted')\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     call bswrit( lun )\n");
    fprintf(redfp,"*     close ( lun )\n");
    fprintf(redfp,"\n");

    if( CERNLIB == 1 ) {
        cmsepar('=');
        fprintf(redfp,"*     save the contents of Histograms ");
        fprintf(redfp,"into Paw buffer\n");
        cmsepar('=');
        fprintf(redfp,"      call bshbok( 0 )\n");
        fprintf(redfp,"      call hrput( 0, 'bases.hbook','N')\n");
    }
    fprintf(redfp,"*xocl end parallel\n");

    fprintf(redfp,"      stop\n");
    fprintf(redfp,"      end\n");
}
/*==================================================================*/
Private Void    ftmavsvpp(numpe)
int numpe;
/*------------------------------------------------------------------*
 */
{
    pindex pa;
    int    n;
    char   c[5];
    char   filenm[20];

    if( !vcode )
        strcpy( filenm , "mainsp");
    else
        strcpy( filenm , "mainvs");

    sprintf(c,"%d",numpe);
    strcat(filenm,c);
    strcat(filenm,".f");

    cmopen(ROFORT, filenm);

    cmsepar('*');

    cmsepar('*');
    fprintf(redfp,"* main program for SPRING 5.1 for VPP\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    fprintf(redfp,"      parameter ( numpe = %d )\n",numpe);

    if( vcode )
        fprintf(redfp,"      include 'inclvs.f'\n");

    if(lang != ROFORT && lang != ROREDA )
        fprintf(redfp,"      include 'incomm.f'\n");
    fprintf(redfp,"      common / knmflg / ");
    fprintf(redfp,"knmgvs, knmhst, knmsph, knmisr\n");
    fprintf(redfp,"      external func\n");
    putc(EOL, redfp);

    if( vcode )
        fprintf(redfp,"      common / sprng3 / ic(nsize), l(nsize)\n");

    if( CERNLIB == 1 && !vcode) {
        fprintf(redfp,"      parameter ( mhsize = 100000 )\n");
        fprintf(redfp,"      common /pawc/ memory(mhsize)\n");
    }
    if( vcode ) {
       fprintf(redfp,"*    Control for number of nodes\n");
       fprintf(redfp,"      common/ninfo/ nodeid, numnod, ipflag\n");
       fprintf(redfp,"*xocl processor pe(numpe)\n");
       fprintf(redfp,"*xocl parallel region\n");
    }
    fprintf(redfp,"      write(*,'(20x,a/)') 'grace %d.%2d(%02d)'\n",
            GRCVER0,GRCVER1,GRCVER2);
    fprintf(redfp,"      write(*,'(10x,a/)')\n");
    fprintf(redfp,"     .'(c)copyright 1990-1996 Minami-Tateya ");
    fprintf(redfp,"Group (Japan)     '\n");

    fprintf(redfp,"      write(*,'(5x,a/)')\n");
    fprintf(redfp,"     .'Process: ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp, " --> ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n");

    cmsepar('*');
    fprintf(redfp,"*               initialization Kinematics Flags\n");
    fprintf(redfp,"*     knmgvs  : (=1)sqrt(S) is given in kinit.f\n");
    fprintf(redfp,"*     knmhst  : (=1)Fill historgram for BASES\n");
    fprintf(redfp,"*     knmsph  : reserved for soft photon check \n");
    fprintf(redfp,"*     knmisr  : reserved for initial state ");
    fprintf(redfp,"radiation\n");
    fprintf(redfp,"      knmgvs = 1\n");
    fprintf(redfp,"      knmhst = 0\n");
    fprintf(redfp,"      knmsph = 0\n");
    fprintf(redfp,"      knmisr = 0\n");
    cmsepar('*');
    if( CERNLIB == 1 && !vcode ) {
        cmsepar('*');
        fprintf(redfp,"*               initialization of HBOOK\n");
        fprintf(redfp,"      call hlimit( mhsize )\n");
    }
    fprintf(redfp,"*               initialization of BASES/SPRING");
    fprintf(redfp," 5.1\n");
    cmsepar('*');

    cmsepar('=');
    fprintf(redfp,"*          initialization of bases by calling ");
    fprintf(redfp,"bsinit\n");
    cmsepar('=');
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           call bsinit\n");
    fprintf(redfp,"*         -------------\n");

    cmsepar('=');
    fprintf(redfp,"*          read the probability information from ");
    fprintf(redfp,"the file\n");
    cmsepar('=');
    fprintf(redfp,"           lun = 23\n");
    fprintf(redfp,"           open(lun,file='bases.data',status='");
    fprintf(redfp,"old',form='unformatted')\n");
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           call bsread( lun )\n");
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           close( lun )\n");
    fprintf(redfp,"\n");

    cmsepar('=');
    fprintf(redfp,"*      initialization of parameters\n");
    fprintf(redfp,"*          for kinematics and matrix elements\n");
    fprintf(redfp,"*      initialization of histograms\n");
    cmsepar('=');
    fprintf(redfp,"      lu     = 12\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      open(lu,file='spring.result',status='");
    fprintf(redfp,"unknown',form='formatted')\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*         ------------------\n");
    fprintf(redfp,"           call userin( lu )\n");
    fprintf(redfp,"*         ------------------\n");
    fprintf(redfp,"\n");

    cmsepar('=');
    fprintf(redfp,"*     initialization of additional histograms ");
    fprintf(redfp,"for spring\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    cmsepar('=');
    fprintf(redfp,"*     event generation\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    fprintf(redfp,"      mxtry  = 50\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      mxevnt = 10000\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     write(6,*)' number of events ? '\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     read(5,*) mxevnt\n");
    fprintf(redfp,"\n");
    if( !vcode ) {
    fprintf(redfp,"      do 100 nevnt = 1, mxevnt\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         call spring( func, mxtry )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*    --------------------------------------------");
    fprintf(redfp,"----\n");
    fprintf(redfp,"*        compute the four vectors of generated ");
    fprintf(redfp,"event\n");
    fprintf(redfp,"*          from the kinematical variables\n");
    fprintf(redfp,"*    --------------------------------------------");
    fprintf(redfp,"----\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*        do 90 k = 1 , nextn\n");
    fprintf(redfp,"*           write(6,*) (vec(j,k),j=1,4)\n");
    fprintf(redfp,"*  90    continue\n");
    fprintf(redfp,"  100 continue\n");
    } else {
    fprintf(redfp,"      msum = 0\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"  100 continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         call vsprng( func, mxtry )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*    --------------------------------------------");
    fprintf(redfp,"----\n");
    fprintf(redfp,"*        compute the four vectors of generated ");
    fprintf(redfp,"event\n");
    fprintf(redfp,"*          from the kinematical variables\n");
    fprintf(redfp,"*    --------------------------------------------");
    fprintf(redfp,"----\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         do 90 i = 1 , nsize\n");
    fprintf(redfp,"            if( ic(i) .eq. 0 ) then\n");
    fprintf(redfp,"                msum = msum + 1\n");
    fprintf(redfp,"*               do 80 k = 1 , nextn\n");
    fprintf(redfp,"*                  write(6,*) (vec(j,k),j=1,4)\n");
    fprintf(redfp,"*  80           continue\n");
    fprintf(redfp,"            endif\n");
    fprintf(redfp,"   90    continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      if( msum .lt. mxevnt) goto 100\n");

    }
    fprintf(redfp,"\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      call spinfo( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      call shplot( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      close( lu )\n");
    fprintf(redfp,"\n");
    if( CERNLIB == 1 && !vcode ) {
        cmsepar('=');
        fprintf(redfp,"*     save the contents of Histograms ");
        fprintf(redfp,"into Paw buffer\n");
        cmsepar('=');
        fprintf(redfp,"      call bshbok( 0 )\n");
        fprintf(redfp,"      call sphbok( 0 )\n");
        fprintf(redfp,"      call hrput( 0, 'spring.hbook','N')\n");
    }
    fprintf(redfp,"*xocl end parallel\n");
    fprintf(redfp,"      stop\n");
    fprintf(redfp,"      end\n");
    fprintf(redfp,"\n");
}
