/*********************************************************************
 *  File :  gensc.h
 *
 *  Global variables for generationg source code.
 *
 *                                               by Kaneko Toshiaki
 */

Global bool   divpart;   /* create divergent part */
Global bool   junpei;
Global bool   gm2;       /* flag for g-2 */
Global int    qcd;
Global int    vcode;
Global int    lang;
Global int    cpol;
Global int    colorv;    /* New Color Factor version */
Global int    basesv;    /* BASES/SPRING version (0:org,1:hundred)*/
Global bool   minami;    /* Minami-Tateya tentative version flag */
Global bool   jtgamm;    /* T-chanel Gamma (smintp) */
Global bool   jano3v;    /* Anomalous Coupling smvww */
Global bool   jqmas0;    /* Quark Mass 0*/
Global bool   jcolmb;    /* Coulomb Correction */
Global bool   jqcdcr;    /* QCD Correction */
Global bool   jetset;    /* Interface to jetset */
Global bool   jqedps;    /* QED-PS interface only for grc4f/susy23 */
Global bool   susylib;   /* SUSY library (tentaive)*/

Global FILE   *redfp;

Global int    nextern;
Global int    nilines;

Local int    x0 = 2;   /* loop momentum => x2 */

Local int    momoffs;
Local int    legoffs;
Local int    conjstart;
Local int    kloop;

Global char   outname[MAXPATHLEN];

Global char   momstr[MAXPATHLEN];
Global char   momstr1[MAXPATHLEN];
Global char   momstr2[MAXPATHLEN];
Global char   momstr3[MAXPATHLEN];

/* The table of processes. */
Global int    nprocs;
Global int    maxloop;
Global int    reproct[MAXPROCS];  /* the table of process numbers */
Global int    reprocg[MAXPROCS];  /* the table of the number of graphs
                                   * in each process.
                                   */
#ifdef DEFGLOBAL
Global int  gmask[5] = {1, 2, 4, 8, 16};
Global char gchr[6] = "?awzg";
Global char ftsuorv[3][2] = {"\0", "u","v"};
Global bool ampl = False;
Global long selgraph = -1L;
#else
Global int gmask[5];
Global char gchr[6];
Global char ftsuorv[3][2];
Global bool ampl;
Global long   selgraph;
#endif

/* program type used in reopen */
#define ROFORM  0
#define ROFORT  1
#define ROC     2
#define ROMAKE  3
#define ROSH    4
#define RORED   5
#define ROFORM1 6
#define ROREDA  7
#define RONQS   8

#define lp0min(lp)  ((int)((lp)+1)/2)
#define lp0max(lp)  (lp)

