/***************************************************************
 * File mkvar.c
 *
 *                                               KANEKO Toshiaki
 *
 *  History
 *    Ver.2.0.0 : 1994/08/09 : Public version.
 *                ?          : Include Kinematics.
 *        2.0.1 : ?          : Color factor.
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "common.h"

#define GRCVER0      2
#define GRCVER1      0
#define GRCVER2     27
/* #define GRCDATE      "1994/08/09" */
#define GRCDATE      NULL
#define FNAME        "version.h"

Public Void japantime(str, ct)
string str;
time_t *ct;
{
    time_t      jtt;
    struct tm  *jtm;

    jtt = *ct + 9*3600;
    jtm = gmtime(&jtt);

    sprintf(str, "%4d/%02d/%02d/%02d:%02d",
                 jtm->tm_year + 1900, jtm->tm_mon+1, jtm->tm_mday,
                 jtm->tm_hour, jtm->tm_min);
}


Public int main(NoArg)
{
    FILE   *fp;
    time_t ct;
    char   str[64];
    string cmptime = str;

    if((fp = fopen(FNAME, "w")) == NULL) {
        fprintf(Stderr, "Open error %s", FNAME);
        exit(1);
    }

    if(GRCDATE != NULL || time(&ct) < 0) {
        sprintf(str, "%s", GRCDATE);
    } else {
        japantime(str, &ct);
    }

    fprintf(fp,"#define GRCVER0    %d\n", GRCVER0);
    fprintf(fp,"#define GRCVER1    %d\n", GRCVER1);
    fprintf(fp,"#define GRCVER2    %d\n", GRCVER2);
    fprintf(fp,"#define GRCDATE    \"%s\"\n", cmptime);

    return 0;
}
