*----------------------------------------------------------------
*  grc_def.cdf    (Version 03)          Created     20 Nov 1994
*                                       Mod.         8 Jan 1995
*----------------------------------------------------------------
*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*      Automatic numerical calculation
*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*  GRACE--*-- eeto2   --*-- total   (cal. of total cross section)
*         |             |
*         |             *-- diff    (cal. of diff. cross section)
*         |             |
*         |             *-- diagram (draw graph & graph selection)
*         |             |
*         |             *-- setmas  (set mass parameters)
*         |             |
*         |             *-- event(*)(event generation)
*         |
*         *-- eeto3(*)
*         |
*         *-- Tree    --*-- gen_graph
*         |             |
*         |             *-- gracefig
*         |             |
*         |             *-- setmas
*         |             |
*         |             *-- make_fort
*         |             |
*         |             *-- make_form(*)
*         |             |
*         |             *-- make_reduce(*)
*         |             |
*         |             *-- kinem   (edit kinematics subroutine)
*         |             |
*         |             *-- integration (cal. of total cross section)
*         |             |
*         |             *-- total(*)    (cal. of total. cross section)
*         |             |
*         |             *-- spring
*        (*) 
*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*      Analytical calculation
*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
* CROSS --*-- muon_pair_total
*         |
*         *-- muon_pair_diff
*         |
*         *-- Bhabha_total
*         |
*         *-- Bhabha_diff
*----------------------------------------------------------------
* (*)....not yet
*----------------------------------------------------------------
>Name GRCDF

>Menu GRACE

*-----------------------------------------------------------------------
***** for distribution
*>Menu Tree

>Command graph_generation
>Parameters
*Process_file 'File name' C D='in.prc'
*
Model_file 'File name' C D='default' R='default,full'

ELWK_Order 'ELWK Order' I D=3

QCD_Order 'QCD Order' I D=0

Initial 'Initial Particle' C D='electron,positron'

Final 'Final Particle' C D='photon,W-plus,W-minus'
+
Kinem 'Kinem-lib' I D=3002
*++
*Expand 'Expand' C D='Yes'
*OPI    'OPI' C D='No'
*Graph_info_file 'File Name' C D='out.grf'
>User_help grc_gen_graph_hlp
>Guidance
Generation of graph.
.
--------- Model ------------
.
default .... without electron-Higgs coupling.
full ....... Full standard model.

>Action grc_act_graph

>Command gracefig
*>Parameters
*Graph_info_file 'File name' C D='out.grf'
>Guidance
Draw graph (Kawabata-version)
>Action grc_act_gracefig

>Command fortran_generation
>Guidance
Generation fortran code
>Action grc_act_fort

*>Command grcmake
*>Guidance
*Make executables
*>Action grc_make_all

>Command gauge_check
>Guidance
Gauge invariance check
>Action grc_act_gauge

>Command integration
>Parameters
ITMX1 'Iter. for grid optimization' I D=10

ITMX2 'Iter. for accumulation' I D=5

NCALL 'Sample Points' I D=20000

ACC1  'Acurracy for grid opt. step' R D=0.1

ACC2  'Acurracy for acc. step' R D=0.05

ENEGY  'Energy ' R D=1000.

Kinem 'Kinem-lib' I D=3002

JOB 'job style' C D='direct' R='direct,background'
>Guidance
Monte Calro Integration

After Integration, a file, "bases.hist", will be generated
by HBOOK.  It includes the information for HISTGRAMs and SCATTER PLOT.
We use the packages of BASES in order to store the information,
then we convert it to the HBOOK format.
If one store the information, one should call the initialization
xhinit and dhinit in "kinit.f", and call the filling subroutine
xhfill and dhfill in "kfill.f".

In order to restore the information, please type
GRACE++> hi/file 1 bases.hist
after integration.

>Action grc_act_integ

>Command event_generation
>Parameters
MXTRY 'Max. number of trials' I D=50

MXEVNT 'Number of events' I D=10000

JOB 'job style' C D='direct' R='direct,background'
>Guidance
Event Generation:

After integration, an information file, "bases.dat" will
be generated. This file is special for BASES/SPRING packages.
In the event generation, we use this file.

At this moment, we does not support the HBOOK file yet.

>Action grc_act_spring

*>Command kinem
*>Guidance
*Edit for kinematics subroutine
*>Action grc_act_kinem
*------------------------------------------------------*
>Command setmas
>Parameters
AMW 'W-Boson Mass'  C D='80.22D0'
AMZ 'Z-Boson Mass'  C D='91.187D0'
AMH 'Higgs Mass' C D='2000.0D0'
AMEL 'Electron Mass' C D='0.51099906D-3'
AMMU 'Muon Mass' C D='105.658389D-3'
AMTA 'Tau Mass' C D='1.7771D0'
AMUQ 'u-quark Mass' C D='2.0D-3'
AMCQ 'c-quark Mass' C D='1.0D0'
AMTQ 't-quark Mass' C D='174.0D0'
AMDQ 'd-quark Mass' C D='5.0D-3'
AMSQ 's-quark Mass' C D='100.0D-3'
AMBQ 'b-quark Mass' C D='4.1D0'
*-----------------------------------------------------------------------
AGW 'W-Boson Width' C D='2.08D0'
AGZ 'Z-Boson Width' C D='2.49D0'
AGH 'Higgs Width' C D='4000.0D0'
>Guidance
Setting masses and width:
>Action grc_act_setmas
*-----------------------------------------------------------------------
**>Menu ../eeto2
*
*>Command total
*>Parameters
*Process_file 'File name' C D='in.prc'
*
*Model_file 'File name' C D='/lapphp0_2/keklapp/japan/tishika/exp-hp/grc/elwk/all.mdl'
*
*Model_sel 'Model selection' C D='ELWK'
*
*Final 'Final Particle' C D='W-plus,W-minus'
*
*OPTION 'Kinematics selection' I D=1
*-1      normal
*-2      forward peak
*-3      forward-backward peak
*
*COSCUT1 'Cos CUT 1', R D=180.
*COSCUT2 'Cos CUT 2', R D=0.
*NCALL 'Sample Points' I D=1000
*ITMX1 'Iter. for grid optimization' I D=5
*ITMX2 'Iter. for accumulation' I D=5
*EMIN  'Energy min' R D=200.
*EMAX  'Energy max ' R D=1000.
*EBIN  'Energy bin ' R D=200.
*++
*IDENT 'Idential particle' I D=1
*Graph_info_file 'File Name' C D='out.grf'
*>Guidance
*Automatic calculation of total cross section
*for $e^+ e^-$ -> 2-body process.
*>Action grc_eeto2_total
*
**---------------
*>Command diff
*>Parameters
*Process_file 'File name' C D='in.prc'
*
*Model_file 'File name' C D='/lapphp0_2/keklapp/japan/tishika/exp-hp/grc/elwk/all.mdl'
*
*Model_sel 'Model selection' C D='ELWK'
*
*Final 'Final Particle' C D='W-plus,W-minus'
*
*OPTION 'Kinematics selection' I D=1
*-1      normal
*-2      forward peak
*-3      forward-backward peak
*
*COSCUT1 'Cos CUT 1', R D=180.
*COSCUT2 'Cos CUT 2', R D=0.
*NCALL 'Sample Points' I D=5000
*ITMX1 'Iter. for grid optimization' I D=5
*ITMX2 'Iter. for accumulation' I D=5
*ENEGY  'Energy ' R D=500.
*++
*IDENT 'Idential particle' I D=1
*Graph_info_file 'File Name' C D='out.grf'
*>Guidance
*Automatic calculation of differential cross section
*for e^+ e^- -> 2-body process.
*>Action grc_eeto2_diff
**---------------
*>Command gracefig
**>Parameters
**Graph_info_file 'File name' C D='out.grf'
*>Guidance
*Draw graph (Kawabata-version)
*>Action grc_act_gracefig
**---------------
*>Command setmas2
*>Parameters
*AMW 'W-Boson Mass'  C D='80.22D0'
*AMZ 'Z-Boson Mass'  C D='91.187D0'
*AMA 'Photon Mass' C D='0.0D0'
*AMG 'Gluon Mass' C D='0.0D0'
*AMH 'Higgs Mass' C D='2000.0D0'
*AMX 'Chi Mass' C D='AMW'
*AMY 'Chi-3 Mass' C D='AMZ'
*AMNE 'NU_e Mass' C D='0.0D0'
*AMNM 'NU_mu Mass' C D='0.0D0'
*AMNT 'NU_tau Mass' C D='0.0D0'
*AMEL 'Electron Mass' C D='0.51099906D-3'
*AMMU 'Muon Mass' C D='105.658389D-3'
*AMTA 'Tau Mass' C D='1.7771D0'
*AMUQ 'u-quark Mass' C D='2.0D-3'
*AMCQ 'c-quark Mass' C D='1.0D0'
*AMTQ 't-quark Mass' C D='174.0D0'
*AMDQ 'd-quark Mass' C D='5.0D-3'
*AMSQ 's-quark Mass' C D='100.0D-3'
*AMBQ 'b-quark Mass' C D='4.1D0'
*AGW 'W-Boson Width' C D='2.08D0'
*AGZ 'Z-Boson Width' C D='2.49D0'
*AGH 'Higgs Width' C D='4000.0D0'
*AGX 'Chi Width' C D='AGW'
*AGY 'Chi-3 Width' C D='AGZ'
*AGCQ 'c-quark Width' C D='0.0D0'
*AGTQ 't-quark Width' C D='0.0D0'
*AGSQ 's-quark Width' C D='0.0D0'
*AGBQ 'b-quark Width' C D='0.0D0'
*>Guidance
*Set mass and width
*>Action grc_gen_setmas
*------------------------------------------------------*
* This is an example for request of Prof. Munehisa
*=================================================
*  crs_def.cdf 
*                                    Nov 1994
*=================================================
*>Name crsdf
*
*>Menu /CROSS
*>Guidence
*Interactive Database for elementary processes
*
*>Command muon_pair_total
*>Parameters
*OPTION 'Model' C D='ELWK'
*-ELWK
*-QED
*+
*XI 'Lowest energy' R D='40'
*XF 'Highest energy' R D='100'
*>Guidence
*Total cross section for muon_pair
*>Action CRS_TOTAL
*
*>Command muon_pair_diff
*>Parameters
*OPTION 'Model' C D='ELWK'
*-ELWK
*-QED
*+
*ET 'Energy' R D='100'
*COS1 'Lowest angle(COS)' R D='0.90'
*COS2 'Highest energy(COS)' R D='-0.90'
*>Guidence
*Differential cross section for muon_pair
*>Action CRS_DIFF
*
*>Command bhabha_total
*>Parameters
*OPTION 'Model' C D='ELWK'
*-ELWK
*-QED
*+
*XI 'Lowest energy' R D='40'
*XF 'Highest energy' R D='100'
*COS1 'Lowest angle(COS)' R D='0.90'
*COS2 'Highest energy(COS)' R D='-0.90'
*>Guidence
*Total cross section for Bhabha
*>Action CRS_TOTAL
*
*>Command bhabha_diff
*>Parameters
*OPTION 'Model' C D='ELWK'
*-ELWK
*-QED
*+
*ET 'Energy' R D='100'
*COS1 'Lowest angle(COS)' R D='0.90'
*COS2 'Highest energy(COS)' R D='-0.90'
*>Guidence
*Differential cross section for Bhabha
*>Action CRS_DIFF
