*-----------------------------------------------------------------------
      subroutine grc_gen_kinem2
      common /parm/ ncall,itmx1,itmx2,icost,ident
      common /cut/  coscut(2)
      common /energy/  emin,emax,ebin
      dimension isel(3)
      data isel/0,1,-1/
*     For Total Cross section, emin,emax and ebin are given in main.
*     For Diffe Cross section, emin is given in here as an energy.
      ISRC = 98
      open(ISRC,file='kinit.f',status='unknown')
      WRITE(ISRC,100)
  100 FORMAT(
     . '      SUBROUTINE KINIT'/
     . '      IMPLICIT REAL*8(A-H,O-Z)'/
     . 'C------------------------------------------------------------' 
     . '---------'/
     . 'C   GRACE System Library File'/
     . 'C   KINEM No. : 200x'/
     . 'C   Date      : 1994.04.30'/
     . 'C   Author    : Y.Kurihara'/
     . 'C------------------------------------------------------------' 
     . '---------')

      WRITE(ISRC,101)
  101 FORMAT(
     . ' '/
     . '      PARAMETER ( MXDIM = 50 )'/
     . '      COMMON / LOOP0 / LOOP'/
     . '      COMMON / BPARM1 / XL(MXDIM),XU(MXDIM),NDIM,NWILD,'/
     . '     &                 IG(MXDIM),NCALL'/
     . '      COMMON / BPARM2 / ACC1,ACC2,ITMX1,ITMX2'/
     . '      COMMON / BASE3 / SI,SI2,SWGT,SCHI,SCALLS,ATACC,NSU,IT,W' 
     . 'GT'/
     . ' '/
     . '      CHARACTER XSTR*14')

      WRITE(ISRC,102)
  102 FORMAT(
     . ' '/
     . '      INCLUDE  ''inclk.f'''/
     . '*------------------------------------------------------------' 
     . '-----------'/
     . '      COMMON/KINEM1/S,W,FACT'/
     . '      COMMON/KCNTL1/ICOST'/
     . '      COMMON/CUT001/COSCUT(2)'/
     . '*------------------------------------------------------------' 
     . '-----------'/
     . '      COMMON /INTGRC/ IFLGWO,IFLGHS')

      WRITE(ISRC,103)
  103 FORMAT(
     . '*             IFLGWO=0 : W is given here.'/
     . '*             IFLGHS=0 : Hist. and Scat. Plot will be suppres' 
     . 'sed.'/
     . '*------------------------------------------------------------' 
     . '-----------'/
     . '* 2-body kinematics'/
     . '*'/
     . '*  Integration variables'/
     . '*        COS(the),Phi'/
     . '*')

      WRITE(ISRC,104) emin
  104 FORMAT(
     . '*--- 1. Initialize constants for kinematics.'/
     . '* S = (P1+P2)**2'/
     . '* W = SQRT(S)'/
     . '      IF( IFLGWO .EQ. 0 ) THEN'/
     . '          W = ',F9.3,'D0'/
     . '      ENDIF'/
     . '      S = W*W'/
     . '      totmas=amass1(3)+amass1(4)'/
     . '      if(totmas.gt.w) then'/
     . '	write(6,*)')

      WRITE(ISRC,105) coscut
  105 FORMAT(
     . '     .'' CM energy is less than the sum of final particle mas' 
     . 'ses.'''/
     . '	stop'/
     . '      end if'/
     . '* Energy and anluare cuts'/
     . '* minimum cos  cut for particle 3'/
     . '      COSCUT(1)= cos(',F9.3,'D0*rad)'/
     . '* maximum cos  cut for particle 3'/
     . '      COSCUT(2)= cos(',F9.3,'D0*rad)'/
     . '*If  ICOST=+-1')

      WRITE(ISRC,106) isel(icost)
  106 FORMAT(
     . '* -t=(p1-p3)**2 is used as integration variable.'/
     . '*  +1; forward peak.'/
     . '*  -1; forward and backward peaks.'/
     . '      ICOST=',I2/
     . ' '/
     . '      WRITE(6,*)''*'''/
     . '      WRITE(6,*)''* Kinematics initialization '''/
     . '      WRITE(6,*)''* particle mass '',amass1'/
     . '      WRITE(6,*)''* CM Energy '',W'/
     . '      WRITE(6,*)''* COSCUT    ''')

      WRITE(ISRC,107)
  107 FORMAT(
     . '      WRITE(6,''(2F20.8)'')COSCUT'/
     . '      WRITE(6,*)''* Integration Variable '''/
     . '      if(icost.eq.0) then'/
     . '      WRITE(6,*)''* cos3 '''/
     . '      else if(icost.eq.+1) then'/
     . '      WRITE(6,*)''* -t ;forward peak'''/
     . '      else if(icost.eq.-1) then'/
     . '      WRITE(6,*)''* -t ;forward-backward peak'''/
     . '      else'/
     . '      WRITE(6,*)''* icost should be 0 or +-1.'',icost')

      WRITE(ISRC,108)
  108 FORMAT(
     . '      end if'/
     . '      WRITE(6,*)''*'''/
     . ' '/
     . '* Following flux factor is for a particle-antiparticle collis' 
     . 'ion'/
     . '* at s/m**2 >> 1. For an e-gamma collision or low energy inte' 
     . 'ractions'/
     . '* you should use appropriate formulae.'/
     . '      VREL = 2'/
     . '      FLUX = VREL*S'/
     . '      FACT = GEVPB/FLUX')
      if( ident .eq. 2 ) then
        write(ISRC,199)
  199 FORMAT(
     . '      FACT = FACT*0.5D0')
      endif

      WRITE(ISRC,109)
  109 FORMAT(
     . ' '/
     . '*----- BASES RELATED INITIALIZATIONS ------------------------' 
     . '-----------'/
     . '*--- 3. Dimension of integration variables.'/
     . ' '/
     . '          NDIM =   2'/
     . '          NWILD=   1'/
     . ' '/
     . 'C------------------------------------------------------------' 
     . '-----------')

      WRITE(ISRC,110)
  110 FORMAT(
     . '*--- 4. Region of integration.'/
     . ' '/
     . '        XL(1)  =   0.D0'/
     . '        XU(1)  =   1.D0'/
     . '        IG(1)  =   1'/
     . ' '/
     . '        XL(2)  =   0.D0'/
     . '        XU(2)  =   1.D0'/
     . '        IG(2)  =   0'/
     . 'C------------------------------------------------------------' 
     . '-----------')

      WRITE(ISRC,111) itmx1,itmx2,ncall
  111 FORMAT(
     . '*--- 5. Number of iterations'/
     . '      ITMX1  =  ',I3/
     . '      ITMX2  =  ',I3/
     . ' '/
     . '      NCALL  = ',I10/
     . ' '/
     . '*--- 6. Set MXREG : the maximum number of values which are re' 
     . 'turned'/
     . '*       by FUNC for one phase space point'/
     . ' ')

      WRITE(ISRC,112)
  112 FORMAT(
     . '      MXREG =   1'/
     . ' '/
     . '*--- 7. Set histograms'/
     . '      NX = 50'/
     . '      ND = 50'/
     . ' '/
     . '*     DO 100 I = 1, NDIM'/
     . '*        WRITE(XSTR, 110) I'/
     . '* 110    FORMAT(''X('',I2,'') SPECTRUM'')'/
     . '*        CALL XHINIT(I, XL(I), XU(I), NX, XSTR)')

      WRITE(ISRC,113)
  113 FORMAT(
     . '* 100 CONTINUE'/
     . ' '/
     . '*        CALL XHINIT(ndim+1, 0.d0, w, NX, ''Energy of Particl' 
     . 'e 3'')'/
     . '*        CALL XHINIT(ndim+2, 0.d0, w, NX, ''Energy of Particl' 
     . 'e 4'')'/
     . '*        CALL XHINIT(ndim+3,-1.d0,1.d0, NX, ''cos_the of Part' 
     . 'icle 3'')'/
     . '*        CALL XHINIT(ndim+4,-1.d0,1.d0, NX, ''cos_the of Part' 
     . 'icle 4'')')

      WRITE(ISRC,114)
  114 FORMAT(
     . ' '/
     . '      IF( IFLGHS .NE. 0 ) THEN'/
     . '         CALL XHINIT(1,-1.d0,1.d0, NX, ''cos_the of Particle ' 
     . '3'')'/
     . '      ENDIF'/
     . ' '/
     . '      RETURN'/
     . '      END')
      close(ISRC)


      open(ISRC,file='kinem.f',status='unknown')
      WRITE(ISRC,200)
  200 FORMAT(
     . '      SUBROUTINE KINEM(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)'/
     . ' '/
     . 'C------------------------------------------------------------' 
     . '---------'/
     . 'C   GRACE System Library File'/
     . 'C   KINEM No. : 200x'/
     . 'C   Date      : 1994.04.30'/
     . 'C   Author    : Y.Kurihara'/
     . 'C------------------------------------------------------------' 
     . '---------')

      WRITE(ISRC,201)
  201 FORMAT(
     . '      IMPLICIT REAL* 8(A-H,O-Z)'/
     . '*************************************************************' 
     . '***********'/
     . '      INTEGER NEXTRN'/
     . '      PARAMETER ( MXDIM = 50 )'/
     . ' '/
     . '      COMMON / BASE1 / XL(MXDIM),XU(MXDIM),NDIM'/
     . '      REAL*8  X(MXDIM)'/
     . '      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)'/
     . '      REAL*8  YACOB')

      WRITE(ISRC,202)
  202 FORMAT(
     . '      INTEGER NREG, IREG'/
     . '      INTEGER JUMP'/
     . ' '/
     . '      INCLUDE ''inclk.f'''/
     . '*------------------------------------------------------------' 
     . '--------'/
     . '      COMMON/KINEM1/S,W,FACT'/
     . '      COMMON/KCNTL1/ICOST'/
     . '      COMMON/CUT001/COSCUT(2)'/
     . '* BETA FUNCTION')

      WRITE(ISRC,203)
  203 FORMAT(
     . '       BETA(Z1,Z2)=SQRT(1-2*(Z1+Z2)+(Z1-Z2)**2)'/
     . '*------------------------------------------------------------' 
     . '-----------'/
     . '      NREG   =   1'/
     . '      JUMP   =   0'/
     . '      YACOB  =   0.D0'/
     . '      AJACOB=    1'/
     . '* Set integration variables'/
     . '************'/
     . '* PHI      *')

      WRITE(ISRC,204)
  204 FORMAT(
     . '************'/
     . '      IF(NDIM.EQ.2) THEN'/
     . '       PHI3=X(2)*2*PI'/
     . '      ELSE'/
     . '       PHI3=0'/
     . '      END IF'/
     . '                 AJACOB = AJACOB*2*PI'/
     . '************'/
     . '* C0S(the) *'/
     . '************')

      WRITE(ISRC,205)
  205 FORMAT(
     . '      E1      = (S+AMASS2(1)-AMASS2(2))/2.D0/W'/
     . '      P1      = SQRT( (E1-AMASS1(1))*(E1+AMASS1(1)) )'/
     . '      E2      = (S+AMASS2(2)-AMASS2(1))/2.D0/W'/
     . '      P2      = P1'/
     . '      E3      = (S+AMASS2(3)-AMASS2(4))/2.D0/W'/
     . '      P3      = SQRT( (E3-AMASS1(3))*(E3+AMASS1(3)) )'/
     . '      E4      = (S+AMASS2(4)-AMASS2(3))/2.D0/W'/
     . '      P4      = P3'/
     . ' '/
     . '*')

      WRITE(ISRC,206)
  206 FORMAT(
     . '      IF     (ICOST.EQ.0) THEN'/
     . '       COS3=COSCUT(1) + (COSCUT(2)-COSCUT(1))*X(1)'/
     . '                 AJACOB = AJACOB*(COSCUT(2)-COSCUT(1))'/
     . '       pp13=E1*E3-P1*P3*COS3'/
     . '       pp14=E1*E4+P1*P4*COS3'/
     . '       pp23=E2*E3+P2*P3*COS3'/
     . '       pp24=E2*E4-P2*P4*COS3'/
     . '      ELSE IF(ICOST.EQ.+1) THEN'/
     . '        x1=x(1)'/
     . '        dmin=    2*(e1*e3-p1*p3*coscut(2))-amass2(3)')

      WRITE(ISRC,207)
  207 FORMAT(
     . '        dmax=    2*(e1*e3-p1*p3*coscut(1))-amass2(3)'/
     . '        if(dmax.lt.dmin) goto 999'/
     . '        if(dmin.le.0) goto 999'/
     . '        d=dmin*(dmax/dmin)**x1'/
     . '        cos3=e1*e3/p1/p3-(d+amass2(3))/2.d0/p1/p3'/
     . '                  ajacob=ajacob*d*log(dmax/dmin)/p1/p3/2.d0'/
     . '*'/
     . '        pp13=(d+amass2(3))/2.d0'/
     . '        pp14=(s+amass2(1)-amass2(2)-amass2(3)-d)/2.d0'/
     . '        pp23=(s-amass2(4)-d)/2.d0')

      WRITE(ISRC,208)
  208 FORMAT(
     . '        pp24=(amass2(2)+amass2(4)-amass2(1)+d)/2.d0'/
     . '*'/
     . '      ELSE IF(ICOST.EQ.-1) THEN'/
     . '       if(x(1).le.0.5d0) then'/
     . '        x1=x(1)*2'/
     . '        dmin=    2*(e1*e3-p1*p3*coscut(2))-amass2(3)'/
     . '        dmax=min(2*(e1*e3-p1*p3*coscut(1)),2*e1*e3)-amass2(3)'/
     . '        if(dmax.lt.dmin) goto 999'/
     . '        if(dmin.le.0) goto 999'/
     . '        d=dmin*(dmax/dmin)**x1')

      WRITE(ISRC,209)
  209 FORMAT(
     . '        cos3=e1*e3/p1/p3-(d+amass2(3))/2.d0/p1/p3'/
     . '                   ajacob=ajacob*d*log(dmax/dmin)/p1/p3'/
     . '*'/
     . '        pp13=(d+amass2(3))/2.d0'/
     . '        pp14=(s+amass2(1)-amass2(2)-amass2(3)-d)/2.d0'/
     . '        pp23=(s-amass2(4)-d)/2.d0'/
     . '        pp24=(amass2(2)+amass2(4)-amass2(1)+d)/2.d0'/
     . '*'/
     . '       else'/
     . '        x1=x(1)*2-1')

      WRITE(ISRC,210)
  210 FORMAT(
     . '        dmin=    2*(e1*e4+p1*p4*coscut(1))-amass2(4)'/
     . '        dmax=min(2*(e1*e4+p1*p4*coscut(2)),2*e1*e4)-amass2(4)'/
     . '        if(dmax.lt.dmin) goto 999'/
     . '        if(dmin.le.0) goto 999'/
     . '        d=dmin*(dmax/dmin)**x1'/
     . '        cos3=-e1*e4/p1/p4+(d+amass2(4))/2.d0/p1/p4'/
     . '                  ajacob=ajacob*d*log(dmax/dmin)/p1/p4'/
     . '*'/
     . '        pp14=(d+amass2(4))/2.d0'/
     . '        pp13=(s+amass2(1)-amass2(2)-amass2(4)-d)/2.d0')

      WRITE(ISRC,211)
  211 FORMAT(
     . '        pp24=(s-amass2(3)-d)/2.d0'/
     . '        pp23=(amass2(2)+amass2(3)-amass2(1)+d)/2.d0'/
     . '*'/
     . '      end if'/
     . '      ELSE'/
     . '       GOTO 999'/
     . '      END IF'/
     . '      if(abs(cos3).gt.1) goto 999'/
     . '      SIN3=SQRT( (1-COS3)*(1+COS3) )'/
     . ' ')

      WRITE(ISRC,212)
  212 FORMAT(
     . '* Set four-vectors'/
     . '*Particle 1'/
     . '      PE(1,1) = 0'/
     . '      PE(2,1) = 0'/
     . '      PE(3,1) = P1'/
     . '      PE(4,1) = E1'/
     . ' '/
     . '*Particle 2'/
     . '      PE(1,2) = 0'/
     . '      PE(2,2) = 0')

      WRITE(ISRC,213)
  213 FORMAT(
     . '      PE(3,2) =-P2'/
     . '      PE(4,2) = E2'/
     . ' '/
     . '*Particle 3'/
     . '      PE(1,3) = P3*SIN3*COS(PHI3)'/
     . '      PE(2,3) = P3*SIN3*SIN(PHI3)'/
     . '      PE(3,3) = P3*COS3'/
     . '      PE(4,3) = E3'/
     . '*Particle 4'/
     . '      PE(1,4) =-P4*SIN3*COS(PHI3)')

      WRITE(ISRC,214)
  214 FORMAT(
     . '      PE(2,4) =-P4*SIN3*SIN(PHI3)'/
     . '      PE(3,4) =-P4*COS3'/
     . '      PE(4,4) = E4'/
     . ' '/
     . '*Set invariants'/
     . '      PP(1,1) = AMASS2(1)'/
     . '      PP(1,2) = (S-AMASS2(1)-AMASS2(2))/2.D0'/
     . '      PP(1,3) = pp13'/
     . '      PP(1,4) = pp14'/
     . ' ')

      WRITE(ISRC,215)
  215 FORMAT(
     . '      PP(2,1) = PP(1,2)'/
     . '      PP(2,2) = AMASS2(2)'/
     . '      PP(2,3) = pp23'/
     . '      PP(2,4) = pp24'/
     . ' '/
     . '      PP(3,1) = PP(1,3)'/
     . '      PP(3,2) = PP(2,3)'/
     . '      PP(3,3) = AMASS2(3)'/
     . '      PP(3,4) = (S-AMASS2(3)-AMASS2(4) )/2.D0'/
     . ' ')

      WRITE(ISRC,216)
  216 FORMAT(
     . '      PP(4,1) = PP(1,4)'/
     . '      PP(4,2) = PP(2,4)'/
     . '      PP(4,3) = PP(3,4)'/
     . '      PP(4,4) = AMASS2(4)'/
     . '*Set jacobian'/
     . '      YACOB=FACT*AJACOB'/
     . '     ./32.D0/PI2'/
     . '     .*BETA(AMASS2(3)/S,AMASS2(4)/S)'/
     . '      return'/
     . '999   continue')

      WRITE(ISRC,217)
  217 FORMAT(
     . '      jump=1'/
     . '      RETURN'/
     . '      END')
      close(ISRC)
*---
      open(ISRC,file='kfill.f',status='unknown')


      WRITE(ISRC,300)
  300 FORMAT(
     . '* FILE kfill'/
     . '*'/
     . '* Grace Version   2. 0. 0'/
     . '*************************************************************' 
     . '***********'/
     . '      SUBROUTINE KFILL(NEXTRN, ndim, X, PE, PP, ANS)'/
     . ' '/
     . '      IMPLICIT REAL* 8(A-H,O-Z)'/
     . ' '/
     . '*************************************************************' 
     . '***********')

      WRITE(ISRC,301)
  301 FORMAT(
     . '      INTEGER NEXTRN'/
     . '      PARAMETER ( MXDIM = 50 )'/
     . '      REAL*8  X(MXDIM)'/
     . '      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)'/
     . ' '/
     . '      INCLUDE ''inclk.f'''/
     . '*============================================================' 
     . '==========='/
     . '*          Fill Histograms and Scatter plots'/
     . '*============================================================' 
     . '===========')

      WRITE(ISRC,302)
  302 FORMAT(
     . ' '/
     . '*       DO 40 I = 1, NDIM'/
     . '*          CALL XHFILL( I, X(I), ANS )'/
     . '*  40   CONTINUE'/
     . ' '/
     . '*          CALL XHFILL(ndim+1,pe(4,3) , ANS )'/
     . '*          CALL XHFILL(ndim+2,pe(4,4) , ANS )'/
     . '*          cos3=pe(3,3)/sqrt(pe(1,3)**2+pe(2,3)**2+pe(3,3)**2)'/
     . '*          CALL XHFILL(ndim+3,cos3, ANS )'/
     . '*          cos4=pe(3,4)/sqrt(pe(1,4)**2+pe(2,4)**2+pe(3,4)**2)')

      WRITE(ISRC,303)
  303 FORMAT(
     . '*          CALL XHFILL(ndim+4,cos4, ANS )'/
     . ' '/
     . '           cos3=pe(3,3)/sqrt(pe(1,3)**2+pe(2,3)**2+pe(3,3)**2)'/
     . '           CALL XHFILL(1,cos3, ANS )'/
     . ' '/
     . '      RETURN'/
     . '      END')
      close(ISRC)
      return
      end
*-----------------------------------------------------------------------
      subroutine  grc_gen_total
      common /energy/  emin,emax,ebin
      ISRC = 98
      open(ISRC,file='totcs.f',status='unknown')
      WRITE(ISRC,100)
  100 FORMAT(
     . '*------------------------------------------------------------' 
     . '--'/
     . '*      totcs.f                             1994/11/30'/
     . '*      root(s) versus total cross section'/
     . '*------------------------------------------------------------' 
     . '--'/
     . '*'/
     . '      IMPLICIT REAL*8(A-H,O-Z)'/
     . '      EXTERNAL FUNC'/
     . ' ')

      WRITE(ISRC,101)
  101 FORMAT(
     . '      COMMON /BSCNTL/ INTV, IPNT'/
     . '      COMMON /LOOP0/ LOOP'/
     . ' '/
     . 'C'/
     . '      COMMON/KINEM1/ S, W, FACT'/
     . '      COMMON /INTGRC/ IFLGWO,IFLGHS'/
     . '      REAL*4 STIME'/
     . '      PARAMETER (MXLOOP = 100 )'/
     . '      REAL*4 WCM(MXLOOP),XDATA(MXLOOP),XERROR(MXLOOP)'/
     . '      data ypos/0.6/'/
     . ' ')

      WRITE(ISRC,102)
  102 FORMAT(
     . '*========================================================='/
     . '*          Initialization of BASES by calling BSINIT'/
     . '*========================================================='/
     . ' '/
     . '      ifirst = 0'/
     . '      IFLGWO = 1'/
     . '      IFLGHS = 0'/
     . ' '/
     . '*         -------------'/
     . '           CALL BSINIT'/
     . '*         -------------'/
     . '           INTV  = 0')

      WRITE(ISRC,103) emin,emax,ebin
  103 FORMAT(
     . ' '/
     . '      LX      = 9'/
     . '      LU      = 10'/
     . '      LX2     = 12'/
     . '      OPEN( LU, FILE=''totcs.result'','/
     . '     .      STATUS=''unknown'', FORM=''formatted'')'/
     . ' '/
     . '      LOOP = 0'/
     . ' '/
     . '      DO 1000 W = ',F9.3,'D0,',F9.3,'D0,',F9.3,'D0')

      WRITE(ISRC,104)
  104 FORMAT(
     . '         LOOP = LOOP + 1'/
     . '         IF( LOOP .GT. MXLOOP ) GOTO 1000'/
     . ' '/
     . '*========================================================='/
     . '*      Initialization of BASES parameters'/
     . '*========================================================='/
     . '*        -------------'/
     . '	  CALL USERIN'/
     . '*        -------------'/
     . '*************************************************************' 
     . '*******')

      WRITE(ISRC,105)
  105 FORMAT(
     . '*              Nimerical Integration by BASES v5.1'/
     . '*************************************************************' 
     . '*******'/
     . ' '/
     . '         CALL BASES( FUNC, ESTIM, SIGMA, CTIME, IT1, IT2 )'/
     . ' '/
     . '         IF( LOOP .EQ. 1 ) THEN'/
     . '             WRITE(LU,9650)'/
     . ' 9650        FORMAT('/
     . '     .        20X,''Results of Integration'',')

      WRITE(ISRC,106)
  106 FORMAT(
     . '     .       /10X,5(''----------''),''------'','/
     . '     .       /10X,'' RootS  Estimate(+- Error )order'''/
     . '     .                       ''  It1  It2 ( H: M: Sec )'','/
     . '     .       /10X,5(''----------''),''------'')'/
     . '         ENDIF'/
     . ' '/
     . '         RE  = ESTIM'/
     . '         AC  = SIGMA'/
     . '         ARE = RE'/
     . '         IF( ARE .GE. AC) THEN')

      WRITE(ISRC,107)
  107 FORMAT(
     . '             CALL BSORDR( ARE, F2, ORDER, IORDR)'/
     . '         ELSE'/
     . '             CALL BSORDR(  AC, F2, ORDER, IORDR )'/
     . '         ENDIF'/
     . '         RE  = RE/ORDER'/
     . '         AC  = AC/ORDER'/
     . '         STIME = CTIME'/
     . '         CALL BSTCNV( STIME, IH, MN, IS1, IS2)'/
     . '         WRITE(LU,9660) W,RE,AC,IORDR,IT1,IT2,IH,MN,IS1,IS2'/
     . '         WRITE(6 ,9660) W,RE,AC,IORDR,IT1,IT2,IH,MN,IS1,IS2')

      WRITE(ISRC,108)
  108 FORMAT(
     . ' 9660    FORMAT(10X,F6.1,F10.6,''(+-'',F8.6,'')E'',I3.2,2I5,'/
     . '     .           1X,I3,'':'',I2,'':'',I2,''.'',I2.2,'/
     . '     .         /10X,5(''----------''),''------'')'/
     . ' '/
     . '          WCM(LOOP)    = W'/
     . '          XDATA(LOOP)  = ESTIM'/
     . '          XERROR(LOOP) = SIGMA'/
     . '*--'/
     . '	  if( ifirst .eq. 0 ) then'/
     . '              xmax = xdata(loop)')

      WRITE(ISRC,109)
  109 FORMAT(
     . '              xmin = xdata(loop)'/
     . '	      ifirst = 1'/
     . '	  else'/
     . '	      if( xdata(loop) .gt. xmax ) xmax = xdata(loop)'/
     . '	      if( xdata(loop) .lt. xmin ) xmin = xdata(loop)'/
     . '	  endif'/
     . ' 1000 CONTINUE'/
     . ' '/
     . ' '/
     . '      LX3   = 13')

      WRITE(ISRC,110)
  110 FORMAT(
     . '      LX5   = 15'/
     . '      OPEN( LX2, FILE=''vx0.data'','/
     . '     .      STATUS=''unknown'', FORM=''formatted'')'/
     . '      OPEN( LX3, FILE=''vy0.data'','/
     . '     .      STATUS=''unknown'', FORM=''formatted'')'/
     . '*     OPEN( LX5, FILE=''totcs.tex'','/
     . '*    .      STATUS=''unknown'', FORM=''formatted'')'/
     . ' '/
     . '      DO 2100 I = 1, LOOP'/
     . '         WRITE(LX3,9200) XDATA(I)')

      WRITE(ISRC,111)
  111 FORMAT(
     . ' 2100 CONTINUE'/
     . '*'/
     . '        DO 2000 I = 1, LOOP'/
     . '           WRITE(LX2,9200) WCM(I)'/
     . ' 9200      FORMAT(E15.6)'/
     . ' 2000   CONTINUE'/
     . ' '/
     . '*     WRITE(LX5,9300)'/
     . '*9300 FORMAT(''\begin{center}'','/
     . '*    .     /,''{\footnotesize'',')

      WRITE(ISRC,112)
  112 FORMAT(
     . '*    .     /,''\begin{tabular}{||r|c||r|c||} \hline'','/
     . '*    .     /,''$\sqrt{s}$ {\footnotesize (GeV)} &'','/
     . '*    .       '' Cross section ( error ) {\footnotesize (pb)} ' 
     . '&'','/
     . '*    .     /,''$\sqrt{s}$ {\footnotesize (GeV)} &'','/
     . '*    .       '' Cross section ( error ) {\footnotesize (pb)} ' 
     . ''','/
     . '*    .       ''\\ \hline'')'/
     . '*'/
     . '*     K1 = 0')

      WRITE(ISRC,113)
  113 FORMAT(
     . '*     KK = LOOP/2'/
     . '*     if( mod(loop,2) .eq. 1 ) KK = KK + 1'/
     . '*     K2 = KK'/
     . '*     DO 2300 I = 1, KK'/
     . '*        K1 = K1 + 1'/
     . '*        K2 = K2 + 1'/
     . '*'/
     . '*        RE  = XDATA(K1)'/
     . '*        AC  = XERROR(K1)'/
     . '*        ARE = RE')

      WRITE(ISRC,114)
  114 FORMAT(
     . '*        IF( ARE .GE. AC) THEN'/
     . '*            CALL BSORDR( ARE, F2, ORDER, IORDR)'/
     . '*        ELSE'/
     . '*            CALL BSORDR(  AC, F2, ORDER, IORDR )'/
     . '*        ENDIF'/
     . '*        RE  = RE/ORDER'/
     . '*        AC  = AC/ORDER'/
     . '*'/
     . '*        if( k2 .le. loop ) then'/
     . '*            RE1 = XDATA(K2)')

      WRITE(ISRC,115)
  115 FORMAT(
     . '*            AC1 = XERROR(K2)'/
     . '*            ARE = RE1'/
     . '*            IF( ARE .GE. AC1) THEN'/
     . '*                CALL BSORDR( ARE, F2, ORDER, IORDR1)'/
     . '*            ELSE'/
     . '*                CALL BSORDR( AC1, F2, ORDER, IORDR1 )'/
     . '*            ENDIF'/
     . '*            RE1 = RE1/ORDER'/
     . '*            AC1 = AC1/ORDER'/
     . '*')

      WRITE(ISRC,116)
  116 FORMAT(
     . '*            WRITE(LX5,9310) WCM(K1),RE,AC,IORDR,WCM(K2),RE1,' 
     . 'AC1,IORDR1'/
     . '*         else'/
     . '*            WRITE(LX5,9311) WCM(K1),RE,AC,IORDR'/
     . '*         endif'/
     . '*'/
     . '*9310    FORMAT(F7.1,'' &'',F10.6,'' ($\pm$'',F8.6,'' ) $\tim' 
     . 'es 10^{'','/
     . '*    .          I3,''}$ &'','/
     . '*    .          F7.1,'' &'',F10.6,'' ($\pm$'',F8.6,'' ) $\tim' 
     . 'es 10^{'',')

      WRITE(ISRC,117)
  117 FORMAT(
     . '*    .          I3,''}$ '',''\\ \hline'')'/
     . '*9311    FORMAT(F7.1,'' &'',F10.6,'' ($\pm$'',F8.6,'' ) $\tim' 
     . 'es 10^{'','/
     . '*    .          I3,''}$ & & \\ \hline'')'/
     . '*2300 CONTINUE'/
     . '*     WRITE(LX5,9320)'/
     . '*9320 FORMAT(''\end{tabular}}'',/,''\end{center}'')'/
     . ' '/
     . '      CLOSE( LX )'/
     . '      CLOSE( LX3 )')

      WRITE(ISRC,118)
  118 FORMAT(
     . '*     CLOSE( LX5 )'/
     . '      CLOSE( LX2 )'/
     . ' '/
     . '*--------------'/
     . '*     max/min'/
     . '*--------------'/
     . '*     print *,xmax,xmin'/
     . '      ilmax = int(log10(xmax))'/
     . '	if( xmax .gt. 1 ) ilmax = ilmax + 1'/
     . '      ilmin = int(log10(xmin))')

      WRITE(ISRC,119)
  119 FORMAT(
     . '	if( xmin .lt. 1. ) ilmin = ilmin - 1'/
     . '*---- writedown totcs.kumac'/
     . '      open(2,file=''totcs.kumac'',status=''unknown'')'/
     . '      write(2,100)'/
     . '      write(2,120) 10.**(ilmin), 10.**(ilmax)'/
     . '	   ycor = ilmin + ypos*(ilmax-ilmin)'/
     . '	   ycorl = 10.**ycor'/
     . '      write(2,130) loop,ycor,ycor'/
     . '      write(2,160)'/
     . '      close(2)')

      WRITE(ISRC,120)
  120 FORMAT(
     . '      stop'/
     . '  100 format('/
     . '     . ''*----- root(s) versus Total Cross Section''/'/
     . '     . ''vector/create vx0(100)''/'/
     . '     . ''vector/read vx0 ''''vx0.data''''''/'/
     . '     . ''vector/create vy0(100)''/'/
     . '     . ''vector/read vy0 ''''vy0.data'''''')'/
     . ' '/
     . '  120 format('/
     . '     . ''OPTION LOGY''/')

      WRITE(ISRC,121)
  121 FORMAT(
     . '     . ''opt tic''/'/
     . '     . ''set xsiz 15.0''/'/
     . '     . ''set ysiz 10.0''/'/
     . '     . ''set xmgl  2.5''/'/
     . '     . ''set xmgr  1.0''/'/
     . '     . ''set ymgu  0.7''/'/
     . '     . ''set ymgl  1.8''/'/
     . '     . ''set asiz 0.3''/'/
     . '     . ''set xlab  1.4''/'/
     . '     . ''set ylab 0.8''/')

      WRITE(ISRC,122)
  122 FORMAT(
     . '     . ''set yval  0.3''/'/
     . '     . ''set chhe  0.3''/'/
     . '     . ''set pass    5''/'/
     . '     . ''set dmod    3''/'/
     . '     . ''*set vfon -20''/'/
     . '     . ''fortran/file 66 totcs.ps''/'/
     . '     . ''metafile 66 -113''/'/
     . '     . ''null 180 1000 '',1pE6.0,'' '',1pE6.0/'/
     . '     . ''*    ^^^      ^^^^^^ ^^^^^'')'/
     . '  130 format(')

      WRITE(ISRC,123)
  123 FORMAT(
     . '     . ''*************************************''/'/
     . '     . ''set plci 1''/'/
     . '     . ''set dmod 1''/'/
     . '     . ''graph '',I2,'' vx0 vy0 ''''C''''''/'/
     . '     . ''line 700.0 '',F9.3,'' 750.0 '',F9.3/'/
     . '     . ''*^^^^^^^^^^^^^^^^^^^^^^^^^^^'')'/
     . '  160 format('/
     . '     . ''*===================================================' 
     . '=======''/'/
     . '     . ''atitle ''''CMS energy (GeV)''''  ''''Total cross sec' 
     . 'tion (pb)''''''/')

      WRITE(ISRC,124)
  124 FORMAT(
     . '     . ''fortran/close 66'')'/
     . '      end')
      close(ISRC)
      return
      end
*-----------------------------------------------------------------------
      subroutine grc_gen_diff
      common /energy/  emin,emax,ebin
      ISRC = 98
      open(ISRC,file='difcs.f',status='unknown')
      WRITE(ISRC,100)
  100 FORMAT(
     . 'C----- difcs.f'/
     . 'C'/
     . '      IMPLICIT REAL*8(A-H,O-Z)'/
     . '      EXTERNAL FUNC'/
     . '      PARAMETER ( MXDIM = 50 )'/
     . '      COMMON /BSCNTL/ INTV, IPNT'/
     . '      COMMON /INTGRC/ IFLGWO,IFLGHS'/
     . '      COMMON /LOOP0/ LOOP'/
     . '      PARAMETER ( MHSIZE = 10000 )'/
     . '      COMMON /PAWC/ MEMORY( 10000 )')

      WRITE(ISRC,101)
  101 FORMAT(
     . 'C'/
     . '      COMMON/KINEM1/ S, W, FACT'/
     . '      REAL*4 STIME'/
     . '      REAL*4 VLSMAX(50),VLSMIN(50)'/
     . '      COMMON /DSDXMM/ VLSMAX,VLSMIN'/
     . '*'/
     . '*---------------------------------------------------------'/
     . '*     "W" is given in "kinit.f"'/
     . '*---------------------------------------------------------'/
     . '      IFLGWO = 0'/
     . '*---------------------------------------------------------')

      WRITE(ISRC,102)
  102 FORMAT(
     . '*     Generate Histogram'/
     . '*---------------------------------------------------------'/
     . '      IFLGHS = 1'/
     . '*========================================================='/
     . '*          Initialization of HBOOK and PAW Buffer'/
     . '*========================================================='/
     . ' '/
     . '      CALL HLIMIT( MHSIZE )'/
     . '      CALL HTITLE(''Differential Cross Sections'')'/
     . ' ')

      WRITE(ISRC,103)
  103 FORMAT(
     . '*========================================================='/
     . '*          Initialization of BASES by calling BSINIT'/
     . '*========================================================='/
     . ' '/
     . '      LU0 = 6'/
     . ' '/
     . '*     -------------'/
     . '       CALL BSINIT'/
     . '*     -------------'/
     . '      INTV  = 0')

      WRITE(ISRC,104)
  104 FORMAT(
     . ' '/
     . '      LU = 10'/
     . '      OPEN( LU, FILE =''difcs.result'','/
     . '     .             STATUS=''unknown'', FORM=''formatted'' )'/
     . ' '/
     . '*========================================================='/
     . '*        Initialization of BASES parameters'/
     . '*========================================================='/
     . '*       -------------'/
     . '         CALL USERIN')

      WRITE(ISRC,105)
  105 FORMAT(
     . '*       -------------'/
     . '*************************************************************' 
     . '*******'/
     . '*              Nimerical Integration by BASES v5.1'/
     . '*************************************************************' 
     . '*******'/
     . ' '/
     . '         CALL BASES( FUNC, ESTIM, SIGMA, CTIME, IT1, IT2 )'/
     . ' '/
     . '             WRITE(LU0,9650)')

      WRITE(ISRC,106)
  106 FORMAT(
     . ' 9650        FORMAT('/
     . '     .        20X,''Results of Integration'','/
     . '     .       /2X,5(''----------''),''---------------'','/
     . '     .       /2X,''    Wcm  Higgs   Estimate(+- Error )order' 
     . ''''/
     . '     .                       ''  It1  It2 ( H: M: Sec )'','/
     . '     .       /2X,5(''----------''),''---------------'')'/
     . ' '/
     . '         RE  = ESTIM'/
     . '         AC  = SIGMA')

      WRITE(ISRC,107)
  107 FORMAT(
     . '         ARE = RE'/
     . '         IF( ARE .GE. AC) THEN'/
     . '             CALL BSORDR( ARE, F2, ORDER, IORDR)'/
     . '         ELSE'/
     . '             CALL BSORDR(  AC, F2, ORDER, IORDR )'/
     . '         ENDIF'/
     . '         RE  = RE/ORDER'/
     . '         AC  = AC/ORDER'/
     . '         STIME = CTIME'/
     . '         CALL BSTCNV( STIME, IH, MN, IS1, IS2)')

      WRITE(ISRC,108)
  108 FORMAT(
     . '         WRITE(LU0,9660) W,RE,AC,IORDR,IT1,IT2,'/
     . '     .                  IH,MN,IS1,IS2'/
     . ' 9660    FORMAT(2X,F6.1,1X,F10.6,''(+-'',F8.6,'')E'',I3.2,' 
     . '2I5,'/
     . '     .           1X,I3,'':'',I2,'':'',I2,''.'',I2.2,'/
     . '     .         /2X,5(''----------''),''---------------'')'/
     . ' '/
     . '	 CALL BSINFO( LU )'/
     . '	 CALL BHPLOT( LU )'/
     . '      CLOSE(LU)')

      WRITE(ISRC,109)
  109 FORMAT(
     . ' '/
     . '      CALL BSHBOK( 0 , 0 )'/
     . ' '/
     . '*==========================================================='/
     . '*          Save the contents of Histograms into PAW Buffer'/
     . '*==========================================================='/
     . ' '/
     . '      CALL HRPUT( 0, ''bases.hist'', ''N'' )'/
     . ' '/
     . '*----------------------------')

      WRITE(ISRC,110)
  110 FORMAT(
     . '      open(2,file=''difcs.kumac'',status=''unknown'')'/
     . '      dmax = VLSMAX(1)'/
     . '      dmin = VLSMIN(1)'/
     . '      ilmax = int(log10(dmax))'/
     . '      if( dmax .gt. 1. ) ilmax = ilmax + 1'/
     . '      ilmin = int(log10(dmin))'/
     . '      if( dmin .lt. 1. ) ilmin = ilmin - 1'/
     . '      write(2,6001)'/
     . '      write(2,6005) real(10.**ilmin),real(10.**ilmax)'/
     . '      write(2,6003)')

      WRITE(ISRC,111)
  111 FORMAT(
     . '      write(2,6004)'/
     . '      close(2)'/
     . '      STOP'/
     . ' 6005 format(''null -1.0 1.0 '',E15.7,'' '',E15.7)'/
     . ' 6004 format(''atitle ''''cos[q]''''  ''''d[s]/dcos[q] (pb)''' 
     . '''''/'/
     . '     .       ''*---------------------------------------'')'/
     . ' 6003 format(''set dmod 1''/''hi/pl 1 S'')'/
     . ' 6001 format('/
     . '     . ''hi/file 1 bases.hist''/''opt logy''/''opt utit''/''s' 
     . 'et xsiz 13.0''/')

      WRITE(ISRC,112)
  112 FORMAT(
     . '     . ''set ysiz 13.0''/''*set ymgu  0.2''/''set ymgu  0.5''' 
     . '/'/
     . '     . ''set xmgl  2.2''/''set ymgl  1.3''/''set xmgr  0.3''/' 
     . '''set xwin  2.5''/'/
     . '     . ''set xlab  1.5''/''set ylab  0.8''/''set asiz  0.3''/' 
     . '''set vsiz  0.2''/'/
     . '     . ''set chhe 0.3''/''fortran/file 66 difcs.ps''/''metafi' 
     . 'le 66 -113''/'/
     . '     . ''zone 1 1''/''set pass 5''/''*-----------------------' 
     . '--------------'')')

      WRITE(ISRC,113)
  113 FORMAT(
     . '      END')
*----------------------------
*     Toriaezu
*----------------------------
      call grc_gen_bshbok
      close(ISRC)
      return
      end
*-----------------------------------------------------------------------
      subroutine grc_gen_bshbok
      ISRC = 98
      WRITE(ISRC,100)
  100 FORMAT(
     . '*************************************************************' 
     . '***********'/
     . '*    ===============================                         ' 
     . '          *'/
     . '      SUBROUTINE BSHBOK( IHFLAG, LOOP )'/
     . '*    ===============================                         ' 
     . '          *'/
     . '* ((Purpose))                                                ' 
     . '          *'/
     . '*      To write the ID-th histogram on the unit LUNIT.       ' 
     . '          *')

      WRITE(ISRC,101)
  101 FORMAT(
     . '* ((Input))                                                  ' 
     . '          *'/
     . '*      LUNIT: Logical unit number                            ' 
     . '          *'/
     . '*      ID   : Historgram ID                                  ' 
     . '          *'/
     . '*                                                            ' 
     . '          *'/
     . '* ((Author))                                                 ' 
     . '          *')

      WRITE(ISRC,102)
  102 FORMAT(
     . '*       S.Kawabata   June ''90 at KEK                        ' 
     . '           *'/
     . '*                                                            ' 
     . '          *'/
     . '*************************************************************' 
     . '***********'/
     . ' '/
     . '      REAL*8         SCALLS,WGT,TI,TSI,TACC'/
     . '      COMMON /BASE3/ SCALLS,WGT,TI,TSI,TACC,IT'/
     . ' ')

      WRITE(ISRC,103)
  103 FORMAT(
     . '      PARAMETER ( NHS = 50, NSC = 50 )'/
     . '      INTEGER*4 XHASH,DHASH,NHIST,MAPL,IFBASE,NSCAT,MAPD'/
     . '      COMMON/PLOTH/ XHASH(NHS+1,13),DHASH(NSC+1,14),IFBASE(NH' 
     . 'S),'/
     . '     .              NHIST, MAPL(4,NHS),'/
     . '     .              NSCAT, MAPD(4,NSC),'/
     . '     .              NW'/
     . '      COMMON /PLOTB/ IBUF( 281*NHS + 2527*NSC )'/
     . '      REAL*4         BUFF( 281*NHS + 2527*NSC )'/
     . '      EQUIVALENCE (IBUF(1),BUFF(1))')

      WRITE(ISRC,104)
  104 FORMAT(
     . ' '/
     . '      CHARACTER*80 TITLE'/
     . ' '/
     . '      COMMON/PLOTLU/ LU'/
     . '      REAL*4 VLSMAX(50),VLSMIN(50)'/
     . '      COMMON /DSDXMM/ VLSMAX,VLSMIN'/
     . ' '/
     . 'C'/
     . '      IF( NHIST .GT. 0 ) THEN'/
     . ' ')

      WRITE(ISRC,105)
  105 FORMAT(
     . '          NTOTAL= SCALLS'/
     . ' '/
     . '          DO 500 IHIST = 1, NHIST'/
     . '             ID    = MAPL(1,IHIST) + IHFLAG*1000 + LOOP*10000'/
     . '             IP1   = MAPL(2,IHIST)'/
     . '             XMIN  = BUFF(IP1)'/
     . '             XMAX  = BUFF(IP1+1)'/
     . '             NXBIN = IBUF(IP1+2)'/
     . '             DEV   = BUFF(IP1+3)'/
     . '             IP2   = MAPL(3,IHIST)')

      WRITE(ISRC,106)
  106 FORMAT(
     . '             IP3   = MAPL(4,IHIST)'/
     . ' '/
     . '*        WRITE(LU,9200) ID,LUNIT,(BUFF(I),I=IP3+1,IP3+15),'/
     . '*    .              NTOTAL,NXBIN,DEV'/
     . '*9200    FORMAT(/1H1,'/
     . '*    .         1X,''** Histogram ID('',I5,'' ) was saved in U' 
     . 'nit('',I2,'') **'/
     . '*    .         /1X,''Title : '',15A4,'/
     . '*    .         /1X,''Entries     ='',I10,'/
     . '*    .         /1X,''No. of bins ='',I10,''  Width ='',G13.4)')

      WRITE(ISRC,107)
  107 FORMAT(
     . ' '/
     . '             WRITE( TITLE, 9500) (BUFF(I), I=IP3+1,IP3+15)'/
     . ' 9500        FORMAT(15A4)'/
     . ' '/
     . '             CALL HBOOK1( ID, TITLE, NXBIN, XMIN, XMAX, 0.0 )'/
     . ' '/
     . '             IPF   = IP2 + 156'/
     . '             IPF2  = IPF + 52'/
     . '             FACT       = 1./(NTOTAL*DEV)'/
     . '             DO 400 I = 1, NXBIN')

      WRITE(ISRC,108)
  108 FORMAT(
     . '                TX     = BUFF(I+IPF)'/
     . '                NX     = IBUF(I+IP2)'/
     . '                VLS    = TX*FACT'/
     . '*               IF( ID .EQ. 5 ) THEN'/
     . '*                   WRITE(LU,9990) I, VLS'/
     . '*9990               FORMAT( I4,E14.7 )'/
     . '*               ENDIF'/
     . '*               IF( NX .GT. 1 ) THEN'/
     . '*                   DEV2   =  NX*BUFF(I+IPF2)-TX*TX'/
     . '*                   IF( DEV2 .LE. 0.0 ) THEN')

      WRITE(ISRC,109)
  109 FORMAT(
     . '*                       VER = 0.0'/
     . '*                   ELSE'/
     . '*                       VER = FACT*SQRT( DEV2/( NX-1 ))'/
     . '*                   ENDIF'/
     . '*               ELSEIF( NX .EQ. 1 ) THEN'/
     . '*                   VER = VLS'/
     . '*               ELSE'/
     . '*                   VER = 0.0'/
     . '*               ENDIF'/
     . '                XX     = XMIN + DEV*(FLOAT(I) - 0.5)')

      WRITE(ISRC,110)
  110 FORMAT(
     . ' '/
     . '	        CALL HFILL( ID, XX, 0.0, VLS )'/
     . '		IF( I .EQ. 1 ) THEN'/
     . '		    VLSMAX(IHIST) = VLS'/
     . '		    VLSMIN(IHIST) = VLS'/
     . '                ELSE'/
     . '		    IF( VLS .GT. VLSMAX(IHIST) ) VLSMAX(IHIST) = VLS'/
     . '		    IF( VLS .LT. VLSMIN(IHIST) ) VLSMIN(IHIST) = VLS'/
     . '                ENDIF'/
     . '  400        CONTINUE')

      WRITE(ISRC,111)
  111 FORMAT(
     . '*            print *,''VLSMAX'',IHIST,VLSMAX(IHIST)'/
     . '*            print *,''VLSMIN'',IHIST,VLSMIN(IHIST)'/
     . ' '/
     . '  500     CONTINUE'/
     . ' '/
     . '      ENDIF'/
     . ' '/
     . '      IF( NSCAT .GT. 0 ) THEN'/
     . '         DO 900 ISCAT = 1, NSCAT'/
     . ' ')

      WRITE(ISRC,112)
  112 FORMAT(
     . '            IP3   = MAPD(4,ISCAT)'/
     . ' '/
     . '            WRITE( TITLE, 9500) (BUFF(I), I=IP3+1,IP3+15)'/
     . ' '/
     . '            ID  = MAPD(1,ISCAT) + 1000*IHFLAG + LOOP*10000'/
     . ' '/
     . '            IP1   = MAPD(2,ISCAT)'/
     . '            XL    = BUFF(IP1)'/
     . '            XU    = BUFF(IP1+1)'/
     . '            NX    = IBUF(IP1+2)')

      WRITE(ISRC,113)
  113 FORMAT(
     . '            DX    = BUFF(IP1+3)'/
     . '            YL    = BUFF(IP1+4)'/
     . '            YU    = BUFF(IP1+5)'/
     . '            NY    = IBUF(IP1+6)'/
     . '            DY    = BUFF(IP1+7)'/
     . ' '/
     . ' '/
     . '            IP2   = MAPD(3,ISCAT)'/
     . '            NTOTAL= IBUF(IP2)'/
     . '            FACT       = 1./(NTOTAL*DX*DY)')

      WRITE(ISRC,114)
  114 FORMAT(
     . ' '/
     . '            vlslmx = 0.0d0'/
     . '            DO 300 L = 0, NY-1'/
     . '               IB     = NX*L + IP2'/
     . '               DO 200 I = 1,NX'/
     . '                  VLS   = BUFF( I + IB )* FACT'/
     . '                  if(vls .gt. vlslmx ) vlslmx = vls'/
     . '                  XX    = XL + DX*(FLOAT(I) - 0.5)'/
     . '                  YY    = YL + DY*(FLOAT(L) - 0.5)'/
     . ' ')

      WRITE(ISRC,115)
  115 FORMAT(
     . ' '/
     . '  200          CONTINUE'/
     . '  300       CONTINUE'/
     . ' '/
     . '            CALL HBOOK2( ID, TITLE, NX, XL, XU, NY, YL, YU, 0' 
     . '.)'/
     . ' '/
     . '            DO 310 L = 0, NY-1'/
     . '               IB     = NX*L + IP2'/
     . '               DO 210 I = 1,NX')

      WRITE(ISRC,116)
  116 FORMAT(
     . '                  VLS   = BUFF( I + IB )* FACT'/
     . '                  XX    = XL + DX*(FLOAT(I) - 0.5)'/
     . '                  YY    = YL + DY*(FLOAT(L) - 0.5)'/
     . ' '/
     . '*                 CALL HFILL( ID, XX, YY, VLS )'/
     . '                  CALL HF2( ID, XX, YY, VLS )'/
     . ' '/
     . '  210          CONTINUE'/
     . '  310       CONTINUE'/
     . ' ')

      WRITE(ISRC,117)
  117 FORMAT(
     . '  900    CONTINUE'/
     . '      ENDIF'/
     . ' '/
     . '      RETURN'/
     . '      END')
      RETURN
      END
