      subroutine grc_gen_3005
      common /parm/ ncall,itmx1,itmx2,icost,ident
      common /rparm/ acc1,acc2
      common /energy/ emin,emax,ebin
      isrc = 98 
      open(isrc,file='kinit.f',status='unknown')

      WRITE(ISRC,100)
  100 FORMAT(
     . '      SUBROUTINE KINIT'/
     . 'C------------------------------------------------------------' 
     . '---------'/
     . 'C   GRACE System Library File'/
     . 'C   KINEM No. : 3005'/
     . 'C   Date      : 1994.08.19'/
     . 'C   Author    : Y.Kurihara'/
     . 'C------------------------------------------------------------' 
     . '---------'/
     . 'C'/
     . '      IMPLICIT REAL*8(A-H,O-Z)'/
     . ' '/
     . '      PARAMETER ( MXDIM = 50 )'/
     . '      COMMON / LOOP0 / LOOP'/
     . '      COMMON / BPARM1 / XL(MXDIM),XU(MXDIM),NDIM,NWILD,'/
     . '     &                 IG(MXDIM),NCALL')

      WRITE(ISRC,101)
  101 FORMAT(
     . '      COMMON / BPARM2 / ACC1,ACC2,ITMX1,ITMX2'/
     . ' '/
     . '      CHARACTER XSTR*14'/
     . ' '/
     . '      INCLUDE ''inclk.f'''/
     . '*------------------------------------------------------------' 
     . '-----------'/
     . '      COMMON/KMCNTL/Idummy,ICOS3'/
     . '      COMMON/KINEM1/S,W,FACT'/
     . '      COMMON/CUT001/COSCUT(2,3),ENGYCT(2,3),AMASCT(2),Adummy(' 
     . '2)'/
     . '*------------------------------------------------------------' 
     . '-----------'/
     . '* 3-body kinematics')

      WRITE(ISRC,102)
  102 FORMAT(
     . '*'/
     . '*  Integration variables'/
     . '*        Energy_p3,COS(the3),Phi3(=0)'/
     . '*        Energy_p4,COS(the4)'/
     . '*'/
     . '*'/
     . '*'/
     . '*           p1 ------------------- p3'/
     . '*                      |'/
     . '*                      |'/
     . '*                      *'/
     . '*                     ***--------- p5'/
     . '*                      *'/
     . '*                      |'/
     . '*                      |'/
     . '*           p2 ------------------- p4')

      WRITE(ISRC,103) emin
  103 FORMAT(
     . '*'/
     . '*'/
     . '*--- 1. Initialize constants for kinematics.'/
     . '* S = (P1+P2)**2'/
     . '* W = SQRT(S)'/
     . '      W =',f9.3,'D0'/
     . '      S = W*W'/
     . '      totmas=amass1(3)+amass1(4)+amass1(5)'/
     . '      if(totmas.gt.w) then'/
     . '	write(6,*)'/
     . '      '' CM energy is less than the sum of final particle mas' 
     . 'ses.'''/
     . '	stop'/
     . '      end if'/
     . '*******************************'/
     . '* Angular cuts in Lab-frame.  *')

      WRITE(ISRC,104)
  104 FORMAT(
     . '*******************************'/
     . '* particle 3'/
     . '* minimum cos  cut'/
     . '      COSCUT(1,1)= -1'/
     . '* maximum cos  cut'/
     . '      COSCUT(2,1)=  1'/
     . '* particle 4'/
     . '* minimum cos  cut'/
     . '      COSCUT(1,2)= -1'/
     . '* maximum cos  cut'/
     . '      COSCUT(2,2)=  1'/
     . '* particle 5'/
     . '* minimum cos  cut'/
     . '      COSCUT(1,3)= -1'/
     . '* maximum cos  cut'/
     . '      COSCUT(2,3)=  1')

      WRITE(ISRC,105)
  105 FORMAT(
     . ' '/
     . '*******************************'/
     . '* Energy  cuts in Lab-frame.  *'/
     . '*******************************'/
     . '* particle 3'/
     . '* minimum energy cut'/
     . '      ENGYCT(1,1) = AMASS1(3)'/
     . '* maximum energy cut'/
     . '      ENGYCT(2,1) = W'/
     . '* particle 4'/
     . '* minimum energy cut'/
     . '      ENGYCT(1,2) = AMASS1(4)'/
     . '* maximum energy cut'/
     . '      ENGYCT(2,2) = W'/
     . '* particle 5'/
     . '* minimum energy cut')

      WRITE(ISRC,106)
  106 FORMAT(
     . '      ENGYCT(1,3) = AMASS1(5)'/
     . '* maximum energy cut'/
     . '      ENGYCT(2,3) = W'/
     . ' '/
     . '***********************************************'/
     . '* mass singularity treatment for particle 3   *'/
     . '***********************************************'/
     . '* no-singularity           : ICOS3=0'/
     . '* mass-singularity         : ICOS3=1'/
     . '*'/
     . '*'/
     . '* Particle 3 can have arbitrary mass even for ICOS3=1.'/
     . '*'/
     . '      ICOS3=1'/
     . ' '/
     . '      WRITE(6,*)''*''')

      WRITE(ISRC,107)
  107 FORMAT(
     . '      WRITE(6,*)''* Kinematics initialization '''/
     . '      WRITE(6,*)''* particle mass '',amass1'/
     . '      WRITE(6,*)''* CM Energy '',W'/
     . '      WRITE(6,*)''* COSCUT    '''/
     . '      WRITE(6,''(2F10.3)'')COSCUT'/
     . '      WRITE(6,*)''* ENGYCT    '''/
     . '      WRITE(6,''(2F10.3)'')ENGYCT'/
     . '      WRITE(6,*)''* AMASCT    '''/
     . '      WRITE(6,''(2F10.3)'')AMASCT'/
     . '      WRITE(6,*)''* Singularity treatment '''/
     . '      IF(ICOS3.EQ.0) THEN'/
     . '         WRITE(6,*)''* NO mass-singularity '''/
     . '      ELSE'/
     . '         WRITE(6,*)''*    mass-singularity '''/
     . '      END IF'/
     . '      WRITE(6,*)''*''')

      WRITE(ISRC,108)
  108 FORMAT(
     . ' '/
     . '* Following flux factor is for a particle-antiparticle collis' 
     . 'ion'/
     . '* at s/m**2 >> 1. For an e-gamma collision or low energy inte' 
     . 'ractions'/
     . '* you should use appropriate formulae.'/
     . '      VREL = 2'/
     . '      FLUX = VREL*S'/
     . '      FACT = GEVPB/FLUX'/
     . ' '/
     . '*----- BASES RELATED INITIALIZATIONS ------------------------' 
     . '-----------'/
     . '*--- 2. Dimension of integration variables.'/
     . ' '/
     . '          NDIM =   5'/
     . '          NWILD=   4')

      WRITE(ISRC,109) itmx1,itmx2
  109 FORMAT(
     . ' '/
     . 'C------------------------------------------------------------' 
     . '-----------'/
     . '*--- 3. Region of integration.'/
     . ' '/
     . '        DO 1 I=1,NDIM'/
     . '         XL(I)  =   0.D0'/
     . '         XU(I)  =   1.D0'/
     . '         IG(I)  =   1'/
     . '1       CONTINUE'/
     . 'C------------------------------------------------------------' 
     . '-----------'/
     . '*--- 4. Number of iterations'/
     . '      ITMX1  =  ',i3/
     . '      ITMX2  =  ',i3/
     . ' ')

      WRITE(ISRC,110) ncall,acc1,acc2
  110 FORMAT(
     . '      NCALL  = ',i10/
     . ' '/
     . '      ACC1   = ',f9.6/
     . '      ACC2   = ',f9.6/
     . '*--- 5. Set MXREG : the maximum number of values which are re' 
     . 'turned'/
     . '*       by FUNC for one phase space point'/
     . ' '/
     . '      MXREG =   1'/
     . ' '/
     . '*--- 6. Set histograms'/
     . '      NX = 50'/
     . '      ND = 50'/
     . ' '/
     . '      DO 100 I = 1, NDIM'/
     . '         WRITE(XSTR, 110) I'/
     . '  110    FORMAT(''X('',I2,'') SPECTRUM'')'/
     . '         CALL XHINIT(I, XL(I), XU(I), NX, XSTR)')

      WRITE(ISRC,111)
  111 FORMAT(
     . '  100 CONTINUE'/
     . '         CALL XHINIT(ndim+1, 0.d0, w, NX, ''Energy of Particl' 
     . 'e 3'')'/
     . '         CALL XHINIT(ndim+2, 0.d0, w, NX, ''Energy of Particl' 
     . 'e 4'')'/
     . '         CALL XHINIT(ndim+3, 0.d0, w, NX, ''Energy of Particl' 
     . 'e 5'')'/
     . '         CALL XHINIT(ndim+4,-1.d0,1.d0, NX, ''cos_the of Part' 
     . 'icle 3'')'/
     . '         CALL XHINIT(ndim+5,-1.d0,1.d0, NX, ''cos_the of Part' 
     . 'icle 4'')'/
     . '         CALL XHINIT(ndim+6,-1.d0,1.d0, NX, ''cos_the of Part' 
     . 'icle 5'')'/
     . ' '/
     . '      RETURN'/
     . '      END')

      close(isrc)
      return
      end
