      subroutine grc_gen_4005
      common /parm/ ncall,itmx1,itmx2,icost,ident
      common /rparm/ acc1,acc2
      common /energy/ emin,emax,ebin
      isrc = 98 
      open(isrc,file='kinit.f',status='unknown')

      WRITE(ISRC,100)
  100 FORMAT(
     . '      SUBROUTINE KINIT'/
     . ' '/
     . 'C------------------------------------------------------------' 
     . '---------'/
     . 'C   GRACE System Library File'/
     . 'C   KINEM No. : 4005'/
     . 'C   Date      : 1995.01.25'/
     . 'C   Author    : Y.Kurihara'/
     . 'C------------------------------------------------------------' 
     . '---------'/
     . '      IMPLICIT REAL*8(A-H,O-Z)'/
     . ' '/
     . '      PARAMETER ( MXDIM = 50 )'/
     . '      COMMON / LOOP0 / LOOP'/
     . '      COMMON / BPARM1 / XL(MXDIM),XU(MXDIM),NDIM,NWILD,'/
     . '     &                 IG(MXDIM),NCALL')

      WRITE(ISRC,101)
  101 FORMAT(
     . '      COMMON / BPARM2 / ACC1,ACC2,ITMX1,ITMX2'/
     . ' '/
     . '      CHARACTER XSTR*14'/
     . ' '/
     . '      INCLUDE ''inclk.f'''/
     . '*------------------------------------------------------------' 
     . '-----------'/
     . '      COMMON/KMCNTL/IRESNS(2),icos3,ICOSQ3,icos5'/
     . '      COMMON/KINEM1/S,W,FACT'/
     . '      COMMON/CUT001/COSCUT(2,4),ENGYCT(2,4),AMASCT(2,2),ARESN' 
     . 'S(2,2)'/
     . '*------------------------------------------------------------' 
     . '-----------'/
     . '* 4-body kinematics :')

      WRITE(ISRC,102)
  102 FORMAT(
     . '*'/
     . '*  Integration variables'/
     . '*        q1**2, q2**2'/
     . '*        cos(the_q1), phi_q1(=0)in p1-p2 CM frame'/
     . '*        cos(the_p3), phi_p3   in p3-p4 CM frame'/
     . '*        cos(the_p5), phi_p5             in p5-p6 CM frame'/
     . '*'/
     . '*'/
     . '*'/
     . '*       P1 \              *------- P3'/
     . '*           \            / \'/
     . '*            \          /   \----  P4'/
     . '*             \  ****  /'/
     . '*              >******<'/
     . '*             /  ****  \'/
     . '*            /          \   /-----P5')

      WRITE(ISRC,103) emin
  103 FORMAT(
     . '*           /            \ /'/
     . '*       P2 /              *------- P6'/
     . '*'/
     . '*--- 1. Initialize constants for kinematics.'/
     . '* S = (P1+P2)**2'/
     . '* W = SQRT(S)'/
     . '      W = ',f9.3,'d0'/
     . '      S = W*W'/
     . '      totmas=amass1(3)+amass1(4)+amass1(5)+amass1(6)'/
     . '      if(totmas.gt.w) then'/
     . '	write(6,*)'/
     . '     .'' CM energy is less than the sum of final particle mas' 
     . 'ses.'''/
     . '	stop'/
     . '      end if'/
     . '*******************************')

      WRITE(ISRC,104)
  104 FORMAT(
     . '* Angular cuts in Lab-frame.  *'/
     . '*******************************'/
     . '      angcut=0'/
     . '* particle 3'/
     . '* minimum cos  cut'/
     . '      COSCUT(1,1)= -cos(angcut*rad)'/
     . '* maximum cos  cut'/
     . '      COSCUT(2,1)=  cos(angcut*rad)'/
     . '* particle 4'/
     . '* minimum cos  cut'/
     . '      COSCUT(1,2)= -cos(angcut*rad)'/
     . '* maximum cos  cut'/
     . '      COSCUT(2,2)=  cos(angcut*rad)'/
     . '      angcut=0'/
     . '* particle 5'/
     . '* minimum cos  cut')

      WRITE(ISRC,105)
  105 FORMAT(
     . '      COSCUT(1,3)= -cos(angcut*rad)'/
     . '* maximum cos  cut'/
     . '      COSCUT(2,3)=  cos(angcut*rad)'/
     . '* particle 6'/
     . '* minimum cos  cut'/
     . '      COSCUT(1,4)= -cos(angcut*rad)'/
     . '* maximum cos  cut'/
     . '      COSCUT(2,4)=  cos(angcut*rad)'/
     . ' '/
     . '*******************************'/
     . '* Energy  cuts in Lab-frame.  *'/
     . '*******************************'/
     . '* particle 3'/
     . '* minimum energy cut'/
     . '      ENGYCT(1,1) = AMASS1(3)'/
     . '* maximum energy cut')

      WRITE(ISRC,106)
  106 FORMAT(
     . '      ENGYCT(2,1) = W'/
     . '* particle 4'/
     . '* minimum energy cut'/
     . '      ENGYCT(1,2) = AMASS1(4)'/
     . '* maximum energy cut'/
     . '      ENGYCT(2,2) = W'/
     . '* particle 5'/
     . '* minimum energy cut'/
     . '      ENGYCT(1,3) = AMASS1(5)'/
     . 'c     ENGYCT(1,3) = 1.d0'/
     . '* maximum energy cut'/
     . '      ENGYCT(2,3) = W'/
     . '* particle 6'/
     . '* minimum energy cut'/
     . '      ENGYCT(1,4) = AMASS1(6)'/
     . 'c     ENGYCT(1,4) = 1.d0')

      WRITE(ISRC,107)
  107 FORMAT(
     . '* maximum energy cut'/
     . '      ENGYCT(2,4) = W'/
     . ' '/
     . '*************************'/
     . '* Cut on invariant mass *'/
     . '*************************'/
     . '* Paartile 3-4'/
     . '* minimum'/
     . '      AMASCT(1,1)=   AMASS1(3)+AMASS1(4)'/
     . '* maximum'/
     . '      AMASCT(2,1)= W-AMASS1(5)-AMASS1(6)'/
     . '* Paartile 5-6'/
     . '* minimum'/
     . '      AMASCT(1,2)=   AMASS1(5)+AMASS1(6)'/
     . '* maximum'/
     . '      AMASCT(2,2)= W-AMASS1(3)-AMASS1(4)')

      WRITE(ISRC,108)
  108 FORMAT(
     . ' '/
     . '*******************************'/
     . '* Q2 singularity treatment    *'/
     . '*******************************'/
     . '* no-singularity           : IRESNS= 0'/
     . '* narrow resonance         : IRESNS= 1'/
     . '* 1/Q2 singularity         : IRESNS=-1'/
     . '* resonance+flat           : IRESNS= 2'/
     . '* resonance+1/Q2           : IRESNS= 3'/
     . '* Particle 3-4'/
     . '      IRESNS(1)  = 2'/
     . '      IF(IRESNS(1).GE.1) THEN'/
     . 'C If you want treat narrow resonance, you should set resonanc' 
     . 'e mass'/
     . 'C and width.'/
     . '        ARESNS(1,1)=AMWB')

      WRITE(ISRC,109)
  109 FORMAT(
     . '        ARESNS(2,1)=AGWB'/
     . '      END IF'/
     . '* Particle 5-6'/
     . '      IRESNS(2)  = 3'/
     . '      IF(IRESNS(2).GE.1) THEN'/
     . 'C If you want treat narrow resonance, you should set resonanc' 
     . 'e mass'/
     . 'C and width.'/
     . '        ARESNS(1,2)=AMWB'/
     . '        ARESNS(2,2)=AGWB'/
     . '      END IF'/
     . '* treatment for P3'/
     . '*  D=-(p3-p1)**2'/
     . '*'/
     . '*  ICOS3= 0   : no singularity'/
     . '*       = 1   : 1/D from p1')

      WRITE(ISRC,110)
  110 FORMAT(
     . '*'/
     . '      icos3=1'/
     . '* For the digrma as shown below,'/
     . '*'/
     . '*       P1 ----------------------- P3'/
     . '*               |'/
     . '*               |----------------  P5 or P6'/
     . '*               |'/
     . '*               |  t,u'/
     . '*               |----------------  P6 or P5'/
     . '*               |'/
     . '*       P2 ----------------------  P4'/
     . '* treatment for P5,P6'/
     . '*  T=-(P1-P3-P5)**2'/
     . '*  U=-(P1-P3-P6)**2'/
     . '*')

      WRITE(ISRC,111)
  111 FORMAT(
     . '*  ICOS5= 0   : no singularity'/
     . '*       = 1   : 1/T     from P1-P3'/
     . '*       = 2   : 1/T+1/U from P1-P3'/
     . '*'/
     . '      icos5=2'/
     . '* For the digrma as shown below,'/
     . '*'/
     . '*       P1 ----------------------- P3'/
     . '*               |         \'/
     . '*               |           \----  P4'/
     . '*               |'/
     . '*               |  t = -T'/
     . '*               |'/
     . '*               |           /-----P5'/
     . '*               |          /'/
     . '*       P2 ---------------------- P6')

      WRITE(ISRC,112)
  112 FORMAT(
     . '*'/
     . '*  T is used as integration variables instead of cos(the_q1).'/
     . '*'/
     . '*                 integration       singularity'/
     . '*   ICOSQ3 = 0   : cos(the_q)          non'/
     . '*          = 1   : T                   1/T'/
     . '*          = 2   : T,U                 1/T+1/D'/
     . '      ICOSQ3 = 1'/
     . ' '/
     . '      WRITE(6,*)''*'''/
     . '      WRITE(6,*)''* Kinematics initialization '''/
     . '      WRITE(6,*)''* particle mass '',amass1'/
     . '      WRITE(6,*)''* CM Energy '',W'/
     . '      WRITE(6,*)''* COSCUT    '''/
     . '      WRITE(6,''(2F10.3)'')COSCUT'/
     . '      WRITE(6,*)''* ENGYCT    ''')

      WRITE(ISRC,113)
  113 FORMAT(
     . '      WRITE(6,''(2F10.3)'')ENGYCT'/
     . '      WRITE(6,*)''* AMASCT    '''/
     . '      WRITE(6,''(2F10.3)'')AMASCT'/
     . '      WRITE(6,*)''* Singularity treatment '''/
     . '      WRITE(6,*)''*   Q2 (p3-p4)'''/
     . '      IF     (IRESNS(1).EQ.-1) THEN'/
     . '         WRITE(6,*)''* 1/Q2 singularity '''/
     . '      ELSE IF(IRESNS(1).EQ. 0) THEN'/
     . '         WRITE(6,*)''* NO   singularity '''/
     . '      ELSE IF(IRESNS(1).EQ. 1) THEN'/
     . '         WRITE(6,*)''* Narrow resonance '''/
     . '         WRITE(6,*)''*  resonance mass and width'''/
     . '         WRITE(6,*) ARESNS(1,1),ARESNS(2,1)'/
     . '      END IF'/
     . '      WRITE(6,*)''*   Q2 (p5-p6)'''/
     . '      IF     (IRESNS(2).EQ.-1) THEN')

      WRITE(ISRC,114)
  114 FORMAT(
     . '         WRITE(6,*)''* 1/Q2 singularity '''/
     . '      ELSE IF(IRESNS(2).EQ. 0) THEN'/
     . '         WRITE(6,*)''* NO   singularity '''/
     . '      ELSE IF(IRESNS(2).EQ. 1) THEN'/
     . '         WRITE(6,*)''* Narrow resonance '''/
     . '         WRITE(6,*)''*  resonance mass and width'''/
     . '         WRITE(6,*) ARESNS(1,2),ARESNS(2,2)'/
     . '      END IF'/
     . '      IF     (Icosq3.EQ.0) THEN'/
     . '         WRITE(6,*)''* cos(the_q) ; flat '''/
     . '      ELSE IF(Icosq3.EQ.1) THEN'/
     . '         WRITE(6,*)''* T ; 1/T '''/
     . '      ELSE IF(Icosq3.EQ.2) THEN'/
     . '         WRITE(6,*)''* T,D ; 1/T+1/D '''/
     . '      END IF'/
     . '      IF     (Icos3.EQ.0) THEN')

      WRITE(ISRC,115)
  115 FORMAT(
     . '         WRITE(6,*)''* cos(p3) ; flat '''/
     . '      ELSE IF(Icos3.EQ.1) THEN'/
     . '         WRITE(6,*)''* D ; 1/D '''/
     . '      END IF'/
     . '      WRITE(6,*)''*'''/
     . ' '/
     . '* Following flux factor is for a particle-antiparticle collis' 
     . 'ion'/
     . '* at s/m**2 >> 1. For an e-gamma collision or low energy inte' 
     . 'ractions'/
     . '* you should use appropriate formulae.'/
     . '      VREL = 2'/
     . '      FLUX = VREL*S'/
     . '      FACT = GEVPB/FLUX'/
     . ' '/
     . '*----- BASES RELATED INITIALIZATIONS ------------------------' 
     . '-----------')

      WRITE(ISRC,116)
  116 FORMAT(
     . '*--- 2. Dimension of integration variables.'/
     . ' '/
     . '          NDIM =   7'/
     . '          NWILD=   7'/
     . ' '/
     . 'C------------------------------------------------------------' 
     . '-----------'/
     . '*--- 3. Region of integration.'/
     . ' '/
     . '        DO 1 I=1,NDIM'/
     . '         XL(I)  =   0.D0'/
     . '         XU(I)  =   1.D0'/
     . '         IG(I)  =   1'/
     . '1       CONTINUE'/
     . ' '/
     . 'C------------------------------------------------------------' 
     . '-----------')

      WRITE(ISRC,117) itmx1,itmx2,ncall,acc1,acc2
  117 FORMAT(
     . '*--- 4. Number of iterations'/
     . '      ITMX1  =  ',i3/
     . '      ITMX2  =  ',i3/
     . ' '/
     . '      NCALL  = ',i10/
     . ' '/
     . '      ACC1   = ',f9.6/
     . '      ACC2   = ',f9.6/
     . '*--- 5. Set MXREG : the maximum number of values which are re' 
     . 'turned'/
     . '*       by FUNC for one phase space point'/
     . ' '/
     . '      MXREG =   1'/
     . ' '/
     . '*--- 6. Set histograms'/
     . '      NX = 50'/
     . ' '/
     . '      DO 100 I = 1, NDIM')

      WRITE(ISRC,118)
  118 FORMAT(
     . '         WRITE(XSTR, 110) I'/
     . '  110    FORMAT(''X('',I2,'') SPECTRUM'')'/
     . '         CALL XHINIT(I, XL(I), XU(I), NX, XSTR)'/
     . '  100 CONTINUE'/
     . '         CALL XHINIT(ndim+1, 0.d0, w, NX, ''Energy of Particl' 
     . 'e 3'')'/
     . '         CALL XHINIT(ndim+2, 0.d0, w, NX, ''Energy of Particl' 
     . 'e 4'')'/
     . '         CALL XHINIT(ndim+3, 0.d0, w, NX, ''Energy of Particl' 
     . 'e 5'')'/
     . '         CALL XHINIT(ndim+4, 0.d0, w, NX, ''Energy of Particl' 
     . 'e 6'')'/
     . '         CALL XHINIT(ndim+5,-1.d0,1.d0, NX, ''cos_the of Part' 
     . 'icle 3'')'/
     . '         CALL XHINIT(ndim+6,-1.d0,1.d0, NX, ''cos_the of Part' 
     . 'icle 4'')')

      WRITE(ISRC,119)
  119 FORMAT(
     . '         CALL XHINIT(ndim+7,-1.d0,1.d0, NX, ''cos_the of Part' 
     . 'icle 5'')'/
     . '         CALL XHINIT(ndim+8,-1.d0,1.d0, NX, ''cos_the of Part' 
     . 'icle 6'')'/
     . '         CALL XHINIT(ndim+9, 0.d0, w, NX, ''Mass 3-4 '')'/
     . '         CALL XHINIT(ndim+10, 0.d0, w, NX, ''Mass 5-6 '')'/
     . '      RETURN'/
     . '      END')
      close(isrc)
      return
      end
