/********************************************************************
 *  File : cmfort.c *
 *  Fortran source code generation (main, kinem, etc).
 *                           by Kaneko Toshiaki   95/07/13 (LAPP)
 *                                     Rev.  TI   95/07/17 (LAPP)
 */

#include <stdlib.h>
#include <stdio.h>
#include "common.h"
#include "config.h"
#include "dbgh.h"
#include "ptable.h"
#include "grdata.h"
#include "gensc.h"
#include "cfbase.h"
#include "version.h"

/*------------------------------------------------------------------*/
/* Entry points */
Public  Void    cmbases    ARG((NoArg));
Public  Void    cminclk    ARG((NoArg));
Public  Void    cmmakes    ARG((NoArg));

/*------------------------------------------------------------------*/
/* External references */
/* rdptbl.c */
Extern  string  pvename    ARG((int,pindex));
Extern  int     pvvnfind        ARG((int));
/* path.c */
Extern  string  pnfname    ARG((string,string,string,string));
/* cmfin.c */
Extern  Void    cmamparm   ARG((NoArg));
/*------------------------------------------------------------------*/
/* Private functions */
Private Void    cmusrout   ARG((NoArg));
Private Void    cmmainbs   ARG((NoArg));
Private Void    cmmainsp   ARG((NoArg));
Private Void    cmmaintc   ARG((NoArg));
Private Void    cmmaincs   ARG((NoArg));
Private Void    cmtest     ARG((NoArg));
Private Void    cmprms     ARG((NoArg));
Private Void    cmdmmy     ARG((NoArg));
Private Void    cmuserin   ARG((NoArg));
Private Void    cmfunc     ARG((NoArg));
Private Void    cmvbfnct   ARG((NoArg));
Private Void    cminclvs   ARG((NoArg));
Private Void    cminclvb   ARG((NoArg));
Private Void    cmusrprm1  ARG((NoArg));
Private Void    cmusrprm2  ARG((NoArg));
Private Void    cmsetmas   ARG((NoArg));
Private Void    cmmodmas   ARG((NoArg));
Private Void    cmmodmasc  ARG((NoArg));
Private Void    cmuscom    ARG((NoArg));
Private Void    cmeps      ARG((NoArg));
Private int     cmndf      ARG((int));
Private Void    cmkinem    ARG((NoArg));
Private Void    cmfkinemv  ARG((NoArg));
Private Void    cmfkfillv   ARG((NoArg));
Private bool    cmcpkin    ARG((string,string));
Private Void    cmfkfill   ARG((NoArg));
Private Void    cmfkinem   ARG((NoArg));
Private Void    cmfkinit   ARG((NoArg));
Private Void    cmdnn      ARG((NoArg));
Private int     cmnumhgs   ARG((NoArg));
Private Void    cmsp2lnd   ARG((NoArg));
Private Void    cmspdetc   ARG((NoArg));

/*------------------------------------------------------------------*/
/* Local variable */

#define TCUT    (100)

/*==================================================================*/
Public  Void    cmbases(NoArg)
/*------------------------------------------------------------------*
 */
{
    cmusrprm1();
/*  cmamparm treats 'incl1.f' 'usrprm.f' and 'amparm.f'             */
    cmamparm();
    cmusrprm2();

    if( !vcode )
        cmfunc();
    else {
        cmvbfnct();
        cminclvs();
/*        cminclvb();*/
    }

    cmmainbs();
    cmmainsp();
/*  if colorv ==1 && cbase->nbase >0 && jetset_flag on */
    if( colorv == 1 && cbase->nbase > 1 ) cmspdetc();
    if( jetset ) cmsp2lnd();
    if( CATALOG == 1 ) cmmaintc();
    if( CATALOG == 1 ) cmmaincs();
    cmprms();
    cmsetmas();
    cmmodmas();
    if( CATALOG == 1 ) cmmodmasc();
    cmtest();
    cmuserin();
    cmusrout();
    cmkinem();
    if(lang != ROFORT)
        cmeps();
/* 95.5.22 TI */
    if(lang == ROREDA)
        cmdnn();
/*
    cmdmmy();
 */
}
 
/*==================================================================*/
Private Void    cmusrout(NoArg)
/*------------------------------------------------------------------*
 * 
 *------------------------------------------------------------------*/
{
    cmopen(ROFORT, "usrout.f");

    cmsepar('*');
    fprintf(redfp,"      subroutine usrout\n");
    fprintf(redfp,"      implicit real* 8(a-h,o-z)\n");
    fprintf(redfp,"\n");
    if( vcode )
        fprintf(redfp,"      include 'inclvs.f'\n");
    if(lang == ROFORT || lang == ROREDA )
        fprintf(redfp,"      include 'incl1.f'\n");
    else
        fprintf(redfp,"      include 'incomm.f'\n");
    fprintf(redfp,"      include 'inclk.f'\n");
    cmsepar('-');
/* CF */
/*    if( colorv == 0 ) {*/
    if(lang == ROFORT || lang == ROREDA ) {
        if( vcode )
            fprintf(redfp,"      do 200 j=1,1\n");
        fprintf(redfp,"      write(*,620)\n");
        fprintf(redfp,"  620 format('1'/' integrated value of square of ");
        fprintf(redfp,"each graph',/\n");
        fprintf(redfp,"     & ' graph  ',8x,'absolute',10x,'relative')");
        fprintf(redfp,"\n");
        fprintf(redfp,"\n");
    
        fprintf(redfp,"      rn = 1.0d0/(fkcall + nkcall)\n");
        fprintf(redfp,"      do 100 ig = 1, jgraph\n");
        fprintf(redfp,"        write(*,600) igraph(ig), ");
        if( !vcode )
            fprintf(redfp," ansp(ig)*rn, ansp(ig)/ansp(0)\n");
        else
            fprintf(redfp," ansp(j,ig)*rn, ansp(j,ig)/ansp(j,0)\n");
        fprintf(redfp,"  100 continue\n");
        if( !vcode )
            fprintf(redfp,"      write(*,610) ansp(0)*rn\n");
        else
            fprintf(redfp,"      write(*,610) ansp(j,0)*rn\n");
        if( vcode )
        fprintf(redfp,"  200 continue\n");
    
        fprintf(redfp,"  600 format(1x,i5,' :', e18.8, e18.8)\n");
        fprintf(redfp,"  610 format(' total :', e18.8)\n");
        fprintf(redfp,"\n");
    }
/*    }*/

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmmainbs(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    pindex pa;
    int    n;

    if( !vcode )
        cmopen(ROFORT, "mainbs.f");
    else
        cmopen(ROFORT, "mainvb.f");

    cmsepar('*');
    if( !vcode )
        fprintf(redfp,"* main program for BASES 5.1\n");
    else
        fprintf(redfp,"* main program for vector BASES 5.1\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if(lang != ROFORT && lang != ROREDA )
        fprintf(redfp,"      include 'incomm.f'\n");
    fprintf(redfp,"      common / knmflg / ");
    fprintf(redfp,"knmgvs, knmhst, knmsph, knmisr\n");
    fprintf(redfp,"      external func\n");
    putc(EOL, redfp);
    if( CERNLIB == 1 && !vcode ) {
        fprintf(redfp,"      parameter ( mhsize = 100000 )\n");
        fprintf(redfp,"      common /pawc/ memory(mhsize)\n");
    }

    if( vcode ) {
       fprintf(redfp,"*    Control for number of nodes\n");
       fprintf(redfp,"      common/ninfo/ nodeid, numnod, ipflag\n");
    }
    fprintf(redfp,"      write(*,'(20x,a/)') 'grace %d.%2d (%02d)'\n",
            GRCVER0,GRCVER1,GRCVER2);
    fprintf(redfp,"      write(*,'(10x,a/)')\n");
    fprintf(redfp,"     .'(c)Copyright 1990-1996 Minami-Tateya ");
    fprintf(redfp,"Group (Japan)     '\n");
    cmsepar('*');

    if( vcode ) {
        fprintf(redfp,"      nodeid = 0\n");
        fprintf(redfp,"      numnod = 1\n");
    }

 
    fprintf(redfp,"      write(*,'(5x,a/)')\n");
    fprintf(redfp,"     .'Process: ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp, " --> ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n");
    cmsepar('*');
    fprintf(redfp,"*               initialization Kinematics Flags\n");
    fprintf(redfp,"*     knmgvs  : (=1)sqrt(S) is given in kinit.f\n");
    fprintf(redfp,"*     knmhst  : (=1)Fill historgram \n");
    fprintf(redfp,"*     knmsph  : reserved for soft photon check \n");
    fprintf(redfp,"*     knmisr  : reserved for initial state ");
    fprintf(redfp,"radiation\n");
    fprintf(redfp,"      knmgvs = 1\n");
    fprintf(redfp,"      knmhst = 1\n");
    fprintf(redfp,"      knmsph = 0\n");
    fprintf(redfp,"      knmisr = 0\n");

    if( CERNLIB == 1 && !vcode ) {
        cmsepar('*');
        fprintf(redfp,"*               initialization of HBOOK\n");
        fprintf(redfp,"      call hlimit( mhsize )\n");
        fprintf(redfp,"      call htitle('Histograms generated by ");
        fprintf(redfp,"BASES')\n");
    }
    cmsepar('*');
    fprintf(redfp,"*               initialization of BASES/SPRING");
    fprintf(redfp," 5.1\n");
    cmsepar('*');

    cmsepar('=');
    fprintf(redfp,"*          initialization of bases by calling ");
    fprintf(redfp,"bsinit\n");
    cmsepar('=');
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           call bsinit\n");
    fprintf(redfp,"*         -------------\n");

    cmsepar('=');
    fprintf(redfp,"*      initialization of parameters\n");
    fprintf(redfp,"*          for kinematics and matrix elements\n");
    fprintf(redfp,"*      initialization of histograms\n");
    cmsepar('=');
    fprintf(redfp,"      lu     = 11\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      open(lu,file='bases.result',status='");
    fprintf(redfp,"unknown',form='formatted')\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*         ------------------\n");
    fprintf(redfp,"           call userin( lu )\n");
    fprintf(redfp,"*         ------------------\n");

    cmsepar('*');
    fprintf(redfp,"*              numerical integration by ");
    fprintf(redfp,"BASES 5.1\n");
    cmsepar('*');
    fprintf(redfp,"\n");
    if( !vcode )
        fprintf(redfp,"      call bases( func, estim, sigma, ctime, ");
    else
        fprintf(redfp,"      call vbases( func, estim, sigma, ctime, ");
    fprintf(redfp,"it1, it2 )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      call bsinfo( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      call bhplot( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      close( lu )\n");
    fprintf(redfp,"\n");

    cmsepar('*');
    fprintf(redfp,"*             event generation by SPRING 5.1\n");
    cmsepar('*');
    cmsepar('=');
    fprintf(redfp,"*     save the probability information to the ");
    fprintf(redfp,"file\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    fprintf(redfp,"      lun = 23\n");
    fprintf(redfp,"      open(lun,file='bases.data',status='");
    fprintf(redfp,"unknown',form='unformatted')\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      call bswrit( lun )\n");
    fprintf(redfp,"      close ( lun )\n");
    fprintf(redfp,"\n");

    if( CERNLIB == 1 && !vcode ) {
        cmsepar('=');
        fprintf(redfp,"*     save the contents of Histograms ");
        fprintf(redfp,"into Paw buffer\n");
        cmsepar('=');
        fprintf(redfp,"      call bshbok( 0 )\n");
        fprintf(redfp,"      call hrput( 0, 'bases.hbook','N')\n");
    }

    fprintf(redfp,"      stop\n");
    fprintf(redfp,"      end\n");
}


/*==================================================================*/
Private Void    cmmainsp(NoArg)
/*------------------------------------------------------------------*
 */
{
    pindex pa;
    int    n, i, j;
    if( !vcode )
        cmopen(ROFORT, "mainsp.f");
    else
        cmopen(ROFORT, "mainvs.f");

    cmsepar('*');
    fprintf(redfp,"* main program for SPRING 5.1\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if( vcode )
        fprintf(redfp,"      include 'inclvs.f'\n");

    if(lang != ROFORT && lang != ROREDA )
        fprintf(redfp,"      include 'incomm.f'\n");

    fprintf(redfp,"      include 'inclk.f'\n");
    fprintf(redfp,"      common / knmflg / ");
    fprintf(redfp,"knmgvs, knmhst, knmsph, knmisr\n");
    fprintf(redfp,"      external func\n");
    fprintf(redfp,"      parameter (nextn  =%d)\n", nextern);
    if( !vcode )
        fprintf(redfp, "      common /sp4vec/ vec(4,nextn)\n");
    else
        fprintf(redfp, "      common /sp4vec/ vec(nsize,4,nextn)\n");
    putc(EOL, redfp);

    if( vcode )
        fprintf(redfp,"      common / sprng3 / ic(nsize), l(nsize)\n");

    if( CERNLIB == 1 && !vcode) {
        fprintf(redfp,"      parameter ( mhsize = 100000 )\n");
        fprintf(redfp,"      common /pawc/ memory(mhsize)\n");
    }

    fprintf(redfp,"      write(*,'(20x,a/)') 'grace   ver.   2. 0'");
    fprintf(redfp,"\n");
    fprintf(redfp,"      write(*,'(10x,a/)')\n");
    fprintf(redfp,"     .'(c)copyright 1990-1996 Minami-Tateya ");
    fprintf(redfp,"Group (Japan)     '\n");

    fprintf(redfp,"      write(*,'(5x,a/)')\n");
    fprintf(redfp,"     .'Process: ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp, " --> ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n");

    cmsepar('*');
    fprintf(redfp,"*               initialization Kinematics Flags\n");
    fprintf(redfp,"*     knmgvs  : (=1)sqrt(S) is given in kinit.f\n");
    fprintf(redfp,"*     knmhst  : (=1)Fill historgram for BASES\n");
    fprintf(redfp,"*     knmsph  : reserved for soft photon check \n");
    fprintf(redfp,"*     knmisr  : reserved for initial state ");
    fprintf(redfp,"radiation\n");
    fprintf(redfp,"      knmgvs = 1\n");
    fprintf(redfp,"      knmhst = 0\n");
    fprintf(redfp,"      knmsph = 0\n");
    fprintf(redfp,"      knmisr = 0\n");
    cmsepar('*');
    if( CERNLIB == 1 && !vcode ) {
        cmsepar('*');
        fprintf(redfp,"*               initialization of HBOOK\n");
        fprintf(redfp,"      call hlimit( mhsize )\n");
    }
    fprintf(redfp,"*               initialization of BASES/SPRING");
    fprintf(redfp," 5.1\n");
    cmsepar('*');

    cmsepar('=');
    fprintf(redfp,"*          initialization of bases by calling ");
    fprintf(redfp,"bsinit\n");
    cmsepar('=');
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           call bsinit\n");
    fprintf(redfp,"*         -------------\n");

    cmsepar('=');
    fprintf(redfp,"*          read the probability information from ");
    fprintf(redfp,"the file\n");
    cmsepar('=');
    fprintf(redfp,"           lun = 23\n");
    fprintf(redfp,"           open(lun,file='bases.data',status='");
    fprintf(redfp,"old',form='unformatted')\n");
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           call bsread( lun )\n");
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           close( lun )\n");
    fprintf(redfp,"\n");

    cmsepar('=');
    fprintf(redfp,"*      initialization of parameters\n");
    fprintf(redfp,"*          for kinematics and matrix elements\n");
    fprintf(redfp,"*      initialization of histograms\n");
    cmsepar('=');
    fprintf(redfp,"      lu     = 12\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      open(lu,file='spring.result',status='");
    fprintf(redfp,"unknown',form='formatted')\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*         ------------------\n");
    fprintf(redfp,"           call userin( lu )\n");
    fprintf(redfp,"*         ------------------\n");
    fprintf(redfp,"\n");

    if( jetset ) {
    cmsepar('=');
    fprintf(redfp,"*     Set parameters for LUND from GRACE\n");
    cmsepar('=');
    fprintf(redfp,"*         --------------------------------\n");
    fprintf(redfp,"           if( jhadrn .eq. 1 ) call gr2lnd\n");
    fprintf(redfp,"*         --------------------------------\n");
    }

    cmsepar('=');
    fprintf(redfp,"*     initialization of additional histograms ");
    fprintf(redfp,"for spring\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    cmsepar('=');
    fprintf(redfp,"*     event generation\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    fprintf(redfp,"      mxtry  = 50\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      mxevnt = 10000\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     write(6,*)' number of events ? '\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     read(5,*) mxevnt\n");
    fprintf(redfp,"\n");
    if( !vcode ) {
    fprintf(redfp,"      do 100 nevnt = 1, mxevnt\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         call spring( func, mxtry )\n");
    fprintf(redfp,"\n");
    if( colorv == 1 && cbase->nbase > 1 ) {
        cmsepar('-');
        fprintf(redfp,"*     Determine color-state.\n");
        cmsepar('-');
        fprintf(redfp,"*         -------------\n");
        fprintf(redfp,"            call spdetc\n");
        fprintf(redfp,"*         -------------\n");
    }
    fprintf(redfp,"\n");
    cmsepar('-');
    fprintf(redfp,"*        compute the four vectors of generated ");
    fprintf(redfp,"event\n");
    fprintf(redfp,"*          from the kinematical variables\n");
    cmsepar('-');
    fprintf(redfp,"\n");
    fprintf(redfp,"*        do 90 k = 1 , nextn\n");
    fprintf(redfp,"*           write(6,*) (vec(j,k),j=1,4)\n");
    fprintf(redfp,"*  90    continue\n");
    if( jetset ) {
        cmsepar('-');
        fprintf(redfp,"*     SET /LUJETS/ and so on\n");
        cmsepar('-');
        fprintf(redfp,"*         --------------------------------\n");
        fprintf(redfp,"           if( jhadrn .eq. 1 ) call sp2lnd\n");
        fprintf(redfp,"*         --------------------------------\n");
    }
    fprintf(redfp,"  100 continue\n");
    } else {
    fprintf(redfp,"      msum = 0\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"  100 continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         call vsprng( func, mxtry )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*    --------------------------------------------");
    fprintf(redfp,"----\n");
    fprintf(redfp,"*        compute the four vectors of generated ");
    fprintf(redfp,"event\n");
    fprintf(redfp,"*          from the kinematical variables\n");
    fprintf(redfp,"*    --------------------------------------------");
    fprintf(redfp,"----\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         do 90 i = 1 , nsize\n");
    fprintf(redfp,"            if( ic(i) .eq. 0 ) then\n");
    fprintf(redfp,"                msum = msum + 1\n");
    fprintf(redfp,"*               do 80 k = 1 , nextn\n");
    fprintf(redfp,"*                  write(6,*) (vec(j,k),j=1,4)\n");
    fprintf(redfp,"*  80           continue\n");
    fprintf(redfp,"            endif\n");
    fprintf(redfp,"   90    continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      if( msum .lt. mxevnt) goto 100\n");

    }
    fprintf(redfp,"\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      call spinfo( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      call shplot( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      close( lu )\n");
    fprintf(redfp,"\n");
    if( CERNLIB == 1 && !vcode ) {
        cmsepar('=');
        fprintf(redfp,"*     save the contents of Histograms ");
        fprintf(redfp,"into Paw buffer\n");
        cmsepar('=');
        fprintf(redfp,"      call bshbok( 0 )\n");
        fprintf(redfp,"      call sphbok( 0 )\n");
        fprintf(redfp,"      call hrput( 0, 'spring.hbook','N')\n");
    }
    fprintf(redfp,"      stop\n");
    fprintf(redfp,"      end\n");
    fprintf(redfp,"\n");
}

/*==================================================================*/
Private Void    cmmaintc(NoArg)
/*------------------------------------------------------------------*
   Main program for CATALOG Project (limited for KEK)
 *------------------------------------------------------------------*/
{
    pindex pa;
    int    n, numhgs;

    cmopen(ROFORT, "maintc.f");

    cmsepar('*');
    fprintf(redfp, "*     Main program for Catalogue Project\n");
    fprintf(redfp, "*     root(s) v.s. total cross section with ");
    fprintf(redfp, "changing Higgs masses.\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "      parameter ( maxenp = 200 )\n");
    fprintf(redfp, "      include 'incl1.f'\n");
    fprintf(redfp, "      include 'inclk.f'\n");
    fprintf(redfp, "      common /loop0 / loop\n");
    fprintf(redfp, "      common /hgsflg/ ihflag\n");
    fprintf(redfp, "      common /kinem1/ s, w, fact\n");
    fprintf(redfp, "      common /knmflg/ knmgvs, knmhst, knmsph, ");
    fprintf(redfp, "knmisr\n");
    fprintf(redfp, "      common /bscntl/ intv, ipnt, nloop, mloop\n");
    fprintf(redfp, "      external func\n");
    fprintf(redfp, "*     parameter ( mhsize = 100000 )\n");
    fprintf(redfp, "*     common /pawc/ memory(mhsize)\n");
    fprintf(redfp, "      dimension energy(0:maxenp,0:2),");
    fprintf(redfp, "mxennm(0:2)\n");
    fprintf(redfp, "      real*4 stime\n");
    fprintf(redfp, "      real*4 wcm(0:maxenp,0:2),");
    fprintf(redfp, "xdata(0:maxenp,0:2),\n");
    fprintf(redfp, "     &       xerror(0:maxenp,0:2)\n");
    cmsepar('-');
    fprintf(redfp, "*     for graph of PAW\n");
    cmsepar('-');
    fprintf(redfp, "      dimension ypos(0:2),iplci(0:2),idmod(0:2)\n");
    fprintf(redfp, "      data ypos/0.6,0.55,0.5/\n");
    fprintf(redfp, "      data iplci/1,4,6/, idmod/3,2,1/\n");
    fprintf(redfp, "      character mess(0:2)*16\n");
    fprintf(redfp, "      character hmas(0:2)*8\n");
    fprintf(redfp, "*\n");
    cmsepar('-');
    fprintf(redfp,"      write(*,'(5x,a/)')\n");
    fprintf(redfp,"     .'Process: ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp, " --> ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n");
    fprintf(redfp, "*     INPUT parameters (1/2)\n");
    fprintf(redfp, "*     ihflag_max ..... No final Higgs -> 2 ");
    fprintf(redfp, "(3 parameters)\n");
    fprintf(redfp, "*                         final Higgs -> 1 ");
    fprintf(redfp, "(2 parameters)\n");
    cmsepar('-');
    numhgs = cmnumhgs();
    fprintf(redfp, "      ihflag_max = %c\n",(numhgs==0)?'2':'1');
    cmsepar('-');
    fprintf(redfp, "*     INPUT parameters (2/2)\n");
    fprintf(redfp, "*     engfrm     ..... lower limit of energy\n");
    fprintf(redfp, "*     engto      ..... upper limit of energy\n");
    fprintf(redfp, "*     engdiv     ..... energy bin\n");
    cmsepar('-');
    fprintf(redfp, "      engdiv     = 20.d0\n");
    fprintf(redfp, "      engfrm     = 180.d0\n");
    fprintf(redfp, "      engto      = 1000.d0\n");
    fprintf(redfp, "*     engdiv     = 200.d0\n");
    fprintf(redfp, "*     engfrm     = 200.d0\n");
    fprintf(redfp, "*     engto      = 1000.d0\n");
    cmsepar('-');
    fprintf(redfp, "*               initialization Kinematics Flags\n");
    fprintf(redfp, "*     knmgvs  : (=1)sqrt(S) is given in kinit.f\n");
    fprintf(redfp, "*     knmhst  : (=1)Fill historgram \n");
    fprintf(redfp, "*     knmsph  : reserved for soft photon check \n");
    fprintf(redfp, "*     knmisr  : reserved for initial state ");
    fprintf(redfp, "radiation\n");
    fprintf(redfp, "      knmgvs = 0\n");
    fprintf(redfp, "      knmhst = 0\n");
    fprintf(redfp, "      knmsph = 0\n");
    fprintf(redfp, "      knmisr = 0\n");
    cmsepar('-');
    fprintf(redfp, "*               initialization of HBOOK\n");
    cmsepar('-');
    fprintf(redfp, "*     call hlimit( mhsize )\n");
    fprintf(redfp, "*     call htitle('Histograms generated by ");
    fprintf(redfp, "BASES')\n");
    cmsepar('-');
    fprintf(redfp, "*     make tables of root(s) with each Higgs ");
    fprintf(redfp, "mass parameters\n");
    cmsepar('-');
    fprintf(redfp, "      do 1020 ihflag = 0 , ihflag_max\n");
    fprintf(redfp, "*        call userin( lu )\n");
    fprintf(redfp, "         call setmas\n");
    fprintf(redfp, "         call modmas\n");
    fprintf(redfp, "         call amparm\n");
    for(n = 2; n < nextern; n++) {
        fprintf(redfp, "         print *,'amass1(%d)',",n+1);
        fprintf(redfp, "amass1(%d)\n",n+1);
    }
    fprintf(redfp, "         th = ");
    for(n = 2; n < nextern; n++) {
        fprintf(redfp, "%c amass1(%d)",(n==2)? ' ':'+',n+1);
    }
    fprintf(redfp, "\n");
    fprintf(redfp, "         print *,'Sum of mass of final particles'");
    fprintf(redfp, ",th\n");
    fprintf(redfp, "         thnew = (int(th/engdiv)+1)*engdiv\n");
    fprintf(redfp, "         print *,'thnew',thnew\n");
    fprintf(redfp, "         ic = 0\n");
    fprintf(redfp, "         if( int(th)+1 .ge. int(engfrm) ) then\n");
    fprintf(redfp, "             energy(ic,ihflag) = int(th) + ");
    fprintf(redfp, "1.0d0\n");
    fprintf(redfp, "             wfirst = int(th) + 1.\n");
    fprintf(redfp, "             ic = ic + 1\n");
    fprintf(redfp, "         endif\n");
    fprintf(redfp, "         do 1010 x = thnew, engto + 1.d0, ");
    fprintf(redfp, "engdiv\n");
    fprintf(redfp, "            if( x .ge. engfrm ) then\n");
    fprintf(redfp, "                if( ic .gt. maxenp ) then\n");
    fprintf(redfp, "                    write(6,*) ' Lack of ");
    fprintf(redfp, "array(energy) ',maxenp\n");
    fprintf(redfp, "                    stop\n");
    fprintf(redfp, "                endif\n");
    fprintf(redfp, "                energy(ic,ihflag) = x\n");
    fprintf(redfp, "                if( ic .eq. 0 ) wfirst = x\n");
    fprintf(redfp, "                ic = ic + 1\n");
    fprintf(redfp, "            endif\n");
    fprintf(redfp, " 1010    continue     \n");
    fprintf(redfp, "         mxennm(ihflag) = ic\n");
    fprintf(redfp, "*        print *,'ihflag',ihflag,jhiggs,amh\n");
    fprintf(redfp, "         if( jhiggs .eq. 1 ) then\n");
    fprintf(redfp, "             write(mess(ihflag),9622) int(amh)\n");
    fprintf(redfp, "             write(hmas(ihflag),9624) int(amh)\n");
    fprintf(redfp, "         else\n");
    fprintf(redfp, "             write(mess(ihflag),9623)\n");
    fprintf(redfp, "             write(hmas(ihflag),9625)\n");
    fprintf(redfp, "         endif\n");
    fprintf(redfp, " 9620 format(10x,' Higgs mass = ',F9.3,");
    fprintf(redfp, "' width = ',F9.3)\n");
    fprintf(redfp, " 9621 format(10x,' Without Higgs ')\n");
    fprintf(redfp, " 9622 format('M?H! = ',i4,' GeV ')\n");
    fprintf(redfp, " 9623 format('without Higgs   ')\n");
    fprintf(redfp, " 9624 format(i4,' GeV')\n");
    fprintf(redfp, " 9625 format('No Higgs')\n");
    fprintf(redfp, " 1020 continue\n");
    fprintf(redfp, "\n");
    cmsepar('-');
    fprintf(redfp, "C     dump of energy table\n");
    cmsepar('-');
    fprintf(redfp, "*     write(6,*) ' Dump '\n");
    fprintf(redfp, "      do 1120 ihflag = 0 , ihflag_max\n");
    fprintf(redfp, "         i1 = mxennm(ihflag)/10\n");
    fprintf(redfp, "         write(6,6010) ihflag, mxennm(ihflag), ");
    fprintf(redfp, "mess(ihflag)\n");
    fprintf(redfp, "         do 1110 j = 1 , i1\n");
    fprintf(redfp, "            write(6,6020) (energy(k,ihflag),");
    fprintf(redfp, "k=10*(j-1),10*j-1)\n");
    fprintf(redfp, " 1110    continue\n");
    fprintf(redfp, "         write(6,6020) (energy(k,ihflag),");
    fprintf(redfp, "k=10*i1,mxennm(ihflag)-1)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, " 1120 continue\n");
    fprintf(redfp, " 6010 format(1h ,'ihflag = ',i2,' : num = ',");
    fprintf(redfp, "i5,4x,a)\n");
    fprintf(redfp, " 6020 format(1h ,10(f6.0,1x))\n");
    cmsepar('*');
    fprintf(redfp, "*     Calculation for Cross Section changing ");
    fprintf(redfp, "Energy and Higgs Mass.\n");
    cmsepar('*');
    cmsepar('=');
    fprintf(redfp, "*          Open a result file.\n");
    cmsepar('=');
    fprintf(redfp, "      lu = 11\n");
    fprintf(redfp, "      open( lu, file='roots.result',\n");
    fprintf(redfp, "     .      status='unknown', form='formatted')\n");
    fprintf(redfp, "      do 2020 ihflag = 0 , ihflag_max\n");
    cmsepar('=');
    fprintf(redfp, "*          initialization of bases by calling ");
    fprintf(redfp, "bsinit\n");
    cmsepar('=');
    fprintf(redfp, "*         -------------\n");
    fprintf(redfp, "           call bsinit\n");
    fprintf(redfp, "*         -------------\n");
    cmsepar('=');
    fprintf(redfp, "*          Modification of print flag for ");
    fprintf(redfp, "BASES/SPRING\n");
    cmsepar('=');
    fprintf(redfp, "*          ------------\n");
    fprintf(redfp, "             intv = 0\n");
    fprintf(redfp, "*          ------------\n");
    fprintf(redfp, "      do 2010 ie     = 0 , mxennm(ihflag) - 1\n");
    fprintf(redfp, "          w = energy( ie, ihflag )\n");
    cmsepar('=');
    fprintf(redfp, "*      initialization of parameters\n");
    fprintf(redfp, "*          for kinematics and matrix elements\n");
    fprintf(redfp, "*      initialization of histograms\n");
    cmsepar('=');
    fprintf(redfp, "*         ------------------\n");
    fprintf(redfp, "           call userin( lu )\n");
    fprintf(redfp, "*         ------------------\n");
    cmsepar('=');
    fprintf(redfp, "*              numerical integration by ");
    fprintf(redfp, "BASES 5.1\n");
    cmsepar('=');
    fprintf(redfp, "\n");
    fprintf(redfp, "      call bases( func, estim, sigma, ctime, ");
    fprintf(redfp, "it1, it2 )\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      if( ie .eq. 0 ) then\n");

    fprintf(redfp, "      write(lu,'(9x,a/)')\n");
    fprintf(redfp, "     .'Process: ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp, " --> ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n");

    fprintf(redfp, "             write(lu,9650) hmas(ihflag)\n");
    fprintf(redfp, " 9650        format(\n");
    fprintf(redfp, "     .        20X,'Results of Integration ");
    fprintf(redfp, "(',a,')',\n");
    fprintf(redfp, "     .       /10X,5('----------'),'------',\n");
    fprintf(redfp, "     .       /10X,' RootS  Estimate(+- Error )");
    fprintf(redfp, "order'\n");
    fprintf(redfp, "     .                       '  It1  It2 ");
    fprintf(redfp, "( H: M: Sec )',\n");
    fprintf(redfp, "     .       /10X,5('----------'),'------')\n");
    fprintf(redfp, "         endif\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "         re  = estim\n");
    fprintf(redfp, "         ac  = sigma\n");
    fprintf(redfp, "         are = re\n");
    fprintf(redfp, "         if( are .ge. ac) then\n");
    fprintf(redfp, "             call bsordr( are, f2, order, ");
    fprintf(redfp, "iordr)\n");
    fprintf(redfp, "         else\n");
    fprintf(redfp, "             call bsordr(  ac, f2, order, ");
    fprintf(redfp, "iordr )\n");
    fprintf(redfp, "         endif\n");
    fprintf(redfp, "         re  = re/order\n");
    fprintf(redfp, "         ac  = ac/order\n");
    fprintf(redfp, "         stime = ctime\n");
    fprintf(redfp, "         call bstcnv( stime, ih, mn, is1, is2)\n");
    fprintf(redfp, "         write(lu,9660) w,re,ac,iordr,it1,it2,");
    fprintf(redfp, "ih,mn,is1,is2\n");
    fprintf(redfp, "         write(6 ,9660) w,re,ac,iordr,it1,it2,");
    fprintf(redfp, "ih,mn,is1,is2\n");
    fprintf(redfp, " 9660    format(10X,F6.1,F10.6,'(+-',F8.6,')E',");
    fprintf(redfp, "I3.2,2I5,\n");
    fprintf(redfp, "     .           1X,I3,':',I2,':',I2,'.',I2.2,\n");
    fprintf(redfp, "     .         /10X,5('----------'),'------')\n");
    fprintf(redfp, " \n");
    fprintf(redfp, "            wcm(ie,ihflag) = w\n");
    fprintf(redfp, "          xdata(ie,ihflag) = estim\n");
    fprintf(redfp, "         xerror(ie,ihflag) = sigma\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, " 2010 continue\n");
    fprintf(redfp, " 2020 continue\n");
    fprintf(redfp, "      close(lu)\n");
    cmsepar('-');
    fprintf(redfp, "C     Get wmin, wmax (Energy min. and max.)\n");
    cmsepar('-');
    fprintf(redfp, "      ifirst = 0\n");
    fprintf(redfp, "      do 2120 ihflag = 0 , ihflag_max\n");
    fprintf(redfp, "      do 2110 ie     = 0 , mxennm(ihflag) - 1\n");
    fprintf(redfp, "	  if( ifirst .eq. 0 ) then\n");
    fprintf(redfp, "              wmax = xdata(ie,ihflag)\n");
    fprintf(redfp, "              wmin = xdata(ie,ihflag)\n");
    fprintf(redfp, "	      ifirst = 1\n");
    fprintf(redfp, "	  else\n");
    fprintf(redfp, "	      if( xdata(ie,ihflag) .gt. wmax ) ");
    fprintf(redfp, "wmax = xdata(ie,ihflag)\n");
    fprintf(redfp, "	      if( xdata(ie,ihflag) .lt. wmin ) ");
    fprintf(redfp, "wmin = xdata(ie,ihflag)\n");
    fprintf(redfp, "	  endif\n");
    fprintf(redfp, " 2110 continue\n");
    fprintf(redfp, " 2120 continue\n");
    cmsepar('-');
    fprintf(redfp, "C     Put TeX file \n");
    cmsepar('-');
    fprintf(redfp, "      lutex = 12\n");
    fprintf(redfp, "      do 2220 ihflag = 0 , ihflag_max\n");
    fprintf(redfp, "         if( ihflag .eq. 0 ) then\n");
    fprintf(redfp, "             open(lutex,file='roots0.tex',\n");
    fprintf(redfp, "     &       status='unknown',form='formatted')\n");
    fprintf(redfp, "         else if( ihflag .eq. 1 ) then\n");
    fprintf(redfp, "             open(lutex,file='roots1.tex',\n");
    fprintf(redfp, "     &       status='unknown',form='formatted')\n");
    fprintf(redfp, "         else if( ihflag .eq. 2 ) then\n");
    fprintf(redfp, "             open(lutex,file='roots2.tex',\n");
    fprintf(redfp, "     &       status='unknown',form='formatted')\n");
    fprintf(redfp, "         endif\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "         write(lutex,9300)\n");
    fprintf(redfp, " 9300    format('\\begin{center}',\n");
    fprintf(redfp, "     .     /,'{\\footnotesize',\n");
    fprintf(redfp, "     .     /,'\\begin{tabular}{||r|c||r|c||} ");
    fprintf(redfp, "\\hline',\n");
    fprintf(redfp, "     .     /,'$\\sqrt{s}$ {\\footnotesize (GeV)} ");
    fprintf(redfp, "&',\n");
    fprintf(redfp, "     .       ' Cross section ( error ) ");
    fprintf(redfp, "{\\footnotesize (pb)} &',\n");
    fprintf(redfp, "     .     /,'$\\sqrt{s}$ ");
    fprintf(redfp, "{\\footnotesize (GeV)} &',\n");
    fprintf(redfp, "     .       ' Cross section ( error ) ");
    fprintf(redfp, "{\\footnotesize (pb)} ',\n");
    fprintf(redfp, "     .       '\\\\ \\hline')\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "          k1 = 0\n");
    fprintf(redfp, "          kk = mxennm(ihflag)/2\n");
    fprintf(redfp, "          if( mod(mxennm(ihflag),2) .eq. 1 ) ");
    fprintf(redfp, "kk = kk + 1\n");
    fprintf(redfp, "          k2 = kk\n");
    fprintf(redfp, "          do 2210 i = 1, kk\n");
    fprintf(redfp, " \n");
    fprintf(redfp, "             re  = xdata(k1,ihflag)\n");
    fprintf(redfp, "             ac  = xerror(k1,ihflag)\n");
    fprintf(redfp, "             are = re\n");
    fprintf(redfp, "             if( are .ge. ac) then\n");
    fprintf(redfp, "                 call bsordr( are, f2, order, ");
    fprintf(redfp, "iordr)\n");
    fprintf(redfp, "             else\n");
    fprintf(redfp, "                 call bsordr(  ac, f2, order, ");
    fprintf(redfp, "iordr )\n");
    fprintf(redfp, "             endif\n");
    fprintf(redfp, "             re  = re/order\n");
    fprintf(redfp, "             ac  = ac/order\n");
    fprintf(redfp, " \n");
    fprintf(redfp, "	     if( k2 .le. mxennm(ihflag) ) then\n");
    fprintf(redfp, "                 re1 = xdata(k2,ihflag)\n");
    fprintf(redfp, "                 ac1 = xerror(k2,ihflag)\n");
    fprintf(redfp, "                 are = re1\n");
    fprintf(redfp, "                 if( are .ge. ac1) then\n");
    fprintf(redfp, "                     call bsordr( are, f2, ");
    fprintf(redfp, "order, iordr1)\n");
    fprintf(redfp, "                 else\n");
    fprintf(redfp, "                     call bsordr( ac1, f2, ");
    fprintf(redfp, "order, iordr1 )\n");
    fprintf(redfp, "                 endif\n");
    fprintf(redfp, "                 re1 = re1/order\n");
    fprintf(redfp, "                 ac1 = ac1/order\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "                 write(lutex,9310) ");
    fprintf(redfp, "wcm(k1,ihflag),re,ac,iordr,\n");
    fprintf(redfp, "     &                             ");
    fprintf(redfp, "wcm(k2,ihflag),re1,ac1,iordr1\n");
    fprintf(redfp, "	     else\n");
    fprintf(redfp, "                 write(lutex,9311) ");
    fprintf(redfp, "wcm(k1,ihflag),re,ac,iordr\n");
    fprintf(redfp, "             endif\n");
    fprintf(redfp, "	  \n");
    fprintf(redfp, " 9310        format(F7.1,' &',F10.6,' ($\\pm$',");
    fprintf(redfp, "F8.6,' ) $\\times 10^{',\n");
    fprintf(redfp, "     .          I3,'}$ &',\n");
    fprintf(redfp, "     .          F7.1,' &',F10.6,' ($\\pm$',F8.6,");
    fprintf(redfp, "' ) $\\times 10^{',\n");
    fprintf(redfp, "     .          I3,'}$ ','\\\\ \\hline')\n");
    fprintf(redfp, " 9311        format(F7.1,' &',F10.6,' ($\\pm$',");
    fprintf(redfp, "F8.6,' ) $\\times 10^{',\n");
    fprintf(redfp, "     .          I3,'}$ & & \\\\ \\hline')\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "             k1 = k1 + 1\n");
    fprintf(redfp, "             k2 = k2 + 1\n");
    fprintf(redfp, "\n");
    fprintf(redfp, " 2210     continue\n");
    fprintf(redfp, "          write(lutex,9320)\n");
    fprintf(redfp, " 9320     format('\\end{tabular}}',/,");
    fprintf(redfp, "'\\end{center}')\n");
    fprintf(redfp, "          close(lutex)\n");
    fprintf(redfp, " 2220 continue\n");
    cmsepar('-');
    fprintf(redfp, "C     Put Kumac File.\n");
    cmsepar('-');
    fprintf(redfp, "      ilmax = int(log10(wmax))\n");
    fprintf(redfp, "      if( wmax .gt. 1.d0 ) ilmax = ilmax + 1\n");
    fprintf(redfp, "      ilmin = int(log10(wmin))\n");
    fprintf(redfp, "      if( wmin .lt. 1.d0 ) ilmin = ilmin - 1\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      lukmac = 13\n");
    fprintf(redfp, "      open(lukmac,file='roots.kumac',\n");
    fprintf(redfp, "     &     status='unknown',form='formatted')\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      write(lukmac,9501) '*',('-',k=1,71)\n");
    fprintf(redfp, " 9501 format(72a1)\n");
    fprintf(redfp, "      write(lukmac,9502)\n");
    fprintf(redfp, " 9502 format('*     Catalogue Project (c) ");
    fprintf(redfp, "Minami-Tateya ')\n");
    fprintf(redfp, "      write(lukmac,9501) '*',('-',k=1,71)\n");
    fprintf(redfp, "      write(lukmac,'(''*'',2x,a/)')\n");
    fprintf(redfp, "     .'Process: ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp, " --> ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n");
    cmsepar('=');
    fprintf(redfp, "C     Put Energy.\n");
    cmsepar('=');
    fprintf(redfp, "      do 2320 ihflag = 0 , ihflag_max\n");
    fprintf(redfp, "         i1 = (mxennm(ihflag)-1)/5\n");
    fprintf(redfp, "         write(lukmac,9503) 'w',ihflag, ");
    fprintf(redfp, "mxennm(ihflag)\n");
    fprintf(redfp, "         do 2310 j = 1 , i1\n");
    fprintf(redfp, "            write(lukmac,9504) ");
    fprintf(redfp, "(energy(k,ihflag),k=5*(j-1),5*j-1)\n");
    fprintf(redfp, " 2310    continue\n");
    fprintf(redfp, "         write(lukmac,9505) ");
    fprintf(redfp, "(energy(k,ihflag),k=5*i1,mxennm(ihflag)-1)\n");
    fprintf(redfp, " 2320 continue\n");
    fprintf(redfp, " 9503 format('vect/cre ',a,i1,'(',i3.3,') r _')\n");
    fprintf(redfp, " 9504 format(2x,5(F9.3,5X),'_')\n");
    fprintf(redfp, " 9505 format(2x,5(F9.3,5X))\n");
    cmsepar('=');
    fprintf(redfp, "C     Put Total Cross Section.\n");
    cmsepar('=');
    fprintf(redfp, "      do 2420 ihflag = 0 , ihflag_max\n");
    fprintf(redfp, "         i1 = (mxennm(ihflag)-1)/5\n");
    fprintf(redfp, "         write(lukmac,9503) 'total',ihflag, ");
    fprintf(redfp, "mxennm(ihflag)\n");
    fprintf(redfp, "         do 2410 j = 1 , i1\n");
    fprintf(redfp, "            write(lukmac,9506) ");
    fprintf(redfp, "(xdata(k,ihflag),k=5*(j-1),5*j-1)\n");
    fprintf(redfp, " 2410    continue\n");
    fprintf(redfp, "         write(lukmac,9507) ");
    fprintf(redfp, "(xdata(k,ihflag),k=5*i1,mxennm(ihflag)-1)\n");
    fprintf(redfp, " 2420 continue\n");
    fprintf(redfp, " 9506 format(2x,5(E14.7),' _')\n");
    fprintf(redfp, " 9507 format(2x,5(E14.7))\n");
    cmsepar('=');
    fprintf(redfp, "C     Put parameters for Paw.\n");
    cmsepar('=');
    fprintf(redfp, "      write(lukmac,9508)\n");
    fprintf(redfp, " 9508 format(\n");
    fprintf(redfp, "     . 'option logy'/,'opt tic'/,'set xsiz 15.0'");
    fprintf(redfp, "/\n");
    fprintf(redfp, "     . 'set ysiz 10.0'/,'set xmgl  2.5'/,'set ");
    fprintf(redfp, "xmgr  1.0'/\n");
    fprintf(redfp, "     . 'set ymgu  0.7'/,'set ymgl  1.8'/,'set ");
    fprintf(redfp, "asiz 0.3'/\n");
    fprintf(redfp, "     . 'set xlab  1.4'/,'set ylab 0.8'/,'set ");
    fprintf(redfp, "yval  0.3'/\n");
    fprintf(redfp, "     . 'set chhe  0.3'/,'set pass    5'/,'set ");
    fprintf(redfp, "dmod    3'/\n");
    fprintf(redfp, "     . '*set vfon -20'/,'fortran/file 66 ");
    fprintf(redfp, "roots.ps'/\n");
    fprintf(redfp, "     . 'metafile 66 -113'/)\n");
    cmsepar('=');
    fprintf(redfp, "C     Put Window size\n");
    cmsepar('=');
    fprintf(redfp, "      write(lukmac,9509) 10.**(ilmin), ");
    fprintf(redfp, "10.**(ilmax)\n");
    fprintf(redfp, " 9509 format(\n");
    fprintf(redfp, "     . 'null 180 1000 ',1pE6.0,' ',1pE6.0/\n");
    fprintf(redfp, "     . '*             ^^^^^^ ^^^^^')\n");
    cmsepar('=');
    fprintf(redfp, "C     Put graph action\n");
    cmsepar('=');
    fprintf(redfp, "      do 2520 ihflag = 0 , ihflag_max\n");
    fprintf(redfp, "	 ycor = ilmin + ypos(ihflag)*(ilmax-ilmin)\n");
    fprintf(redfp, "	 ycorl = 10.**ycor\n");
    fprintf(redfp, "         write(lukmac,9510) iplci(ihflag),");
    fprintf(redfp, "idmod(ihflag),mxennm(ihflag),\n");
    fprintf(redfp, "     &                ihflag,ihflag,ycor,");
    fprintf(redfp, "ycor,ycorl,mess(ihflag)\n");
    fprintf(redfp, " 9510 format(\n");
    fprintf(redfp, "     . '*-----------------------------------");
    fprintf(redfp, "---------------------'/\n");
    fprintf(redfp, "     . 'set plci ',i1/\n");
    fprintf(redfp, "     . 'set dmod ',i1/\n");
    fprintf(redfp, "     . 'graph ',I3,' w',i1,' total',i1,' ");
    fprintf(redfp, "''C'''/\n");
    fprintf(redfp, "     . 'line 700.0 ',F9.3,' 750.0 ',F9.3/\n");
    fprintf(redfp, "     . '*^^^^^^^^^^^^^^^^^^^^^^^^^^^'/\n");
    fprintf(redfp, "     . 'text 800.0 ',0PE15.7,' ''',a,''' 0.2'/\n");
    fprintf(redfp, "     . '*^^^^^^^^^^^^^')\n");
    fprintf(redfp, " 2520 continue\n");
    cmsepar('=');
    fprintf(redfp, "C     Put title\n");
    cmsepar('=');
    fprintf(redfp, "      write(lukmac,9511)\n");
    fprintf(redfp, " 9511 format(\n");
    fprintf(redfp, "     . '*========================================");
    fprintf(redfp, "=================='/\n");
    fprintf(redfp, "     . 'atitle ''CMS energy (GeV)''  ");
    fprintf(redfp, "''Total cross section (pb)'''/\n");
    fprintf(redfp, "     . 'close 66')\n");
    fprintf(redfp, "      close(lukmac)\n");
    fprintf(redfp, "      stop\n");
    fprintf(redfp, "      end\n");
}

/*==================================================================*/
Private Void    cmmaincs(NoArg)
/*------------------------------------------------------------------*
   Main program for CATALOG Project (limited for KEK)
 *------------------------------------------------------------------*/
{
    pindex pa;
    int    n, numhgs;

    cmopen(ROFORT, "maincs.f");
    fprintf(redfp, "*     Main program for Catalogue Project ");
    fprintf(redfp, "(Differential Cross Section)\n");
    cmsepar('-');
    fprintf(redfp, "      implicit real*8(a-h,o-z)\n");
    cmsepar('-');
    fprintf(redfp, "      parameter ( maxenp = 200 )\n");
    fprintf(redfp, "      include 'incl1.f'\n");
    fprintf(redfp, "      include 'inclk.f'\n");
    fprintf(redfp, "      common /hgsflg/ ihflag\n");
    fprintf(redfp, "      common /kinem1/ s, w, fact\n");
    fprintf(redfp, "      common /knmflg/ knmgvs, knmhst, knmsph, ");
    fprintf(redfp, "knmisr\n");
    fprintf(redfp, "      common /bscntl/ intv, ipnt, nloop, mloop\n");
    fprintf(redfp, "      external func\n");
    fprintf(redfp, "      parameter ( mhsize = 100000 )\n");
    fprintf(redfp, "      common /pawc/ memory(mhsize)\n");
    fprintf(redfp, "      dimension energy(0:maxenp,0:2),");
    fprintf(redfp, "mxennm(0:2)\n");
    fprintf(redfp, "      real*4 stime\n");
    fprintf(redfp, "      real*4 wcm(0:maxenp,0:2),");
    fprintf(redfp, "xdata(0:maxenp,0:2),\n");
    fprintf(redfp, "     &       xerror(0:maxenp,0:2)\n");
    fprintf(redfp, "      integer ktbl(10)\n");
    cmsepar('-');
    fprintf(redfp, "*     for graph of PAW\n");
    cmsepar('-');
    fprintf(redfp, "      dimension ypos(0:2),iplci(0:2),");
    fprintf(redfp, "idmod(0:2),ihtyp(0:2)\n");
    fprintf(redfp, "      data ypos/0.7,0.65,0.6/\n");
    fprintf(redfp, "      data iplci/1,4,6/, idmod/3,2,1/\n");
    fprintf(redfp, "      character mess(0:2)*16\n");
    fprintf(redfp, "      character hmas(0:2)*8\n");
    fprintf(redfp, "      logical   hexist\n");
    fprintf(redfp, "      real*4    hmax,hmin\n");
    fprintf(redfp, "      external  hmax,hmin,hexist\n");
    fprintf(redfp, "      character *1 calph(0:9),cover(0:1)\n");
    fprintf(redfp, "      data calph/'a','b','c','d','e', ");
    fprintf(redfp, "'f','g','h','i','j'/\n");
    fprintf(redfp, "      data ihtyp/345,354,305/\n");
    fprintf(redfp, "      data cover/' ','s'/\n");
    fprintf(redfp, "*\n");
    cmsepar('-');
    fprintf(redfp, "      write(*,'(5x,a/)')\n");
    fprintf(redfp,"     .'Process: ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp, " --> ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n");
    fprintf(redfp, "*     INPUT parameters (1/2)\n");
    fprintf(redfp, "*     ihflag_max ..... No final Higgs -> 2 ");
    fprintf(redfp, "(3 parameters)\n");
    fprintf(redfp, "*                         final Higgs -> 1 ");
    fprintf(redfp, "(2 parameters)\n");
    cmsepar('-');
    numhgs = cmnumhgs();
    fprintf(redfp, "      ihflag_max = %c\n",(numhgs==0)?'2':'1');
    cmsepar('-');
    fprintf(redfp, "*     INPUT parameters (2/2)\n");
    fprintf(redfp, "*     engfrm     ..... lower limit of energy\n");
    fprintf(redfp, "*     engto      ..... upper limit of energy\n");
    fprintf(redfp, "*     engdiv     ..... energy bin\n");
    cmsepar('-');
    fprintf(redfp, "      engdiv     = 500.d0\n");
    fprintf(redfp, "      engfrm     =   0.d0\n");
    fprintf(redfp, "      engto      = 1000.d0\n");
    fprintf(redfp, "      englim     =  180.d0\n");
    fprintf(redfp, "*     engdiv     = 200.d0\n");
    fprintf(redfp, "*     engfrm     = 200.d0\n");
    fprintf(redfp, "*     engto      = 1000.d0\n");
    cmsepar('-');
    fprintf(redfp, "*     ktblmx .... max. of histrogram for kumac\n");
    fprintf(redfp, "*     ktbl() .... histogram id for kumac\n");
    cmsepar('-');
    fprintf(redfp, "      ktblmx  = 1\n");
    fprintf(redfp, "      ktbl(1) = 5\n");
    fprintf(redfp, "*     ktbl(2) = 6\n");
    cmsepar('-');
    fprintf(redfp, "*               initialization Kinematics Flags\n");
    fprintf(redfp, "*     knmgvs  : (=1)sqrt(S) is given in kinit.f\n");
    fprintf(redfp, "*     knmhst  : (=1)Fill historgram \n");
    fprintf(redfp, "*     knmsph  : reserved for soft photon check \n");
    fprintf(redfp, "*     knmisr  : reserved for initial state ");
    fprintf(redfp, "radiation\n");
    fprintf(redfp, "      knmgvs = 0\n");
    fprintf(redfp, "      knmhst = 1\n");
    fprintf(redfp, "      knmsph = 0\n");
    fprintf(redfp, "      knmisr = 0\n");
    cmsepar('-');
    fprintf(redfp, "*               Information of BASES \n");
    fprintf(redfp, "                info = 1\n");
    cmsepar('-');
    cmsepar('-');
    fprintf(redfp, "*               initialization of HBOOK\n");
    cmsepar('-');
    fprintf(redfp, "      call hlimit( mhsize )\n");
    fprintf(redfp, "      call htitle('Differential Cross Sections ");
    fprintf(redfp, "(Catalog Project)')\n");
    cmsepar('-');
    fprintf(redfp, "*     make tables of root(s) with each Higgs ");
    fprintf(redfp, "mass parameters\n");
    cmsepar('-');
    fprintf(redfp, "      do 1002 ihflag = 0 , 2\n");
    fprintf(redfp, "      do 1001 ie     = 0 , maxenp\n");
    fprintf(redfp, "         energy(ie,ihflag) = 0.0d0\n");
    fprintf(redfp, " 1001 continue\n");
    fprintf(redfp, " 1002 continue\n");
    fprintf(redfp, "      do 1020 ihflag = 0 , ihflag_max\n");
    fprintf(redfp, "*        call userin( lu )\n");
    fprintf(redfp, "         call setmas\n");
    fprintf(redfp, "         call modmas\n");
    fprintf(redfp, "         call amparm\n");
    for(n = 2; n < nextern; n++) {
        fprintf(redfp, "         print *,'amass1(%d)',",n+1);
        fprintf(redfp, "amass1(%d)\n",n+1);
    }
    fprintf(redfp, "         th = ");
    for(n = 2; n < nextern; n++) {
        fprintf(redfp, "%c amass1(%d)",(n==2)? ' ':'+',n+1);
    }
    fprintf(redfp, "\n");
    fprintf(redfp, "         print *,'Sum of mass of final particles',th\n");
    fprintf(redfp, "         thnew = (int(th/engdiv)+1)*engdiv\n");
    fprintf(redfp, "         print *,'thnew',thnew\n");
    fprintf(redfp, "*--\n");
    fprintf(redfp, "         if( ihflag .eq. 0 ) then\n");
    fprintf(redfp, "*--\n");
    fprintf(redfp, "         ic = 0\n");
    fprintf(redfp, "         if( int(th)+1 .ge. int(engfrm) ) then\n");
    fprintf(redfp, "             wfirst = int(th) + 1.0d0\n");
    fprintf(redfp, "             if( wfirst .le. englim )");
    fprintf(redfp, " wfirst = englim\n");
    fprintf(redfp, "             energy(ic,ihflag) = wfirst\n");
    fprintf(redfp, "             ic = ic + 1\n");
    fprintf(redfp, "         endif\n");
    fprintf(redfp, "         do 1010 x = thnew, engto + 1.d0, engdiv\n");
    fprintf(redfp, "            if( x .ge. engfrm ) then\n");
    fprintf(redfp, "                if( ic .gt. maxenp ) then\n");
    fprintf(redfp, "                    write(6,*) ' Lack of array(energy) ',maxenp\n");
    fprintf(redfp, "                    stop\n");
    fprintf(redfp, "                endif\n");
    fprintf(redfp, "                energy(ic,ihflag) = x\n");
    fprintf(redfp, "                if( ic .eq. 0 ) wfirst = x\n");
    fprintf(redfp, "                ic = ic + 1\n");
    fprintf(redfp, "            endif\n");
    fprintf(redfp, " 1010    continue     \n");
    fprintf(redfp, "         mxennm(ihflag) = ic\n");
    fprintf(redfp, "         else\n");
    fprintf(redfp, "*   copy from energy(ic,0) (....thnew)\n");
    fprintf(redfp, "              do 1015 j = 0, mxennm(0)-1\n");
    fprintf(redfp, "                 if( energy(j,0) .ge. wfirst )\n");
    fprintf(redfp, "     .               energy(j,ihflag) = energy(j,0)\n");
    fprintf(redfp, " 1015    continue\n");
    fprintf(redfp, "         endif\n");
    fprintf(redfp, "*        print *,'ihflag',ihflag,jhiggs,amh\n");
    fprintf(redfp, "         if( jhiggs .eq. 1 ) then\n");
    fprintf(redfp, "             write(mess(ihflag),9622) int(amh)\n");
    fprintf(redfp, "             write(hmas(ihflag),9624) int(amh)\n");
    fprintf(redfp, "         else\n");
    fprintf(redfp, "             write(mess(ihflag),9623)\n");
    fprintf(redfp, "             write(hmas(ihflag),9625)\n");
    fprintf(redfp, "         endif\n");
    fprintf(redfp, " 9620 format(10x,' Higgs mass = ',F9.3,' width = ',F9.3)\n");
    fprintf(redfp, " 9621 format(10x,' Without Higgs ')\n");
    fprintf(redfp, " 9622 format('M?H! = ',i4,' GeV ')\n");
    fprintf(redfp, " 9623 format('without Higgs   ')\n");
    fprintf(redfp, " 9624 format(i4,' GeV')\n");
    fprintf(redfp, " 9625 format('No Higgs')\n");
    fprintf(redfp, " 1020 continue\n");
    fprintf(redfp, "\n");
    cmsepar('-');
    fprintf(redfp, "C     dump of energy table\n");
    cmsepar('-');
    fprintf(redfp, "*     write(6,*) ' Dump '\n");
    fprintf(redfp, "      do 1120 ihflag = 0 , ihflag_max\n");
    fprintf(redfp, "         i1 = mxennm(0)/10\n");
    fprintf(redfp, "         write(6,6010) ihflag, mxennm(0), mess(ihflag)\n");
    fprintf(redfp, "         do 1110 j = 1 , i1\n");
    fprintf(redfp, "            write(6,6020) (energy(k,ihflag),k=10*(j-1),10*j-1)\n");
    fprintf(redfp, " 1110    continue\n");
    fprintf(redfp, "         write(6,6020) (energy(k,ihflag),k=10*i1,mxennm(0)-1)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, " 1120 continue\n");
    fprintf(redfp, " 6010 format(1h ,'ihflag = ',i2,' : num = ',i5,4x,a)\n");
    fprintf(redfp, " 6020 format(1h ,10(f6.0,1x))\n");
    cmsepar('*');
    fprintf(redfp, "*     Calculation for Cross Section changing Energy and Higgs Mass.\n");
    cmsepar('*');
    cmsepar('=');
    fprintf(redfp, "*          Open a result file.\n");
    cmsepar('=');
    fprintf(redfp, "      lu = 11\n");
    fprintf(redfp, "      open( lu, file='dsdx.result',\n");
    fprintf(redfp, "     .      status='unknown', form='formatted')\n");
    fprintf(redfp, "      do 2020 ihflag = 0 , ihflag_max\n");
    fprintf(redfp, "      do 2010 ie     = 0 , mxennm(0) - 1\n");
    cmsepar('=');
    fprintf(redfp, "*          initialization of bases by calling bsinit\n");
    cmsepar('=');
    fprintf(redfp, "*         -------------\n");
    fprintf(redfp, "           call bsinit\n");
    fprintf(redfp, "*         -------------\n");
    cmsepar('=');
    fprintf(redfp, "*          Modification of print flag for BASES/SPRING\n");
    cmsepar('=');
    fprintf(redfp, "*          --------------------------------\n");
    fprintf(redfp, "             if( info .eq. 0 ) intv = 0\n");
    fprintf(redfp, "*          --------------------------------\n");
    fprintf(redfp, "          iofset = ie*1000 + ihflag*100\n");
    fprintf(redfp, "          w = energy( ie, ihflag )\n");
    fprintf(redfp, "          if( w .le. 0.0d0 ) goto 2010\n");
    cmsepar('=');
    fprintf(redfp, "*      initialization of parameters\n");
    fprintf(redfp, "*          for kinematics and matrix elements\n");
    fprintf(redfp, "*      initialization of histograms\n");
    cmsepar('=');
    fprintf(redfp, "*         ------------------\n");
    fprintf(redfp, "           call userin( lu )\n");
    fprintf(redfp, "*         ------------------\n");
    cmsepar('=');
    fprintf(redfp, "*              Set parameters for integration.\n");
    cmsepar('=');
    fprintf(redfp, "         ncall = 20000\n");
    fprintf(redfp, "         itmx1 = 10\n");
    fprintf(redfp, "         itmx2 = 20\n");
    fprintf(redfp, "         acc1  = 0.005\n");
    fprintf(redfp, "         acc2  = 0.001\n");
    fprintf(redfp, "*       ------------------------------------------------\n");
    fprintf(redfp, "	 call bsparm( ncall, acc1, acc2, itmx1, itmx2 )\n");
    fprintf(redfp, "*       ------------------------------------------------\n");
    cmsepar('=');
    fprintf(redfp, "*              numerical integration by BASES 5.1\n");
    cmsepar('=');
    fprintf(redfp, "\n");
    fprintf(redfp, "      call bases( func, estim, sigma, ctime, it1, it2 )\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      if( info .eq. 0 ) then\n\n");
    fprintf(redfp, "      if( ie .eq. 0 ) then\n");
    fprintf(redfp, "      write(lu,'(10x,a/)')\n");
    fprintf(redfp,"     .'Process: ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp, " --> ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n");
    fprintf(redfp, "             write(lu,9650) hmas(ihflag)\n");
    fprintf(redfp, " 9650        format(\n");
    fprintf(redfp, "     .        20X,'Results of Integration (',a,')',\n");
    fprintf(redfp, "     .       /10X,5('----------'),'------',\n");
    fprintf(redfp, "     .       /10X,' RootS  Estimate(+- Error )order'\n");
    fprintf(redfp, "     .                       '  It1  It2 ( H: M: Sec )',\n");
    fprintf(redfp, "     .       /10X,5('----------'),'------')\n");
    fprintf(redfp, "         endif\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "         re  = estim\n");
    fprintf(redfp, "         ac  = sigma\n");
    fprintf(redfp, "         are = re\n");
    fprintf(redfp, "         if( are .ge. ac) then\n");
    fprintf(redfp, "             call bsordr( are, f2, order, iordr)\n");
    fprintf(redfp, "         else\n");
    fprintf(redfp, "             call bsordr(  ac, f2, order, iordr )\n");
    fprintf(redfp, "         endif\n");
    fprintf(redfp, "         re  = re/order\n");
    fprintf(redfp, "         ac  = ac/order\n");
    fprintf(redfp, "         stime = ctime\n");
    fprintf(redfp, "         call bstcnv( stime, ih, mn, is1, is2)\n");
    fprintf(redfp, "         write(lu,9660) w,re,ac,iordr,it1,it2,ih,mn,is1,is2\n");
    fprintf(redfp, "         write(6 ,9660) w,re,ac,iordr,it1,it2,ih,mn,is1,is2\n");
    fprintf(redfp, " 9660    format(10X,F6.1,F10.6,'(+-',F8.6,')E',I3.2,2I5,\n");
    fprintf(redfp, "     .           1X,I3,':',I2,':',I2,'.',I2.2,\n");
    fprintf(redfp, "     .         /10X,5('----------'),'------')\n");
    fprintf(redfp, " \n");
    fprintf(redfp, "      else\n");
    fprintf(redfp, "          call bsinfo( lu )\n");
    fprintf(redfp, "      endif\n");
    fprintf(redfp, "            wcm(ie,ihflag) = w\n");
    fprintf(redfp, "          xdata(ie,ihflag) = estim\n");
    fprintf(redfp, "         xerror(ie,ihflag) = sigma\n");
    cmsepar('=');
    fprintf(redfp, "*        Book for HBOOK.\n");
    cmsepar('=');
    fprintf(redfp, "*         -----------------------\n");
    fprintf(redfp, "           call bshbok( iofset )\n");
    fprintf(redfp, "*         -----------------------\n");
    fprintf(redfp, " 2010 continue\n");
    fprintf(redfp, " 2020 continue\n");
    fprintf(redfp, "      close(lu)\n");
    cmsepar('=');
    fprintf(redfp, "*          Save the contents of Histograms into PAW Buffer\n");
    cmsepar('=');
    fprintf(redfp, "\n");
    fprintf(redfp, "      call hrput( 0, 'dsdx.hbook', 'n' )\n");
    fprintf(redfp, "\n");
    cmsepar('-');
    fprintf(redfp, "C     Put Kumac File.\n");
    cmsepar('-');
    fprintf(redfp, "\n");
    fprintf(redfp, "      lukmac = 13\n");
    fprintf(redfp, "      open(lukmac,file='dsdx.kumac',\n");
    fprintf(redfp, "     &     status='unknown',form='formatted')\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      write(lukmac,9501) '*',('-',k=1,71)\n");
    fprintf(redfp, " 9501 format(72a1)\n");
    fprintf(redfp, "      write(lukmac,9502)\n");
    fprintf(redfp, " 9502 format('*     Catalogue Project (c) Minami-Tateya ')\n");
    fprintf(redfp, "      write(lukmac,9501) '*',('-',k=1,71)\n");
    fprintf(redfp, "      write(lukmac,'(''*'',2x,a)')\n");
    fprintf(redfp,"     .'Process: ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp, " --> ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n");
    fprintf(redfp, "      write(lukmac,9501) '*',('-',k=1,71)\n");
    fprintf(redfp, "      write(lukmac,9531)\n");
    fprintf(redfp, " 9531 format('macro dsdx'/\n");
    fprintf(redfp, "     .       'if [1] = 0 then')\n");
    fprintf(redfp, "      do 2495 ik = 1, ktblmx\n");
    fprintf(redfp, "         write(lukmac,9532) ik\n");
    fprintf(redfp, " 9532    format('  exec dsdx ',i2)\n");
    fprintf(redfp, " 2495 continue\n");
    fprintf(redfp, "      write(lukmac,9533)\n");
    fprintf(redfp, " 9533 format('   exitm'/'endif')\n");
    fprintf(redfp, "      do 2496 ik = 1, ktblmx\n");
    fprintf(redfp, "         write(lukmac,9534) ik,ik\n");
    fprintf(redfp, " 9534    format('if [1] = ',i2,' goto label',i2.2)\n");
    fprintf(redfp, " 2496 continue\n");
    fprintf(redfp, "      write(lukmac,9535) ktblmx\n");
    fprintf(redfp, " 9535 format(\n");
    fprintf(redfp, "     .   'mess p1=[1]//'' is invalid'''/\n");
    fprintf(redfp, "     .   'mess dsdx 0(all), from 1 to ',i2/\n");
    fprintf(redfp, "     .   'exitm')\n");
    cmsepar('=');
    fprintf(redfp, "C     Read File \n");
    cmsepar('=');
    fprintf(redfp, "*    ID, Energy, mixed Higgs mass\n");
    fprintf(redfp, "      do 2530 ik     = 1 , ktblmx\n");
    cmsepar('=');
    fprintf(redfp, "C     Put parameters for Paw.\n");
    cmsepar('=');
    fprintf(redfp, " 9508 format(\n");
    fprintf(redfp, "     . 'opt logy'/'opt utit'/\n");
    fprintf(redfp, "     . 'set xsiz 13.0'/'set ysiz 13.0'/\n");
    fprintf(redfp, "     . 'set ymgu  0.5'/'set xmgl  2.2'/\n");
    fprintf(redfp, "     . 'set ymgl  1.3'/'set xmgr  0.3'/\n");
    fprintf(redfp, "     . 'set xwin  2.5'/\n");
    fprintf(redfp, "     . 'set xlab  1.5'/'set ylab  0.8'/\n");
    fprintf(redfp, "     . 'set asiz  0.3'/'set vsiz  0.2'/\n");
    fprintf(redfp, "     . 'set chhe 0.3'/\n");
    fprintf(redfp, "     . 'zone 2 2'/'set pass 5'/\n");
    fprintf(redfp, "     . '*')\n");
    fprintf(redfp, "*     print *,' do 2530 ik ... ',ik\n");
    fprintf(redfp, "      write(lukmac,6021) ('-',k=1,71),ktbl(ik),('-',k=1,71)\n");
    fprintf(redfp, " 6021 format('*',71a/'*   ID in BASES/SPRING = ',i2,/'*',71a)\n");
    fprintf(redfp, "      write(lukmac,9503) ik\n");
    fprintf(redfp, " 9503 format(\n");
    fprintf(redfp, "     .    'label',i2.2,':'/\n");
    fprintf(redfp, "     .    'hi/file 1  dsdx.hbook')\n");
    fprintf(redfp, "      write(lukmac,9508)\n");
    fprintf(redfp, "      if( ik .gt. 1 ) write(lukmac,6026)\n");
    fprintf(redfp, " 6026 format('clr')\n");
    fprintf(redfp, "      write(lukmac,6024) ik\n");
    fprintf(redfp, " 6024 format('fortran/file 66 dsdx',i2.2,'.ps'/\n");
    fprintf(redfp, "     .       'metafile 66 -133')\n");
    fprintf(redfp, "      do 2520 ie     = 0 , maxenp\n");
    fprintf(redfp, "*         print *,' do 2520 ie ... ',ie\n");
    fprintf(redfp, "          sum = 0.0d0\n");
    fprintf(redfp, "          do 2501 ih = 0 , ihflag_max\n");
    fprintf(redfp, "             sum = sum + energy(ie,ih)\n");
    fprintf(redfp, " 2501     continue\n");
    fprintf(redfp, "          if( sum .eq. 0.0d0 ) goto 2520\n");
    fprintf(redfp, "          ifirst = 0\n");
    fprintf(redfp, "          do 2510 ih= 0 , ihflag_max\n");
    fprintf(redfp, "             id = ie*1000 + ih*100 + ktbl(ik)\n");
    fprintf(redfp, "             if( hexist(id) ) then\n");
    fprintf(redfp, "                 if( ifirst .eq. 0 ) then\n");
    fprintf(redfp, "                     dmax = dble(hmax(id))\n");
    fprintf(redfp, "                     dmin = dble(hmin(id))\n");
    fprintf(redfp, "                     ifirst = 1\n");
    fprintf(redfp, "                 else\n");
    fprintf(redfp, "                     if( dble(hmax(id)) .gt. dmax )\n");
    fprintf(redfp, "     .                   dmax = dble(hmax(id))\n");
    fprintf(redfp, "                     if( dble(hmin(id)) .gt. dmin )\n");
    fprintf(redfp, "     .                   dmin = dble(hmin(id))\n");
    fprintf(redfp, "                 endif\n");
    fprintf(redfp, "             endif\n");
    fprintf(redfp, "*         print *,'id,max,min',id,dsdxmx,dsdxmn\n");
    fprintf(redfp, " 2510 continue\n");
    fprintf(redfp, "          ilmax = int(log10(dmax))\n");
    fprintf(redfp, "          if( dmax .gt. 1.d0 ) ilmax = ilmax + 1\n");
    fprintf(redfp, "          ilmin = int(log10(dmin))\n");
    fprintf(redfp, "          if( dmin .lt. 1.d0 ) ilmin = ilmin - 1\n");
    fprintf(redfp, "          write(lukmac,6005) 10.**ilmin,10.**ilmax\n");
    fprintf(redfp, "          ycor  = ilmin + ypos(0)*(ilmax-ilmin)\n");
    fprintf(redfp, "          ycorl = 10.**ycor\n");
    fprintf(redfp, "          write(lukmac,6002) ycorl,calph(ie),int(energy(ie,0))\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, "          do 2515 ih= 0 , ihflag_max\n");
    fprintf(redfp, "             id = ie*1000 + ih*100 + ktbl(ik)\n");
    fprintf(redfp, "             if( hexist(id) ) then\n");
    fprintf(redfp, "             write(lukmac,6003) \n");
    fprintf(redfp, "     .             ('-',k=1,35),\n");
    fprintf(redfp, "     .             int(energy(ie,0)),hmas(ih),\n");
    fprintf(redfp, "     .             ('-',k=1,35),\n");
    fprintf(redfp, "     .             3-ih,iplci(ih),ihtyp(ih),\n");
    fprintf(redfp, "     .             id,cover(1)\n");
    fprintf(redfp, " 6003        format(\n");
    fprintf(redfp, "     .       '*',35a/\n");
    fprintf(redfp, "     .       '* Energy ',i4,' GeV: Higss ',a/\n");
    fprintf(redfp, "     .       '*',35a/\n");
    fprintf(redfp, "     .       '*set dmod ',I2/\n");
    fprintf(redfp, "     .       'set hcol ',I3/\n");
    fprintf(redfp, "     .       'set htyp ',I3/\n");
    fprintf(redfp, "     .       'hi/pl ',I10,' ',a)\n");
    fprintf(redfp, "             endif\n");
    fprintf(redfp, " 2515     continue\n");
    fprintf(redfp, "          write(lukmac,6004)\n");
    fprintf(redfp, " 6004 format('atitle ''cos[q]''  ''d[s]/dcos[q] (pb)''')\n");
    fprintf(redfp, "*     write(6,*) id\n");
    fprintf(redfp, " 2520 continue\n");
    fprintf(redfp, "*     write(6,*) 'next'\n");
    fprintf(redfp, "          \n");
    fprintf(redfp, "          write(lukmac,6022)\n");
    fprintf(redfp, "*         write(6,6022)\n");
    fprintf(redfp, "          do 2525 ih= 0 , ihflag_max\n");
    fprintf(redfp, "          write(lukmac,6023) (iplci(ih),k=1,2),ihtyp(ih),\n");
    fprintf(redfp, "     .        0.35-ih*0.1,0.40-ih*0.1,0.365-ih*0.1,mess(ih)\n");
    fprintf(redfp, " 2525     continue\n");
    fprintf(redfp, " \n");
    fprintf(redfp, " 6022 format(\n");
    fprintf(redfp, "     . 'opt liny'/'swn 1 0 1 0 1'/\n");
    fprintf(redfp, "     . 'selnt 1'/'igset bord 1'/)\n");
    fprintf(redfp, " 6023 format(\n");
    fprintf(redfp, "     . 'igset plci ',i3/'igset faci ',i3/\n");
    fprintf(redfp, "     . 'igset fasi ',i3/\n");
    fprintf(redfp, "     . 'box 0.65 0.7 ',f6.3,' ',f6.3/\n");
    fprintf(redfp, "     . 'text 0.75 ',f6.3,' ''',a,''' 0.015')\n");
    fprintf(redfp, "        write(lukmac,6025)\n");
    fprintf(redfp, " 6025 format(\n");
    fprintf(redfp, "     .      'close 1'/\n");
    fprintf(redfp, "     .      'close 66'/\n");
    fprintf(redfp, "     .      'exitm')\n");
    fprintf(redfp, " 2530 continue\n");
    fprintf(redfp, "      write(lukmac,6027)\n");
    fprintf(redfp, " 6027 format(\n");
    fprintf(redfp, "     .   'return'/\n");
    fprintf(redfp, "     .   '*----- end of macro -----*')\n");
    fprintf(redfp, " 6005 format('null -1.0 1.0 ',E15.7,' ',E15.7)\n");
    fprintf(redfp, " 6002 format('text    -0.75 ',E15.7,' ''(',a,') W = ',I4,' GeV'' 0.2')\n");
    fprintf(redfp, "      close(lukmac)\n");
    fprintf(redfp, "      stop\n");
    fprintf(redfp, "      end\n");
}
/*==================================================================*/
Private Void    cmtest(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    pindex p, pa;
    int    n;

    if(lang == ROFORT)
        cmopen(ROFORT, "gauge.f");
    else
        cmopen(ROFORT, "test.f");

    cmsepar('*');
    fprintf(redfp,"* main program for test\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if(lang == ROFORT) {
        fprintf(redfp,"      include 'incl1.f'\n");
        fprintf(redfp,"      include 'incl2.f'\n");
    } else if(lang == ROREDA) {
        fprintf(redfp,"      include 'incl1.f'\n");
    } else {
        fprintf(redfp,"      include 'incomm.f'\n");
    }
    fprintf(redfp,"      include 'inclk.f'\n");
    putc(EOL, redfp);

    if( basesv == 0 )
        fprintf(redfp, "      parameter ( mxdim = 50 )\n");
    else
        fprintf(redfp, "      parameter ( mxdim = 100 )\n");
    fprintf(redfp, "      common / loop0 / loop\n");
    fprintf(redfp, "      common / bparm1 / xl(mxdim),xu(mxdim),");
    fprintf(redfp,       "ndim,nwild,\n");
    fprintf(redfp, "     &                 ig(mxdim),ncall\n");
    fprintf(redfp, "      common / bparm2 / acc1,acc2,itmx1,itmx2\n");
    fprintf(redfp, "      common / knmflg / knmgvs,knmhst,knmsph,");
    fprintf(redfp, "knmisr\n");
    putc(EOL, redfp);

    fprintf(redfp, "      real*8   x(mxdim)\n");
    putc(EOL, redfp);

    cmuscom();

    cmsepar('-');
    fprintf(redfp,"      write(*,'(20x,a/)') 'grace   ver.   2. 0'");
    fprintf(redfp,"\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"      write(*,'(5x,a/)')\n");
    fprintf(redfp,"     .'Process: ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp, " --> ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n");

    cmsepar('-');
    fprintf(redfp,"      call bsinit\n");
    putc(EOL, redfp);

    fprintf(redfp,"      wgt    = 1.0d0\n");
    fprintf(redfp,"      loop   = 1\n");
    fprintf(redfp,"      knmgvs = 1\n");
    fprintf(redfp,"      knmhst = 0\n");
    fprintf(redfp,"      knmsph = 0\n");
    fprintf(redfp,"      knmisr = 0\n");
    fprintf(redfp,"      call bsputw(wgt)\n");
    putc(EOL, redfp);

    fprintf(redfp,"      call userin( 6 )\n");
    putc(EOL, redfp);

    for(p = 0; p < nmtable[N_WIDTH]; p++) {
        if(mtable[N_WIDTH][p][0] == '0')
            continue;
        fprintf(redfp,"      %6s = 0.0d0\n", mtable[N_WIDTH][p]);
    }
    putc(EOL, redfp);

    fprintf(redfp,"      call bschck\n");
    putc(EOL, redfp);

    fprintf(redfp,"      call prmass\n");
    putc(EOL, redfp);

    fprintf(redfp,"ct    do 100 many x's\n");
    putc(EOL, redfp);

    fprintf(redfp,"      do 10 i = 1, ndim\n");
    fprintf(redfp,"        x(i) = 0.45d0\n");
    fprintf(redfp,"   10 continue\n");
    putc(EOL, redfp);

    if(lang == ROFORT || lang == ROREDA ) {
        fprintf(redfp, "* graph selection\n");
        fprintf(redfp, "      do 20 ng = 1, ngraph\n");
        fprintf(redfp, "        jselg(ng) = 1\n");
        fprintf(redfp, "   20 continue\n\n");
    } else {
        fprintf(redfp, "* graph selection\n");
        fprintf(redfp, "      do 20 n2 = 1, ng0\n");
        fprintf(redfp, "      do 20 n1 = 1, ng0\n");
        fprintf(redfp, "        jsel0(n1, n2) = 1\n");
        fprintf(redfp, "   20 continue\n\n");
        fprintf(redfp, "      do 30 n2 = 1, ng0\n");
        fprintf(redfp, "      do 30 n1 = 1, ng1\n");
        fprintf(redfp, "        jsel1(n1, n2) = 1\n");
        fprintf(redfp, "   30 continue\n\n");
    }

    if(lang == ROFORT || lang == ROREDA) {
        fprintf(redfp,"      write(*,*) 'integration variables'\n");
        fprintf(redfp,"      write(*,*) 'x     = ', (x(i),i=1,ndim)\n");
        putc(EOL, redfp);

        fprintf(redfp, "      write(*,*) 'graph selection flags'\n");
        fprintf(redfp, "      write(*,*) 'jselg = ', jselg\n");
        fprintf(redfp,"\n");

        if(lang == ROFORT) {
            fprintf(redfp,"*   Unitary gauge\n");
            fprintf(redfp,"      igauab = 0\n");
            fprintf(redfp,"      igauwb = 0\n");
            fprintf(redfp,"      igauzb = 0\n");
            fprintf(redfp,"      igaugl = 0\n");
            fprintf(redfp,"\n");
            fprintf(redfp,"      agauge(0) = 1.0d20\n");
            fprintf(redfp,"\n");
        } else if(lang == ROREDA) {
            fprintf(redfp,"*   Feynman gauge\n");
            fprintf(redfp,"      igauab = 1\n");
            fprintf(redfp,"      igauwb = 2\n");
            fprintf(redfp,"      igauzb = 3\n");
            fprintf(redfp,"      igaugl = 4\n");
            fprintf(redfp,"\n");
            fprintf(redfp,"      agauge(igauab) = 1.0d0\n");
            fprintf(redfp,"      agauge(igauwb) = 1.0d0\n");
            fprintf(redfp,"      agauge(igauzb) = 1.0d0\n");
            fprintf(redfp,"      agauge(igaugl) = 1.0d0\n");
            fprintf(redfp,"\n");
        }


        fprintf(redfp,"      write(*,*) 'igauab = ', igauab, ' agauge = ");
        fprintf(redfp,"',agauge(igauab)\n");
        fprintf(redfp,"      write(*,*) 'igauwb = ', igauwb, ' agauge = ");
        fprintf(redfp,"',agauge(igauwb)\n");
        fprintf(redfp,"      write(*,*) 'igauzb = ', igauzb, ' agauge = ");
        fprintf(redfp,"',agauge(igauzb)\n");
        fprintf(redfp,"      write(*,*) 'igaugl = ', igaugl, ' agauge = ");
        fprintf(redfp,"',agauge(igaugl)\n");
    } else {
        fprintf(redfp,"      write(*,*) 'integration variables'\n");
        fprintf(redfp,"      write(*,*) 'x     = ', (x(i),i=1,ndim)\n");
        putc(EOL, redfp);

        fprintf(redfp, "      write(*,*) 'graph selection flags'\n");
        fprintf(redfp, "      write(*,*) '  tree -- tree'\n");
        fprintf(redfp, "      do 40 n1 = 1, ng0\n");
        fprintf(redfp, "        write(*,*) n1, ':', ");
        fprintf(redfp,          "(jsel0(n1, n2), n2 = 1, ng0)\n");
        fprintf(redfp, "   40 continue\n\n");
        fprintf(redfp, "      write(*,*) '  1 loop -- tree'\n");
        fprintf(redfp, "      do 50 n1 = 1, ng1\n");
        fprintf(redfp, "        write(*,*) n1, ':', ");
        fprintf(redfp,          "(jsel1(n1, n2), n2 = 1, ng1)\n");
        fprintf(redfp, "   50 continue\n\n");
    }
    fprintf(redfp,"      aaa = func(x)\n");
    fprintf(redfp,"      write(*,*) '  ans1   = ',aaa\n");
    fprintf(redfp,"      write(*,*) '# graphs = ',jgraph\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"      call usrout\n");
    fprintf(redfp,"\n");

    if(lang != ROFORT) {
        fprintf(redfp,"ct100 continue\n");
        fprintf(redfp,"      end\n");
        return;   
    }
/* CF */
/*    if( colorv == 0 ) {*/
    fprintf(redfp,"      fkcall = 0\n");
    fprintf(redfp,"      nkcall = 0\n");
    fprintf(redfp,"      do 30 i = 0, jgraph\n");
    fprintf(redfp,"   30     ansp(i) = 0\n");
    fprintf(redfp,"\n");
/*    }*/

    fprintf(redfp,"*   Covariant gauge\n");
    fprintf(redfp,"      igauab = 1\n");
    fprintf(redfp,"      igauwb = 2\n");
    fprintf(redfp,"      igauzb = 3\n");
    fprintf(redfp,"      igaugl = 4\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"      agauge(igauab) = 2.0d0\n");
    fprintf(redfp,"      agauge(igauwb) = 3.0d0\n");
    fprintf(redfp,"      agauge(igauzb) = 4.0d0\n");
    fprintf(redfp,"      agauge(igaugl) = 5.0d0\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"      write(*,*) 'x     = ', (x(i),i=1,ndim)\n");
    fprintf(redfp,"      write(*,*) 'jselg = ', jselg\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"      write(*,*) 'igauab = ', igauab, ' agauge = ");
    fprintf(redfp,"',agauge(igauab)\n");
    fprintf(redfp,"      write(*,*) 'igauwb = ', igauwb, ' agauge = ");
    fprintf(redfp,"',agauge(igauwb)\n");
    fprintf(redfp,"      write(*,*) 'igauzb = ', igauzb, ' agauge = ");
    fprintf(redfp,"',agauge(igauzb)\n");
    fprintf(redfp,"      write(*,*) 'igaugl = ', igaugl, ' agauge = ");
    fprintf(redfp,"',agauge(igaugl)\n");
    fprintf(redfp,"      bbb = func(x)\n");
    fprintf(redfp,"      write(*,*) '  ans2     = ',bbb\n");
    fprintf(redfp,"      write(*,*) '# graphs = ',jgraph\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"      call usrout\n");
    putc(EOL, redfp);

/* CF */
/*    if( colorv == 0 ) {*/
    fprintf(redfp,"      fkcall = 0\n");
    fprintf(redfp,"      nkcall = 0\n");
    fprintf(redfp,"      do 40 i = 0, jgraph\n");
    fprintf(redfp,"   40     ansp(i) = 0\n");
    fprintf(redfp,"\n");
/*    }*/

    fprintf(redfp,"      write(*,'(''1'',72a1)') ('=', i = 1, 72)\n");
    fprintf(redfp,"      write(*,*) '  ans1   = ',aaa\n");
    fprintf(redfp,"      write(*,*) '  ans2   = ',bbb\n");
    fprintf(redfp,"      if(bbb.ne.0) then\n");
    fprintf(redfp,"        write(*,*) '  ans1/ans2 - 1 = ', aaa/bbb - ");
    fprintf(redfp,"1\n");

    fprintf(redfp,"      else\n");
    fprintf(redfp,"        write(*,*) 'ans1 = ', aaa,'  ans2 =', ");
    fprintf(redfp,"bbb\n");
    fprintf(redfp,"      endif\n");
    putc(EOL, redfp);

    fprintf(redfp,"ct100 continue\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmprms(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    int p, s, l, i, n0, n1, j, nc, k, lp;
    string m;

    cmopen(ROFORT, "prmass.f");

    cmsepar('*');
    fprintf(redfp,"      subroutine prmass\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if(lang == ROFORT || lang == ROREDA)
        fprintf(redfp,"      include 'incl1.f'\n");
    else
        fprintf(redfp,"      include 'incomm.f'\n");
    fprintf(redfp,"      include 'inclk.f'\n");
    putc(EOL, redfp);

    fprintf(redfp,"* spin average factor\n");
    if(lang != ROFORT && lang != ROREDA) {
        fprintf(redfp, "      common /amspin/aspin\n");
    }

    /* mass */
    cmsepar('-');
    fprintf(redfp,"      write(*,*) '+++ mass +++'\n");
    for(p = 1; p < nptable; p++) {
        m = ptable[p]->mass;
        if(strcmp(m,"0") == 0) {
            continue;
        }
        fprintf(redfp,"      write(*,*) '   %6s = ', %6s\n", m, m);
    }
    putc(EOL, redfp);

    /* width */
    cmsepar('-');
    fprintf(redfp,"      write(*,*) '+++ width +++'\n");
    for(p = 1; p < nptable; p++) {
        m = ptable[p]->width;
        if(m == NULL || strcmp(m,"0") == 0) {
            continue;
        }
        fprintf(redfp,"      write(*,*) '   %6s = ', %6s\n", m, m);
    }
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp,"      write(*,*) '+++ coupling constants +++'\n");
    fprintf(redfp,"      write(*,*) '     cqed = ',      cqed\n");
    fprintf(redfp,"      write(*,*) '     cqcd = ',      cqcd\n");

    if(lang == ROFORT || lang == ROREDA ) {
        for(lp = 0; lp < 1; lp++) {
            for(p = nvstart; p < nvtable; p++) {
                if(vtable[p]->loop > lp)
                    continue;    
                if(p != pvvnfind(p))
                    continue;
                Discard cmcoupl(p, 0, lp, momstr);
                fprintf(redfp,"      write(*,*) '%9s = ', %9s\n",
                        momstr, momstr);
            }
        }
    } else {
        for(lp = 0; lp < 2; lp++) {
            for(p = nvstart; p < nvtable; p++) {
                if(vtable[p]->loop > lp)
                    continue;    
                Discard cmcoupl(p, 0, lp, momstr);
                fprintf(redfp,"      write(*,*) '%9s = ', %9s\n",
                        momstr, momstr);
                Discard cmcoupl(p, -2, lp, momstr);
                fprintf(redfp,"      write(*,*) '%9s = ', %9s\n",
                        momstr, momstr);
            }
    
            if(lp == 0) {
                fprintf(redfp,"\n      if(lloop.gt.0) then\n\n");
            } else {
                fprintf(redfp,"\n      endif\n\n");
            }
        }
    }
    putc(EOL, redfp);
    fprintf(redfp,"      write(*,*) '   aspin   = ', aspin\n");

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}


/*==================================================================*/
Private Void    cmdmmy(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    cmopen(ROFORT, "bdummy.f");

    cmsepar('*');
    fprintf(redfp,"* dummy routines\n");
    putc(EOL, redfp);
    fprintf(redfp,"      subroutine bsinit\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");

    putc(EOL, redfp);
    fprintf(redfp,"      subroutine bschck\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmuserin(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    int    n, n0, n1, p;
    tnode  *nd;
    tleg   *lg;

    cmopen(ROFORT, "userin.f");

    cmsepar('*');
    fprintf(redfp,"      subroutine userin( lu )\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if( vcode )
        fprintf(redfp,"      include 'inclvs.f'\n");
    if(lang == ROFORT || lang == ROREDA) {
        fprintf(redfp,"      include 'incl1.f'\n");
    } else {
        fprintf(redfp,"      include 'incomm.f'\n");
    }

    cmuscom();

    cmsepar('=');
    fprintf(redfp,"*          parameters for amplitude calculation\n");
    cmsepar('=');
    putc(EOL, redfp);

    fprintf(redfp,"*         ============= Set global parameters\n");
    fprintf(redfp,"           call usrprm\n");
    fprintf(redfp,"*         =============\n");
    putc(EOL, redfp);

    fprintf(redfp,"*         ============= default mass and width\n");
    fprintf(redfp,"           call setmas\n");
    fprintf(redfp,"*         =============\n");
    putc(EOL, redfp);

    fprintf(redfp,"*         ============= modification of mass and width\n");
    fprintf(redfp,"           call modmas\n");
    fprintf(redfp,"*         =============\n");
    putc(EOL, redfp);

    fprintf(redfp,"*         ============= coupling constants\n");
    fprintf(redfp,"           call amparm\n");
    fprintf(redfp,"*         =============\n");
    putc(EOL, redfp);

    cmsepar('=');
    fprintf(redfp,"*          initialization of kinematics\n");
    cmsepar('=');
    putc(EOL, redfp);

    if( !jqedps ) {
    fprintf(redfp,"*         ================= \n");
    fprintf(redfp,"           call kinit( lu )\n");
    fprintf(redfp,"*         =================\n");
    } else {
      fprintf(redfp,"          if( jqedps .eq. 0 ) then\n");
      fprintf(redfp,"*             ================= \n");
      fprintf(redfp,"              call kinit( lu )\n");
      fprintf(redfp,"*             =================\n");
      fprintf(redfp,"          else\n");
      fprintf(redfp,"*             ================= \n");
      fprintf(redfp,"              call kinitq( lu )\n");
      fprintf(redfp,"*             =================\n");
      fprintf(redfp,"          endif\n");
    }
    if(!gm2 && maxloop > 0) {
        fprintf(redfp,"           call cterms\n");
        fprintf(redfp,"*         ============ \n");
        putc(EOL, redfp);
    }

    cmsepar('=');
    fprintf(redfp,"*          initialization of summary table\n");
    cmsepar('=');
    putc(EOL, redfp);

/* CF */
    if( colorv == 0 ) {
    if(lang == ROFORT || lang == ROREDA) {
        fprintf(redfp,"           do 300 igr = 0, ngraph\n");
        if( !vcode ) {
            fprintf(redfp,"             ansp(igr) = 0.0d0\n");
        } else {
            fprintf(redfp,"           do 300 j = 1, nsize\n");
            fprintf(redfp,"              ansp(j,igr) = 0.0d0\n");
        }
        fprintf(redfp,"  300      continue\n");
        fprintf(redfp,"           fkcall = 0\n");
        fprintf(redfp,"           nkcall = 0\n");
        putc(EOL, redfp);
    }
    }

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmuscom(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    int ng0, ng1;

    if(lang != ROFORT && lang != ROREDA ){
        ng0 = max(reprocg[0], 1);
        ng1 = max(reprocg[1], 1);
    
        fprintf(redfp,"* table of amplitudes\n");
        fprintf(redfp,"      parameter (ng0 = %d, ng1 = %d)\n", ng0, ng1);
        fprintf(redfp,"      common /amslct/");
        fprintf(redfp,      "jgraph, jsel0(ng0,ng0),jsel1(ng1,ng0)\n");
        putc(EOL, redfp);
    }
    fprintf(redfp,"\n* Spin average factor\n");
    if(lang != ROFORT && lang != ROREDA) {
        fprintf(redfp, "      common /amspin/aspin\n");
    }
    putc(EOL, redfp);
}

/*==================================================================*/
Private Void    cmeps(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{

    cmopen(ROFORT, "eps.f");

    fprintf(redfp, "***************************************");
    fprintf(redfp,       "*********************************\n");
    fprintf(redfp, "      function eps(p1, p2, p3, p4)\n");
    fprintf(redfp, "      implicit real*8(a-h,o-z)\n");
    fprintf(redfp, "      real*8   eps\n");
    putc(EOL, redfp);

    fprintf(redfp, "      real*8   p1(4), p2(4), p3(4), p4(4)\n");
    putc(EOL, redfp);

    fprintf(redfp, "*======================================");
    fprintf(redfp,       "=================================\n");
    fprintf(redfp, "*          initialization\n");
    fprintf(redfp, "*======================================");
    fprintf(redfp,       "=================================\n");
    putc(EOL, redfp);

    fprintf(redfp, "      de4=\n");
    fprintf(redfp, "     & +p1(4)*p2(3)*p3(2)*p4(1)\n");
    fprintf(redfp, "     & -p1(4)*p2(3)*p3(1)*p4(2)\n");
    fprintf(redfp, "     & -p1(4)*p2(2)*p3(3)*p4(1)\n");
    fprintf(redfp, "     & +p1(4)*p2(2)*p3(1)*p4(3)\n");
    fprintf(redfp, "     & +p1(4)*p2(1)*p3(3)*p4(2)\n");
    fprintf(redfp, "     & -p1(4)*p2(1)*p3(2)*p4(3)\n");
    fprintf(redfp, "      de3=\n");
    fprintf(redfp, "     & -p1(3)*p2(4)*p3(2)*p4(1)\n");
    fprintf(redfp, "     & +p1(3)*p2(4)*p3(1)*p4(2)\n");
    fprintf(redfp, "     & +p1(3)*p2(2)*p3(4)*p4(1)\n");
    fprintf(redfp, "     & -p1(3)*p2(2)*p3(1)*p4(4)\n");
    fprintf(redfp, "     & -p1(3)*p2(1)*p3(4)*p4(2)\n");
    fprintf(redfp, "     & +p1(3)*p2(1)*p3(2)*p4(4)\n");
    fprintf(redfp, "      de2=\n");
    fprintf(redfp, "     & +p1(2)*p2(4)*p3(3)*p4(1)\n");
    fprintf(redfp, "     & -p1(2)*p2(4)*p3(1)*p4(3)\n");
    fprintf(redfp, "     & -p1(2)*p2(3)*p3(4)*p4(1)\n");
    fprintf(redfp, "     & +p1(2)*p2(3)*p3(1)*p4(4)\n");
    fprintf(redfp, "     & +p1(2)*p2(1)*p3(4)*p4(3)\n");
    fprintf(redfp, "     & -p1(2)*p2(1)*p3(3)*p4(4)\n");
    fprintf(redfp, "      de1=\n");
    fprintf(redfp, "     & -p1(1)*p2(4)*p3(3)*p4(2)\n");
    fprintf(redfp, "     & +p1(1)*p2(4)*p3(2)*p4(3)\n");
    fprintf(redfp, "     & +p1(1)*p2(3)*p3(4)*p4(2)\n");
    fprintf(redfp, "     & -p1(1)*p2(3)*p3(2)*p4(4)\n");
    fprintf(redfp, "     & -p1(1)*p2(2)*p3(4)*p4(3)\n");
    fprintf(redfp, "     & +p1(1)*p2(2)*p3(3)*p4(4)\n");
    fprintf(redfp, "      eps = de4 + de3 + de2 + de1\n");
    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
}

/*==================================================================*/
Private Void    cmfunc(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    int    n, n0, n1, p, l0, l1, lp;
    tnode  *nd;
    tleg   *lg;

    cmopen(ROFORT, "func.f");

    cmsepar('*');
    fprintf(redfp, "      function func(x)\n");
    fprintf(redfp, "      implicit real*8(a-h,o-z)\n");
    fprintf(redfp, "      real*8     func\n");
    putc(EOL, redfp);

    if(lang == ROFORT || lang == ROREDA ) {
        fprintf(redfp,"      include 'incl1.f'\n");
    } else {
        fprintf(redfp,"      include 'incomm.f'\n");
        fprintf(redfp,"      include 'inargs.f'\n");
    }
    putc(EOL, redfp);

    if( basesv == 0 )
        fprintf(redfp, "      parameter ( mxdim = 50 )\n");
    else
        fprintf(redfp, "      parameter ( mxdim = 100 )\n");
    fprintf(redfp, "      common / loop0 / loop\n");
    fprintf(redfp, "      common / bparm1 / xl(mxdim),xu(mxdim),");
    fprintf(redfp,       "ndim,nwild,\n");
    fprintf(redfp, "     &                 ig(mxdim),ncall\n");
    fprintf(redfp, "      common / bparm2 / acc1,acc2,itmx1,itmx2\n");
    putc(EOL, redfp);

    fprintf(redfp, "      real*8   x(mxdim)\n");
    putc(EOL, redfp);


    fprintf(redfp, "      common /amreg / mxreg\n");
    if(lang != ROFORT && lang != ROREDA) {
        fprintf(redfp, "      common /amspin/aspin\n");
    }
    fprintf(redfp, "      real*8     ansm, ans\n");
    putc(EOL, redfp);

    fprintf(redfp, "      real*8     xx(mxdim),p(4,nextn),");
    fprintf(redfp,       "pp(nextn,nextn)\n");
    fprintf(redfp, "      common /sp4vec/ vec(4,nextn)\n");
    cmsepar('=');
    fprintf(redfp, "*          initialization\n");
    cmsepar('=');
    putc(EOL, redfp);

    fprintf(redfp, "      ansum = 0.0d0\n");
    putc(EOL, redfp);

    fprintf(redfp, "      do  5 i = 1, ndim\n");
    fprintf(redfp, "         xx(i) = x(i)\n");
    fprintf(redfp, "    5 continue\n");
    putc(EOL, redfp);

    fprintf(redfp, "      nreg  = 1\n");
    fprintf(redfp, "      dft   = 0.d0\n");
    cmsepar('=');
    fprintf(redfp, "*          kinematics\n");
    cmsepar('=');
    putc(EOL, redfp);

    fprintf(redfp, "      do 1000 ireg = 1 , mxreg\n");
    putc(EOL, redfp);

    fprintf(redfp, "         if( ireg .gt. nreg ) go to 1000\n");
    putc(EOL, redfp);

    if( !jqedps ) {
    fprintf(redfp, "        call kinem(nextn, xx, p, pp, yacob,");
    fprintf(redfp,       "nreg,ireg,jump)\n");
    } else {
      fprintf(redfp, "      if( jqedps .eq. 0 ) then\n");
      fprintf(redfp, "        call kinem(nextn, xx, p, pp, yacob,");
      fprintf(redfp,       "nreg,ireg,jump)\n");
      fprintf(redfp, "      else\n");
      fprintf(redfp, "        call kinemq(nextn, xx, p, pp, yacob,");
      fprintf(redfp,       "nreg,ireg,jump)\n");
      fprintf(redfp, "      endif\n");
    }
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "*          reset the temporal buffer for ");
    fprintf(redfp,       "the region 1\n");
    cmsepar('-');
    fprintf(redfp, "      if( ireg .eq. 1 ) then\n");
    fprintf(redfp, "          dft = 0.d0\n");
    fprintf(redfp, "          do 180 k = 1, nextn\n");
    fprintf(redfp, "          do 180 j = 1, 4\n");
    fprintf(redfp, "             vec(j,k) = 0.d0\n");
    fprintf(redfp, "  180     continue\n");
    fprintf(redfp, "      endif\n");
    putc(EOL, redfp);

    fprintf(redfp, "         if( jump .ne. 0 ) go to 1000\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "*          for user's cut\n");
    cmsepar('-');
    putc(EOL, redfp);

    fprintf(redfp, "*--> call usrcut(jump)\n");
    fprintf(redfp, "*--> if( jump .ne. 0 ) goto 1000\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "*          four momenta of external particles\n");
    cmsepar('-');
    putc(EOL, redfp);

    fprintf(redfp, "      do 20 i = 1, 4\n");

    for(n = 0; n < nextern; n++) {
        nd  = ndnode(n);
        lg  = ndleg(n, 0);
        p   = abs(ndname(n));
        cmmom(momstr, n, 0, False);

        fprintf(redfp, "*     %d: %s %s mass=%s\n",
                n+1, eliorf(nd->nvkind), 
                pvename(nd->nvkind, lg->lgpart),
                ptable[p]->mass);

        if(lang == ROFORT || lang == ROREDA)
            fprintf(redfp, "      pe%d(i) = p(i, %d)\n", n+1, n+1);
        else
            fprintf(redfp, "      p%d(i) = p(i, %d)\n", n+1, n+1);

        putc(EOL, redfp);
    }
    fprintf(redfp, "   20 continue\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "*          inner products of momenta of ");
    fprintf(redfp,       "external particles\n");
    cmsepar('-');
    putc(EOL, redfp);

    if(lang == ROFORT || lang == ROREDA) {
        fprintf(redfp,"      do 30 j = 1, nextn\n");
        fprintf(redfp,"      do 30 i = 1, nextn\n");
        fprintf(redfp,"        prod(i, j) = pp(i, j)\n");
        fprintf(redfp,"   30 continue\n");
    } else {
        for(n0 = 1; n0 <= nextern; n0++) {
            for(n1 = 1; n1 <= nextern; n1++) {
                fprintf(redfp, "      e%de%d = pp(%d, %d)\n",
                        n0, n1, n0, n1);
            }
        }
    }
    fprintf(redfp,"\n");

    cmsepar('=');
    fprintf(redfp, "*          amplitude calculation\n");
    cmsepar('=');

    if(lang == ROFORT || lang == ROREDA){
        fprintf(redfp, "        call amptbl\n");
        fprintf(redfp, "*       ===================\n");
        fprintf(redfp, "        call ampsum(ansm)\n");
    } else {
        fprintf(redfp, "        ansm = 0.0d0\n");
        n = 0;
        for(lp = 0; lp <= maxloop; lp++) {
            for(l0 = lp0min(lp); l0 <= lp0max(lp); l0++) {
                l1 = lp - l0;         /* loop */
                n++;
                fprintf(redfp, "        call s%dx%d(ans%d)\n",
                        l0, l1, n);
                fprintf(redfp, "        ansm = ansm + ans%d\n", n);
            }
        }
    }
    fprintf(redfp, "*       ===================\n");
    putc(EOL, redfp);

    fprintf(redfp, "        fknorm = yacob*aspin\n");
    fprintf(redfp, "        ans    = ansm*fknorm\n");
    fprintf(redfp, "        ansum  = ansum + ans\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "*          save four momenta and probabilities ");
    fprintf(redfp,       "of the region 1\n");
    cmsepar('-');
    fprintf(redfp, "      if( ireg .eq. 1 ) then\n");
    fprintf(redfp, "          dft = ans\n");
    fprintf(redfp, "          do 420 k = 1, nextn\n");
    fprintf(redfp, "          do 420 j = 1, 4\n");
    fprintf(redfp, "             vec(j,k) = p(j,k)\n");
    fprintf(redfp, "  420     continue\n");
    fprintf(redfp, "      endif\n");
    putc(EOL, redfp);

    cmsepar('=');
    fprintf(redfp, "*          fill histograms and scatter plots\n");
    cmsepar('=');
    if( !jqedps ) {
      fprintf(redfp, "      call kfill(nextn, ndim, x, p, pp, ans)\n");
    } else {
      fprintf(redfp, "      if( jqedps .eq. 0 ) then\n");
      fprintf(redfp, "          call kfill (nextn, ndim, x, p, pp, ans)\n");
      fprintf(redfp, "      else\n");
      fprintf(redfp, "          call kfillq(nextn, ndim, x, p, pp, ans)\n");
      fprintf(redfp, "      endif\n");
    }

    cmsepar('=');
    fprintf(redfp, "*          update summary table\n");
    cmsepar('=');
    putc(EOL, redfp);
/* CF */
/*    if( colorv == 0 ) {*/
    if(lang == ROFORT || lang == ROREDA) {
        fprintf(redfp, "        call bsgetw(wgt)\n");
        fprintf(redfp, "        ansp(0) = ansp(0) + wgt*ans\n");
        fprintf(redfp, "        do 60 igr = 1, jgraph\n");
        fprintf(redfp, "          ansp(igr)=ansp(igr) + ");
        fprintf(redfp,       "wgt*yacob*aspin*ancp(igr)\n");
        fprintf(redfp, "   60   continue\n");
        fprintf(redfp, "        nkcall = nkcall + 1\n");
        fprintf(redfp, "        if(nkcall.gt.10000) then\n");
        fprintf(redfp, "          nkcall = nkcall - 10000\n");
        fprintf(redfp, "          fkcall = fkcall + 10000\n");
        fprintf(redfp, "        endif\n");
        putc(EOL, redfp);
    }
/*    }*/

    fprintf(redfp, " 1000 continue\n");
    putc(EOL, redfp);

    fprintf(redfp, "      func = ansum\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "*          put the final 4 vectors into ");
    fprintf(redfp,       "the arrays vec()\n");
    cmsepar('-');
    fprintf(redfp, "*     if( func .gt. 0.d0 ) then\n");
    fprintf(redfp, "*         if( dft/func .lt. drn(dum)) then\n");
    fprintf(redfp, "*             do 850 k = 1, nextn\n");
    fprintf(redfp, "*             do 850 j = 1, 4\n");
    fprintf(redfp, "*                vec(j,k) = p(j,k)\n");
    fprintf(redfp, "* 850         continue\n");
    fprintf(redfp, "*         endif\n");
    fprintf(redfp, "*     endif\n");
    putc(EOL, redfp);

    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
}

/*==================================================================*/
Private Void    cmvbfnct(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    int    n, n0, n1, p, l0, l1, lp;
    tnode  *nd;
    tleg   *lg;

    cmopen(ROFORT, "vbfnct.f");

    cmsepar('*');
    fprintf(redfp, "      subroutine vbfnct(func,nsampl,x,fx,wgt)\n");
    fprintf(redfp, "      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    fprintf(redfp,"      external func\n");
    fprintf(redfp,"      include 'inclvs.f'\n");
    if( basesv == 0 )
        fprintf(redfp, "      parameter ( mxdim = 50 )\n");
    else
        fprintf(redfp, "      parameter ( mxdim = 100 )\n");
    fprintf(redfp,"      real*8   wgt(nsize), x(nsize,mxdim), fx(nsize)\n");
    if(lang == ROFORT || lang == ROREDA ) {
        fprintf(redfp,"      include 'incl1.f'\n");
    } else {
        fprintf(redfp,"      include 'incomm.f'\n");
        fprintf(redfp,"      include 'inargs.f'\n");
    }
    putc(EOL, redfp);

    fprintf(redfp, "      common / loop0 / loop\n");
    fprintf(redfp, "      common / bparm1 / xl(mxdim),xu(mxdim),");
    fprintf(redfp,       "ndim,nwild,\n");
    fprintf(redfp, "     &                 ig(mxdim),ncall\n");
    fprintf(redfp, "      common / bparm2 / acc1,acc2,itmx1,itmx2\n");
    putc(EOL, redfp);

    putc(EOL, redfp);

    fprintf(redfp, "      common /amreg / mxreg\n");
    if(lang != ROFORT && lang != ROREDA) {
        fprintf(redfp, "      common /amspin/aspin\n");
    }
    putc(EOL, redfp);

    fprintf(redfp, "      real*8     ansm(nsize)\n");
    fprintf(redfp, "      real*8     p(nsize,4,nextn),");
    fprintf(redfp, "pp(nsize,nextn,nextn)\n");
    fprintf(redfp, "      real*8     yacob(nsize),dfx(nsize),");
    fprintf(redfp, "dft(nsize),rn(nsize)\n");
    fprintf(redfp, "      integer    nreg(nsize),jump(nsize),");
    fprintf(redfp, "l(nsize)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      common /sp4vec/ vec(nsize,4,nextn)\n");
    cmsepar('=');
    fprintf(redfp, "*          initialization\n");
    cmsepar('=');
    putc(EOL, redfp);

    fprintf(redfp, "      do 100 i = 1, nsampl\n");
    fprintf(redfp, "         fx(i)   = 0.0d0\n");
    fprintf(redfp, "         nreg(i) = 1\n");
    fprintf(redfp, "         dft(i)  = 0.0d0\n");
    fprintf(redfp, "  100 continue\n");
    fprintf(redfp, " \n");

    cmsepar('=');
    fprintf(redfp, "*          kinematics\n");
    cmsepar('=');
    putc(EOL, redfp);

    fprintf(redfp, "      do 1000 ireg = 1 , mxreg\n");
    putc(EOL, redfp);

    fprintf(redfp, "        call kinemv(nsampl, ndim, x, p, pp, ");
    fprintf(redfp,       "yacob, nreg, ireg, jump)\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "*          reset the temporal buffer for ");
    fprintf(redfp,       "the region 1\n");
    cmsepar('-');
    fprintf(redfp, "*     if( ireg .eq. 1 ) then\n");
    fprintf(redfp, "*       do 200 k = 1, nextn\n");
    fprintf(redfp, "*       do 200 j = 1, 4\n");
    fprintf(redfp, "*       do 200 i = 1, nsampl\n");
    fprintf(redfp, "*          vec(i,j,k) = 0.d0\n");
    fprintf(redfp, "* 200   continue\n");
    fprintf(redfp, "*       do 210 i = 1, nsampl\n");
    fprintf(redfp, "*          dft(i) = 0.d0\n");
    fprintf(redfp, "* 210   continue\n");
    fprintf(redfp, "*     endif\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "*          for user's cut ( jump(i) = 1 )\n");
    cmsepar('-');
    putc(EOL, redfp);

    fprintf(redfp, "*--> call usrcut(jump)\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "*      Gather the actual sampling points ");
    fprintf(redfp, "(MXLOOP : # of actual S.P.\n");
    cmsepar('-');
    fprintf(redfp, "        mxloop    = 0\n");
    fprintf(redfp, "        do 300 i  = 1, nsampl\n");
    fprintf(redfp, "           dfx(i) = 0.0d0\n");
    fprintf(redfp, "           if( jump(i) .eq. 0 ) then\n");
    fprintf(redfp, "               mxloop = mxloop + 1\n");
    fprintf(redfp, "               l(mxloop) = i\n");
    fprintf(redfp, "           endif\n");
    fprintf(redfp, "  300   continue\n");
    fprintf(redfp, " \n");
    fprintf(redfp, "        if( mxloop .le. 0 ) go to 1000\n");
    cmsepar('-');
    fprintf(redfp, "*          four momenta of external particles\n");
    cmsepar('-');
    putc(EOL, redfp);

    fprintf(redfp, "      do 400 j  = 1, 4\n");
    fprintf(redfp, "      do 400 i  = 1, mxloop\n");

    for(n = 0; n < nextern; n++) {
        nd  = ndnode(n);
        lg  = ndleg(n, 0);
        p   = abs(ndname(n));
        cmmom(momstr, n, 0, False);

        fprintf(redfp, "*     %d: %s %s mass=%s\n",
                n+1, eliorf(nd->nvkind), 
                pvename(nd->nvkind, lg->lgpart),
                ptable[p]->mass);

        if(lang == ROFORT || lang == ROREDA)
            fprintf(redfp, "      pe%d(i,j) = p(l(i), j, %d)\n",
                    n+1, n+1);
        else
            fprintf(redfp, "      p%d(i,j) = p(l(i), j, %d)\n",
                    n+1, n+1);

        putc(EOL, redfp);
    }
    fprintf(redfp, "  400 continue\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "*          inner products of momenta of ");
    fprintf(redfp,       "external particles\n");
    cmsepar('-');
    putc(EOL, redfp);

    if(lang == ROFORT || lang == ROREDA) {
        fprintf(redfp,"      do 410 k = 1, nextn\n");
        fprintf(redfp,"      do 410 j = 1, nextn\n");
        fprintf(redfp,"      do 410 i = 1, mxloop\n");
        fprintf(redfp,"         prod(i, j, k) = pp(l(i), j, k)\n");
        fprintf(redfp,"  410 continue\n");
    } else {
        for(n0 = 1; n0 <= nextern; n0++) {
            for(n1 = 1; n1 <= nextern; n1++) {
                fprintf(redfp, "      e%de%d(i) = pp(i, %d, %d)\n",
                        n0, n1, n0, n1);
            }
        }
    }
    fprintf(redfp,"\n");

    cmsepar('=');
    fprintf(redfp, "*          amplitude calculation\n");
    cmsepar('=');

    if(lang == ROFORT || lang == ROREDA){
        fprintf(redfp, "        call amptbl(mxloop)\n");
        fprintf(redfp, "*       ===================\n");
        fprintf(redfp, "        call ampsum(mxloop,ansm)\n");
    } else {
        fprintf(redfp, "        ansm = 0.0d0\n");
        n = 0;
        for(lp = 0; lp <= maxloop; lp++) {
            for(l0 = lp0min(lp); l0 <= lp0max(lp); l0++) {
                l1 = lp - l0;         /* loop */
                n++;
                fprintf(redfp, "        call s%dx%d(ans%d)\n",
                        l0, l1, n);
                fprintf(redfp, "        ansm = ansm + ans%d\n", n);
            }
        }
    }
    fprintf(redfp, "*       ===================\n");
    putc(EOL, redfp);

    fprintf(redfp, "*VOCL LOOP,SCALAR\n");
    fprintf(redfp, "        do 500 i=1, mxloop\n");
    fprintf(redfp, "           dfx(l(i)) = ansm(i)*yacob(l(i))");
    fprintf(redfp, "*aspin\n");
    fprintf(redfp, "           fx(l(i))  = fx(l(i)) + dfx(l(i))\n");
    fprintf(redfp, "  500   continue\n");
    fprintf(redfp, "*       fknorm = yacob*aspin\n");
    fprintf(redfp, "*       ans    = ansm*fknorm\n");
    fprintf(redfp, "*       ansum  = ansum + ans\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "*          save four momenta and probabilities ");
    fprintf(redfp,       "of the region 1\n");
    cmsepar('-');
    fprintf(redfp, "c        if( ireg .eq. 1 ) then\n");
    fprintf(redfp, "c            do 620 k = 1, nextn\n");
    fprintf(redfp, "c            do 620 j = 1, 4\n");
    fprintf(redfp, "c            do 620 i = 1, mxloop\n");
    fprintf(redfp, "c               vec(l(i),j,k) = p(l(i),j,k)\n");
    fprintf(redfp, "c 620        continue\n");
    fprintf(redfp, "c            do 630 i  = 1, nsampl\n");
    fprintf(redfp, "c               dft(i) = dfx(i)\n");
    fprintf(redfp, "c 630        continue\n");
    fprintf(redfp, "c        endif\n");
    fprintf(redfp, " \n");
    putc(EOL, redfp);

    cmsepar('=');
    fprintf(redfp, "*          fill histograms and scatter plots\n");
    cmsepar('=');
    fprintf(redfp, "      call kfillv(nsampl, nextn, ndim, x, p, pp, ");
    fprintf(redfp, "dfx)\n");

    cmsepar('=');
    fprintf(redfp, "*          update summary table\n");
    cmsepar('=');
    putc(EOL, redfp);
/* CF */
/*    if( colorv == 0 ) {*/
    if(lang == ROFORT || lang == ROREDA) {
       fprintf(redfp, "c       do 710 i  = 1, mxloop\n");
       fprintf(redfp, "c          ansp(l(i),0)   = ansp(l(i),0) + ");
       fprintf(redfp, "wgt(l(i))*dfx(l(i))\n");
       fprintf(redfp, "c 710   continue\n");
       fprintf(redfp, "c       do 720 igr = 1, jgraph\n");
       fprintf(redfp, "c       do 720 i   = 1, mxloop\n");
       fprintf(redfp, "c          ansp(l(i),igr) = ansp(l(i),igr)\n");
       fprintf(redfp, "c    .        +  wgt(l(i))*yacob(l(i))*aspin*");
       fprintf(redfp, "ancp(l(i),igr)\n");
       fprintf(redfp, "c 720   continue\n");
       fprintf(redfp, "*       do 810 i  = 1, nsampl\n");
       fprintf(redfp, "*          nkcall = nkcall + 1\n");
       fprintf(redfp, "*          if(nkcall.gt.10000) then\n");
       fprintf(redfp, "*             nkcall = nkcall - 10000\n");
       fprintf(redfp, "*             fkcall = fkcall + 10000\n");
       fprintf(redfp, "*          endif\n");
       fprintf(redfp, "* 810   continue\n");
       putc(EOL, redfp);
    }
/*    }*/

    fprintf(redfp, " 1000 continue\n");
    putc(EOL, redfp);


    cmsepar('-');
    fprintf(redfp, "*          put the final 4 vectors into ");
    fprintf(redfp,       "the arrays vec()\n");
    cmsepar('-');
    fprintf(redfp, "*     call vbrndm( 1, nsize, nsampl, rn )\n");
    fprintf(redfp, "*     do 900 i = 1, nsampl\n");
    fprintf(redfp, "*        l(i)  = 0\n");
    fprintf(redfp, "* 900 continue\n");
    fprintf(redfp, "*     mxloop   = 0\n");
    fprintf(redfp, "*     do 920 i = 1, nsampl\n");
    fprintf(redfp, "*        if( fx(i) .gt. 0.d0 ) then\n");
    fprintf(redfp, "*            if( dft(i)/fx(i) .lt. rn(i)) then\n");
    fprintf(redfp, "*                mxloop = mxloop + 1\n");
    fprintf(redfp, "*                l(mxloop) = i\n");
    fprintf(redfp, "*            endif\n");
    fprintf(redfp, "*        endif\n");
    fprintf(redfp, "* 920 continue\n");
    fprintf(redfp, "*     do 950 k = 1, nextn\n");
    fprintf(redfp, "*     do 950 j = 1, 4\n");
    fprintf(redfp, "*     do 950 i = 1, mxloop\n");
    fprintf(redfp, "*        vec(l(i),j,k) = p(l(i),j,k)\n");
    fprintf(redfp, "* 950 continue\n");
    putc(EOL, redfp);

    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
    cmsepar('=');
    fprintf(redfp, "      function func(x)\n");
    fprintf(redfp, "      implicit real*8(a-h,o-z)\n");
    fprintf(redfp, "      real*8     func\n");
    if( basesv == 0 )
        fprintf(redfp, "      parameter ( mxdim = 50 )\n");
    else
        fprintf(redfp, "      parameter ( mxdim = 100 )\n");
    fprintf(redfp, "      real*8   x(mxdim)\n");
    fprintf(redfp, "      func = 0.0d0\n");
    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
}
/*==================================================================*/
Private Void    cmsetmas(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    pindex p, pa;
    string m, v;
    int    n, lg, tp, il, c;
    tnode  *nd;
    tleg   *leg;

    cmopen(ROFORT, "setmas.f");

    cmsepar('*');
    fprintf(redfp, "      subroutine setmas\n");
    fprintf(redfp, "      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if( vcode )
        fprintf(redfp,"      include 'inclvs.f'\n");
    if(lang == ROFORT || lang == ROREDA)
        fprintf(redfp,"      include 'incl1.f'\n");
    else
        fprintf(redfp,"      include 'incomm.f'\n");
    fprintf(redfp,"      include 'inclk.f'\n");
    fprintf(redfp,"      common /chcntl/ jwidth\n");

    cmuscom();

    cmsepar('-');
    fprintf(redfp, "* constants\n");
    fprintf(redfp, "      pi    = acos(- 1.0d0 )\n");
    fprintf(redfp, "      pi2   = pi * pi\n");
    fprintf(redfp, "      rad   = pi / 180.0d0\n");
    fprintf(redfp, "      gevpb = 0.38937966d9\n");
    fprintf(redfp, "      alpha = 1.0d0/128.07d0\n");
    fprintf(redfp, "      alpha0= 1.0d0/137.0359895d0\n");
    fprintf(redfp, "*KEK  alphas= 0.123d0\n");
    fprintf(redfp, "      alphas= 0.12d0\n");
    fprintf(redfp, "\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "* graph selection\n");
    if(lang == ROFORT || lang == ROREDA){
        fprintf(redfp, "      do 10 n1 = 1, ngraph\n");
        fprintf(redfp, "        jselg(n1) = 1\n");
        fprintf(redfp, "   10 continue\n\n");
        fprintf(redfp, "      jgraph = 0\n");
    } else {
        fprintf(redfp, "      do 10 n2 = 1, ng0\n");
        fprintf(redfp, "      do 10 n1 = 1, ng0\n");
        fprintf(redfp, "        jsel0(n1, n2) = 1\n");
        fprintf(redfp, "   10 continue\n\n");
        fprintf(redfp, "      do 20 n2 = 1, ng0\n");
        fprintf(redfp, "      do 20 n1 = 1, ng1\n");
        fprintf(redfp, "        jsel1(n1, n2) = 1\n");
        fprintf(redfp, "   20 continue\n\n");
        fprintf(redfp, "      jgraph = 0\n");
    }
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp, "* mass\n");
    fprintf(redfp, "*\n");
    for(p = 1; p < nptable; p++) {
        m = ptable[p]->mass;
        if(strcmp(m,"0") == 0) {
            continue;
        }
        v = ptable[p]->mvalue;
        if(v == NULL)
            continue;
        fprintf(redfp,"      %6s = %s\n", m, v);
/*        fprintf(redfp,"      %5s2 = %s**2\n\n", m, m);*/
    }
    putc(EOL, redfp);
/* quark only (TI) */
    if( jqmas0 ) {

    fprintf(redfp, "* set quark mass = 1.d-5\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, "      if( jqmass .eq. 0 )then\n");
    fprintf(redfp, "*\n");

    for(p = 1; p < nptable; p++) {
        m = ptable[p]->mass;
        if(strcmp(m,"0") == 0) {
            continue;
        }
        v = ptable[p]->mvalue;
        if(v == NULL)
            continue;
        if( ptable[p]->kfcode > 0 && ptable[p]->kfcode < 10 ) {
            fprintf(redfp,"          %6s = 1.0d-5\n", m);
/*            printf(" quark %d %s \n",ptable[p]->kfcode,
            ptable[p]->mass);*/
        }
    }
    fprintf(redfp, "      endif\n");
    fprintf(redfp, "*\n");

    } /* end of jqmas0 */

    fprintf(redfp, "* width\n");
    fprintf(redfp, "\n");
    for(p = 1; p < nptable; p++) {
        m = ptable[p]->width;
        if(strcmp(m,"0") == 0) {
            continue;
        }
        v = ptable[p]->wvalue;
        if(v == NULL)
            continue;
        fprintf(redfp,"      %6s = %s\n", m, v);
    }
    putc(EOL, redfp);

    for(n = 0; n < nextern; n++) {
        pa  = ndname(n);
        p   = abs(pa);
        if(pa > 0)
            c =   ptable[p]->charge3;
        else
            c = - ptable[p]->charge3;
        if(ndiorf(n) == ELINITIAL)
            c *= ptable[p]->antip;
        fprintf(redfp, "      kcharg(%d) = %3d\n", n+1, c);
    }

    if(lang == ROFORT || lang == ROREDA){
        if(lang == ROFORT) {
        fprintf(redfp, "\n* Gauge parametes (default is unitary gauge)\n");
        for(n = 1; n < 5; n++)
            fprintf(redfp, "      igau%cb = 0\n", gchr[n]);
        for(n = 1; n < 5; n++)
            fprintf(redfp, "      agauge(igau%cb) = 1.0d0\n", gchr[n]);
        fprintf(redfp, "      agauge(igau00) = 1.0d0\n", gchr[n]);
        } else if(lang == ROREDA) {
        fprintf(redfp, "\n* Gauge parametes (default is Feynman gauge)\n");
        for(n = 1; n < 5; n++)
            fprintf(redfp, "      igau%cb = %d\n", gchr[n],n);
        for(n = 1; n < 5; n++)
            fprintf(redfp, "      agauge(igau%cb) = 1.0d0\n", gchr[n]);
        fprintf(redfp, "      agauge(igau00) = 1.0d0\n", gchr[n]);
        }

        fprintf(redfp, "\n* Spin average\n");
        fprintf(redfp, "      aspin = 1.0d0\n");
        for(n = 0; n < nextern; n++) {
            pa  = ndname(n);
            p   = abs(pa);
            il  = ndiline(n, 0);
            tp  = iltable[il].iltype;
            Discard cmindx(momstr, tp, p);
    
            fprintf(redfp, "\n");
            fprintf(redfp, "*     %d: %s %s mass=%s\n",
                    n+1, eliorf(ndiorf(n)), pvename(ndiorf(n),pa),
                    ptable[p]->mass);
    
            Discard cmindx(momstr1, tp, p);
            fprintf(redfp, "      jhs(%d) = 0\n", n+1);
            fprintf(redfp, "      jhe(%d) = %s - 1\n", n+1, momstr);
            if(ndiorf(n) == ELINITIAL) {
                fprintf(redfp, "      aspin = aspin/");
                fprintf(redfp, "dble(jhe(%d) - jhs(%d)+1)\n",
                        n+1, n+1);
            }
        }
        if(cpol) {
            for(n = 0; n < ndnodes(); n++) {
                if( n == 0 )
                    fprintf(redfp, "\n* Flag of cyclic polarization\n");
                if(ndtype(n) != NDEXTERN)
                    continue;
                if(cmphoton(n))
                    fprintf(redfp, "      jcpol(%d) = 0\n", n+1);
            }
        }
    } else {
        fprintf(redfp, "\n* Spin average\n");
        fprintf(redfp, "      aspin = 1.0d0");
        for(n = 0; n < nextern; n++) {
            nd  = ndnode(n);
            if(nd->nvkind == ELINITIAL) {
                p = abs(ndname(n));
                fprintf(redfp, "/%d.0d0", pvsdeg(p));
            }
        }
    }
    if( jtgamm ) {
    fprintf(redfp, "*     QED vertex with on-shell fermions.\n");
    fprintf(redfp, "      jtgamm = 0\n");
    }
    if( jano3v ) {
    fprintf(redfp, "*     Anomalous coupling for 3-vector-boson.\n");
    fprintf(redfp, "      jano3v = 0\n");
    }
    if( jcolmb ) {
    fprintf(redfp, "*     Coulomb correction.\n");
    fprintf(redfp, "      jcolmb = 0\n");
    }
    if( jqcdcr ) {
    fprintf(redfp, "*     QCD correction.\n");
    fprintf(redfp, "      jqcdcr = 0\n");
    }
    fprintf(redfp, "*     Private flag (Internal Higgs)\n");
    fprintf(redfp, "      jhiggs = 1\n");
    fprintf(redfp, "*     Private flag (Internal Gluon)\n");
    fprintf(redfp, "      jgluon = 0\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*     Private flag (Decay)\n");
    fprintf(redfp, "      jdecay = 0\n");
    fprintf(redfp, "*     Private flag (Hadronization)\n");
    fprintf(redfp, "      jhadrn = 1\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*     Running width (0) or fixed width(1) in CHANEL\n");
    fprintf(redfp, "      jwidth = 0\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
}

/*==================================================================*/
Private Void    cmusrprm1(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    cmopen(ROFORT, "usrprm.f");

    cmsepar('*');
    fprintf(redfp, "      subroutine usrprm\n");
    fprintf(redfp, "      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if( vcode )
        fprintf(redfp,"      include 'inclvs.f'\n");
    if(lang == ROFORT || lang == ROREDA)
        fprintf(redfp,"      include 'incl1.f'\n");
    else
        fprintf(redfp,"      include 'incomm.f'\n");
    fprintf(redfp,"      include 'inclk.f'\n");

    cmsepar('-');
    fprintf(redfp, "* \n");
    fprintf(redfp, "* Set global parameters.\n");
    fprintf(redfp, "* \n");
    if( jqmas0 ) {
        fprintf(redfp, "*     Set quark-mass = 0.(jqmass = 0 )\n");
        fprintf(redfp, "*     Default is massive.(jqmass = 1 )\n");
        fprintf(redfp, "      jqmass = 1\n");
    }
    if( jqedps ) {
        fprintf(redfp, "*     If QEDPS is used, jqedps = 1 )\n");
        fprintf(redfp, "      jqedps = 0\n");
    }
}
/*==================================================================*/
Private Void    cmusrprm2(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    FILE *outfp;
    if((outfp = fopen("usrprm.f", "a")) == NULL) {
        fprintf(Stderr, "*** incl1.f : open error\n");
        exit(FAIL);
    }

    fprintf(outfp, "\n");
    fprintf(outfp, "      return\n");
    fprintf(outfp, "      end\n");
    fclose(outfp);
}
/*==================================================================*/
Private Void    cmmodmas(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    cmopen(ROFORT, "modmas.f");

    cmsepar('*');
    fprintf(redfp, "      subroutine modmas\n");
    fprintf(redfp, "      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if( vcode )
        fprintf(redfp,"      include 'inclvs.f'\n");
    if(lang == ROFORT || lang == ROREDA)
        fprintf(redfp,"      include 'incl1.f'\n");
    else
        fprintf(redfp,"      include 'incomm.f'\n");
    fprintf(redfp,"      include 'inclk.f'\n");

    cmsepar('-');
    fprintf(redfp, "* \n");
    fprintf(redfp, "* modification of mass and width.\n");
    fprintf(redfp, "* \n");

    fprintf(redfp, "\n");
    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
}
/*==================================================================*/
Private Void    cmmodmasc(NoArg)
/*------------------------------------------------------------------*
 For Catalog Project
 *------------------------------------------------------------------*/
{
    cmopen(ROFORT, "modmasc.f");

    cmsepar('*');
    fprintf(redfp, "      subroutine modmas\n");
    fprintf(redfp, "*     re-define mass parameters for Catalogue ");
    fprintf(redfp, "Project. (1995 Aug)\n");
    cmsepar('*');
    fprintf(redfp, "      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if( vcode )
        fprintf(redfp,"      include 'inclvs.f'\n");
    if(lang == ROFORT || lang == ROREDA)
        fprintf(redfp,"      include 'incl1.f'\n");
    else
        fprintf(redfp,"      include 'incomm.f'\n");
    fprintf(redfp,"      include 'inclk.f'\n");
    fprintf(redfp, "      common /hgsflg/ ihflag\n");
    cmsepar('-');
    fprintf(redfp, "      print *, 'ihflag = ', ihflag\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      amh  =  100.0d0\n");
    fprintf(redfp, "      amh2 =  amh**2\n");
    fprintf(redfp, "*     agw  = 1.942d0\n");
    fprintf(redfp, "      agw  = 1.9437d0\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      agx   = agw\n");
    fprintf(redfp, "      agcp  = agw\n");
    fprintf(redfp, "      agcm  = agw\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      if( ihflag .eq. 0 ) then\n");
    fprintf(redfp, "          amh  =  100.0d0\n");
    fprintf(redfp, "          amh2 =  amh**2\n");
    fprintf(redfp, "          agh  = 5.0409d-3\n");
    fprintf(redfp, "      else if( ihflag .eq. 1 ) then\n");
    fprintf(redfp, "          amh  =  400.0d0\n");
    fprintf(redfp, "          amh2 =  amh**2\n");
    fprintf(redfp, "          agh  = 27.077d0\n");
    fprintf(redfp, "      else if( ihflag .eq. 2 ) then\n");
    fprintf(redfp, "          amh  = 2000.0d0\n");
    fprintf(redfp, "          amh2 =  amh**2\n");
    fprintf(redfp, "          agh  = 4000.0d0\n");
    fprintf(redfp, "          jhiggs = 0\n");
    fprintf(redfp, "      endif\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      amuq  =   5.0d-3\n");
    fprintf(redfp, "      amuq2 =  amuq**2\n");
    fprintf(redfp, "      amcq  =   1.3d0\n");
    fprintf(redfp, "      amcq2 =  amcq**2\n");
    fprintf(redfp, "      amtq  = 174.0d0\n");
    fprintf(redfp, "      amtq2 =  amtq**2\n");
    fprintf(redfp, "      amdq  =  10.0d-3\n");
    fprintf(redfp, "      amdq2 =  amdq**2\n");
    fprintf(redfp, "      amsq  = 200.0d-3\n");
    fprintf(redfp, "      amsq2 =  amsq**2\n");
    fprintf(redfp, "      ambq  =   4.3d0\n");
    fprintf(redfp, "      ambq2 =  ambq**2\n");
    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
}
/*==================================================================*/
Public  Void    cminclk(NoArg)
/*------------------------------------------------------------------*
 * generate "inclk.f"
 *------------------------------------------------------------------*/
{
    int p, i, mxlen;

    cmopen(ROFORT, "inclk.f");

    fprintf(redfp,"* masses and width of particles\n");
    /* common /ammass/... */
    puinit(redfp,"      common /ammass/",
                  "     &               ",
                  ",", ",", "", 72, 16);
    for(p = 0; p < nmtable[N_MASS]; p++) {
        sprintf(momstr,"%6s", mtable[N_MASS][p]);
        putid(momstr);
    }
    putend();
    putc(EOL, redfp);

    if(lang != ROFORT) {
        /* common /ammas2/... */
        puinit(redfp,"      common /ammas2/",
                      "     &               ",
                      ",", ",", "", 72, 16);
        for(p = 0; p < nmtable[N_MASS]; p++) {
            sprintf(momstr,"%6s2", mtable[N_MASS][p]);
            putid(momstr);
        }
        putend();
        putc(EOL, redfp);
    }

    /* common /amgmma/... */
    puinit(redfp,"      common /amgmma/",
                  "     &               ",
                  ",", ",", "", 72, 16);
    for(p = 0; p < nmtable[N_WIDTH]; p++) {
        if(mtable[N_WIDTH][p][0] == '0')
            continue;
        sprintf(momstr,"%6s", mtable[N_WIDTH][p]);
        putid(momstr);
    }
    putend();
    putc(EOL, redfp);

    /* common /amcnst/ */
    fprintf(redfp,"      common /amcnst/ pi, pi2, rad, gevpb, alpha, ");
    fprintf(redfp,"alphas, alpha0\n");

    /* common /amreg/ */
    fprintf(redfp,"      common /amreg / mxreg\n");

    /* common /amopts/ */
    if( minami ) {
    fprintf(redfp,"      common /amopts/ jtgamm, jano3v, jcolmb, ");
    fprintf(redfp,"jqcdcr\n");
    }
    /* common /amoptc/ */
    if( jcolmb )
        fprintf(redfp,"      common /amoptc/ colmbf\n");
    /* common /amoptm/ */
    if( jqmas0 )
        fprintf(redfp,"      common /amoptm/ jqmass\n");
    /* common /aman3v/ */
    if( jano3v )
    fprintf(redfp,"      common /aman3v/ andka, andkz, anlma, anlmz\n");

    if( jetset )
        fprintf(redfp,"      common /amoptj/ jdecay, jhadrn\n");
 
    fprintf(redfp,"\n* external particles name\n");
    fprintf(redfp,"      character*16    kmprtc\n");
    fprintf(redfp,"      common /kmprt1/ kmprtc(%d)\n",nextern);
    fprintf(redfp,"      common /kmprt2/ kmprtl(%d)\n",nextern);

    /* common /kmmass/ */
    fprintf(redfp,"\n* masses of external particles\n");
    fprintf(redfp,"      common /kmmass/ amass1(%d), amass2(%d)\n",
           nextern, nextern);
    fprintf(redfp,"\n* charge(*3) and KFcode of external particles\n");
    fprintf(redfp,"      common /kminfo/ kcharg(%d), kfcode(%d)\n",
           nextern,nextern);
/*    fprintf(redfp,"      common /tgamma/itapol\n");*/
    if( colorv == 1 && cbase->nbase > 0 ) {
        fprintf(redfp,"\n* Color string information\n");
        fprintf(redfp,"      common /kmcsti/ kmcbas, kmcbmx");

        if( cbase->nbase == 1 ) {
            if( cbase->nconid[0] > 0 )
                fprintf(redfp,", kmcstr(%d)",cbase->nconid[0]);
        } else if( cbase->nbase > 1 ) {
            mxlen = cbase->nconid[0];
            for( i = 1; i < cbase->nbase; i++) {
               if( cbase->nconid[i] > mxlen )
                   mxlen = cbase->nconid[i];
            }
            fprintf(redfp,", kmcstr(%d,0:%d)",mxlen,cbase->nbase-1);
        }
        fprintf(redfp,", icinfo(%d), icolst\n",nextern);
    }
}

/*==================================================================*/
Private Void    cmkinem(NoArg)
/*------------------------------------------------------------------*
 * copy kinit.f, kinem.f and kfill.f
 */
{
    if(cprocess->kinem == NULL) {
        printf("Kinem is not specified\n");
        cmfkinit();
        cmfkinem();
        if( !vcode )
            cmfkfill();
        else
            cmfkfillv();
    } else {
        if(!cmcpkin(cprocess->kinem, "kinit.f"))
            cmfkinit();
        if(!cmcpkin(cprocess->kinem, "kinem.f"))
            cmfkinem();
        if( jqedps ) {
            cmcpkin(cprocess->kinem, "kinitq.f");
            cmcpkin(cprocess->kinem, "kinemq.f");
            cmcpkin(cprocess->kinem, "kfillq.f");
        }
        if( !vcode ) {
            if(!cmcpkin(cprocess->kinem, "kfill.f"))
                cmfkfill();
        } else {
            if(!cmcpkin(cprocess->kinem, "kfillv.f"))
                cmfkfillv();
        }
    }
    if( vcode ) cmfkinemv();
}

/*==================================================================*/
Private bool    cmcpkin(subdir, fname)
string  subdir;
string  fname;
/*------------------------------------------------------------------*
 * copy a file from kinematics directory
 */
{
    string fullname;
    FILE   *fp;
    int c;

    fullname = pnfname("KINEMPATH", kinempath, subdir, fname);
    if(fullname == NULL)
        return False;

    if((fp = fopen(fullname, "r")) == NULL) {
        fprintf(Stderr, "*** cmcpkinem : open error %s\n", fullname);
        return False;
    }

    cmopen(ROFORT, fname);

    while((c = getc(fp)) != EOF) {
        putc(c, redfp);
    }

    printf("+++ \"%s\" is copied \n", fullname);

    return True;
}

/*==================================================================*/
Private Void    cmfkinit(NoArg)
/*------------------------------------------------------------------*
 * generate template of kinit.f
 */
{
    pindex p, pa;
    int    n,  tp, il;
    cmopen(ROFORT, "kinit.f");
    fprintf(redfp, "      subroutine kinit\n");
    fprintf(redfp, "      implicit real*8(a-h,o-z)\n\n");
    cmsepar('-');
    fprintf(redfp, "*     This subroutine is called by USERIN");
    fprintf(redfp, " and initilizes kinematics.\n");
    cmsepar('-');
    if( basesv == 0 )
        fprintf(redfp, "      parameter ( mxdim = 50 )\n");
    else
        fprintf(redfp, "      parameter ( mxdim = 100 )\n");
    fprintf(redfp, "      common / loop0 / loop\n");
    fprintf(redfp, "      common / bparm1 / ");
    fprintf(redfp, "xl(mxdim),xu(mxdim),ndim,nwild,\n");
    fprintf(redfp, "     &                 ig(mxdim),ncall\n");
    fprintf(redfp, "      common / bparm2 / acc1,acc2,itmx1,itmx2\n");
    fprintf(redfp, "      COMMON / kinem1 / s,w,fact\n");
    fprintf(redfp, "      common / knmflg /");
    fprintf(redfp, " knmgvs, knmhst, knmsph, knmisr\n\n");
    fprintf(redfp, "      include 'inclk.f'\n");
    fprintf(redfp, "      character xstr*14, dstr*24\n");
    fprintf(redfp, "*--- 1. inforamtion of Mass and width\n");

        for(n = 0; n < nextern; n++) {
            pa  = ndname(n);
            p   = abs(pa);
            il  = ndiline(n, 0);
            tp  = iltable[il].iltype;
            Discard cmindx(momstr, tp, p);
    
            fprintf(redfp, "*     %d: %s %s mass=%s\n",
                    n+1, eliorf(ndiorf(n)), pvename(ndiorf(n),pa),
                    ptable[p]->mass);
          }

    fprintf(redfp, "*--- 2. Initialize constants for kinematics.\n");
    fprintf(redfp, "*        User's parameters, i.e. beam energy, ");
    fprintf(redfp, "cut-off parameters etc.,\n");
    fprintf(redfp, "*        can be given here.\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, "*     S = (P1+P2)**2\n");
    fprintf(redfp, "*     W = SQRT(S)\n");
    cmsepar('-');
    fprintf(redfp, "      if( knmgvs .eq. 1 ) then\n");
    fprintf(redfp, "          w = 200.d0\n");
    fprintf(redfp, "      endif\n");
    fprintf(redfp, "      s = w*w\n\n\n");
    cmsepar('-');
    fprintf(redfp, "* Following flux factor is for a ");
    fprintf(redfp, "particle-antiparticle collision\n");
    fprintf(redfp, "* at s/m**2 >> 1. For an e-gamma collision ");
    fprintf(redfp, "or low energy interactions\n");
    fprintf(redfp, "* you should use appropriate formulae.\n");
    cmsepar('-');
    fprintf(redfp, "      vrel = 2.d0\n");
    fprintf(redfp, "      flux = vrel*s\n");
    fprintf(redfp, "      fact = gevpb/flux\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*--- 3. Set MXREG : the maximum number of ");
    fprintf(redfp, "values which are returned \n");
    fprintf(redfp, "*       by FUNC for one phase space point\n\n");
    fprintf(redfp, "      mxreg = \n\n");
    cmsepar('=');
    fprintf(redfp, "*          Parameters for BASES\n");
    cmsepar('=');
    fprintf(redfp, "\n");
    fprintf(redfp, "*--- 4. Dimension of integration.\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "           ndim  =\n");
    fprintf(redfp, "           nwild =\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*--- 5. Region of integration.\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "           xl(1)     =\n");
    fprintf(redfp, "           xu(1)     =\n");
    fprintf(redfp, "           xl(2)     =\n");
    fprintf(redfp, "           xu(2)     =\n");
    fprintf(redfp, "              ...     \n");
    fprintf(redfp, "           xl(ndim)  =\n");
    fprintf(redfp, "           xu(ndim)  =\n");
    fprintf(redfp, "                      \n");
    fprintf(redfp, "           ig(1)     =\n");
    fprintf(redfp, "           ig(2)     =\n");
    fprintf(redfp, "              ...  \n");
    fprintf(redfp, "           ig(ndim)  =\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "C          do 10 i  =   1, ndim\n");
    fprintf(redfp, "C             xl(i)  = \n");
    fprintf(redfp, "C             xu(i)  = \n");
    fprintf(redfp, "C             ig(i)  = \n");
    fprintf(redfp, "C  10      continue \n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*--- 6. Numbers of iterations and sampling ");
    fprintf(redfp, "points / iteration\n");
    fprintf(redfp, "*       and expected accuracies\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "           itmx1  =  15\n");
    fprintf(redfp, "           itmx2  = 100\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "           acc1   = 0.2d0\n");
    fprintf(redfp, "           acc2   = 0.01d0\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "           ncall  = 5000\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*--- 7. Set histograms\n");
    fprintf(redfp, "      if( knmhst .eq. 1 ) then\n");
    fprintf(redfp, "           nx = 50\n");
    fprintf(redfp, "           nd = 50\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "           do 100 i = 1, ndim\n");
    fprintf(redfp, "              write(xstr, 110) I\n");
    fprintf(redfp, "  110         format('x(',i2,') Spectrum')\n");
    fprintf(redfp, "              call xhinit(i, xl(i), xu(i), nx,");
    fprintf(redfp, " xstr)\n");
    fprintf(redfp, "  100      continue\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "           k = ndim\n");
    fprintf(redfp, "           do 200 i = 1, ndim - 1\n");
    fprintf(redfp, "           do 200 j = i + 1, ndim\n");
    fprintf(redfp, "              write(dstr, 210) i, j\n");
    fprintf(redfp, "  210         format('x(',i2,')-x(',i2,') ");
    fprintf(redfp, "Distribution')\n");
    fprintf(redfp, "              k = k + 1\n");
    fprintf(redfp, "              call dhinit(k, xl(i),xu(i),nd, ");
    fprintf(redfp, "xl(j),xu(j),nd,dstr)\n");
    fprintf(redfp, "  200      continue\n");
    fprintf(redfp, "      endif\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
}

/*==================================================================*/
Private Void    cmfkinem(NoArg)
/*------------------------------------------------------------------*
 * generate template of kinem.f
 */
{
    pindex p, pa;
    int    n,  i, tp, il;
    cmopen(ROFORT, "kinem.f");
    fprintf(redfp, "      subroutine kinem(nextrn, x, pe, pp, ");
    fprintf(redfp, "yacob, nreg, ireg, jump) \n");
    cmsepar('*');
    fprintf(redfp, "      implicit real* 8(a-h,o-z)\n");
    fprintf(redfp, "      integer nextrn \n");
    if( basesv == 0 )
        fprintf(redfp, "      parameter ( mxdim = 50 )\n");
    else
        fprintf(redfp, "      parameter ( mxdim = 100 )\n");
    fprintf(redfp, "      real*8  x(mxdim) \n");
    fprintf(redfp, "      real*8  pe(4,nextrn), pp(nextrn,nextrn) \n");
    fprintf(redfp, "      real*8  yacob \n");
    fprintf(redfp, "      integer nreg, ireg \n");
    fprintf(redfp, "      integer jump \n");
    fprintf(redfp, "      include 'inclk.f'\n");
    cmsepar('=');
    fprintf(redfp, "*     This subroutine calculates four momenta ");
    fprintf(redfp, "of external particles.\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, "*     Arguments\n");
    fprintf(redfp, "*       NEXTRN : input  : The number of ");
    fprintf(redfp, "external particles.\n");
    fprintf(redfp, "*       X      : input  : Position in the ");
    fprintf(redfp, "integration volume.\n");
    fprintf(redfp, "*       PE     : output : Table of four momenta ");
    fprintf(redfp, "of external particles.\n");
    fprintf(redfp, "*       PP     : output : Table of inner ");
    fprintf(redfp, "products of four momenta\n");
    fprintf(redfp, "*                         between two external ");
    fprintf(redfp, "particles.\n");
    fprintf(redfp, "*       YACOB  : output : Normalization for ");
    fprintf(redfp, "converting square of\n");
    fprintf(redfp, "*                         amplitude to ");
    fprintf(redfp, "cross-section.\n");
    fprintf(redfp, "*       NREG   : in/out : Maximum number of ");
    fprintf(redfp, "points in the phase space\n");
    fprintf(redfp, "*                         which correspond to ");
    fprintf(redfp, "the integration point.\n");
    fprintf(redfp, "*                         This value is one ");
    fprintf(redfp, "for the first call\n");
    fprintf(redfp, "*                         for the same ");
    fprintf(redfp, "integration point.\n");
    fprintf(redfp, "*       IREG   : input  : Counter of calling ");
    fprintf(redfp, "this subroutine for the\n");
    fprintf(redfp, "*                         same integration ");
    fprintf(redfp, "point.\n");
    fprintf(redfp, "*                         same integration ");
    fprintf(redfp, "point.\n");
    fprintf(redfp, "*                         Function FUNC ");
    fprintf(redfp, "increments this variable,\n");
    fprintf(redfp, "*                         and call this ");
    fprintf(redfp, "subroutine while (IREG.LE.NREG)\n");
    fprintf(redfp, "*       JUMP   : output : If this integration ");
    fprintf(redfp, "point is rejected,\n");
    fprintf(redfp, "*                         one should set this ");
    fprintf(redfp, "variable other than one,\n");
    fprintf(redfp, "*                         otherwize it should ");
    fprintf(redfp, "be zero.\n");
    cmsepar('=');
    fprintf(redfp, "      jump = 0\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*     if(reject this integration point) then\n");
    fprintf(redfp, "*       jump = 1 \n");
    fprintf(redfp, "*       return \n");
    fprintf(redfp, "*     endif \n");
    fprintf(redfp, "\n");
    cmsepar('-');
    fprintf(redfp, "*     if(ireg.eq.1) then\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*       The first call for this phase space ");
    fprintf(redfp, "point. \n");
    fprintf(redfp, "*       If you want to use this subroutine ");
    fprintf(redfp, "more than once for the same\n");
    fprintf(redfp, "*       phase space point, change the value ");
    fprintf(redfp, "of NREG.\n");
    fprintf(redfp, "*       This subroutine will be called NREG ");
    fprintf(redfp, "times.\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*     else\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*       IREG-th call for this phase space ");
    fprintf(redfp, "point.\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*     endif\n");
    cmsepar('-');
    fprintf(redfp, "*     Table of four momenta.\n");
    fprintf(redfp, "* PE(I, J) : I = 1 -> X, 2 -> Y, ... 4 -> ");
    fprintf(redfp, "energy, of J-th particle.\n");
    cmsepar('-');
        for(n = 0; n < nextern; n++) {
            pa  = ndname(n);
            p   = abs(pa);
            il  = ndiline(n, 0);
            tp  = iltable[il].iltype;
            Discard cmindx(momstr, tp, p);
    
            fprintf(redfp, "*     %d: %s %s mass=%s\n",
                    n+1, eliorf(ndiorf(n)), pvename(ndiorf(n),pa),
                    ptable[p]->mass);
            for(i=0;i<4;i++) {
                fprintf(redfp, "      pe(%2d,%2d) =    \n",i+1,n+1);
            }
          }
    cmsepar('-');
    fprintf(redfp, "*     PP(I,J) = inner product between I-th ");
    fprintf(redfp, " and J-th particle's momenta\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, "*     This table should be calculated from ");
    fprintf(redfp, "invariants.\n");
    fprintf(redfp, "*     When it is constructed from PE, it will ");
    fprintf(redfp, "not so accurate.\n");
    cmsepar('-');
        for(n = 0; n < nextern; n++) {
        for(i = 0; i < nextern; i++) {
            fprintf(redfp, "      pp(%2d,%2d) = ",n+1,i+1);
            if( i == n ) {
                fprintf(redfp, "amass2(%d)\n",i+1);
            } else if( i > n ) {
                fprintf(redfp, "\n");
            } else {
                fprintf(redfp, "pp(%2d,%2d)\n",i+1,n+1);
            }
        }
        cmsepar('-');
        }
    fprintf(redfp, "*     Normalization factor\n");
    cmsepar('-');
    fprintf(redfp, "\n");
    fprintf(redfp, "      yacob =\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
}

/*==================================================================*/
Private Void    cmfkinemv(NoArg)
/*------------------------------------------------------------------*
 * generate template of kinemv.f for interface to kinem.f
 */
{
    cmopen(ROFORT, "kinemv.f");
    fprintf(redfp, "      subroutine kinemv(nsampl, ndim, "); 
    fprintf(redfp, " xv, pev, ppv, yacobv,\n");
    fprintf(redfp, "     &                  nregv, ireg, jumpv)\n");
    cmsepar('*');
    fprintf(redfp, "      implicit real* 8(a-h,o-z)\n");
    fprintf(redfp, "      include 'inclvs.f'\n");
    fprintf(redfp, "      include 'incl1.f'\n");
    if( basesv == 0 )
        fprintf(redfp, "      parameter ( mxdim = 50 )\n");
    else
        fprintf(redfp, "      parameter ( mxdim = 100 )\n");
    fprintf(redfp, "      real*8  xv(nsize,mxdim) \n");
    fprintf(redfp, "      real*8  pev(nsize,4,nextn), ");
    fprintf(redfp, "ppv(nsize,nextn,nextn) \n");
    fprintf(redfp, "      real*8  yacobv(nsize) \n");
    fprintf(redfp, "      integer nregv(nsize), ireg \n");
    fprintf(redfp, "      integer jumpv(nsize) \n");
    cmsepar('*');
    fprintf(redfp, "      real*8  xx(mxdim)\n");
    fprintf(redfp, "      real*8  pe(4,nextn), pp(nextn,nextn)\n");
    fprintf(redfp, "      real*8  yacob\n");
    fprintf(redfp, "      integer nreg, jump\n");
    cmsepar('=');

    fprintf(redfp, "      do 500 j = 1, nsampl\n");
    fprintf(redfp, "         do 100 i = 1, ndim\n");
    fprintf(redfp, "            xx(i)  = xv(j,i)\n");
    fprintf(redfp, "  100    continue\n");
    fprintf(redfp, "         nreg = nregv(j)\n");
    cmsepar('=');
    fprintf(redfp, "         call kinem(nextn, xx, pe, pp, yacob, ");
    fprintf(redfp, "nreg, ireg, jump)\n");
    cmsepar('=');
    fprintf(redfp, "         jumpv(j)  = jump\n");
    fprintf(redfp, "         nregv(j)  = nreg\n");
    fprintf(redfp, "         if( jumpv(j)  .eq. 0 ) then\n");
    fprintf(redfp, "             do 200 i = 1, 4\n");
    fprintf(redfp, "             do 200 k = 1, nextn\n");
    fprintf(redfp, "                pev(j,i,k) = pe(i,k)\n");
    fprintf(redfp, "  200        continue\n");
    fprintf(redfp, "             do 300 i = 1, nextn\n");
    fprintf(redfp, "             do 300 k = 1, nextn\n");
    fprintf(redfp, "                ppv(j,i,k) = pp(i,k)\n");
    fprintf(redfp, "  300        continue\n");
    fprintf(redfp, "             yacobv(j) = yacob\n");
    fprintf(redfp, "         else\n");
    fprintf(redfp, "             yacobv(j) = 0.0d0\n");
    fprintf(redfp, "         endif\n");
    fprintf(redfp, "  500 continue\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
}
/*==================================================================*/
Private Void    cmfkfill(NoArg)
/*------------------------------------------------------------------*
 * generate template of kfill.f
 */
{
    int i;
    cmopen(ROFORT, "kfill.f");
    fprintf(redfp,"      subroutine kfill");
    fprintf(redfp,"(nextrn, ndim, x, pe, pp, ans)\n");
    fprintf(redfp,"      implicit real* 8(a-h,o-z)\n\n");
    for(i=0;i<72;i++) fprintf(redfp,"*");
    fprintf(redfp,"\n      integer nextrn\n");
    if( basesv == 0 )
        fprintf(redfp, "      parameter ( mxdim = 50 )\n");
    else
        fprintf(redfp, "      parameter ( mxdim = 100 )\n");
    fprintf(redfp,"      real*8  x(mxdim)\n");
    fprintf(redfp,"      real*8  pe(4,nextrn), pp(nextrn,nextrn)\n");
    fprintf(redfp,"      include 'inclk.f'\n");
    fprintf(redfp,"*");
    for(i=1;i<72;i++) fprintf(redfp,"=");
    fprintf(redfp,"\n");
    fprintf(redfp,"      *          ");
    fprintf(redfp,"Fill Histograms and Scatter plots\n");
    fprintf(redfp,"*");
    for(i=1;i<72;i++) fprintf(redfp,"=");
    fprintf(redfp,"\n\n");

    fprintf(redfp,"      do 40 i = 1, ndim\n");
    fprintf(redfp,"         call xhfill( i, x(i), ans )\n");
    fprintf(redfp,"   40 continue\n\n");

    fprintf(redfp,"      k = ndim\n");
    fprintf(redfp,"      do 50 i = 1, ndim-1\n");
    fprintf(redfp,"      do 50 j = i+1, ndim\n");
    fprintf(redfp,"         k    = k + 1\n");
    fprintf(redfp,"         call dhfill( k, x(i), x(j), ans )\n");
    fprintf(redfp,"   50 continue\n");

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmfkfillv(NoArg)
/*------------------------------------------------------------------*
 * generate template of kfillv.f for interface to kfill.f
 */
{
    cmopen(ROFORT, "kfillv.f");
    fprintf(redfp,"      subroutine kfillv");
    fprintf(redfp,"(nsampl, nextrn, ndim, xv, pev, ppv, ansv)\n");
    fprintf(redfp,"      implicit real* 8(a-h,o-z)\n\n");
    cmsepar('*');
    fprintf(redfp, "      include 'inclvs.f'\n");
    fprintf(redfp, "      integer nextrn \n");
    if( basesv == 0 )
        fprintf(redfp, "      parameter ( mxdim = 50 )\n");
    else
        fprintf(redfp, "      parameter ( mxdim = 100 )\n");
    fprintf(redfp, "      real*8  xv(nsize,mxdim) \n");
    fprintf(redfp, "      real*8  pev(nsize,4,nextrn), ");
    fprintf(redfp, "ppv(nsize,nextrn,nextrn) \n");
    cmsepar('*');
    fprintf(redfp, "      real*8  xx(mxdim)\n");
    fprintf(redfp, "      real*8  pe(4,nextrn), pp(nextrn,nextrn)\n");
    cmsepar('=');

    fprintf(redfp, "      do 500 j = 1, nsampl\n");
    fprintf(redfp, "         do 100 i = 1, ndim\n");
    fprintf(redfp, "            xx(i)  = xv(j,i)\n");
    fprintf(redfp, "  100    continue\n");
    fprintf(redfp, "         do 200 i = 1, 4\n");
    fprintf(redfp, "         do 200 k = 1, nextrn\n");
    fprintf(redfp, "            pe(i,k) = pev(j,i,k)\n");
    fprintf(redfp, "  200    continue\n");
    fprintf(redfp, "         do 300 i = 1, nextrn\n");
    fprintf(redfp, "         do 300 k = 1, nextrn\n");
    fprintf(redfp, "            pp(i,k) = ppv(j,i,k)\n");
    fprintf(redfp, "  300    continue\n");
    fprintf(redfp, "         ans = ansv(j)\n");
    cmsepar('=');
    fprintf(redfp, "         call kfill(nextn, ndim, x, p, pp, ans)\n");
    cmsepar('=');
    fprintf(redfp, "  500 continue\n");
    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
}
/*==================================================================*/
Private Void    cmdnn(NoArg)
/*------------------------------------------------------------------*
 * Generate dnn.f
 *------------------------------------------------------------------*/
{
    cmopen(ROFORT, "dnn.f");

    cmsepar('*');
    fprintf(redfp, "      double precision function dnn(p,am)\n");
    fprintf(redfp, "      implicit real*8(a-h,o-z)\n\n");
    fprintf(redfp, "      dimension p(4)\n\n");
    fprintf(redfp, "      dnn = p(4)*p(4) - p(1)*p(1) - p(2)*p(2)");
    fprintf(redfp, " - p(3)*p(3) - am*am\n");
    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
}
/*==================================================================*/
Private int      cmnumhgs(NoArg)
/*------------------------------------------------------------------*
 * return number of final Higgs
 *------------------------------------------------------------------*/
{
    pindex pa;
    int    n, numhgs;
    numhgs=0;
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            if( strcmp(pvename(ndiorf(n),pa),"higgs") == 0 )
                numhgs++;
        }
    }
    return numhgs;
}
/*==================================================================*/
Public  Void    cminclvs(NoArg)
/*------------------------------------------------------------------*
 * generate "inclvs.f" for vector code
 *------------------------------------------------------------------*/
{
    int p;

    cmopen(ROFORT, "inclvs.f");

    fprintf(redfp,"* buffer size (vector length)\n");
    fprintf(redfp,"*     parameter ( nsize =   256 )\n");
    fprintf(redfp,"*     parameter ( nsize =  2048 )\n");
    fprintf(redfp,"      parameter ( nsize =  8192 )\n");
    fprintf(redfp,"* end of inclvs.f \n");
}
/*==================================================================*/
Public  Void    cminclvb(NoArg)
/*------------------------------------------------------------------*
 * generate "inclvb.f" for vector code
 *------------------------------------------------------------------*/
{
    int p;

    cmopen(ROFORT, "inclvb.f");

    fprintf(redfp,"* common block for vector bases\n");
    if( basesv == 0 )
        fprintf(redfp, "      parameter ( mxdim = 50 )\n");
    else
        fprintf(redfp, "      parameter ( mxdim = 100 )\n");
    fprintf(redfp,"      include 'inclvs.f'\n");
    fprintf(redfp,"      common / vbvect / wgt(nsize), ");
    fprintf(redfp,"x(nsize,mxdim), fx(nsize)\n");
    fprintf(redfp,"* end of inclvb.f \n");
}
/*==================================================================*/
Public  Void    cmsp2lnd(NoArg)
/*------------------------------------------------------------------*
 * generate "sp2lnd.f" for JETSET interface routine
 *------------------------------------------------------------------*/
{
    int p;

    cmopen(ROFORT, "sp2lnd.f");

    fprintf(redfp, "      subroutine sp2lnd\n");
    fprintf(redfp,"*  Inteface of SPRING to JETSET.\n");

    fprintf(redfp, "      implicit real*8 (a-h,o-z)\n");
    fprintf(redfp, "      include 'incl1.f'\n");
    fprintf(redfp, "      include 'inclk.f'\n");
    fprintf(redfp, "      dimension ijoin(2)\n");
    fprintf(redfp, "*     real*4  en,th,ph\n");
    fprintf(redfp, "      real*4  p,v\n");
    fprintf(redfp, "      common/lujets/n,k(4000,5),p(4000,5),");
    fprintf(redfp, "v(4000,5)\n");
    fprintf(redfp, "      common /sp4vec/ vec(4,nextn)\n");
    cmsepar('-');
    fprintf(redfp, "*     For only QEDPS\n");
    cmsepar('-');
    fprintf(redfp, "      common common/qplist/plptn(10,1000),nlptn(10,1000),ntop\n");
    fprintf(redfp, "\n");
    cmsepar('-');
    fprintf(redfp, "*     Put 4-momentum\n");
    cmsepar('-');
    fprintf(redfp, "*     kc = 0\n");
    fprintf(redfp, "*     do 10 j = 3 , nextn\n");
    fprintf(redfp, "*        px = vec(1,j)\n");
    fprintf(redfp, "*        py = vec(2,j)\n");
    fprintf(redfp, "*        pz = vec(3,j)\n");
    fprintf(redfp, "*        en = vec(4,j)\n");
    fprintf(redfp, "*        pa = sqrt(px**2+py**2+pz**2)\n");
    fprintf(redfp, "*        th = acos(pz/pa)\n");
    fprintf(redfp, "*        if( px**2+py**2 .le. 0.0d0 ) then\n");
    fprintf(redfp, "*            ph = 0.0\n");
    fprintf(redfp, "*        else\n");
    fprintf(redfp, "*            ph = atan2(py,px)\n");
    fprintf(redfp, "*        endif\n");
    fprintf(redfp, "*        kc  = kc + 1\n");
    fprintf(redfp, "*        call lu1ent(k,kfcode(j),en,th,ph)\n");
    fprintf(redfp, "*  10 continue\n");
    cmsepar('-');
    fprintf(redfp, "      if( jqedps .eq. 0 ) then\n");
    cmsepar('-');
    fprintf(redfp, "      kc = 0\n");
    fprintf(redfp, "      do 10 j = 3 , nextn\n");
    fprintf(redfp, "         kc  = kc + 1\n");
    fprintf(redfp, "         p(kc,1) = real(vec(1,j))\n");
    fprintf(redfp, "         p(kc,2) = real(vec(2,j))\n");
    fprintf(redfp, "         p(kc,3) = real(vec(3,j))\n");
    fprintf(redfp, "         p(kc,4) = real(vec(4,j))\n");
    fprintf(redfp, "         p(kc,5) = real(amass1(j))\n");
    fprintf(redfp, "         k(kc,1) = 1\n");
    fprintf(redfp, "         k(kc,2) = kfcode(j)\n");
    fprintf(redfp, "         k(kc,3) = 0\n");
    fprintf(redfp, "         k(kc,4) = 0\n");
    fprintf(redfp, "         k(kc,5) = 0\n");
    fprintf(redfp, "         v(kc,1) = 0.0\n");
    fprintf(redfp, "         v(kc,2) = 0.0\n");
    fprintf(redfp, "         v(kc,3) = 0.0\n");
    fprintf(redfp, "         v(kc,4) = 0.0\n");
    fprintf(redfp, "         v(kc,5) = 0.0\n");
    fprintf(redfp, "   10 continue\n");
    fprintf(redfp, "      n = kc\n");
    cmsepar('-');
    fprintf(redfp, "      else\n");
    cmsepar('-');
    fprintf(redfp, "      k0 = nextn - 2\n");
    fprintf(redfp, "      do 11 j = 1 , ntop\n");
    fprintf(redfp, "         if(nlptn(3,j).ne.0) goto 11\n");
    fprintf(redfp, "         if(nlptn(1,j).ge.3) then\n");
    fprintf(redfp, "            kc     = nlptn(1,j)\n");
    fprintf(redfp, "            p(kc,1) = real(plptn(4,j))\n");
    fprintf(redfp, "            p(kc,2) = real(plptn(5,j))\n");
    fprintf(redfp, "            p(kc,3) = real(plptn(6,j))\n");
    fprintf(redfp, "            p(kc,4) = real(plptn(7,j))\n");
    fprintf(redfp, "            p(kc,5) = real(amass1(j))\n");
    fprintf(redfp, "            k(kc,1) = 1\n");
    fprintf(redfp, "            k(kc,2) = kfcode(j)\n");
    fprintf(redfp, "            k(kc,3) = 0\n");
    fprintf(redfp, "            k(kc,4) = 0\n");
    fprintf(redfp, "            k(kc,5) = 0\n");
    fprintf(redfp, "            v(kc,1) = 0.0\n");
    fprintf(redfp, "            v(kc,2) = 0.0\n");
    fprintf(redfp, "            v(kc,3) = 0.0\n");
    fprintf(redfp, "            v(kc,4) = 0.0\n");
    fprintf(redfp, "            v(kc,5) = 0.0\n");
    fprintf(redfp, "         else\n");
    fprintf(redfp, "            k0      = k0 + 1\n");
    fprintf(redfp, "            p(k0,1) = real(plptn(4,j))\n");
    fprintf(redfp, "            p(k0,2) = real(plptn(5,j))\n");
    fprintf(redfp, "            p(k0,3) = real(plptn(6,j))\n");
    fprintf(redfp, "            p(k0,4) = real(plptn(7,j))\n");
    fprintf(redfp, "            p(k0,5) = 0.0\n");
    fprintf(redfp, "            k(k0,1) = 1\n");
    fprintf(redfp, "            k(k0,2) = 22\n");
    fprintf(redfp, "            k(k0,3) = 0\n");
    fprintf(redfp, "            k(k0,4) = 0\n");
    fprintf(redfp, "            k(k0,5) = 0\n");
    fprintf(redfp, "            v(k0,1) = 0.0\n");
    fprintf(redfp, "            v(k0,2) = 0.0\n");
    fprintf(redfp, "            v(k0,3) = 0.0\n");
    fprintf(redfp, "            v(k0,4) = 0.0\n");
    fprintf(redfp, "            v(k0,5) = 0.0\n");
    fprintf(redfp, "         endif\n");
    fprintf(redfp, "   11 continue\n");
    fprintf(redfp, "      n = k0\n");
    cmsepar('-');
    fprintf(redfp, "      endif\n");
    cmsepar('-');

    if( cbase->nbase > 1 ) {
        cmsepar('-');
        fprintf(redfp, "*     String Join\n");
        cmsepar('-');
        fprintf(redfp, "      do 20 i = 1, kmcbmx, 2\n");
        fprintf(redfp, "         if( kmcstr(i,icolst) .ne. 0 ) then\n");
        fprintf(redfp, "             ijoin(1) = kmcstr( i ,icolst) - 2\n");
        fprintf(redfp, "             ijoin(2) = kmcstr(i+1,icolst) - 2\n");
        fprintf(redfp, "*            call lujoin(2,ijoin)\n");
        fprintf(redfp, "             k(ijoin(1),1) = 3\n");
        fprintf(redfp, "             if( k(ijoin(1),2) .gt. 0 ) then\n");
        fprintf(redfp, "                 k(ijoin(1),4) = ijoin(2)*10000\n");
        fprintf(redfp, "             else\n");
        fprintf(redfp, "                 k(ijoin(1),5) = ijoin(2)*10000\n");
        fprintf(redfp, "             endif\n");
        fprintf(redfp, "             k(ijoin(2),1) = 3\n");
        fprintf(redfp, "             if( k(ijoin(2),2) .gt. 0 ) then\n");
        fprintf(redfp, "                 k(ijoin(2),4) = ijoin(1)*10000\n");
        fprintf(redfp, "             else\n");
        fprintf(redfp, "                 k(ijoin(2),5) = ijoin(1)*10000\n");
        fprintf(redfp, "             endif\n");
        fprintf(redfp, "         endif\n");
        fprintf(redfp, "   20 continue\n");
    } else if( cbase->nbase == 1 && cbase->nexcolor > 0 ) {
        cmsepar('-');
        fprintf(redfp, "*     String Join\n");
        cmsepar('-');
        fprintf(redfp, "      do 20 i = 1, kmcbmx, 2\n");
        fprintf(redfp, "         if( kmcstr(i) .ne. 0 ) then\n");
        fprintf(redfp, "             ijoin(1) = kmcstr( i ) - 2\n");
        fprintf(redfp, "             ijoin(2) = kmcstr(i+1) - 2\n");
        fprintf(redfp, "*            call lujoin(2,ijoin)\n");
        fprintf(redfp, "             k(ijoin(1),1) = 3\n");
        fprintf(redfp, "             if( k(ijoin(1),2) .gt. 0 ) then\n");
        fprintf(redfp, "                 k(ijoin(1),4) = ijoin(2)*10000\n");
        fprintf(redfp, "             else\n");
        fprintf(redfp, "                 k(ijoin(1),5) = ijoin(2)*10000\n");
        fprintf(redfp, "             endif\n");
        fprintf(redfp, "             k(ijoin(2),1) = 3\n");
        fprintf(redfp, "             if( k(ijoin(2),2) .gt. 0 ) then\n");
        fprintf(redfp, "                 k(ijoin(2),4) = ijoin(1)*10000\n");
        fprintf(redfp, "             else\n");
        fprintf(redfp, "                 k(ijoin(2),5) = ijoin(1)*10000\n");
        fprintf(redfp, "             endif\n");
        fprintf(redfp, "         endif\n");
        fprintf(redfp, "   20 continue\n");
    }
    cmsepar('-');
    fprintf(redfp, "*     Hadronization\n");
    cmsepar('-');
    fprintf(redfp, "*     call lulist(1)\n");
    fprintf(redfp, "*     call luexec\n");
    fprintf(redfp, "*     call lulist(1)\n");
    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
/* Generation of gr2lnd */
    cmsepar('=');
    cmsepar(' ');
    fprintf(redfp, "*    Set parameter of GRACE to LUND*\n");
    cmsepar(' ');
    fprintf(redfp, "*    Coded by S.Kawabata May'93 at LAPP                                *\n");
    cmsepar('=');
    fprintf(redfp, "      subroutine gr2lnd\n");
    fprintf(redfp, "      implicit real*8(a-h,o-z)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      include 'inclk.f'\n");
    fprintf(redfp, "      real*4  paru,parj\n");
    fprintf(redfp, "      real*4  pmas,parf,vckm\n");
    fprintf(redfp, "      common/ludat1/mstu(200),paru(200),");
    fprintf(redfp, "mstj(200),parj(200)\n");
    fprintf(redfp, "      common/ludat2/kchg(500,3),pmas(500,4),");
    fprintf(redfp, "parf(2000),vckm(4,4)\n");
    fprintf(redfp, "*     character*18 cmass,calpha\n");
    fprintf(redfp, "\n");
    cmsepar('-');
    fprintf(redfp, "*     GRACE will generate the direct statment from model file.\n");
    fprintf(redfp, "*     call lugive('pmas(lucomp(24,1)= 70.0d0');\n");
    cmsepar('-');
    fprintf(redfp, "*     cmass(19:20) = 'd0'\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*   Mass\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amw\n");
    fprintf(redfp, "*     call lugive('pmas(24,1)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amz\n");
    fprintf(redfp, "*     call lugive('pmas(23,1)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') ama\n");
    fprintf(redfp, "*     call lugive('pmas(22,1)='//cmass)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amg\n");
    fprintf(redfp, "*     call lugive('pmas(21,1)='//cmass)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amh\n");
    fprintf(redfp, "*     call lugive('pmas(25,1)='//cmass)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amne\n");
    fprintf(redfp, "*     call lugive('pmas(12,1)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amnm\n");
    fprintf(redfp, "*     call lugive('pmas(14,1)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amnt\n");
    fprintf(redfp, "*     call lugive('pmas(16,1)='//cmass)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amel\n");
    fprintf(redfp, "*     call lugive('pmas(11,1)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') ammu\n");
    fprintf(redfp, "*     call lugive('pmas(13,1)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amta\n");
    fprintf(redfp, "*     call lugive('pmas(15,1)='//cmass)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amuq\n");
    fprintf(redfp, "*     call lugive('pmas( 2,1)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amcq\n");
    fprintf(redfp, "*     call lugive('pmas( 4,1)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amtq\n");
    fprintf(redfp, "*     call lugive('pmas( 6,1)='//cmass)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amdq\n");
    fprintf(redfp, "*     call lugive('pmas( 1,1)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') amsq\n");
    fprintf(redfp, "*     call lugive('pmas( 3,1)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') ambq\n");
    fprintf(redfp, "*     call lugive('pmas( 5,1)='//cmass)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*   Width\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') agw\n");
    fprintf(redfp, "*     call lugive('pmas(24,2)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') agz\n");
    fprintf(redfp, "*     call lugive('pmas(23,2)='//cmass)\n");
    fprintf(redfp, "**    write(cmass,'(e18.10)') aga\n");
    fprintf(redfp, "**    call lugive('pmas(22,2)='//cmass)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "**    write(cmass,'(e18.10)') agg\n");
    fprintf(redfp, "**    call lugive('pmas(21,2)='//cmass)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') agh\n");
    fprintf(redfp, "*     call lugive('pmas(25,2)='//cmass)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "**    write(cmass,'(e18.10)') agne\n");
    fprintf(redfp, "**    call lugive('pmas(12,2)='//cmass)\n");
    fprintf(redfp, "**    write(cmass,'(e18.10)') agnm\n");
    fprintf(redfp, "**    call lugive('pmas(14,2)='//cmass)\n");
    fprintf(redfp, "**    write(cmass,'(e18.10)') agnt\n");
    fprintf(redfp, "**    call lugive('pmas(16,2)='//cmass)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "**    write(cmass,'(e18.10)') agel\n");
    fprintf(redfp, "**    call lugive('pmas(11,2)='//cmass)\n");
    fprintf(redfp, "**    write(cmass,'(e18.10)') agmu\n");
    fprintf(redfp, "**    call lugive('pmas(13,2)='//cmass)\n");
    fprintf(redfp, "**    write(cmass,'(e18.10)') agta\n");
    fprintf(redfp, "**    call lugive('pmas(15,2)='//cmass)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "**    write(cmass,'(e18.10)') aguq\n");
    fprintf(redfp, "**    call lugive('pmas( 2,2)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') agcq\n");
    fprintf(redfp, "*     call lugive('pmas( 4,2)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') agtq\n");
    fprintf(redfp, "*     call lugive('pmas( 6,2)='//cmass)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "**    write(cmass,'(e18.10)') agdq\n");
    fprintf(redfp, "**    call lugive('pmas( 1,2)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') agsq\n");
    fprintf(redfp, "*     call lugive('pmas( 3,2)='//cmass)\n");
    fprintf(redfp, "*     write(cmass,'(e18.10)') agbq\n");
    fprintf(redfp, "*     call lugive('pmas( 5,2)='//cmass)\n");
    fprintf(redfp, "*  Alpha\n");
    fprintf(redfp, "*     calpha(19:20) = 'd0'\n");
    fprintf(redfp, "*     write(calpha,'(e18.10)') alpha\n");
    fprintf(redfp, "*     call lugive('paru(101)='//calpha)\n");
    fprintf(redfp, "\n");
    cmsepar('-');
    fprintf(redfp, "*     PUT COMMON BLOCK \n");
    cmsepar('-');
    fprintf(redfp, "*\n");
    fprintf(redfp, "*   Mass & Width\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, "*     <Gauge Boson>\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, "      pmas(21,1) = real(amg)\n");
    fprintf(redfp, "      pmas(22,1) = real(ama)\n");
    fprintf(redfp, "      pmas(23,1) = real(amz)\n");
    fprintf(redfp, "      pmas(24,1) = real(amw)\n");
    fprintf(redfp, "      pmas(25,1) = real(amh)\n");
    fprintf(redfp, "*     pmas(21,2) = real(agg)\n");
    fprintf(redfp, "*     pmas(22,2) = real(aga)\n");
    fprintf(redfp, "      pmas(23,2) = real(agz)\n");
    fprintf(redfp, "      pmas(24,2) = real(agw)\n");
    fprintf(redfp, "      pmas(25,2) = real(agh)\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, "*     <Quark>\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, "      pmas( 1,1) = real(amdq)\n");
    fprintf(redfp, "      pmas( 2,1) = real(amuq)\n");
    fprintf(redfp, "      pmas( 3,1) = real(amsq)\n");
    fprintf(redfp, "      pmas( 4,1) = real(amcq)\n");
    fprintf(redfp, "      pmas( 5,1) = real(ambq)\n");
    fprintf(redfp, "      pmas( 6,1) = real(amtq)\n");
    fprintf(redfp, "*     pmas( 1,2) = real(agdq)\n");
    fprintf(redfp, "*     pmas( 2,2) = real(aguq)\n");
    fprintf(redfp, "      pmas( 3,2) = real(agsq)\n");
    fprintf(redfp, "      pmas( 4,2) = real(agcq)\n");
    fprintf(redfp, "      pmas( 5,2) = real(agbq)\n");
    fprintf(redfp, "      pmas( 6,2) = real(agtq)\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, "*     <Lepton>\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, "      pmas(11,1) = real(amel)\n");
    fprintf(redfp, "      pmas(12,1) = real(amne)\n");
    fprintf(redfp, "      pmas(13,1) = real(ammu)\n");
    fprintf(redfp, "      pmas(14,1) = real(amnm)\n");
    fprintf(redfp, "      pmas(15,1) = real(amta)\n");
    fprintf(redfp, "      pmas(16,1) = real(amnt)\n");
    fprintf(redfp, "*     pmas(11,2) = real(agel)\n");
    fprintf(redfp, "*     pmas(12,2) = real(agne)\n");
    fprintf(redfp, "*     pmas(13,2) = real(agmu)\n");
    fprintf(redfp, "*     pmas(14,2) = real(agnm)\n");
    fprintf(redfp, "*     pmas(15,2) = real(agta)\n");
    fprintf(redfp, "*     pmas(16,2) = real(agnt)\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, "*  Alpha\n");
    fprintf(redfp, "*\n");
    fprintf(redfp, "      paru(101) = real(alpha)\n");
    fprintf(redfp, "\n");
    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end \n");
}
/*==================================================================*/
Public  Void    cmspdetc(NoArg)
/*------------------------------------------------------------------*
 * generate "spdetc.f" for JETSET interface routine
 *------------------------------------------------------------------*/
{
    cmopen(ROFORT, "spdetc.f");

    fprintf(redfp, "      subroutine spdetc\n");
    cmsepar('-');
    fprintf(redfp, "*     Selection of Color State\n");
    fprintf(redfp, "*        output:icolst (0->ncbase-1)\n");
    cmsepar('-');
    fprintf(redfp, "      implicit real*8 (a-h,o-z)\n");
    fprintf(redfp, "      include 'incl1.f'\n");
    fprintf(redfp, "      include 'inclk.f'\n");
    fprintf(redfp, "      dimension asum(0:ncbase-1)\n");
    cmsepar('-');
    fprintf(redfp, "*        Calcul amplitutes squared.");
    cmsepar('-');
    fprintf(redfp, "      do 120 ic = 0 , ncbase-1\n");
    fprintf(redfp, "      asum(ic) = 0.0d0\n");
    fprintf(redfp, "      do 110 ih = 0, lag-1\n");
    fprintf(redfp, "         asum(ic) = asum(ic) + dble(agc(ih,ic))**2 + imag(agc(ih,ic))**2\n");
    fprintf(redfp, "  110 continue\n");
    fprintf(redfp, "  120 continue\n");
    cmsepar('-');
    fprintf(redfp, "*        Search maximum.\n");
    cmsepar('-');
    fprintf(redfp, "      icolst = 0\n");
    fprintf(redfp, "      amax = asum(icolst)\n");
    fprintf(redfp, "      do 130 ic = 1, ncbase-1\n");
    fprintf(redfp, "         if( asum(ic) .gt. amax ) then\n");
    fprintf(redfp, "             amax = asum(ic)\n");
    fprintf(redfp, "             icolst = ic\n");
    fprintf(redfp, "         endif\n");
    fprintf(redfp, "  130 continue\n");
    fprintf(redfp, "*     print *,'asum',icolst,' ',asum\n");
    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
}
